package charite.christo;
import charite.christo.interfaces.*;
import java.io.File;
import java.awt.*;
import java.util.List;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import static java.awt.event.MouseEvent.*;
import static java.awt.event.KeyEvent.*;
import static charite.christo.ChTextComponents.Highlight;
public class AsciiView extends ChPanel implements ChRunnable {
    public final static String KOPT_SEARCH_SKIP_BLANKS="KB$$B";
    private final static int LINE_NUM_WIDTH=7;
    private File file;
    private int lineNumbers=MIN_INT;
    private ByteArray byteArray;
    private long byteArray_mc;
    private int modiCount;
    public File getFile() { return file;}
    public void setFile(File f) { file=f; byteArray=null; refText=null; ChDelay.repaint(this,333); }
    private int setText_byteArray_mc=0;
    public AsciiView setText(CharSequence cs) {
        final ByteArray baOld=byteArray, ba=byteArray=toByteArray(cs);
        if (ba==null) return this;
        final int mc=byteArray.getModificationCount();
        if (baOld==null || baOld!=ba || setText_byteArray_mc!=mc) {

            maxLineWidth=0;
            setText_byteArray_mc=mc;
            file=null;
            ChDelay.revalidate(this,222);
            ChDelay.repaint(this,333);
            modiCount++;
        }
        return this;
    }
    private Object refText;
    private ChTextComponents tools_;
    public ChTextComponents tools() { if (tools_==null) tools_=new ChTextComponents(this); return tools_;}
    private int maxLineWidth=0, posLastClicked=-1;
    private final int lineSkip=1;
    private final Highlight region;
    Highlight region(){ return region;}

    private final int regionFromTo[]=new int[2];
    private int regionFrom, regionTo;
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> Constructor >>> */
    public AsciiView(File f) { file=f;}
    public AsciiView(CharSequence ba) { setText(ba);}
    public AsciiView(int size) { this(new ByteArray(size));}
    {
        setAutoscr(this);
        monospc(this);
        tools().addHighlight(this.region=ChTextComponents.newHighlight(regionFromTo, C(0x0000ff,0x30),HIGHLIGHT_NOT_IN_SCROLLBAR|HIGHLIGHT_NEVER_REMOVE));

    }
    public AsciiView setLineNumberStart(int b) { lineNumbers=b; repaint(); return this;}
    public synchronized ByteArray byteArray() {
        if (byteArray!=null) return byteArray;
        ByteArray ba=(ByteArray)deref(refText);
        if (ba==null) {
            refText=newSoftRef(ba=readBytes(file));
            if (ba!=null) ChTextComponents.tools(this).underlineRefs(UNDERLINE_REFS_BG);
            if (ba==null) ba=new ByteArray(NO_BYTE);
        }
        return ba;
    }
    private int gps_byteArray_mc;
    @Override public Dimension getPreferredSize() {
        final ByteArray text=byteArray();
        if (text==null) return dim(1,1);
        final File f=this.file;
        final int charW=charW(this);
        final int mc=text.getModificationCount() + (f!=null ? (int)(f.lastModified()/1024) : 0);
        final int ends[]=text.getLineEnds();
        if (maxLineWidth==0 || gps_byteArray_mc!=mc) {
            gps_byteArray_mc=mc;
            int begin=0;
            for(int i=0; i<ends.length; i++) {
                final int e=ends[i];
                if (e-begin>maxLineWidth) maxLineWidth=e-begin;
                begin=e;
            }
        }
        final int w=charW*maxLineWidth+(lineNumbers!=MIN_INT ? LINE_NUM_WIDTH*charW : 0);
        final int h=getFixedRowHeight()* ends.length;
        return dim(maxi(1,w), maxi(1,h));
    }

    private int ba_mc;
    private static AnsiEscape attributes;
    @Override public void paintComponent(Graphics g) {
        final Color background,forground;
        {
            final Color bg=getBackground(), fg=getForeground();
            forground=fg!=null ? fg : C(0);
            background=bg!=null ? bg : C(0xFFffFF);
        }
        if (attributes==null) attributes=new AnsiEscape(); else attributes.reset();
        testWheterChanged(byteArray());
        final Rectangle clip=g.getClipBounds();
        final int
            clipX1=clip!=null ? clip.x : 0,
            clipY1=clip!=null ? clip.y : 0,
            clipX2=clip!=null ? clip.x+clip.width : getWidth(),
            clipY2=clip!=null ? clip.y+clip.height: getHeight();
        g.clearRect(clipX1,clipY1,clipX2-clipX1, clipY2-clipY1);

        tools().paintHook(this,g,false);
        final String strgLen1[]=getStringsLenght1();
        final ByteArray text=byteArray();
        if (text==null) return;
        final long[] escape=text.getAnsiEscapes();
        final int escapeL=text.countAnsiEscapes();

        final byte T[]=text.getBytes();

        final int mc=text.getModificationCount()+modiCount;
        if (ba_mc!=mc) { ba_mc=mc; ChDelay.revalidate(this,222,(long[])null);}
        final int ends[]=text.getLineEnds();
        final int charH=charH(this), charW=charW(this), charA=charA(this);
        final int wLineNum=lineNumbers!=MIN_INT?charW*LINE_NUM_WIDTH : 0;
        final int firstRow=maxi(0,clipY1/(charH+lineSkip)) ,lastRow=(clipY2-1)/(charH+lineSkip)+1;
        final int firstCol=maxi(0, (clipX1-wLineNum)/charW) ,lastCol=(clipX2-1)/charW+1;
        final int maxRow=mini(ends.length, lastRow+1);
        int nextEscapeI=-1, nextEscapePos=-1;
        Color fg=null, bg=null;
        for(int row=firstRow; row<maxRow; row++) {
            final int begin=row==0 ? text.getBegin(): ends[row-1]+1;
            final int y=row*(charH+lineSkip);
            final int to=mini(ends[row],begin+lastCol);
            final int from=mini(to,begin+firstCol);
            for(int i=from,  x=firstCol*charW+wLineNum; i<to; i++,x+=charW ) {
                if (i>=nextEscapePos) {
                    final int j0=maxi(0,nextEscapeI);
                    nextEscapePos=nextEscapeI=MAX_INT;
                    boolean changed=false;
                    for(int j=j0; j<escapeL; j++) {
                        final long e=escape[j];
                        final int pos=(int)(e&AnsiEscape.MASK_POS);
                        if (pos<=i) {
                            AnsiEscape.inferIntoAttribute(e,attributes);
                            changed=true;
                        } else {
                            nextEscapePos=pos;
                            nextEscapeI=j;
                            break;
                        }
                    }
                    if (changed) {
                        bg=attributes.bg();
                        fg=attributes.fg();
                    }
                }

                if (bg!=background && bg!=null) {
                    g.setColor(bg);
                    fillBigRect(g,x,y,charW,charH);
                }
                g.setColor(fg!=null ? fg : forground);
                g.drawString(T[i]=='\t' ? "\u00bb" : strgLen1[127&T[i]],x,y+charA);
            }
            if (lineNumbers!=MIN_INT) {
                g.setColor(C(0xFF));
                final String s=String.valueOf(row+lineNumbers);
                g.drawString(s,charW*(LINE_NUM_WIDTH-s.length()-1),y+charA);
            }
        }
        tools().paintHook(this,g,true);
    }

    public final static long FRAME_OPTS=ChFrame.AT_CLICK|ChFrame.SIZE_REGARD_RESOLUTION|ChFrame.DISPOSE_ON_CLOSE|DISPOSE_ON_CtrlW;
    public AsciiView showInFrame(String t) {
        pcp(KEY_TITLE,t,this);
        return showInFrame(t,FRAME_OPTS);
    }

    public AsciiView showInFrame(String title0,long options) {
        final String title= title0!=null ? title0 : filepathUnixStyle(getFile());
        ChFrame.frame(title,this, options|ChFrame.SCROLLPANE|(getFile()!=null?DISPOSE_ON_CtrlW:0)).shw(options);
        return this;
    }
    public void modelToView(int iPosition, Rectangle r) {
        final ByteArray text=byteArray();
        final int[] ends=text.getLineEnds();
        for(int i=0;i<ends.length; i++) {
            if (ends[i]>iPosition) {
                final int row=i;
                final int begin=i==0 ? 0 : ends[i-1]+1;
                final int col=iPosition-begin;
                final int charW=charW(this), charH=charH(this);
                r.setBounds(col*charW, row*(lineSkip+charH), charW,charH);
                return;
            }
        }
        r.setBounds(getWidth(), getHeight(), 0,0);
    }

    public int viewToModel(int x, int y) {
        final ByteArray ba=byteArray();
        if (y<0 || ba==null) return 0;
        final int ends[]=ba.getLineEnds();
        final int row=y/maxi(1,getFixedRowHeight());
        if (row>=ends.length) return ba.getEnd();
        final int charW=charW(this);
        final int wLineNum=lineNumbers!=MIN_INT ? LINE_NUM_WIDTH*charW : 0;

        final int lineStart=row<=0 ? 0 : ends[row-1]+1;
        return mini(ends[row],lineStart+(maxi(0,x-wLineNum))/charW);
    }
    private boolean testWheterChanged(ByteArray text) {
        if (text==null) return false;
        long mc=text.getModificationCount();
        if(byteArray_mc!=mc) {
            byteArray_mc=mc;
            setText(text);
            return true;
        }
        return false;
    }

    @Override public void processEvent(AWTEvent ev) {
        final ByteArray text=byteArray();
        if (text==null) return;
        final int
            id=ev.getID(),
            modi=modifiers(ev),
            kcode=keyCode(ev),
            x=x(ev),
            y=y(ev),
            pos=viewToModel(x,y),
            B=text.getBegin(),
            E=text.getEnd();
        testWheterChanged(text);

        final boolean
            ctrl= 0!=((CTRL_MASK|shortCutMask())&modi),
            shift=0!=(CTRL_MASK&modi);
        if (!shift && id==MOUSE_DRAGGED || id==MOUSE_CLICKED && shift) {
            if (posLastClicked>=0) regionFrom=posLastClicked;
            regionTo=pos;
            repaint();
        }
        if (id==MOUSE_PRESSED || id==MOUSE_CLICKED) {
            requestFocus();
            if (!shift) posLastClicked=pos;
        }

        if (id==KEY_PRESSED && ctrl) {
            if (kcode==VK_L)  setLineNumberStart(lineNumbers==MIN_INT?0:MIN_INT);
            if (kcode==VK_A)  { regionFrom=0; regionTo=E; repaint(); }
        }

        final int f=maxi(B, mini(regionFrom, regionTo));
        final int t=mini(E, maxi(regionFrom, regionTo));
        {
            if ( (id==MOUSE_RELEASED || ctrl && kcode==VK_C) && t>f) {
                toClipbd(toStrg(text.getBytes(),f,t));
            }
            regionFromTo[0]=f;
            regionFromTo[1]=t;
        }
        final AWTEvent newEv=tools().processEvent(this,ev);
        if (newEv!=null) super.processEvent(newEv);

    }

    { this.enableEvents(MOUSE_EVENT_MASK|MOUSE_MOTION_EVENT_MASK|KEY_EVENT_MASK|MOUSE_WHEEL_EVENT_MASK);}

    public int getFixedRowHeight() { return charH(this)+lineSkip;}

    public void highlightXML(ByteArray ba) {
        if (strstr("><",ba)>=0) {
            ba.replace("><FEATURE",">\n\n  <FEATURE");
            ba.replace("><TYPE ",">\n   <TYPE ");
            ba.replace("><START>",">\n   <START>");
            ba.replace("><START>",">\n   <START>");
            ba.replace("</FEATURE><","</FEATURE>\n\n  <");
        }
        final Object
            cyan=C(0x00FFff),
            hl[][]={
            {"<FEATURE", C(0xFF0000)}, {"</FEATURE", C(0xFF0000)}, {"<TYPE", C(0xFFff00)},
            {"<START>", cyan}, {"</START>", cyan}, {"<END>", cyan}, {"</END>", cyan}
        };
        setText(ba);
        for(Object[]  o :hl) tools().highlightOccurrence((String)o[0], null,null, HIGHLIGHT_NOT_IN_SCROLLBAR, (Color)o[1]);
        tools().highlightOccurrence("<SEGMENT ", null,null, 0, C(0xFFafAF));
        tools().underlineRefs(UNDERLINE_REFS);
    }
    @Override public String getToolTipText(java.awt.event.MouseEvent mev) {
        final String tt=tools().getToolTipText(mev);
        return sze(tt)>0 ? tt :  super.getToolTipText(mev);
    }

    public java.util.List getDndDateien() { return getDndFilesV(this); }

    public AsciiView appendS(CharSequence s) {
        final ByteArray ba=this.byteArray();
        if (s==null || ba==null) return this;
        ba.append(s);
        ChDelay.repaint(this,555);
        return this;
    }
    public AsciiView appendSS(CharSequence... ss) {
        if (sze(ss)>0) for(CharSequence s : ss) appendS(s);
        return this;
    }
    public AsciiView appendBB(byte bb[]) {
        final ByteArray ba=this.byteArray();
        if (ba!=null &&sze(bb)>0) {
            ba.append(bb);
            ChDelay.repaint(this,555);
        }
        return this;
    }
    public Object run(final String id, Object arg) {
    final Object argv[]=arg instanceof Object[] ? (Object[]) arg : null;
      if (id==ChRunnable.APPEND && arg!=null) {
        if (argv!=null) for(Object o : argv) run(id,o);
        else if (arg instanceof byte[]) appendBB((byte[])arg);
        else if (arg!=null) appendS(toStrg(arg));
      }
      return null;
    }
}
