package charite.christo;
import javax.swing.*;
import charite.christo.interfaces.*;
import java.awt.*;
import java.awt.event.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**
   Opens a JColorChooser.
   @author Christoph Gille
*/
public class ButColor extends ChButton implements javax.swing.event.ChangeListener, Disposable {
    public final static String KEY_PAN_SOUTH="BuCol$$2";
    public final static long NO_TRANSPARENCY=1<<0, SHOW_PREVIEW_PANEL=1<<1, TRANSPARENCY_CHANGE_EVT=1<<2;
    private JColorChooser colorChooser;
    private final Object colored;
    private final Color defaultColor;
    private final long options;
    public ButColor(long options, Color col, Object c) {
        this.colored=c;
        this.defaultColor=col!=null ? col:Color.MAGENTA;
        this.options=options;
        i(IC_COLOR).tt("Change color");
    }

    private JSlider slider;
    private ChFrame frame;
    private ActionEvent aev;
    private boolean shown;
    private JComponent panel;
    public JComponent getDialogPanel() {
        if (panel==null) {
            final JColorChooser cs=colorChooser=new JColorChooser();
            cs.getSelectionModel().addChangeListener(this);
            if (0==(options&SHOW_PREVIEW_PANEL)) cs.setPreviewPanel(new JLabel());
            if (defaultColor!=null) cs.setColor(defaultColor);
            final int alpha=defaultColor!=null? defaultColor.getRGB()>>>24 : 255;
            Object panTransp=null;
            if (0==(options&NO_TRANSPARENCY)) {
                final JSlider sl=this.slider=new JSlider(0,255,255-alpha&255);
                panTransp=hB("Transparency ",sl);
                sl.addChangeListener(this);
            }
            panel=newCNSEW(colorChooser,panTransp, gcp(KEY_PAN_SOUTH,this),null,null);
            closeOnCtrlW(true, colorChooser, CLOSE_PARENT_WINDOW);            
            shown=true;
        }
        return panel;
    }
    public void shw() {
        if (frame==null) {
            String title=gcps(KEY_FRAME_TITLE,this);
            frame=new ChFrame(title!=null ? title : "color").ad(getDialogPanel());

        }
        frame.shw(ChFrame.AT_CLICK|ChFrame.PACK);

    }
    public Color getColor() {
        final JSlider sl=this.slider;
        final JColorChooser cs=this.colorChooser;

        final Color c=cs!=null?cs.getColor() : defaultColor;
        return c!=null ? C(c.getRGB()&0xFFffFF, sl!=null ? (255-sl.getValue())&255 : 255) : defaultColor;
    }
    public void stateChanged(javax.swing.event.ChangeEvent ev) {
        if (ev.getSource() instanceof JSlider && 0==(options&TRANSPARENCY_CHANGE_EVT)) return;
        final Color col=getColor();
        Container parent=getParent();
        if (parent!=null) {
            java.awt.image.ImageProducer ip=new java.awt.image.FilteredImageSource(iicon(IC_COLOR).getImage().getSource(),new ColorFilter(col));
            i(new ImageIcon(createImage(ip)));
            parent.repaint();
        }
        if (colored instanceof Colored) ((Colored)colored).setColor(col);
        if (colored instanceof ActionListener && shown) {
            if (aev==null) aev=new ActionEvent(this,ActionEvent.ACTION_PERFORMED,ACTION_COLOR_CHANGED);
            ((ActionListener)colored).actionPerformed(aev);
        }
    }
    @Override public final void r() {shw(); }
    public void dispose() {
        slider=null;
        colorChooser=null;
    }
}
