package charite.christo;
import javax.swing.*;
import java.awt.event.*;
import charite.christo.interfaces.*;
import java.awt.*;
import java.util.Map;
import javax.swing.Icon;
import java.io.File;
import static java.awt.event.MouseEvent.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**
   the extended button class
   @author Christoph Gille
*/
public class ChButton extends JButton implements HasRendererComponent,Runnable,ChRunnable, HasModiCount, ChProcessEvent {
    public final static long CROSSING_OUT=1<<1, SHOW_HIDE=1<<2, NO_FILL=1<<3, NO_BORDER=1<<4,ICON_SIZE=1<<6,
        NOT_OPAQUE=1<<7, PAINT_IN_TABLE=1<<8, DISABLED=1<<9, HEIGHT_I=1<<10, UNDOCKABLE=1<<11, HIDE_IF_DISABLED=1<<12,
        MAC_TYPE_ICON=1<<13, PAINT_IF_ENABLED=1<<14, ARROWS_MAXIMIZE=1<<15;
    final Map MAPCP=new java.util.HashMap();
    public final static String
    GO="CB$$1",
        MSG_SHOW_ALL_PREVIOUS="Show all previous info  messages",
        DISPOSE_PARENT_WINDOW="CB$$DPW",
        KEY_COLOR_BOX_L="CB$$KCBl", KEY_COLOR_BOX_R="CB$$KCBr";

    private boolean  contains, handleEvt=true;
    private final char type;
    private int mouseX, mouseY,  modifiers, height=-1, modiCount;
    public final static JButton BUTTON_GO=new JButton("<html><body><b> GO </b></body></html>");
    static {
        setFG(0x007c00, BUTTON_GO);
        Font f=BUTTON_GO.getFont();
        BUTTON_GO.setFont(new Font(f.getName(),Font.BOLD,f.getSize()+2));
        BUTTON_GO.setPreferredSize(dim(32,32));
    }

    private final static Object
    VIEW_MSG=new Object(), KEY_DO_CLICK=new Object(),
        FRAME_TITLE=new Object(),DO_HIDE_PARENT_WINDOW=new Object(),
        KEY_EXECUTE_CUST=new Object(),KEY_EXECUTE_ARG=new Object(), KEY_VIEW_FILE=new Object(),
        KEY_EDIT_FILE=new Object(),KEY_PRINTABLE=new Object(),KEY_ChTabPane=new Object(),
        KEY_CTRL=new Object(),KEY_SHARED_CTRL=new Object(), KEY_CUSTOMIZE=new Object(),
        KEY_HELP_OBJECTS=new Object(), KEY_HELP_SUFFIX=new Object(),
        KEY_pack=new Object(),
        KEY_undock_component=new Object(),KEY_OPEN_URL=new Object(),
        CLOSE=new Object(),CLOSE_OPTION=new Object(), KEY_COLLAPSE[]={new Object(),new Object(), new Object()};

    // ----------------------------------------
    /* >>> Constructor >>> */
            {  assertInstAllowed(); }
    private long options;
    public ChButton options(long o) {
        if (0!=(SHOW_HIDE&o)) { i(new Object[]{IC_HIDE,IC_SHOW});}
        if (0!=(NO_FILL&o))   setContentAreaFilled(false);
        if (0!=(NO_BORDER&o)) setBorderPainted(false);
        if (0!=(MAC_TYPE_ICON&o)) putClientProperty("JButton.buttonType","icon");
        if (0!=(ICON_SIZE&o)) {
            cp(KEY_PREF_SIZE,dim(ICON_HEIGHT,ICON_HEIGHT));
            setMargin(new Insets(0,0,0,0));
        }
        if (0!=((NOT_OPAQUE|PAINT_IF_ENABLED|NO_FILL|PAINT_IF_ENABLED)&o)) setOpaque(false);
        if (0!=(PAINT_IN_TABLE&o)) setRequestFocusEnabled(false);
        if (0!=(DISABLED&o)) setEnabld(false,this);
        if (0!=(HEIGHT_I&o)) height=ICON_HEIGHT;
        if (0!=(UNDOCKABLE&o)) ChUtils.setUndockble(this);
        if (0!=(HIDE_IF_DISABLED&o)) cp(KOPT_HIDE_IF_DISABLED,"");
        if (0!=(ARROWS_MAXIMIZE&o)){
            final Dimension d=t(" ").getPreferredSize();
            d.width=d.height;
            t("").setPreferredSize(d);
        }
        this.options=o;
        return this;
    }

    public ChButton(AbstractButton b) {
        this(b instanceof ChButton ? ((ChButton)b).type:'B',b.getText());
        setModel(b.getModel());
        cp(KEY_CLONED_FROM,b);
    }
    public ChButton() { this('B',null);}
    public ChButton(String s) { this('B',s); }
    public ChButton(String s, long options) {
        this('B',s);
        options(options);
    }
    public ChButton(char buttonType, String s) {
        this.type=buttonType;
        setModel(buttonType=='T'||buttonType=='C' ? new JToggleButton.ToggleButtonModel() : new DefaultButtonModel());

        setAlignmentX(LEFT_ALIGNMENT);
        setAlignmentY(CENTER_ALIGNMENT);
        cp(KEY_ACTION_COMMAND,s);
        setDefaultCapable(false);
        if (s!=null) setText(addHtmlTagsAsStrg(s));
        LI.addTo("a",getModel());

        if (buttonType=='C') {
            setBorderPainted(false);
            setText(s);
            setHorizontalAlignment(LEADING);
        }
        if (isMacintoshLaf()) {
            setOpaque(false);
        }
        shiftTooltip(this);
    }
    @Override protected void finalize() throws Throwable {
        logFinalize(ANSI_RED+ANSI_FG_WHITE+"ChButton ",getText());
        super.finalize();
    }

    /* <<< Constructor <<< */
    /* ---------------------------------------- */
    /* >>> Paint >>> */
    @Override public void paintChildren(Graphics g) {
        if (UserProfile.isHidden(this)) {return;  }
        super.paintChildren(g);
    }

    private void cBox(Graphics g) {
        for(int left=2; --left>=0;) {
            final Color c=colr(gcp(left!=0 ? KEY_COLOR_BOX_L : KEY_COLOR_BOX_R,this));
            if (c!=null) {
                g.setColor(c);
                g.fillRect(left!=0?0:getWidth()-4, (getHeight()-8)/2, 4,8);
            }
        }
    }
    @Override public void paintComponent(Graphics g) {
        {
            ChButton cl=this;
            while(this.oIcon==null &&  ((cl=gcp(KEY_CLONED_FROM,cl,ChButton.class))!=null)) this.oIcon=cl.oIcon;
            this.oIcon=ChButton.mkIcon(this.oIcon, this);
        }
        if (g==null) return;
        final long opt=this.options;
        final int w=getWidth(), h=getHeight(), w2=w/2, h2=h/2;

        final boolean isEnabled=isEnabled();
        if (!isEnabled && (
                           null!=gcp(KEY_HELP_OBJECTS,this) ||
                           null!=gcp(KEY_CUSTOMIZE,this) ||
                           null!=gcp(KEY_SHARED_CTRL,this) ||
                           0!=(opt&PAINT_IF_ENABLED))) return;
        if (null==gcp(UserProfile.KEY_IGNORE,this) && UserProfile.isHidden(this)) {
            if (isOpaque()) g.clearRect(0,0,w,h); return;
        }
        antiAliasing(g);

        if (paintHooks(this, g, false)) {

            if (getModel().isEnabled()!=isEnabled()) super.setEnabled(isEnabled);
            if (isMacintoshLaf()) setOpaque(false);
            if (!isOpaque()) cBox(g);
            try { super.paintComponent(g); } catch(Throwable ex){ vMaliciousIcons.add(getIcon()); }
            if (isOpaque()) cBox(g);
            if (0!=(opt&ARROWS_MAXIMIZE)) {
                g.setColor(C(s()?0:0x080808));
                g.drawLine(0,h2, w,h2);
                g.drawLine(w2,0, w2,h);
                for(int j=4;--j>=0;) {
                    final int
                        D=4,
                        LR01=j&1,
                        LRhead=(LR01==0?D:-D),
                        upDown=(j&2)==0?-D*2/3:D*2/3;
                    g.drawLine(LR01*w, h2, LR01*w+LRhead, h2+upDown);
                    g.drawLine(w2, LR01*h, w2+upDown, LR01*h+LRhead);
                }
            }
            final Object magnify=gcp("MAGNIFY",this);
            if (magnify!=null) {
                final int a; /*Abstand zum Rand */
                final float ZOOM=.3f;
                if (contains) {
                    g.setColor(C(0x808080));g.drawRect(0,0,w-1,h-1);
                    int dx=mouseX-w/2, dy=mouseY-h/2;
                    if (dx<0) dx=-dx;
                    if (dy<0) dy=-dy;
                    a=(int)((dx+dy)*ZOOM);
                } else a=(int)(ZOOM*(w+h)/4);

                if (magnify instanceof ImageIcon)  {
                    if (isEnabled()) {
                        final Image im=((ImageIcon)magnify).getImage();
                        g.drawImage(im,
                                    a,a,w-a,h-a,
                                    0,0,im.getWidth(this),im.getHeight(this),this);

                    }
                } else if (magnify instanceof String) {
                    g.setColor(C(0));
                    final String s=(String) magnify;
                    final int font=maxi(h-a, 2);
                    final Font f=getFnt(font,true,Font.BOLD);
                    g.setFont(f);
                    final Rectangle cb=charBounds(f);
                    final int x=(w-strgWidth(f,s))/2;
                    final int y=(h-cb.height)/2;
                    g.drawString(s,x, y+charA(f)-4);

                }
            }
            drawTopAndButtomText(this,g);
            if (gcp(IC_CURSOR16,this)!=null)  ChIcon.drawCursor(g,64,8,16,16,this);
            if (0!=(opt&CROSSING_OUT)) {
                g.setColor(C(0xFF0000));
                g.drawLine(0,0,w,h);
                g.drawLine(0,h,w,0);
            }
        }
        paintHooks(this, g, true);
    }

    public static void drawTopAndButtomText(final JComponent c,final Graphics g) {
        final Color color=c.isEnabled() ? c.getForeground() : C(0x808080);
        final int h=c.getHeight();
        final Rectangle cb=charBounds(c.getFont());

        for(int i=0;i<2;i++) {
            final String s=toStrg(gcpa(i==0?TOP_TEXT:BOTTOM_TEXT,c));
            if (s==null) continue;
            final int y=  c instanceof JSlider ? h+2-cb.height : i==0 ? 4 : h-1-cb.height;
            final int x=2-cb.x+2;
            if (c.isEnabled() && (!(c instanceof ChButton) || !((ChButton)c).s())) {
                g.setColor(C(0xFFffFF,160));
                g.fillRoundRect(x-2,y-2,  4+strgWidth(g,s)   , 4+cb.height,8,8);
            }
            g.setColor(color);
            g.drawString(s,x,y+cb.y);
        }
    }

    public ChButton magnifyUnderMouse(String icon ) {
        final ImageIcon i=iicon(icon);
        cp("MAGNIFY",i!=null ? i : icon);
        i(IC_BLANK);
        options(ICON_SIZE|NO_FILL|NO_BORDER);
        return this;
    }
    /* ---------------------------------------- */
    /* >>> Icon >>> */
    private Object oIcon;
    public final ChButton i(Object iconOrString) {
        final Object o=iconOrString;
        this.oIcon=o;
        setIcon(o instanceof String || o instanceof String[] && get(0,o) instanceof String ? iicon(IC_BLANK) : deref(o,Icon.class));
        final ChButton[] bb=derefArray(gcp(KEY_CLONES,this), ChButton.class);
        if (bb!=null) for(ChButton b: bb) b.i(o);
        return this;
    }
    static Object mkIcon(final Object object, final JComponent c) {
        Object o=object, oo[]=o instanceof Object[] ? (Object[])o:null;
        if (oo!=null) {
            if (oo[0] instanceof String) oo[0]=iicon((String)oo[0]);
            if (oo[1] instanceof String) oo[1]=iicon((String)oo[1]);
        }
        if (o instanceof String) o=iicon((String)o);
        if (!isSelctd(buttn(TOG_ICONS_IN_MENUS)) || o==ERROR_STRING) return null;
        if (o==null) o=ERROR_STRING;
        Icon ic=deref(oo!=null ? oo[isSelctd(c)?1:0] : o,Icon.class);

        if (ic!=null) {
            if (vMaliciousIcons.contains(ic)) ic=null;
            if (ic!=getIcn(c)) {
                if (c instanceof AbstractButton) ((AbstractButton)c).setIcon(ic);
                if (c instanceof JLabel) ((JLabel)c).setIcon(ic);
            }
        }
        return o;
    }

    /* <<< Icon <<< */
    /* ---------------------------------------- */
    /* >>> Label Text >>> */
    public final ChButton t(CharSequence t) {
        if (!isEDT()) {
            ChDelay.invokeAndWait(this,"T",t);
        } else {
            if (t==GO) like(BUTTON_GO);
            else setText(t==null ? null : addHtmlTagsAsStrg(t));
        }
return this;
    }
    public void setText(String s) {
        super.setText(s);
        if (gcp(KOPT_ALREADY_PAINTED,this)!=null) assertEDT();
    }
    /* <<< Label Text <<< */
    /* ---------------------------------------- */
    /* >>> ToolTip >>> */
    @Override public String getToolTipText(MouseEvent ev) {
        final StringBuffer sbP=appendTooltips(this,ev,null);
        if (sbP!=null)  return sbP.toString();
        final StringBuffer sb=strBuf(SB_TIP);
        if (!super.isVisible()) return null;
        final ChButton cloned=gcp(KEY_CLONED_FROM,this, ChButton.class);
        if (cloned!=null) return cloned.getToolTipText();

        Object o=gcp(KEY_HELP_OBJECTS,this);
        if (o!=null) {
            if (gcp(KEY_HELP_SUFFIX,this)==Boolean.FALSE) sb.append("Source code of<br>");
            for(Object q :oo(o)) {
                if (q==null || q instanceof Boolean) continue;
                if (sze(sb)>0) sb.append("<br>");
                sb.append(clazzName(q));
            }
            if (sze(sb)>0) return addHtmlTagsAsStrg(sb);
        }

        if ((o=gcp(KEY_TOOLTIP,this))!=null) return addHtmlTagsAsStrg(toStrg(o));
        if ((o=gcp(KEY_SHARED_CTRL,this))!=null || (o=gcp(KEY_CUSTOMIZE,this))!=null) return "Settings for "+clazzName(o);
        if ((o=gcp(KEY_EXECUTE_CUST,this))!=null) return addHtmlTagsAsStrg(o+"<br>"+gcp(KEY_EXECUTE_ARG,this));
        return super.getToolTipText();
    }

    public final ChButton tt(Object tt) {
        if (tt==null) setToolTipText(null);
        else if (tt instanceof TooltipProvider) addTooltip((TooltipProvider)tt,this);
        else {
            CharSequence tip=addHtmlTagsAsStrg(tt instanceof CharSequence ? (CharSequence)tt : tt.toString());
            setToolTipText(toStrg(tip));
        }
        return this;
    }
    @Override public String toString() { return (isToggle() ? "ChToggle " :"ChButton ")+getText()+" / "+gcp(KEY_ACTION_COMMAND,this)+" "+isEnabled();}
    /* <<< Label Text <<< */
    /* ---------------------------------------- */
    /* >>> Appearance >>> */
    @Override public boolean isBorderPainted() { return UserProfile.isHidden(this) ?  false : super.isBorderPainted(); }
    public final ChButton fg(int rgb) {
        setFG(rgb, this);
        return this;
    }
    public final ChButton bg(int rgb) {
        setBG(rgb,this);
        return this;
    }

    @Override public boolean isContentAreaFilled() {
        return null==gcp(UserProfile.KEY_IGNORE,this) && UserProfile.isHidden(this) ? false : super.isContentAreaFilled();
    }

    public ChButton like(JComponent protoType) {
        if (protoType==null) return this;
        t(getTxt(protoType));
        setIcon(getIcn(protoType));
        setForeground(protoType.getForeground());

        setFont(protoType.getFont());
        tt(protoType.getToolTipText());

        for(Object key : new Object[]{TOP_TEXT,BOTTOM_TEXT, KEY_PREF_SIZE}) cp(key, gcp(key, protoType));

        setFont(protoType.getFont());
        if (protoType instanceof AbstractButton) {
            Icon i= ((AbstractButton)protoType).getSelectedIcon();
            if (i!=null) setSelectedIcon(i);
            if (((AbstractButton)protoType).isSelected()) s(true);
        }
        final ChButton b=deref(protoType,ChButton.class);
        if (b!=null) {
            oIcon=b.oIcon;
        }
        return this;
    }
    public ChButton tabItemTipIcon(Object c) {
        if (c!=null) cp(Class.class,c);
        return t(TabItemTipIcon.item(c)).tt(TabItemTipIcon.tip(c)).i(TabItemTipIcon.iconOrStrg(c));
    }
    public JComponent getRendererComponent() { return this;}
    /* <<< Appearance <<< */
    /* ---------------------------------------- */
    /* >>> Size >>> */
    @Override public Insets getMargin() { return UserProfile.isHidden(this) ? insets0(false) : super.getMargin();}
    @Override public Dimension getMinimumSize() { try { return super.getMinimumSize();} catch(Throwable e){return dim(32,32);}}
    @Override public Dimension getMaximumSize() { try { return super.getMaximumSize();} catch(Throwable e){return dim(32,32);}}

    public Dimension getPreferredSize() {
        Dimension ps=getPrefSize(this);
        if (ps==null) {
            final ChButton cloned=gcp(KEY_CLONED_FROM,this,ChButton.class);
            if (cloned!=null) ps=cloned.getPreferredSize();
        }
        if (ps==null && 0!=(options&SHOW_HIDE) && sze(getText())==0) ps=dim(ICON_HEIGHT,ICON_HEIGHT);
        try {  // NullPointer  at javax.swing.plaf.synth.SynthLookAndFeel.paintRegion(SynthLookAndFeel.java:352)
            if (ps==null) ps=super.getPreferredSize();
        } catch(Throwable e) { ps=dim(EM*10,EX); }
        final int h=this.height>0 ? this.height : oIcon instanceof String && sze(oIcon)>0 ? ICON_HEIGHT : -1;
        if (h>=0) ps=dim(ps.width,h);
        return ps;
    }
    public ChButton ps(Dimension d) {  return cp(KEY_PREF_SIZE,d);}
    public ChButton setHeight(int h) { this.height=h; return this;}
    public ChButton cp(Object key, Object value) { pcp(key,value,this); return this;}
    /* <<< Size <<< */
    /* ---------------------------------------- */
    /* >>> Event >>> */
    public ChButton li(ActionListener l) { addActLi(l,this);  return this;}

    @Override public void processEvent(AWTEvent ev) {
        if (!shouldProcessEvt(this,ev)) return;
        final int id=ev.getID();
        if (id==MOUSE_EXITED)  contains=false;repaint();
        if (id==MOUSE_MOVED && gcp("MAGNIFY",this)!=null) {
            setTipTiming(-1,0);
            mouseX=x(ev);
            mouseY=y(ev);
            contains=true;
            repaint();
        }
        try { super.processEvent(ev); } catch(Throwable ex) { stckTrc(ex);}
    }
    private long actionPerformedWhen;

    private final ChEventAdapter LI=new ChEventAdapter(this);
    public AWTEvent processEvent(JComponent c, AWTEvent ev) {
        final int modi=this.modifiers=modifiers(ev);
        final int id=ev.getID();
        final Object q=ev.getSource();
        if (id==ActionEvent.ACTION_PERFORMED) {
            if (q instanceof JCheckBoxMenuItem) {
                final AbstractButton cbMi=(AbstractButton)q;
                if (getUndockedButton(cbMi)!=null) return ev;
                if (_cbMi==null) {
                    _cbMi=new JCheckBox();
                    final JComponent pSouth=pnl(new ChButton("Ok").actionClose(CLOSE_PARENT_WINDOW));
                    pcp(KEY_SOUTH_PANEL,pSouth,_cbMi);
                    setDragMovesWindow(true, pSouth);
                    setDragMovesWindow(true, _cbMi);
                }
                _cbMi.setToolTipText(cbMi.getToolTipText());
                _cbMi.setText(getTxt(q));
                _cbMi.setModel(cbMi.getModel());
                final ChFrame f=ChFrame.frame("check-box", _cbMi, ChFrame.UNDECORATED|ChFrame.ALWAYS_ON_TOP).shw(ChFrame.PACK);
                final Point p=getMouseLctn();
                if (!f.getBounds().contains(p)) f.setLocation(p.x-EM, p.y-EX);
                return ev;
            }

            this.actionPerformedWhen=System.currentTimeMillis();
            final boolean isSel=s();
            if (propertyClass!=null && propertyId!=null) {
                setPrpty(propertyClass,propertyId, isSel);
            }
            modiCount++;
            if (gcp(KEY_EXECUTE_CUST,this)!=null) run(); else ChDelay.runAfterMS(EDT,this,9);

            CollapseComponent.doNotCollapseNow();
            contains=false;
            Object para=null;

            if ((para=gcp(DO_HIDE_PARENT_WINDOW,this))!=null) {
                try {
                    parentWndw(this).setVisible(false);
                } catch(Exception e) {}
            } else if ((para=gcp(KEY_detach_component,this))!=null) {
                final ChFrame frame=gcp(KEY_detach_frame, para,ChFrame.class);
                if (frame!=null) panelDock(para); else panelDetach(para, -1, -1, true);
            } else if ((para=gcp(VIEW_MSG,this))!=null) {
                final Object db=gcp(ACTION_DATABASE_CLICKED,this);
                if( para==MSG_SHOW_ALL_PREVIOUS) ChMsg.showAllPreviousMsgs();
                else if (para instanceof JPopupMenu) ((JPopupMenu)para).show(this,EM,EX);
                else {
                    Object m=para instanceof File ? readStrg((File)para) : para;
                    if (para instanceof String && equls(_CC,para) && nxt(SPC,para)<0 && strchr('/',para)>0) {
                        final String ss[]=((String)para).split("/");
                        if (ss.length==2) m=readBytes(rscAsStream(0L,ss[0],ss[1]));
                        else assertTrue(false);
                    }
                    if (m instanceof Map) {
                        final StringBuffer sb=new StringBuffer(999);
                        for(Map.Entry e : entryArry((Map)m)) if (e.getValue()!=null) sb.append(e).append('\n');
                        m=sb;
                    }
                    final Component jComp=getPnl(m);
                    if (jComp==null)  {
                        String s=toStrg(m);
                        ChTextViewer tv=gcp(s,this,ChTextViewer.class);
                        if (tv==null) cp(s,weakRef(tv=new ChTextViewer(addHtmlTags(s))));

                        if (db!=null) pcp(ACTION_DATABASE_CLICKED,db,tv);
                        tv.shw(ChFrame.AT_CLICK);
                    } else {
                        ChFrame.frame(gcps(FRAME_TITLE,this), jComp, CLOSE_ON_CtrlW|ChFrame.SIZE_REGARD_RESOLUTION)
                            .i(getIcon()).shw(ChFrame.AT_CLICK);
                        jComp.invalidate();
                        ChDelay.afterMS(EDT,ChDelay.VALIDATE,jComp,333,null);
                    }
                }
            } else if ((para=gcp(CLOSE,this))!=null) {
                final long moreOpt= para!=CLOSE_PARENT_WINDOW ? DISPOSE_CLOSE_WINDOW_ONLY : 0L;
                if (para==CLOSE_PARENT_WINDOW || para==DISPOSE_PARENT_WINDOW) para=parentWndw(this);
                dispos(atol(gcp(CLOSE_OPTION,this)) | moreOpt, para);
            }
            visitURL(gcp(KEY_OPEN_URL,this),modi);
        }
        return ev;
    }

    /* <<< Event <<< */
    /* ---------------------------------------- */
    /* >>> When pressed >>> */
    private Object run;
    public final ChButton r(Runnable r) { run=r; return this;};
    public final ChButton r(String r) { run=r; return this;};
    public void r(){
        final int modi=this.modifiers;
        final boolean ctrl=(modi&CTRL_MASK)!=0, shift=(modi&SHIFT_MASK)!=0;

        final Container ctrlPnl=getCtrlPanel(gcp(KEY_CTRL,this));
        if (ctrlPnl!=null){
            final String KEY="Frame for getControlPanel";

            ChFrame f=gcp(KEY,this,ChFrame.class);
            if (f==null) {
                final Dimension dim=ctrlPnl.getPreferredSize();
                final Container cont= child(ctrlPnl,JScrollPane.class)==null ? scrllpn(0L,ctrlPnl) : ctrlPnl;
                f=new ChFrame("Details").ad(cont).size(mini(800,dim.width)+40,mini(600,dim.height)+40);
                cp(KEY,weakRef(f));
            }
            setWndwState('F',f.shw(CLOSE_ON_CtrlW|ChFrame.AT_CLICK));
        }
        for(Customize c : Customize.cc(gcp(KEY_CUSTOMIZE,this))) Customize.addDialog(c);
        Object o=gcp(KEY_HELP_OBJECTS,this);
        if (o!=null) {
            final JRootPane rp=SwingUtilities.getRootPane(this);
            ChTabPane tp=gcp(KEY_ChTabPane,this,ChTabPane.class);
            if (rp!=null && rp.getParent() instanceof JDialog) tp=null;
            boolean success=false;
            for(Object q: oo(o)){
                q=deref(q);
                if (q==null || q instanceof Boolean) continue;
                final boolean isHelp=gcp(KEY_HELP_SUFFIX,this)==Boolean.TRUE;
                if (isHelp && ctrl) clearHelp();
                if (shift) edFile(-1, sourceFile(HotswapUtil.getClass(q)), 0);
                else success|=  isHelp ? showHelp(q) : showJavaSource(clazzName(q),(String[])null);
            }
            if (tp!=null && success) {
                pushDivider(tp,0.7);
                pushDivider(tp.getParent(),0.7);
            }
        }
        if ((o=gcp(KEY_DO_CLICK,this, AbstractButton.class))!=null) ((AbstractButton)o).doClick();
        if ((o=gcp(KEY_SHARED_CTRL,this))!=null) {
            final Container cp=getSharedCtrlPan(o,true);
            if (cp!=null) {
                final Dimension dim=cp.getPreferredSize();
                final ChFrame f=ChFrame.frame("Control Panel for "+shrtClasNam(o),cp,ChFrame.SCROLLPANE|ChFrame.AT_CLICK)
                    .size(mini(800,dim.width)+40,mini(600,dim.height)+40)
                    .shw(0);
                setWndwState('F',f);
            }
        }
        if ((o=gcp(KEY_PRINTABLE,this))!=null) {
            int i=0;
            for(Object c:oo(gcp(KEY_PRINTABLE_COMPONENTS, o))) {
                if (!(c instanceof JComponent)) continue;
                Object fn=gcp(KEY_IMAGE_FILE_NAME,c);
                if (fn==null) fn=String.valueOf(i++);
                final File f=file(STRAPOUT+"/images/"+fn+".png");
                pcp(KEY_IS_PRINTING,"",c);
                writePng((JComponent)c,f);
                pcp(KEY_IS_PRINTING,null,c);
                visitURL(f, modi);
            }
            new Thread(new ChExec(0).setCommandsAndArgument(getCustomSettings(Customize.fileBrowsers),file(STRAPOUT+"/images/").toString())).start();
        }
        if ((o=gcp(KEY_VIEW_FILE,this))!=null)  viewFile(file(o), modi);
        if ((o=gcp(KEY_EDIT_FILE,this))!=null)  edFile(-1, o, modi);
        if ((o=gcp(KEY_EXECUTE_CUST,this))!=null) {
            final Customize cust=(Customize)o;
            final ChExec ex=new ChExec(0);
            ex.setCommandsAndArgument(cust.getSettings(),gcp(KEY_EXECUTE_ARG,this));
            if (ctrl) ex.log(cust);
            new Thread(ex,"ChButton").start();
            if (cust==Customize.customize(Customize.fileBrowsers))
                ChMsg.savedMsg("<h2>Drag and Drop</h2>You can drag protein files from the native file browser or from the desktop<br>"+
                               "into the STRAP-application frame.","DnD");
        }
    }
    public final void run(){
        if (!handleEvt) return;
        assertEDT();
        r();
        if (run!=null) {
            Runnable r=run instanceof Runnable ? (Runnable) run: null;
            if (r==null) {
                try {
                    Class c= run instanceof Class ? (Class)run: Class.forName(run.toString());
                    r=(Runnable)c.newInstance();
                } catch(Exception ex){ stckTrc(ex);}
            }
            if (r!=null) r.run();
        }
        final String cmd=gcps(KEY_ACTION_COMMAND,this);
        handleActEvt(this, cmd!=null?cmd:getText(), this.modifiers);
        if (cmd=="SHOW_RSLT") ChMsg.getListOfResults(ChFrame.AT_CLICK);
        this.modifiers=0;
        {
            Window window=null;
            for(Object key : KEY_COLLAPSE) {
                final Object collapse=gcp(key, this);
                if (collapse!=null) {
                    for(JMenu jm : derefArray(collapse,JMenu.class)) {
                        final Dimension pfs=gcp(KEY_COLLAPSE,jm,Dimension.class);
                        if (pfs!=null) jm.setPreferredSize(s()? pfs : dim(0,0));
                    }

                    revalidateComponentsInArray(collapse,true);

                    if (window==null) window=gcp(KEY_pack,this,Window.class);
                    if (window==null && gcp(KEY_pack,this)!=null) window=parentWndw(this);
                }
                ChDelay.runAfterMS(EDT, threadM("pack",window, NO_OBJECT), 222);
            }
        }
        final String t=getText();
        if (t==" + " || t==" - ") {
            for(Object k : KEY_COLLAPSE) {
                if (gcpa(k,this)!=null) {
                    t(s() ? " - " : " + ");
                    break;
                }
            }
        }
    }
    private static void revalidateComponentsInArray(Object array_or_comp, boolean alsoParent) {
        final Object[]   oo=deref(array_or_comp, Object[].class);
        final JComponent  c=deref(array_or_comp, JComponent.class);
        if (oo!=null)  for(Object o : oo) revalidateComponentsInArray(o,alsoParent);
        if (c!=null) {
            c.revalidate();
            if (alsoParent) revalidateComponentsInArray(c.getParent(), false);
        }
    }
    /* <<< When pressed <<< */
    /* ---------------------------------------- */
    /* >>> Clone >>> */
    public final ChButton cln() {
        final char buttonType=this.type;
        final boolean isCB=buttonType=='C';
        final ChButton b=new ChButton(buttonType, isCB ? getText() : null).like(this)
            .cp(KEY_CLONED_FROM,this)
            .cp(UserProfile.KEY_IGNORE, gcp(UserProfile.KEY_IGNORE,this));
        b.setForeground(getForeground());

        if (buttonType==type) {
            b.cp(KEY_PREF_SIZE,gcp(KEY_PREF_SIZE,this));
            if (isCB) b.cp("MAGNIFY",gcp("MAGNIFY",this));
        }
        addRef(KEY_CLONES,weakRef(b),this);
        b.setModel(getModel());
        b.setToolTipText(getToolTipText());
        return b;
    }
    private static AbstractButton _cbMi;
    public final AbstractButton mi(String txt0) {
        final String txt=txt0!=null ? txt0 : getText();
        final AbstractButton mi;
        if (isToggle()) (mi=new JCheckBoxMenuItem(txt)).setModel(getModel());
        else {
            mi=new MItem(txt);
            if (oIcon==null) mi.setIcon(iicon(IC_BLANK));
            final KeyStroke ks=gcp(KEY_ACCELERATOR,this, KeyStroke.class);
            if (ks!=null && mi instanceof JMenuItem) ((JMenuItem)mi).setAccelerator(ks);
        }
        ChUtils.setUndockble(mi);
        LI.addTo("a",mi);
        pcp(Class.class,gcp(Class.class,this),mi);
        pcp(KEY_CLONED_FROM,this,mi);
        mi.setToolTipText(getToolTipText());
        pcp(KEY_MENU_ID,gcp(KEY_MENU_ID,this),mi);
        return mi;
    }
    public AbstractButton cb() {
        assertTrue(isToggle());
        return new ChJCheckBox(this);
    }
    public AbstractButton radio() {
        assertTrue(isToggle());
        final JRadioButton cb=new JRadioButton(getText());
        cb.setOpaque(false);
        cb.setModel(getModel());
        cb.setToolTipText(getToolTipText());
        pcp(KEY_CLONED_FROM,this,cb);
        return cb;
    }
    /* <<< Clone <<< */
    /* ---------------------------------------- */
    /* >>> Enabled >>> */
    /* Bugfix, it does not notice isEnabled(); */
    public final ChButton enabled(boolean b) {
        setEnabld(b,this);
        return this;
    }
    @Override public boolean isEnabled() {
        if (!Insecure.EXEC_ALLOWED && gcp(KEY_HIDE_IF_EXEC_FORBIDDEN,this)!=null) return false;
        final boolean superEnabled=super.isEnabled();
        boolean enabled=superEnabled;
        final ChButton cloned=gcp(KEY_CLONED_FROM,this,ChButton.class);

        Object o;
        if (null==gcp(UserProfile.KEY_IGNORE,this) && UserProfile.isHidden(this)) enabled=false;
        else if (cloned!=null) {
            enabled= cloned.isEnabled();
        }
        o=gcp(KEY_HELP_OBJECTS,this);
        if (get(0,o) instanceof java.net.URL) enabled=true;
        else if (o!=null) return helpIsEnabled(o);
        else if ( (o=gcp(KEY_SHARED_CTRL,this))!=null) enabled=hasSharedControlPanel(o);
        else if ( (o=gcp(KEY_CUSTOMIZE,this))!=null) enabled=Customize.cc(o).length>0;
        else if ( (o=gcp(KEY_VIEW_FILE,this))!=null) enabled=sze(file(o))>0;
        else if ( (o=gcp(KEY_ENABLED,this)) instanceof IsEnabled) enabled=((IsEnabled)o).isEnabled(this);
        else if ( (o=gcp(KEY_CTRL,this))!=null) enabled=getCtrlPanel(o)!=null;
        return enabled;
    }
    /* <<< Enabled <<< */
    /* ---------------------------------------- */
    /* >>> Specific Actions >>> */
    public ChButton actionDoClick(Object o) { return cp(KEY_DO_CLICK, o);}
    public ChButton actionClose(Object o) { return actionClose(o,0L);}
    public ChButton actionClose(Object o, long options) {
        if (sze(getText())==0) magnifyUnderMouse(IC_CLOSE).tt("Close");
        return cp(CLOSE,weakRef(o)).cp(CLOSE_OPTION,longObjct(options));
    }

    public static ChButton actionViewMessage(String title,Object msg) {
        ChButton b=new ChButton(title);
        if (msg==MSG_SHOW_ALL_PREVIOUS) {
            if (title==null) b.t(MSG_SHOW_ALL_PREVIOUS);
            b.i(IC_INFO);
        }
        return b.cp(FRAME_TITLE,title).cp(VIEW_MSG,msg);
    }
    public static ChButton actionOpenURL(Object o) {
        final String url;
        final String s;
        if (o instanceof File) {
            s=filepathUnixStyle(o);
            url=toStrg(url(o));
        } else {
            s=toStrg(o);
            url=Hyperrefs.toUrlString(s,Hyperrefs.WEB_LINK|Hyperrefs.PLAIN_TEXT|Hyperrefs.PROTEIN_FILE);
        }
        return new ChButton(s).i(IC_WWW).tt(url).cp(KEY_OPEN_URL,url);
    }
    public static ChButton actionHelp(Object o) {  return actionHelpOrJava(o,'H'); }
    static ChButton actionHelpOrJava(Object o,char HJ) {
        final ChButton b;
        if (o instanceof CharSequence && o.toString().indexOf(' ')>0)  b=ChButton.actionViewMessage("",addHtmlTagsAsStrg(o));
        else {
            b=new ChButton(null,HIDE_IF_DISABLED|PAINT_IF_ENABLED)
                .cp(KEY_HELP_SUFFIX, boolObjct(HJ=='H'))
                .cp(KEY_HELP_OBJECTS,oo(o))
                .cp(KEY_ChTabPane, HJ=='H' ? getHelpPanel() : getJavaPanel());
        }
        if (HJ=='J') UserProfile.set('e',b.i(IC_JAVA));
        rtt(b);
        return b;
    }

    private boolean helpIsEnabled(Object objects) {
        for(Object o:oo(objects)) {
            o=deref(o);
            if (o==null) continue;
            if (gcp(KEY_HELP_SUFFIX,this)==Boolean.TRUE ? hasHelp(o) : hasSource(o)) return true;
        }
        return false;
    }
    public static ChButton actionSharedCtrl(Object o) {
        final ChButton b=new ChButton().cp(KEY_SHARED_CTRL,weakRef(o));
        rtt(b);
        b.tt("Control panel").magnifyUnderMouse(IC_CONTROLPANEL);
        if (o instanceof ChCombo) UIupdateList.add(b,UIupdateList.COMBOBOX);
        return b;
    }
    public static ChButton actionCtrl(Object o) {
        boolean success=false;
        for(Class c : CLASS_MAY_HAVE_CTRL_PANEL) success=success ||  (o!=null && isInstncOf(c,o));
        return !success?null : new ChButton().t("Details").cp(KEY_CTRL,o);
    }

    public static ChButton actionShowResults() { return new ChButton("SHOW_RSLT");}

    public static ChButton actionCustomize(Object o) {
        if (!(o instanceof JComboBox || o instanceof JList || Customize.cc(o).length>0)) return null;
        final ChButton b=new ChButton(null,ChButton.NOT_OPAQUE|ChButton.ICON_SIZE);
        rtt(b);
        return b.i(IC_CUSTOM).cp(KEY_CUSTOMIZE,weakRef(o));
    }
    public ChButton actionViewFile(File f) { return cp(KEY_VIEW_FILE,f); }
    public ChButton actionEditFile(Object file) {
        if (!Insecure.EXEC_ALLOWED) cp(KEY_HIDE_IF_EXEC_FORBIDDEN,"");
        return cp(KEY_EDIT_FILE,file instanceof CharSequence ? file((CharSequence)file) : file);
    }
    public static ChButton actionPrint(Object o) {
        return new ChButton().magnifyUnderMouse(IC_CAMERA)
            .tt("An image file is written to <pre>"+file(dirTmp()+"/images")+"</pre>and opened in the Web-browser."+
                "<br>In the browser it can be printed.<br>CTRL key: use light background")
            .cp(KEY_PRINTABLE,weakRef(o));
    }
    public ChButton actionExecuteProgram(Customize cust,Object arg) {
        rtt(this);
        return cp(KEY_EXECUTE_ARG,arg).cp(KEY_EXECUTE_CUST,cust);
    }
    public ChButton actionFileBrowser(Object oFile) {
        Object arg= oFile instanceof File ? ((File)oFile).getAbsolutePath() : oFile;
        t("Open directory in "+systProprty(SYSP_NAME_FILE_BROWSER));
        i(systProprty(SYSP_ICON_FILE_BROWSER));
        actionExecuteProgram(Customize.customize(Customize.fileBrowsers),arg);
        if (!Insecure.EXEC_ALLOWED) cp(KEY_HIDE_IF_EXEC_FORBIDDEN,"");
        return this;
    }
    public ChButton actionCollapse(boolean b, Object toolbar) {
        assertTrue(isToggle());
        if (sze(getText())==0) t(" + ").options(ChButton.MAC_TYPE_ICON);
        cp(KEY_COLLAPSE[b?0:1],toolbar);
        pcpTargetArray(KEY_TOGGLE_COLLAPSE[b?1:0], weakRef(this),toolbar);

        for(JMenu jm : derefArray(toolbar,JMenu.class)) {
            if (jm instanceof ChJMenu) continue;
            pcp(KEY_COLLAPSE, jm.getPreferredSize(),jm);
            jm.setPreferredSize(dim(0,0));
        }
        //if (isMacintosh()) options|=MAC_TYPE_ICON;

        return this;
    }

    private static void pcpTargetArray(Object key, Object value, Object target) {
        if (target instanceof Object[]) {
            for(Object t : (Object[])target) pcpTargetArray(key,value, t);
        } else pcp(key,value,target);
    }

    public ChButton actionPack() { return actionPack(null);}
    public ChButton actionPack(Window w) {
        assertTrue(isToggle());
        return cp(KEY_pack,w!=null?w:"");
    }
    /* <<< Specific Actions <<< */

    /* ---------------------------------------- */
    /* >>> ChToggle >>> */
    public int getModificationCount() { return modiCount;}
    // public String getUIClassID() { return type=='T'? "ToggleButtonUI" : type=='C' ? "CheckBoxUI" :  "ButtonUI"; }

    public boolean isToggle() { return type=='T'; }
    public final ChButton s(boolean isSelected) { handleEvt=false; setSelected(isSelected); handleEvt=true;  return this;}
    public boolean s() {return isSelected();}
    private Class propertyClass;
    private String propertyId;
    public ChButton save(Class propertyClass,String id_str) {
        id_str=id_str.intern();
        this.propertyClass=propertyClass; this.propertyId=id_str;
        s(getPrpty(propertyClass,propertyId,s()));
        return this;
    }
    /* <<< ChToggle <<< */
    /* ---------------------------------------- */
    /* >>> Threading >>> */
    public Object run(String id, Object arg) {
        if (id=="T") t((CharSequence)arg);
        if (id=="DOCLICK" && System.currentTimeMillis()-actionPerformedWhen>500) ((AbstractButton)arg).doClick();
        if (id==ChRunnable.SET_ICON_IMAGE) {
            Image im=(Image)arg;
            if (im!=null) {
                final long options=atol(gcp(KEY_REQUEST_IMAGE_OPTIONS,this));
                final int maxWidth=atoi(gcp(KEY_REQUEST_IMAGE_MAX_WIDTH,this));
                final int w=im.getWidth(this), h=im.getHeight(this);
                if (maxWidth>0 && w>maxWidth) {
                    im=ChIcon.getScaledInstance(im, maxWidth, h*maxWidth/w,null, C(0xFFffFF));
                }
                if (0!=(options&REQUEST_IMAGE_REMOVE_TEXT)) setText(null);
                if (0!=(options&REQUEST_IMAGE_PACK)) packW(this);
            }
            setIcon(im!=null ? new ImageIcon(im) : null);
        }
        return null;
    }

    class MItem extends JMenuItem {
        public MItem(String s) {
            super(s);
        }
        public void setBackground(Color bg) {}
        @Override public Dimension getPreferredSize() {
            return
                !ChButton.this.isEnabled() && null!=gcp(KOPT_HIDE_IF_DISABLED,ChButton.this) || UserProfile.isHidden(ChButton.this) ? dim(0,0):
                super.getPreferredSize();
        }
        @Override public boolean isEnabled() { return ChButton.this.isEnabled(); }
        @Override public void paintComponent(Graphics g) {
            setFG(0,this);
            ChButton.this.oIcon=ChButton.mkIcon(ChButton.this.oIcon, ChButton.this);
            if (g==null || UserProfile.isHidden(this) || UserProfile.isHidden(ChButton.this)  ) return;
            Color fg=!isEnabled() ? C(0x808080) : gcp(KEY_FOREGROUND,ChButton.this, Color.class);
            if (fg!=null) setForeground(fg);
            g.setColor(fg!=null?fg:C(0)); /* Bugfix Java 1.5 */
            try {
                super.paintComponent(g);
            } catch(Throwable ex){ vMaliciousIcons.add(getIcon()); }
            ChRenderer.drawSmallButtons(this,g);
        }
        @Override public Icon getIcon() {
            Icon c=super.getIcon();
            if (c==null) c=ChButton.this.getIcon();
            if (c==null) c=iicon(IC_BLANK);
            return c;
        }
        { enableEvents(ACTION_EVENT_MASK|MOUSE_EVENT_MASK); }
        @Override public void processEvent(AWTEvent ev) {
            if (shouldProcessEvt(this,ev)) {
                for(AWTEvent ev2 : ChJMenu.lockSubmenuOnClick(ev, this)) {
                    if (ev2!=null) super.processEvent(ev2);
                }
            }
        }
    }
}

/*
  javax.swing.plaf.synth.SynthButtonUI
*/
