package charite.christo;
import java.io.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**HELP

*/
public class ChCompilerJavacPROXY extends AbstractProxy {
    @Override public String getRequiredJars() {
      final int v=javaVsn();
      return "tools_"+maxi(14,v)+".jar"+(v==14?"":".pack.gz");
    }

    public boolean compile(File[] classpath, File sourceFile) {
        final File classFile=file(delSfx(".java",sourceFile)+".class");
        final long ageClassFile=classFile!=null ? classFile.lastModified() : 0L;
        final String[] options=derefArray(new Object[]{"-classpath", joinAsStrg(classpath, systProprty(SYSP_PATH_SEP)), toStrg(sourceFile)}, String.class);
        final ByteArrayOutputStream baos=new ByteArrayOutputStream();
        putln("proxyObject = ",proxyObject());
        proxyObjectRun(ChCompilerJavac.RUN_COMPILE, new Object[]{options, new PrintWriter(baos)});
        final boolean success= classFile!=null && classFile.lastModified()>ageClassFile;
        log(ANSI_YELLOW+"Compiler options="+ANSI_RESET,joinAsStrg(options,"   "),"\n", baos.toString().replace('\t',' '));
        if (!success) log(" "+ANSI_RED+"failed"+ANSI_RESET+"\n\n");
        else log(" "+ANSI_GREEN+"Success: "+ANSI_RESET+classFile+" "+classFile.length()+" bytes\n\n");
        revalAndRepaintC(_log);
        return success;
    }

    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> Log  >>> */
    private static AsciiView _log;
    public static AsciiView log(String... oo) {
        if (isGraphicsAvailable()) {
            if (_log==null) _log=new AsciiView(9999);
            _log.appendSS(oo);
        }
        return _log;
    }
}

