package charite.christo;
import java.awt.event.*;
import charite.christo.interfaces.*;
import javax.swing.JComponent;
import javax.swing.event.*;
import java.awt.*;
import javax.swing.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
public class ChEventAdapter implements MouseListener, MouseWheelListener, MouseMotionListener, ActionListener, FocusListener, KeyListener, ComponentListener,
                            ChangeListener, ListSelectionListener, ItemListener {
    private final Object _pe;
    public ChEventAdapter(ChProcessEvent processEvent) { _pe=weakRef(processEvent);}
    private void pe(AWTEvent ev) {
        final ChProcessEvent pe=deref(_pe, ChProcessEvent.class);
        if (_pe!=null && ev!=null) {
            try {
                Object o=ev.getSource();
                pe.processEvent( o instanceof JComponent ? ((JComponent)o) : null,ev);
            } catch(Throwable exception) { stckTrc(exception);}
        }
    }

    public void mouseExited(MouseEvent ev) {pe(ev);}
    public void mouseEntered(MouseEvent ev) {pe(ev);}
    public void mouseReleased(MouseEvent ev) {pe(ev);}
    public void mouseClicked(MouseEvent ev) {pe(ev);}
    public void mousePressed(MouseEvent ev) { pe(ev); }
    public void mouseDragged(MouseEvent ev) {pe(ev);}
    public void mouseMoved(MouseEvent ev) {pe(ev);}
    public void actionPerformed(ActionEvent ev) {pe(ev);}
    public void mouseWheelMoved(MouseWheelEvent ev) {pe(ev);}
    public void focusGained(FocusEvent ev) {pe(ev);}
    public void focusLost(FocusEvent ev) {pe(ev);}
    public void keyPressed(KeyEvent ev) { pe(ev);}
    public void keyReleased(KeyEvent ev) {pe(ev);}
    public void keyTyped(KeyEvent ev) {pe(ev);}

    public void componentResized(ComponentEvent ev) {pe(ev);}
    public void componentMoved(ComponentEvent ev) {pe(ev);}
    public void componentShown(ComponentEvent ev) {pe(ev);}
    public void componentHidden(ComponentEvent ev) {pe(ev);}

    public void stateChanged(ChangeEvent ev) {

        pe( new ActionEvent( ev.getSource(), ActionEvent.ACTION_PERFORMED, ACTION_CHANGE_EVENT, System.currentTimeMillis(), 0));
    }
    public void valueChanged(ListSelectionEvent ev) {
        pe( new ActionEvent( ev.getSource(), ActionEvent.ACTION_PERFORMED, ACTION_SELECTION_CHANGED, System.currentTimeMillis(), 0));
    }

    @Override public void itemStateChanged(ItemEvent ev) {
        pe( new ActionEvent( ev.getSource(), ActionEvent.ACTION_PERFORMED, ACTION_SELECTION_CHANGED, System.currentTimeMillis(), 0));
    }
    private static String[] ADD, REMOVE;
    private final Object this1[]={this};
    public void addTo(String types, Object p) {
        if (p==null) return;
        if (ADD==null) {
            ADD=new String['z'+1];
            REMOVE=new String['z'+1];
            for(int c='A'; c<='z';c++) {
                final Class clazz=
                    c=='M' ? MouseMotionListener.class :
                    c=='C' ? ChangeListener.class :
                    c=='a' ? ActionListener.class :
                    c=='c' ? ComponentListener.class :
                    c=='f' ? FocusListener.class :
                    c=='i' ? ItemListener.class :
                    c=='k' ? KeyListener.class :
                    c=='m' ? MouseListener.class :
                    c=='s' ? ListSelectionListener.class :
                    c=='w' ? MouseWheelListener.class :
                    null;
                if (clazz==null) continue;
                final String cn=ChUtils.shrtClasNam(clazz);
                ADD[c]="add"+cn;
                REMOVE[c]="remove"+cn;
            }
        }
        for(int i=sze(types); --i>=0; ) {
            final int c=types.charAt(i);
            if (c==' ') continue;
            if (ADD[c]==null) {
                putln(types);
                assertTrue(false);
                continue;
            }
            final long opt=INVOKE_MTHD_PRINT_EXCEPTIONS|INVOKE_MTHD_ASSERT_EXISTS;
            final AbstractButton b= p instanceof AbstractButton ? (AbstractButton)p : null;
            final Component comp= p instanceof Component ? (Component)p : null;
            if (b!=null && c=='a') {
                b.removeActionListener(this);
                b.addActionListener(this);
            } else if (comp!=null && c=='m') {
                comp.removeMouseListener(this);
                comp.addMouseListener(this);
            } else if (comp!=null && c=='M') {
                comp.removeMouseMotionListener(this);
                comp.addMouseMotionListener(this);
            } else if (comp!=null && c=='k') {
                comp.removeKeyListener(this);
                comp.addKeyListener(this);
            } else {
                invokeMthd(opt, REMOVE[c], p, this1);
                invokeMthd(opt, ADD[c], p, this1);
            }
        }
    }
}
// java.util.EventListenerProxy