package charite.christo;
import java.io.*;
import javax.swing.JComponent;
import java.util.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**
     @author Christoph Gille
*/
public final class ChExecSecurity {

    private final static Set<String> vAllow=new HashSet();
    public final static Set<String> vDeny=new HashSet();

    public static Process runtimeExecS(String arg[], String[] env, File dir) throws IOException{
        if (checkPermission(arg, env, dir))  return Runtime.getRuntime().exec(arg, env,dir);
        return null;
    }

    public static boolean checkPermission(String arg[], String[] env, File dir) {

        final String a0=get(0,arg), a1=get(1,arg), a2=get(2,arg);
        final boolean cmdExe="cmd.exe".equalsIgnoreCase(a0) && "/c".equalsIgnoreCase(a1);
        final String prgName=
            cmdExe && "start".equals(a2) ? a0+" "+a1+" "+a2+" "+wordAt(0,get(3,arg)) :
            cmdExe || 0<=strstr(STRSTR_w_R, "sh", a0) && "-c".equals(a1) ? a0+" "+a1+" "+wordAt(0,a2)  :
            a0;

        if (!Insecure.EXEC_ALLOWED || a0==null) return false;

        if (vDeny.contains(prgName)) {
            return false;
        }

        synchronized(prgName.intern()) {
            final ChButton tog=buttn(TOG_ALLOW_EXEC);
            if (!isSelctd(tog) && !vAllow.contains(prgName)) {

                final Object msg=vBhB(
                                      "Strap wants to start the external program ",
                                      "Do you allow starting this program?",
                                      prgName,
                                      "Details:",
                                      scrllpn(0L,monospc(describeExec(arg,env,dir,null)),dim(80*EM,6*EX)),
                                      tog.cb(),
                                      "Also see the menu \"Security\" in the \"Preferences\" menu.");

                    if (!ChMsg.yesNo(tog, ChFrame.CENTER|ChFrame.PACK, msg)) {
                        vDeny.add(prgName);
                        return false;
                    }
                    vAllow.add(prgName);
                    if (isSelctd(tog)) {
                        String info=
                            "<u>Security:</u> <br>"+
                            "In the menu \"Preferences\", sub-menu \"Security\", the toggle <pre>  \""+
                            tog.getText()+"\"</pre> can be released.";
                        ChMsg.savedMsg(info, "togAllowExec");
                    }
                }
        }
        return true;
    }

    public static String describeExec(String argv[], String[] env, File dir, StringBuffer sb0) {
        final StringBuffer sb=sb0!=null?sb0:new StringBuffer(999);
        appendQuoted(toStrg(dir), sb.append(" cd ")).append('\n');
        if (isWindows()) appendQuoted(Microsoft.toCygwinPath(dir),sb.append(" cd ")).append('\n');
        for(int i=0; i<sze(env);i++) {
            final String e=env[i];
            final int eq=strchr('=',e);
            if (eq<0) continue;
            if (isWindows()) {
                sb.append(isWindows()?" set=":" export=").append(e.substring(0,eq));
                appendQuoted(e.substring(eq+1),sb.append('=')).append('\n');
            }
        }
        for(String a:argv) appendQuoted(a,sb).append("   ");
        sb.append('\n');
        return sb.toString();
    }

}