package charite.christo;
import static charite.christo.ChUtils.*;
import charite.christo.interfaces.*;
import java.io.*;
import java.util.*;

public class ChFileFilter extends javax.swing.filechooser.FileFilter implements FileFilter {
    private List<String> vExt;
    public void acceptSuffix(boolean ignCase, String...suffix) {
        if (vExt==null) vExt=new ArrayList();
        for(String s0:suffix) {
            for(int i=3; --i>=0;) {
                if (i>0 && !ignCase) continue;
                final String s=i==1?s0.toUpperCase():i==2?s0.toLowerCase() : s0;
                adUniq(s,vExt);
            }
        }
    }
    public ChFileFilter setRules(String rules) { this.rules=rules; return this;}
    private String rules;
    @Override public boolean accept(File f) {
        if (f==null) return false;
        final boolean isD=f.isDirectory();
        if (isD) return true;
        final String n=f.getName(), r=this.rules;
        for(int i=r!=null?r.length() : 0; --i>=0;) {
            switch(r.charAt(i)) {
            case 'D':
                if (!isD) return false;
                break;
            case '.':
                if (n.startsWith(".")) return false;
                break;
            }
        }
        if (vExt!=null) {
            for(int i=vExt.size();--i>=0;)
                if (n.endsWith(vExt.get(i))) return true;
            return false;
        }
        return true;
    }
    @Override public String getDescription() {
        final StringBuffer sb=strBuf(SB_TIP).append("ChFileFilter ");
        if (vExt!=null) sb.append(vExt).append(' ');
        if (rules!=null) sb.append(rules);
        return sb.toString();
    }
}
