package charite.christo;
import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.util.List;
import java.awt.event.*;
import static java.awt.event.WindowEvent.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**
   @author Christoph Gille
   addComponentListener addContainerListener
*/
public class ChFrame extends JFrame {
    public final static long
    SCROLLPANE=1<<10, ALWAYS_ON_TOP=1<<11, TO_FRONT=1<<12,
        AT_CLICK_R=1<<13, CENTER=1<<14, AT_CLICK=1<<15, STAGGER=1<<16, TO_ICON=1<<17,
        CLEAR_BUTTON=1<<18, PACK=1<<19,     DISPOSE_CHILDREN=1<<20, SYSTEM_EXIT_WHEN_ALL_CLOSED=1<<21,
        ICONIFY_ON_CLOSE=1<<22, DISPOSE_ON_CLOSE=1<<23,  SHUT_DOWN_ON_CLOSE=1<<24, SIZE_REGARD_RESOLUTION=1<<25,
      SHOW_IF_NOT_ICONIFIED=1L<<30, SHOW_IF_VISIBLE=1L<<31, UNDECORATED=1L<<32;
    static { assert RM_TAB_ON_CtrlW<SCROLLPANE; }
    private static List vFrames;
    /* ---------------------------------------- */
    /* >>> Constructor >>> */
    @Override protected void finalize() throws Throwable{ logFinalize(ANSI_CYAN+"ChFrame",""); super.finalize(); }
    {  assertInstAllowed(); }
    public ChFrame(String title) {
        t(title);
        if (!imageIconCausesException)  { ImageIcon ic=iicon(IC_STRAP); if (ic!=null) setIconImage(ic.getImage()); }
        size(366,366);
        try {
            ((JComponent)getContentPane()).revalidate();
            validate();
        } catch(Exception e){}
        (vFrames==null ? vFrames=new ArrayList() : vFrames).add(weakRef(this));
    }
    public final ChFrame t(String s) { setTitle(rplcToStrg("<br>"," ",s)); return this;}
    /* <<< Constructor <<< */
    /* ---------------------------------------- */
    /* >>> Main Frame>>> */
    private static Object refLastFrame, refMainFrame;
    public static ChFrame getMainFrame() { return deref(refMainFrame,ChFrame.class);}
    public static void setMainFrame(ChFrame f) { refMainFrame=weakRef(f);}
    private final long[] durationValidate=new long[ARRAY_DURATION];
    public final ChFrame ad(Object obj) {
        final Component c=getPnl(obj);
        if (c instanceof Container) setContentPane((Container)c);
        else  if (c!=null) getContentPane().add(c);
        ChDelay.afterMS(0,ChDelay.VALIDATE,this,333,null,durationValidate);
        shiftTooltip(getContentPane());
        shiftTooltip(this);
        requestFocus();
        return this;
    }
    /* <<< ad <<< */
    /* ---------------------------------------- */
    /* >>> Icon  >>> */
    public final ChFrame i(String icon) { return i(iicon(icon));}
    public final ChFrame i(Icon ic) {
        if (ic instanceof ImageIcon) {
            Image im=((ImageIcon)ic).getImage();
            if (im!=null && !imageIconCausesException)  setIconImage(im);
        }
        return this;
    }
    private boolean imageIconCausesException;
    @Override public void show() {
        try { super.show(); } catch(Exception e) {
            setIconImage(null);
            imageIconCausesException=true;
            super.show();
        }
    }
    /* <<< Icon <<< */
    /* ---------------------------------------- */
    /* >>> Show  >>> */
    @Override public void setVisible(boolean b) {
        try { super.setVisible(b); } catch(Exception e) {
            setIconImage(null);
            super.setVisible(b);
            imageIconCausesException=true;
        }
    }
    private boolean alreadyShown;
    public final Thread thread_shw(long options) { return threadM("shw",this,new Object[]{longObjct(options)}); }
    public final ChFrame shw(long options) {
        if (!isEDT()) {
            inEDT(thread_shw(options));
            return this;
        }
        this.options=options;
        if ( (options&SHOW_IF_NOT_ICONIFIED)!=0 && getExtendedState()==JFrame.ICONIFIED) return this;
        if ( (options&SHOW_IF_VISIBLE)!=0 && !isVisible()) return this;
        boolean alwaysOnTop=false;
        if (javaVsn()>14) { alwaysOnTop=isAlwaysOnTop(); setAlwaysOnTop(true);}
        alreadyShown=true;
        setVisible(true);
        setExtendedState(NORMAL);
        setVisible(true);
        refLastFrame=weakRef(this);
        final String title=getTitle();
        if (sze(title)>0 && (options&TO_FRONT)!=0) {
            setWndwStateLaterT('F', 999, title);
            final Thread t=thread_setWndwState('F',this);
            t.run();
            runAftrMS(333,t);
        }
        setAOT(alwaysOnTop,this);
        applyOptions(options, deref(refJC,JComponent.class));
        try {
            final Rectangle screen=getGraphicsConfiguration().getBounds();
            final Point l=getLocation();
            final int y=screen.y+screen.height-getHeight();
            final int x=screen.x+screen.width-getWidth();
            if (l.y>y || l.x>x)  setLocation(l.x>x ? x:l.x, l.y>y ? y : l.y);
        } catch(Exception e){}
        return this;
    }
    /* <<< Show <<< */
    /* ---------------------------------------- */
    /* >>> Dispose >>> */
    private boolean isDisposed;
    public boolean isDisposed() { return isDisposed;}
    @Override public void dispose() {
        if ( (options&DISPOSE_CHILDREN)!=0) {
            final Component c=getContentPane();
            disposeChildren(c);
            rmAllChilds(c);
            rmFromParent(c);
            dispos(0L, c);
        }
        super.dispose();
        isDisposed=true;
        if ( ((globalOptions|options)&SYSTEM_EXIT_WHEN_ALL_CLOSED)!=0) {
            for(int i=sze(vFrames); --i>=0;) {
                final ChFrame f=get(i,vFrames,ChFrame.class);
                if (f==null || f.isDisposed) vFrames.remove(i);
            }
            if (sze(vFrames)==0) shutDown();
        }
        for(Map.Entry<Object,ChFrame> e :  entryArry(mapContentFrame)) {
            if (e.getValue()==this) mapContentFrame.remove(e.getKey());
        }
    }
    private final static Map<Object,ChFrame> mapContentFrame=new WeakHashMap();
    private Object refJC;
    /* <<< Dispose <<< */
    /* ---------------------------------------- */
    /* >>> Options >>> */
    private long options;
    private static long globalOptions;
    public static void setGlobalOptions(long options) { globalOptions=options;}
    public long getOptions() { return options;}
    public static ChFrame frame(String title,  Object object,  long options) {
        final Object o=gcp(KEY_PANEL,object)!=null ? gcp(KEY_PANEL,object) : object;
        ChFrame f=mapContentFrame.get(o);
        if (f==null || f.isDisposed()) {
            final ChTextComponents tools=ChTextComponents.tools(o);
            final JComponent jc=o instanceof JComponent ?(JComponent)o : null;
            final OverlayScrollPane osp=tools!=null ? OverlayScrollPane.getSP(jc) : null;
            if (osp!=null && (options&CLEAR_BUTTON)!=0) osp.addButton(tools.newClearButton());
            final Object cont= osp!=null ? osp :
                jc!=null && (options&SCROLLPANE)>0 && child(jc,JScrollPane.class)==null ? scrllpn(0L,jc) : o,
                pNorth=gcp(KEY_NORTH_PANEL,o),
                pSouth=gcp(KEY_SOUTH_PANEL,o);
            f=new ChFrame(title);
            f.ad(pNorth!=null||pSouth!=null?newCNSEW(cont,pNorth,pSouth,null,null) :cont);
            f.refJC=weakRef(jc);
            f.applyOptions(options, jc);
            mapContentFrame.put(o,f);
            f.options=options;
        }
        return f;
    }
    private void applyOptions(long options, JComponent jc) {
        if (0!=(options&UNDECORATED)) setUndecorated(true);
        if ((options&AT_CLICK)!=0) setLocationAtMouse(this);
        if ((options&CENTER)!=0) setLocationRelativeTo(getMainFrame());
        final long closeOptions=options& (CLOSE_ON_CtrlW|DISPOSE_ON_CtrlW|CLOSE_ON_ESC|DISPOSE_ON_ESC);
        for(int j=2; closeOptions!=0 && --j>=0;) {
            for(JComponent  c: childs(getContentPane(), j==0 ? AsciiView.class: javax.swing.text.JTextComponent.class)) {
                disposeOnCtrlW(closeOptions, c,this);
            }
        }
        if ((options&PACK)!=0) pack();
        if ((options&ALWAYS_ON_TOP)!=0) setAOT(true,this);
        if ((options&STAGGER)!=0 && !alreadyShown) {
            final ChFrame lastFrame=deref(refLastFrame,ChFrame.class);
            final Point loc=lastFrame!=null ? lastFrame.getLocation() :  new Point(50,50);
            setLocation(loc.x+20,loc.y+20);
        }
        if ((options&TO_ICON)!=0) setExtendedState(ICONIFIED);
        if ((options&SIZE_REGARD_RESOLUTION)!=0) setSizeAccordingTo(jc, 0,0);
    }
    /* <<< Options <<< */
    /* ---------------------------------------- */
    /* >>> Size and Location  >>> */
    public final ChFrame size(int w,int h) { setSize(maxi(1,w),maxi(1,h)); return this;}
    public final ChFrame relativeSize(double x,double y) {
        final Rectangle screen=getGraphicsConfiguration().getBounds();
        size(maxi(640,(int)(screen.width*x)),maxi(400,(int)(screen.height*y)));
        return this;
    }
    public static void setLocationAtMouse(Window win) {
        if (win==null) return;
        final Point p=getMouseLctn();
        if (p!=null) setLocationFit(p.x,p.y, win);
    }

    public static void setLocationFit(int x0, int y0, Window win) {
        if (win==null || !isGraphicsAvailable()) return;
        final Rectangle screen=win.getGraphicsConfiguration().getBounds();
        final int w=win.getWidth(), h=win.getHeight();
        int x=maxi(0, mini(x0, screen.x+screen.width-w));
        int y=maxi(0, mini(y0, screen.y+screen.height-h));
        win.setLocation(x,y);

    }
    public void setSizeAccordingTo(JComponent jc, int extraW, int extraH) {
        final Dimension d=jc!=null ? jc.getPreferredSize() : null;
        final Rectangle screen=getGraphicsConfiguration().getBounds();
        if (screen!=null && d!=null) {
            final Point p=getLocation();
            final int w=mini(screen.width -4*EM-p.x, d.width +extraW+4*EM);
            final int h=mini(screen.height-4*EX-p.y, d.height+extraH+4*EX);
            size(w, h);
        }
    }
    /* <<< Size and Location <<< */
    /* ---------------------------------------- */
    /* >>> AWTEvent  >>> */
    @Override public void processWindowEvent(WindowEvent e) {
        final int id=e.getID();
        String evt=null;
        if (id==WINDOW_DEACTIVATED) evt=ACTION_WINDOW_DEACTIVATED;
        if (id==WINDOW_ACTIVATED && javaVsn()>14) {
            evt=ACTION_WINDOW_ACTIVATED;
        }
        if (id==WINDOW_CLOSING) {
            setVisible(false);
            if ( (this.options& (DISPOSE_ON_CLOSE|DISPOSE_CHILDREN))!=0)  this.dispose();
            if ( (this.options&SHUT_DOWN_ON_CLOSE)!=0)  shutDown();
            evt=ACTION_WINDOW_CLOSING;
            if ( (options&ICONIFY_ON_CLOSE)!=0) { show();  setExtendedState(ICONIFIED); }
        }  else super.processWindowEvent(e);
        if (evt!=null) handleActEvt(this,evt,0);
    }
    /* <<< AWTEvent <<< */
    /* ---------------------------------------- */
    /* >>> setAlwaysOnTop >>> */
    private static ChFrame _inst;
    static ChFrame instance() { if (_inst==null) _inst=new ChFrame(null); return _inst; }
    private static long maySetAlwaysOnTopTime;
    public static boolean setAotEv(AWTEvent ev) {
        if (javaVsn()>14 && isCtrl(ev) && ev.getID()==KeyEvent.KEY_PRESSED && keyCode(ev)==KeyEvent.VK_T) {
            final JFrame f=deref(parentWndw(ev.getSource()), JFrame.class);
            if (f==null) return true;
            final boolean b=!f.isAlwaysOnTop();
            final long now=System.currentTimeMillis();
            if (now-maySetAlwaysOnTopTime>222) setAOT(b, f);
            maySetAlwaysOnTopTime=now;
            hintFloating=false;
            return true;
        } else return false;
    }
    public static void setAOT(boolean b, Window w) {
        if (javaVsn()>14 && w!=null) {
            w.setAlwaysOnTop(b);
            final JFrame f=deref(w,JFrame.class);
            if (f!=null) {
                final String pfx="^ ", t=rplcToStrg(HINT_FLOATING, "", delPfx(pfx,f.getTitle()));
                f.setTitle(b ? pfx+t : t);
            }
        }
    }
    private final static String HINT_FLOATING="   Hint: Ctrl-T toggles frames \"always floating on top\" ";
    private static boolean hintFloating=true;
    public static String hintAOT(boolean always) { return always || hintFloating ? HINT_FLOATING : null; }
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> static utils >>> */
    public static ChFrame textFrame(byte bb[], int lettersPerLine) {
        StringBuffer sb=new StringBuffer(bb!=null ? bb.length+bb.length/20 : 0);
        foldText(bb,0,MAX_INT,lettersPerLine,sb);
        return new ChFrame("").ad(new ChTextArea("").t(sb).tools().scrollPane()).shw(AT_CLICK);
    }
    static Component imageObserver() {
        if (vFrames==null) return null;
        for(int i=sze(vFrames); --i>=0;) {
            final Component c=get(i,vFrames,Component.class);
            if (c!=null && c.isVisible()) return c;
        }
    return null;
    }
}

/*
  http://saloon.javaranch.com/cgi-bin/ubb/ultimatebb.cgi?ubb=get_topic&f=2&t=014048
  JRootPane
  MetalRootPaneUI
  MetalIconFactory
  MetalTitlePane
  MetalTitlePane
  JFrame
  http://bugs.sun.com/bugdatabase/view_bug.do?bug_id=6491619
  http://www.onjava.com/pub/a/onjava/excerpt/swinghks_hack41/index.html?page=3
*/
