package charite.christo;
import javax.swing.*;
import java.awt.*;
import java.util.List;
import java.util.*;
import java.awt.event.*;
import charite.christo.interfaces.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import static java.awt.event.MouseEvent.*;
/**HELP
   This list supports<ul>
<li>WIKI:Drag_and_drop  (Java 1.5 or higher, Watch movie
  <i>STRING:ChConstants#MOVIE_Export_Proteins</i>
  <i>STRING:ChConstants#MOVIE_Drag_to_another_STRAP</i>
  <i>STRING:ChConstants#MOVIE_Drag_protein_to_3D</i>
  <i>STRING:ChConstants#MOVIE_Sequence_Features_in_3D</i>)
<li>Reordering</li>
<li>WIKI:Context_menu (Watch movie <i>STRING:ChConstants#MOVIE_Context_Menu</i>)</li>
</ul>
   <b>Keep window always visible: </b>You may want to  set the window "Floating on top". See  Strap tool-bar==&gt;options.<br><br>
   <b>Frequently used menu-items:</b> of the context-menu can be dragged out of the menu.
   These extracted menu items are found at the bottom and can be used directly.<br><br>
   <b>Sequence groups:</b> If the list is displaying proteins, two buttons at the bottom provide "Sequence group" functionality.
   Exactly the proteins in the list are displayed in the alignment, all others are hidden.<br>
   Hidden proteins can be reintroduced into the alignment by dragging the tree node "Hidden proteins" of the object tree.
   The object tree is usually not visible because the vertical divider is at the very left. It becomes visible by opening the divider.<br><br>
   @author Christoph Gille
*/
public class ChJList extends JList implements IsEnabled, ChProcessEvent, HasModiCount {
    public final static int OPTIONS_FILES=ChJTable.ICON_ROW_HEIGHT|ChJTable.DEFAULT_RENDERER|ChJTable.FILE_POPUP|ChJTable.RTT|ChJTable.DRAG_ENABLED;
    public final static String KEY_NO_HELP_ON_RIGHT_CLICK="CJL$$NH";
    private int selectedValuesMC;
    private long options;
    private boolean isInitialized;
    /* ---------------------------------------- */
    final Map MAPCP=new java.util.HashMap();
    /* >>> Instance >>> */

    public void setData(Object data) {
        if (data instanceof ListModel) setModel((ListModel)data);
        else if (data instanceof List) setModel(new JListModel(list=(List)data));
        else if (data instanceof Object[]) {
            final DefaultListModel m=new DefaultListModel();
            for(Object o : (Object[])data) m.addElement(o);
            setModel(m);
        }
    }
    public long getOptions() { return this.options;}
    public void addOptions(long options) { this.options|=options;}
    public ChJList(Object data, long options) {
        this.options=options;
        setData(data);
        int fixed=3*EX/2;
        if ( (options&ChJTable.EX_ROW_HEIGHT)!=0) fixed=EX+2;
        if ( (options&ChJTable.ICON_ROW_HEIGHT)!=0) fixed=ICON_HEIGHT;
        if ( (options&ChJTable.DEFAULT_RENDERER)!=0) setCellRenderer(new ChRenderer());
        if ( (options&ChJTable.CLASS_RENDERER)!=0) setCellRenderer(new ChRenderer().options(ChRenderer.CLASS_NAMES));
        if ( (options&ChJTable.RTT)!=0) rtt(this);
        if ( (options&ChJTable.FILE_POPUP)!=0) {
            addTooltip(FilePopup.instance(),this);
            FilePopup.instance().LI.addTo("km",this);
        }
        if ( (options&ChJTable.SINGLE_SELECTION)!=0) setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        setFixedCellHeight(fixed);
        if ( (options&ChJTable.DRAG_ENABLED)!=0) setDragEnabled(true);
        setFG(0,this);
        scrollByWheel(this);
        shiftTooltip(this);

        addListSelectionListener(LI);
    }
    /* <<< Instance <<< */
    /* ---------------------------------------- */
    /* >>> Model >>> */
    private List list;
    public List getList() { return list; }
    public boolean isEnabled(Object o) {
        final Object
            enabled0=gcp(KEY_ENABLED,this),
            enabled=enabled0 instanceof ChCombo ?  ((ChCombo)enabled0).instanceOfSelectedClass(IsEnabled.class) : enabled0;
        final IsEnabled en= isInstncOf(IsEnabled.class,enabled) ?(IsEnabled) enabled: null;
        return en!=null ? en.isEnabled(o) : true;
    }
    public ChJList setSelII(int[] ii) {
        pcp(KEY_IGNORE_SELECTION_EVT,"",this);
        setSelectedIndices(ii);
        pcp(KEY_IGNORE_SELECTION_EVT,null,this);
        selectedValuesMC++;
        return this;
    }
  public ChJList setSelI(int i) {
        pcp(KEY_IGNORE_SELECTION_EVT,"",this);
        setSelectedIndex(i);
        pcp(KEY_IGNORE_SELECTION_EVT,null,this);
        selectedValuesMC++;
        return this;
    }

    public final static long SEL_STRSTR=1<<1, SEL_STRSTR_IC=1<<2;
    public static Thread thread_setSelO(long options, Object o, JComponent c) {
        return threadM("setSelO",ChJList.class, new Object[]{longObjct(options),o, c});
    }
    public static void setSelO(long options, Object o, JComponent c) {
        if (c==null) return;

        final ChJList jl=deref(c,ChJList.class);
        final ChCombo jc=deref(c,ChCombo.class);
        assertTrue(jl!=null || jc!=null);
        if (!isEDT()) {
            inEDT(thread_setSelO(options,o, c));
            return;
        }
        final ListModel m=jc!=null?jc.getModel() : jl.getModel();
        if (m!=null) {
            for(int i=m.getSize(); --i>=0;) {
                final Object oi=m.getElementAt(i);
                boolean found=oi==o;
                if (oi instanceof String && o instanceof String) {
                    found|=oi.equals(o);
                    final boolean ic=0!=(options&SEL_STRSTR_IC);
                    if (ic || 0!=(options&SEL_STRSTR)) found|=strstr(ic?STRSTR_IC:0, o, oi)>=0;
                }
                if (found) {
                    if (jl!=null) jl.setSelI(i);
                    if (jc!=null) jc.s(i);

                    break;
                }
            }
        }
    }
    public ChJList setSelOO(Object[] oo) { setSelII(selIndices(oo,getModel())); return this; }
    public int getModificationCount() { return selectedValuesMC;}
    /* <<< Model <<< */
    /* ---------------------------------------- */
    /* >>> preferredSize >>> */
    @Override public Dimension getPreferredSize() {
        final Dimension d=getPrefSize(this);
        try {
            return d!=null ? d : super.getPreferredSize();
        } catch(Exception e) { return dim(EM,EX);}
    }
    /* <<< preferredSize <<< */
    /* ---------------------------------------- */
    /* >>> Paint >>> */
    {pcp(KEY_NOT_YET_PAINTED,"",this);}
    @Override public void paint(Graphics g) { try {super.paint(g);} catch(Throwable e) {} };
    @Override public void paintComponent(Graphics g) {
        if (!isInitialized){
            isInitialized=true;
            pcp(KEY_NOT_YET_PAINTED,null,this);
            pcp(KEY_IGNORE_SELECTION_EVT,null,this);
            adSelectLisener(this);
        }
        if (paintHooks(this,  g,false)) {
            if (!isEnabled()) g.clearRect(0,0,Short.MAX_VALUE,Short.MAX_VALUE);
            else {
                super.paintComponent(g);
                final String txt;
                if (sze(getModel())==0 && null!=(txt=toStrg(gcpa(KEY_IF_EMPTY,this)))) {
                    g.setColor(C(0x888888));
                    int y= charA(g)+EX/2;
                    for(String s:splitStrg(txt,'\n')) g.drawString(s,EM,y); y+=charH(g)+1;
                }
                if (!paintHooks(this,  g,true)) return;
            }
        }
    }

    /* <<<  Paint <<< */
    /* ---------------------------------------- */
    /* >>> Event >>> */
    //ListSelectionListener
    public ChJList li(ActionListener l) {
        addActLi(l, this);
        return this;
    }
    { this.enableEvents(ENABLE_EVT_MASK);}
    @Override public void processEvent(AWTEvent ev) {
        if (!shouldProcessEvt(this,ev)) return;
        final int kcode=keyCode(ev), id=ev.getID(), modi=modifiers(ev);
        String cmd=null;
        if (0==(options&ChJTable.CHJTABLE_BACKSPACE_DEACTIVATED) && (kcode==KeyEvent.VK_BACK_SPACE || kcode==KeyEvent.VK_DELETE)) cmd=ACTION_DELETE_OR_BACKSPACE;
        if (kcode==KeyEvent.VK_A && modi==shortCutMask()) selectAllItems(this);
        final boolean isPopup=isPopupTrigger(ev);
        final Point point=point(ev);
        if (point!=null) {
            final int idx=locationToIndex(point);
            if ( 0!=(options&ChJTable.FILE_TRANSFER_HANDLER) && jListDoDnD(ev)) return;
            if (isPopup && gcp(KEY_NO_HELP_ON_RIGHT_CLICK,this)==null) {
                if (popup==null) {
                    miCtrlPanel=new ChButton("Shared control panel").li(LI);
                    miHelp=new ChButton("Help").li(LI);
                    popup=jPopupMenu(0L, "list/context-menu",new Object[]{miHelp,miCtrlPanel});
                }
                boolean showPopup=false;
                final Object o=get(idx,this);
                if (isClassOrPC(o)) {
                    final Container cp=getSharedCtrlPan(o,true);
                    if (cp!=null) {
                        pcp("O",cp, miCtrlPanel.enabled(showPopup=true));
                        pcp("C",o,miCtrlPanel);
                    }
                } else miCtrlPanel.enabled(false);
                if (getHlp(o)!=null) pcp("C",o,miHelp.enabled(showPopup=true));
                else miHelp.enabled(false);
                if (showPopup) popup.show(this, x(ev), y(ev));
            }
            if (id==MouseEvent.MOUSE_CLICKED) {
                handleActEvt(this, ACTION_CLICKED ,modi);
            }
        }
        if (!isPopup) {
            if (cmd!=null) handleActEvt(this,cmd,0);
        }
        super.processEvent(ev);

    }
    private final ChEventAdapter LI=new ChEventAdapter(this);
    public AWTEvent processEvent(JComponent c, AWTEvent ev) {
        final Object q=ev.getSource();
        final String cmd=actionCommand(ev);
        final int id=ev.getID();
        if (id==ActionEvent.ACTION_PERFORMED) {
            final Object para=gcp("O",q), clazz=gcp("C",q);
            if (q==miHelp) showHelp(clazz);
            if (q==miCtrlPanel) ChFrame.frame(shrtClasNam(clazz),para,ChFrame.SCROLLPANE|ChFrame.PACK|ChFrame.AT_CLICK).shw(0);
            if (cmd==ACTION_SELECTION_CHANGED && gcp(KOPT_ALREADY_PAINTED,this)!=null) {
                selectedValuesMC++;
                final String cmd2=gcps(KEY_ACTION_COMMAND,this);
                handleActEvt(this,cmd2!=null?cmd2:ACTION_SELECTION_CHANGED,0);
            }
        }
        return ev;
    }
    private ChButton miHelp, miCtrlPanel;
    private JPopupMenu popup;
    /* <<< Event <<< */
    /* ---------------------------------------- */
    /* >>> Tip >>> */
    @Override public String getToolTipText(MouseEvent ev) {
        final String tip=ballonMsg(this, ev);
        return tip!=null ? addHtmlTagsAsStrg(tip) : super.getToolTipText();
    }
    /* <<< Tip  <<< */
    /* ---------------------------------------- */
    /* >>> Frame >>> */
    public ChFrame showInFrame(long option, String title) {
        JComponent pan=gcp(KEY_PANEL, this, JComponent.class);
        return ChFrame.frame(title,pan!=null ? pan : this, ChFrame.SCROLLPANE|option).shw(option|ChFrame.SIZE_REGARD_RESOLUTION);

    }
    /* <<< Frame <<< */
    /* ---------------------------------------- */
    /* >>> DnD >>> */
    public List getDndDateien() { return getDndFilesV(this);}

    /* <<< DnD <<< */
    /* ---------------------------------------- */
    /* >>> Static utils >>> */
    public static long getOptions(Object o) {
        return o instanceof ChJTable ? ((ChJTable)o).getOptions() :
            o instanceof ChJList ? ((ChJList)o).options :
            0;
    }

}
