package charite.christo;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import charite.christo.interfaces.*;
import static java.awt.event.MouseEvent.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**
   @author Christoph Gille
*/
public final class ChJMenu extends JMenu implements charite.christo.interfaces.ChProcessEvent, MenuListener {
    private ChButton _b;
    public ChJMenu(String label) {
        super(label);
        assertInstAllowed();
        addMouseListener(LI);
        setMenuLightW(false); /* required for Java1.5 WinXP */
        addMenuListener(this);
        setFG(0,this);
        shiftTooltip(this);
    }

    public ChJMenu(ChButton b) {
        this(b.getText());
        this._b=b;
    }
    public ChJMenu cp(Object key, Object value) { pcp(key,value,this); return this;}
    /* <<< Constructor <<< */
    /* ---------------------------------------- */
    /* >>> Late Initialization  >>> */
    private boolean isInitialized, _isSelected;
    public void menuDeselected(MenuEvent e) { _isSelected=false; }
    public void menuCanceled(MenuEvent e) { _isSelected=false; }
    private static long actEvtWhen;
    public void menuSelected(MenuEvent e) {
        ChUtils.handleActEvt(e.getSource(), ACTION_MENU_SELECTED, 0);
        ChUtils.callSetEnabled(e);
        if (!_isSelected) _isSelected=true; else return; /* Otherwise 2 events under Windows */
        getPopupMenu().setLightWeightPopupEnabled(false);
        if (!isInitialized) {
            isInitialized=true;
            for(int i=getMenuComponentCount(); --i>=0;) {
                final Object o=getMenuComponent(i);
                if (o instanceof ChJMenu) ((ChJMenu)o).paintComponent(null);
                if (o instanceof ChButton) ((ChButton)o).paintComponent(null);
                if (o instanceof ChButton.MItem) ((ChButton.MItem)o).paintComponent(null);
            }
        }
        final Menu awtM=this.awtMenu;
        if (awtM!=null) {
            long hc=0;
            for(int i=awtM.getItemCount(); --i>=0;) {
                hc+=awtM.getItem(i).hashCode()+awtM.getItem(i).getLabel().hashCode()<<32;
            }
            if (awtMenuHC!=hc) {
                removeAll();
                awtMenuHC=hc;
                menu2jAddItems(awtM,this);
                this.awtMenuHC=awtM.getItemCount();
            }
        }
        if (_b!=null) {
            final long time=System.currentTimeMillis();
            if (time-actEvtWhen>333) {
                actEvtWhen=time;
                pcp(KEY_VISIBLE_COMPONENT, this, _b);
                String cmd=gcps(KEY_ACTION_COMMAND,this);
                if (cmd==null) cmd=gcps(KEY_ACTION_COMMAND, _b);
                if (cmd==null) cmd=CMD_MENU_SELECTION_CHANGED;
                handleActEvt(_b!=null ? _b : this, cmd,0);
                ChDelay.runAfterMS(EDT, threadM("setSelected", this, new Object[]{boolObjct(false)}),99);
            }
        }
    }
    public boolean isEnabled() {
        if (gcp(KOPT_DISABLE_IF_CHILDS_DISABLED,this)!=null) {
            boolean oneEnabled=false;
            for(Component c : childs(this)) {
                oneEnabled|=c instanceof AbstractButton && c.isEnabled();
            }
            if (!oneEnabled) return false;
        }

        if (_b!=null) return _b.isEnabled();
        final IsEnabled ise=gcp(KEY_ENABLED,this,IsEnabled.class);
        if (ise!=null) return ise.isEnabled(this);
        return true;
    }
    /* <<< Late Initialization <<< */
    /* ---------------------------------------- */
    /* >>> Layout  >>> */
    @Override public Insets getMargin() { return UserProfile.isHidden(this) ? insets0(false) : super.getMargin();}
    @Override public Dimension getPreferredSize() {
        if (gcp(KOPT_DISABLE_IF_CHILDS_DISABLED,this)!=null && !isEnabled()) return dim(0,0);
        {
            final Dimension ps=getPrefSize(this);
            if (ps!=null) return ps;
        }
        if (getText()==KEY_ACCELERATOR || UserProfile.isHidden(this)) return dim(0,0);
        final Dimension d=super.getPreferredSize();
        if (d!=null && oIcon!=null) d.height=ICON_HEIGHT;
        return d;
    }
    /* <<< Event <<< */
    /* ---------------------------------------- */
    /* >>> Event JMenu   BasicMenuUI  >>> */
    /* http://bugs.sun.com/bugdatabase/view_bug.do?bug_id=4403182
     */
    private static AWTEvent _ev;
    private static Object _lockedParent;
    private static JMenuItem _lockedMenu;
    private final static AWTEvent _EV[]={null,null};
    static AWTEvent[] lockSubmenuOnClick(AWTEvent ev, JMenuItem c) {
        _EV[1]=ev;
        _EV[0]=null;
        if (!isSelctd(BUTTN[TOG_LOCK_JMENU])) return _EV;
        final int id=ev.getID();
        final Component parent=c==null?null:c.getParent();
        if (parent==null) {
            _lockedParent=_lockedMenu=null;
        } else if (parent==_lockedParent && c==_lockedMenu) {
            _EV[1]=null;
            //putln("skipped is locked");
        } else if (id==MOUSE_ENTERED) {
            if (parent==_lockedParent) {
                _ev=ev;
                _EV[1]=null;
                //putln("skipped MOUSE_ENTERED");
            }
            else _lockedParent=_lockedMenu=null;
        } else if (id==MOUSE_PRESSED && c instanceof JMenu) {
            if (_lockedParent!=null) {
                _EV[0]=_ev;
                _ev=null;
            }
            _lockedParent=parent;
            _lockedMenu=c;
            //putln("feststellen");
        }
        return _EV;
    }
    /*
    @Override public void setSelected(boolean b) {
        putln("isShowing="+isShowing());
        if (isShowing()) putln("getLogetLocationOnScreen "+getLocationOnScreen()+"  "+getMouseLctn());

        super.setSelected(b);
    }
    */
    {enableEvents(ENABLE_EVT_MASK);}
    private final ChEventAdapter LI=new ChEventAdapter(this);
    @Override public void processEvent(AWTEvent ev) {
        if (UserProfile.isHidden(this)) return;
        try{
            for(AWTEvent ev2 : lockSubmenuOnClick(ev, this)) {
                if (ev2!=null) super.processEvent(ev2);
            }
        } catch(Throwable ex){}
    }
    public AWTEvent processEvent(JComponent c, AWTEvent ev) {
        final Object q=ev.getSource();
        final MenuItem mi=(MenuItem)gcp(KEY_AWT_MI,q);
        if (mi!=null) {
            if (mi instanceof CheckboxMenuItem) ((CheckboxMenuItem)mi).setState(isSelctd(q));
            final ActionEvent aev=new ActionEvent(mi,ActionEvent.ACTION_PERFORMED, mi.getActionCommand(),modifiers(ev));
            for(ActionListener al : mi.getActionListeners()) al.actionPerformed(aev);
        }
        return ev;
    }
    /* <<< Event <<< */
    /* ---------------------------------------- */
    /* >>> Layout  >>> */
    public void setBackground(Color bg) { }
    @Override public void paintComponent(Graphics g) {
        //putln(" isBackreoundSet="+ isBackgroundSet());
        this.oIcon=ChButton.mkIcon(this.oIcon, this);
        if (g==null) return;
        if (UserProfile.isHidden(this)) g.clearRect(0,0,999,999);
        else {
            try {
                /* Bug fix Windows laf */
                final JMenuBar mb=deref(getParent(), JMenuBar.class);

                if (mb!=null && !isOpaque()) {
                    final Color fg=mb.getForeground();
                    g.setColor(fg!=null ? fg : C(0));

                    final int h=mb.getHeight();
                    g.drawString(getText(), 0, (h-charH(g))/2+charA(g));

                }
                /*
                Color bg=gcp(KEY_BACKGROUND,mb, Color.class);
                if (bg==null && mb!=null) bg=mb.getBackground();
                if (bg!=null)  {
                    setBG(bg,this);
                    if (!isOpaque()) setOpaque(true);
                    putln(" mb="+getTxt(this));
                }
                */
                else super.paintComponent(g);
            } catch(Throwable ex){vMaliciousIcons.add(getIcon()); }
        }
    }
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> awt-Menu >>> */
    private final static Object KEY_AWT_MI=new Object();
    private Menu awtMenu;
    private long awtMenuHC;
    private String rplcMenuItems[][];
    ChJMenu setAwtMenu(Menu m, String[][] rplc) {
        this.awtMenu=m;
        this.rplcMenuItems=rplc;
        String label=m.getLabel();
        for(int j=sze(rplc); --j>=0;) {
            if (label.equalsIgnoreCase(rplc[j][0]) && get(1,rplc[j])!=null) label=get(1,rplc[j]);
        }
        setText(label);
        setHeavy(this);
        return this;
    }
    void menu2jAddItems(Menu m, JMenu jm) {
        nextItem:
         for(int i=0; i<m.getItemCount(); i++) {
            final MenuItem it=m.getItem(i);
            final String label0=it.getLabel(), rplc[][]=this.rplcMenuItems;
            String label=label0;
            for(int j=sze(rplc); --j>=0;) {
                if (label0.equalsIgnoreCase(rplc[j][0])) label=get(1,rplc[j]);
            }
            if (label==null) continue;
            if ("-".equals(label)) jm.addSeparator();
            else if (it instanceof Menu) jm.add(new ChJMenu("").setAwtMenu((Menu)it,this.rplcMenuItems));
            else {
                final CheckboxMenuItem cb=it instanceof CheckboxMenuItem ? ((CheckboxMenuItem)it) : null;
                final ChButton b=new ChButton(cb!=null ? 'T':'B',label).li(LI).cp(KEY_AWT_MI,it);
                if (cb!=null) b.s(cb.getState());
                setUndockble(b);
                jm.add(b.mi(null));
            }
        }
    }

    /* <<< awt-Menu <<< */
    /* ---------------------------------------- */
    /* >>> Icon >>> */
    private Object oIcon=null;
    public ChJMenu i(Object o) {  this.oIcon=o; return this;}
    /* <<< Icon <<< */
    /* ---------------------------------------- */

    public static void hideChildlessMenus(Component m) {
        final Component cc[]=childs(m);
        if (m instanceof JMenu) {
            boolean e=false;
            for(Component c : cc) if (c.isEnabled()) { e=true; break; }
            ((JMenu)m).setPreferredSize(e?null:dim(0,0));
            if (!e) return;
        }
        for(Component c : cc) hideChildlessMenus(deref(c, JMenu.class));
    }

    public static void simpleMenuBar() {

        final JMenu m1=new JMenu("1");
        final JMenu m2=new JMenu("2");
        final JMenu m3=new JMenu("3");
        m1.add(m2);
        m2.add(m3);
        final JMenuBar mb=new JMenuBar();
        mb.add(m1);
        final JFrame f=new JFrame();
        f.setSize(200,60);
        f.setJMenuBar(mb);
        f.show();

    }

}
/*
http://hintsforums.macworld.com/showthread.php?p=489302#post489302
*/