package charite.christo;
import charite.christo.interfaces.*;
import com.inet.jortho.*;
import java.util.List;
import javax.swing.text.JTextComponent;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
public class ChJOrtho implements ChRunnable, CustomDictionaryProvider {
    private static boolean registeredDict;
    private static ChSet<String> vWords, vStrings;
    private static ChSet<Object> vCollections, vCollectionsAdded;
    public Object run(String id, Object arg) {
        if (id==ChJOrthoPROXY.JTEXTCOMPONENT && arg instanceof JTextComponent) {
            final JTextComponent tc=(JTextComponent)arg;
            if (!registeredDict) {
                try {
                    registeredDict=true;
                    FileUserDictionary provider=new FileUserDictionary(file(dirSettings()+"/jortho/").toString());
                    SpellChecker.setUserDictionaryProvider(provider);
                    SpellChecker.setCustomDictionaryProvider(this);
                    SpellChecker.registerDictionaries( url(dirJars()), "en","en",".ortho" );
                } catch(Throwable ex){}
            }
            //assertEDT();
            SpellChecker.register(tc);
        }
        if (id=="ADD") {
            if (vWords==null) {
                vWords=new ChSet(0L, String.class);
                vStrings=new ChSet(0L, String.class);
                vCollections=new ChSet(0L, Object.class);
                vCollectionsAdded=new ChSet(0L, Object.class);
            }
            vCollections.add(arg);
        }
        return null;
    }
    public String[] getWords(java.util.Locale locale) {
        //putln(ANSI_GREEN+"getWords"+ANSI_RESET);
        if (vWords==null) return NO_STRING;
        for(Object c : vCollections.asArray()) {
            //putln(" getWords c="+c+"   "+vCollectionsAdded.contains(c));
            if (vCollectionsAdded.contains(c)) continue;
            vCollectionsAdded.add(c);
            cpyWords(c);
        }
        //putln(ANSI_GREEN+"JOrtho getWords="+ANSI_RESET+sze(vWords));
        return vWords.asArray();
    }

    private static Object toWord(Object o) {
        Object c=deref(o);
        while(!(c instanceof List) && c instanceof ChRunnable)  c=((ChRunnable)c).run(PROVIDE_JORTHO_WORD_LIST, null);
        if (c instanceof HasName || c instanceof java.io.File) c=getNam(c);
        return deref(c);
    }

    final static String trimLR(String s) {
        if (s==null) return null;
        final int L=s.length();
        final int L1=nxt(LETTR,s);
        final int L9=prev(LETTR,s,L,0)+1;
        return L1>0 || L9!=L ? s.substring(L1,L9) : s;
    }
    private static boolean[] delim;
    public static void cpyWords(Object o0) {
        if (delim==null) delim=charClass(",=:<>+()[]/\\!{}%^;0123456789");
        Object o= toWord(o0);
        if (o==null) return;
        final String strg=o instanceof String ? (String)o : null;
        if (strg!=null || o instanceof List || o instanceof Object[]) {
            final int N=strg!=null ? 1 : sze(o);
            for(int i=0; i<N; i++) {
                Object obj=strg!=null ? strg : toWord(get(i,o));
                if (obj instanceof Object[]) cpyWords(obj);
                else if (obj instanceof String  && !vStrings.contains(obj) && !vWords.contains(obj)) {
                    String s=(String)obj;
                    if (s.length()<2) continue;
                    vStrings.add(s);
                    {
                        final int L1=nxt(LETTR,s);
                        if (L1>0) s=s.substring(L1);
                    }

                    vStrings.add(s);
                    if (nxt(delim,s,0,MAX_INT)>0 && s.length()>1) {
                        for(String s2 : splitTokns(0L, s,delim)) {
                            if (nxt(LETTR,s2)>=0 && s2.length()>1) vWords.add(trimLR(s2));
                        }
                    } else vWords.add(s);

                }
            }
        }
    }
    // java charite.christo.ChJOrtho 0xyz0

}

