package charite.christo;
import charite.christo.interfaces.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.File;
import java.util.List;
import javax.swing.*;
import static charite.christo.ChConstants.*;
import static charite.christo.ChUtils.*;
public class ChLabel extends JLabel {
    private int fromTo[];
    public final static String PFX_VERTICAL="CR$$V";
    public final static int INFO_IN_MENU=1<<1;
    final Map MAPCP=new HashMap();
    @Override public Dimension getMinimumSize() { try { return super.getMinimumSize();} catch(Throwable e){return dim(32,32);}}
    @Override public Dimension getMaximumSize() { try { return super.getMaximumSize();} catch(Throwable e){return dim(32,32);}}

    public ChLabel(CharSequence s){
        if (s!=null) t(s);
        assertInstAllowed();
        setOpaque(false);
        shiftTooltip(this);
    }
    public ChLabel(){ this(null);  }
    public ChLabel addOption(long options){
        if (0!=(options & INFO_IN_MENU)) enlargeFont(fg(0x6464ff),0.85);
        return this;
    }
    public final ChLabel t(CharSequence t0) {
        final CharSequence t=t0==null ? "" : t0;
        if (!t.equals(getText())) setText(addHtmlTagsAsStrg(t));
        return this;
    }
    public ChLabel setDrawFromTo(int from, int to) { fromTo=new int[]{from,to}; return this; }
    /* ---------------------------------------- */
    /* >>> Tip >>> */
    public final ChLabel tt(CharSequence t) { setToolTipText(addHtmlTagsAsStrg(t));return this;}
    @Override public String getToolTipText(MouseEvent ev) {
        final StringBuffer sb=appendTooltips(this,ev,null);
        if (sb!=null) return sb.toString();
        return super.getToolTipText(ev);
    }
    /* <<< Tip <<< */
    /* ---------------------------------------- */
    /* >>> paintComponent >>> */
    private Color fg,bg;
    public Color bg() { return bg;}
    public final ChLabel fg(int rgb) { setFG(rgb,this); return this;}
    public final ChLabel bg(int rgb) { bg=C(rgb); return this;}
    final static Object KEY_JTabbedPane=new Object();
    public void paintComponent(Graphics g0) {
        //putln(" ChLabel.isOpaque "+isOpaque());
        final Graphics2D g=(Graphics2D)g0;
        this.oIcon=ChButton.mkIcon(this.oIcon, this);
        if (g==null) return;
        if (paintHooks(this, g, false)) {
            final int w=getWidth(), h=getHeight();
            /*
            if (getParent() instanceof JPopupMenu && !isOpaque()) {
                g.setColor(getParent().getBackground());
                g.fillRect(0,0,1000,h);
            }
            */
            antiAliasing(g);
            g.setFont(getFont());
            final String txt=getText();
            final boolean isSelected=fromTo==null && null!=gcp(KOPT_IS_SELECTED,this);
            final boolean vertical=equls(PFX_VERTICAL, txt), isTableHeader=gcp(KOPT_IS_IN_TABLE_HEADER,this)!=null;
            final Color
              fg=isSelected ? C(ChRenderer.FG_SELECTED) : this.fg,
                bg=
                isSelected ? C(ChRenderer.BG_SELECTED) :
                isTableHeader ? C(DEFAULT_BACKGROUND) :
                !isOpaque() ? null :
                this.bg!=null ? this.bg : gcp(ChRenderer.KEY_NOT_EDITABLE_BG,this,Color.class);
            if (bg!=null) { g.setColor(bg);  g.fillRect(0,0, w,h); }
            if (fg!=null) setForeground(fg);

            if (fromTo!=null) {
                g.setColor(fg!=null?fg:C(0x808080));
                g.drawRect(0,0,w-1,h-1);
                g.fillRect(2+fromTo[0]*(w-4)/100,h/4,   (fromTo[1]-fromTo[0])*(w-4)/100, h/2);

            }
            if (vertical) {
                final Font font=getFont();
                g.setFont(font);
                g.setColor(getForeground());
                final int charA=charA(font);
                g.rotate(-Math.PI/2, h/2f,h/2f);
                g.drawString(delPfx(PFX_VERTICAL,txt), 2, charA);
                g.rotate(Math.PI/2, h/2f,h/2f);
            }
            final JTabbedPane tp=gcp(KEY_JTabbedPane,this,JTabbedPane.class);
            if (tp!=null) {
              final Object tabComp=invokeMthd(INVOKE_MTHD_PRINT_EXCEPTIONS, "getTabComponentAt",tp,new Object[]{intObjct(tp.getSelectedIndex())});
                if (tabComp==this) {

                    final int placement=tp.getTabPlacement();
                    int x0=w/2,y0=h;
                    if (placement==JTabbedPane.BOTTOM) y0=0;
                    if (placement==JTabbedPane.LEFT) { x0=w; y0=h/2; }
                    if (placement==JTabbedPane.RIGHT) { x0=0; y0=h/2; }
                }
            }
            if (!vertical && fromTo==null) try { super.paintComponent(g); } catch(Throwable e) { vMaliciousIcons.add(getIcon()); }
            if (isTableHeader) {
                g.setColor(C(0));
                g.drawLine(w-1,0, w-1,h);
                g.drawLine(0,h-1, w,h-1);
            }
            ChRenderer.paint(this, g); //4350
            ChButton.drawTopAndButtomText(this,g);
        }
        paintHooks(this, g, true);
    }
   /* <<< Paint <<< */
    /* ---------------------------------------- */
    /* >>> Appearance >>> */

    public ChLabel like(Object c) {
        if (c==null) return this;
        if (c instanceof JComponent) {
            final JComponent jc=(JComponent)c;
            setFont(jc.getFont());
            final Color fg=jc.getForeground(), bg=getBackground();
            if (fg!=null) fg(fg.getRGB());
            if (bg!=null) bg(fg.getRGB());
            setToolTipText(jc.getToolTipText());
        }
        i(getIcn(c));
        final String txt=getTxt(c);
        if (c instanceof JCheckBox) i(null).t("[X] "+txt);
        else {
            t(txt);
            final Object top=gcpa(TOP_TEXT,c),  bot=gcpa(BOTTOM_TEXT,c);
            if (top!=null ||  bot!=null)t((top!=null ? top:"")+"<br>"+ (bot!=null ? bot:""));
        }
        return this;
    }
    /* <<< Appearance <<< */
    /* ---------------------------------------- */
    /* >>> Dimension >>> */

    @Override public Dimension getPreferredSize() {
        {
            final Dimension ps=getPrefSize(this);
            if (ps!=null) return ps;
        }
        final String txt=getText();
        if (equls(PFX_VERTICAL, txt)) {
            final Font f=getFont();
            return dim(charH(f), 4+strgWidth(f, delPfx(PFX_VERTICAL,txt)));
        }
        return super.getPreferredSize();
    }
    /* <<< Dimension <<< */
    /* ---------------------------------------- */
    /* >>> Enabled >>> */
    @Override public boolean isEnabled() {
        final IsEnabled isE=gcp(KEY_ENABLED,this, IsEnabled.class);
        return isE!=null ? isE.isEnabled(this) : super.isEnabled();
    }
    /* <<< Enabled <<< */
    /* ---------------------------------------- */
    /* >>> Icon >>> */
    private Object oIcon;
    public final ChLabel i(Object o) {
       setIcon(o instanceof String ? iicon(IC_BLANK) : deref(o,Icon.class));
       this.oIcon=o;
       return this;
    }
    /* <<< Icon <<< */
    /* ---------------------------------------- */
    /* >>> DnD  >>> */
    private List<File> vDnD;
    public List<File> getDndDateien() {  return vDnD==null ? vDnD=new ArrayList() : vDnD; }
    public ChLabel cp(Object key, Object value) { pcp(key,value,this); return this;}
}
