package charite.christo;
import charite.christo.interfaces.*;
import java.util.*;
import java.io.*;
import javax.swing.*;
import java.awt.event.*;
import static charite.christo.ChConstants.*;
import static charite.christo.ChUtils.*;
import static charite.christo.protein.ProteinViewer.*;

public class ChLogger implements ActionListener {
    private final ByteArray ba=new ByteArray(999);
    private final AsciiView ta=new AsciiView(ba).setLineNumberStart(0);
    private final File saveFile;
    private final long options;
    private final int maxLen;
    private int countF=0, countL=0;
    private File swapDir;
    public ChLogger(long options, int maxLen, File saveFile) {
        this.options=options;
        this.saveFile=saveFile;
        this.maxLen=maxLen;
    }

    public final static String RUN_PREPROCESS="ChLog$$prepr";
    private ChRunnable preprocessor;
    public void setPreprocessor(ChRunnable p) { preprocessor=p;}

    private JComponent _panel;
    public JComponent getPanel() {

        if (_panel==null) {
            final Object pButtons=pnl(
                                      saveFile==null?null:new ChButton("S").t("Save ...").li(this),
                                      new ChButton("D").t("Insert separator").li(this)
                                      );
            _panel=newCNSEW(scrllpn(0L,ta, dim(99,222)), null,pButtons,null,null);
        }
        return _panel;
    }
    /* <<< Pane <<< */
    /* ---------------------------------------- */
    /* >>> append >>> */
    private final Object para[]={null,null,null};
    public synchronized ChLogger appendLine(String line) {
        if (preprocessor!=null) {
            para[0]=line;
            para[1]=ba;
            para[2]=this;
            if (preprocessor.run(RUN_PREPROCESS, para)==null) return this;
        }
        ba.append(line).append('\n');
        if (isVisbl(ta)) {
            ta.repaint();
            ChDelay.scrollToEnd(ta.getParent(), 99);
        }
        if (ba.getEnd()>maxLen) saveTmp();
        countL++;
        return this;
    }

    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> Save >>> */
    private synchronized void saveTmp() {
        final int E=ba.getEnd();
        final byte T[]=ba.getBytes();
        int e=E;
        for(int i=E, count=4; --i>=0;) {
            if (T[i]=='\n') {
                if (count--==0) {
                    e=i;
                    break;
                }
            }
        }
        if (e>0) {
            final File f=swapFile(countF++);
            wrte(f, T, 0, e);
            //vFiles.add(f);
            System.arraycopy(T,e,T,0,E-e);
            ba.setEnd(E-e);
            ta.setLineNumberStart(countL);
        }
    }
    final File swapFile(int i) {
        if (swapDir==null) {
            mkdrs(swapDir=createTempFile(""));

            getPanel().add(vBhB("Externalized to directory ", swapDir), java.awt.BorderLayout.NORTH);
            revalAndRepaintC(getPanel());
        }
        return file(swapDir+"/"+i +".script.txt");
    }
    /* <<< Save <<< */
    /* ---------------------------------------- */
    /* >>> Event >>> */
    private ChFileChooser fs;
    public void actionPerformed(ActionEvent ev) {
        final String cmd=ev.getActionCommand();
        final int kcode=keyCode(ev);
        if (kcode==KeyEvent.VK_ENTER) appendLine("");
        if (cmd=="D") appendLine("# -----------------------------");
        if (cmd=="S") {
            if (fs==null) {
                if (isCtrl(ev)&&isMyComputer()) {
                    saveTmp();
                    return;
                }
                addActLi(this, fs=new ChFileChooser(ChLogger.class).setVisibleFalseParentFrame());
                fs.setCurrentDirectory(mkParentDrs(saveFile));
                fs.setMultiSelectionEnabled(false);
                final String n=saveFile.getName();
                final String fileExt=n.substring(n.indexOf('.')+1);
                fs.setSelectedFile(saveFile);
                fs.setDialogType(JFileChooser.SAVE_DIALOG);
                if (sze(fileExt)>0) fs.filter().acceptSuffix(isWindows(), fileExt);
            }
            ChFrame.frame("Choose a script output file",fs,ChFrame.ALWAYS_ON_TOP|ChFrame.PACK).shw(ChFrame.CENTER);

        }
        if (cmd==JFileChooser.APPROVE_SELECTION) {
            final File f=fs.getSelectedFile();
            if (!ChFileChooser.canModify(f)) return;
            if (f.isDirectory()) { error(ChFrame.AT_CLICK,"Error writing script: <pre> "+f+"</pre>is a directory."); return;}
            if (sze(f)>0 && !ChMsg.yesNo(ChFrame.AT_CLICK,"The file  <pre> "+f+"</pre>already exists.<br>Overwrite?")) return;
            save(SAVE_DISPLAY_FILE, f);
        }
    }
    public final static long SAVE_DISPLAY_FILE=1<<1;
    public void save(long options, File f) {
        try {
            final OutputStream os=fileOutStream(f);
            for(int i=0; i<countF;i++) {
                final File fi=swapFile(i);
                final InputStream is=new FileInputStream(fi);
                copyIsOs(is,os);
                closeStrm(is);
            }
            ba.write(os);
            closeStrm(os);
            if (0!=(options&SAVE_DISPLAY_FILE)) {
                new ChFrame("Written file").ad(new ChJList(oo(f),ChJList.OPTIONS_FILES))
                    .shw(ChFrame.ALWAYS_ON_TOP|ChFrame.AT_CLICK|ChFrame.PACK);
            }
        } catch(IOException iox) {
            error(ChFrame.AT_CLICK, iox, "Error writing "+f);
        }
    }
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> Static >>> */

}
/*
L3   3D_selection_name  picked
L2   3D_select 117:N
L1   3D_selection_name  picked
line 3D_select 117:N

*/