package charite.christo;
import javax.swing.*;
import charite.christo.interfaces.*;
import java.awt.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
public class ChPanel extends JPanel implements Scrollable {
    final java.util.Map MAPCP=new java.util.HashMap();
    {
        setBG(DEFAULT_BACKGROUND,this);
        assertInstAllowed();
        setOpaque(true);
        pcp(KEY_NOT_YET_PAINTED,"",this);
        shiftTooltip(this);
    }
    public ChPanel() { super();}
    public ChPanel(LayoutManager l) { super(l);}

    /* ---------------------------------------- */
    /* >>> Paint >>> */
    private long duration[];
    public void paintChildren(Graphics g){
        final JScrollBar sb=gcp(KEY_NO_PAINT_IF_ADJUSTING, this, JScrollBar.class);
        if (sb!=null && sb.getValueIsAdjusting()) return;

        try {
            super.paintChildren(g);
        } catch (Throwable e){ putln(RED_CAUGHT_IN+"ChPanel paintChildren ",e); }
        CollapseComponent.paintComponent(this,g);
    }
    @Override public boolean isValidateRoot() { return gcp(KOPT_IS_VALIDATE_ROOT, this)!=null; }

    public long[] getWhenPainted() {
        if (duration==null) duration=new long[ARRAY_DURATION];
        return duration;
    }

    @Override public void paintComponent(Graphics g){
        final long time=System.currentTimeMillis();

        if (paintHooks(this, g, false)) {
            try {super.paintComponent(g);}catch(Throwable t){}
            final JTabbedPane tp=deref(getParent(), JTabbedPane.class);
            //Color bg=tp==null?null:tp.getBackgroundAt(tp.getSelectedIndex());
            Color bg=tp==null?null:tp.getBackground();
            if (bg!=null) {
                g.setColor(bg);
                fillBigRect(g,0,0,getWidth(),getHeight());
            }

            final long d[]=this.duration;
            if (d==null) {
                pcp(KEY_NOT_YET_PAINTED,null,this);
            }
            if (d!=null) d[DURATION]=(d[WHEN]=System.currentTimeMillis())-time;
            paintHooks(this, g, true);
        }
    }
    @Override public void paint(Graphics g){
      try { super.paint(g); } catch(Throwable ex){putln(RED_ERROR+" ChPanel.paint(g) "+ex); }
        if (null==gcp(KOPT_NOT_INDICATE_TOO_SMALL,this)) {
            final Component cc[]=getComponents();
            int smallH=-1, smallW=-1;
            final int H=getHeight(), W=getWidth();
            for(int i=cc.length; --i>=0;) {
                if (!(cc[i] instanceof JComponent)) continue;
                final JComponent c=(JComponent)cc[i];
                final Dimension ps=c.getPreferredSize();
                if (ps==null || ps.width*ps.height==0)continue;
                final int x=c.getX(), y=c.getY(), h=c.getHeight(), w=c.getWidth();
                if (smallH<0 && (h<1 || y>=H-h/2)) smallH=mini(y,H-2);
                if (smallW<0 && (w<1 || x>=W-w/2)) smallW=mini(x,W-2);

            }
            if (smallH>=0) ChRenderer.randomStrikeThrough(0L, hashCode(), g, 0, W, smallH);
            if (smallW>=0) ChRenderer.randomStrikeThrough(ChRenderer.STRIKE_THROUGH_V, hashCode(), g, 0, H, W-2);
        }
    }

    public boolean isAlreadyPainted() { return duration!=null;}

    @Override public boolean isShowing() { return super.isShowing() || gcp(KEY_JUST_WRITING_PNG,this)!=null;  }
    /* <<< Paint <<< */
    /* ---------------------------------------- */
    /* >>> preferredSize >>> */
    @Override public Dimension getMaximumSize() {
        Dimension d=getPrefSize(this);
        return d!=null && d.width+d.height==0 ? d : super.getMaximumSize();
    }
    @Override public Dimension getPreferredSize() {
        Dimension d=getPrefSize(this);
        try { // =Fri.08.09.06 42 linux .NullPointerException
            return d!=null ? d : super.getPreferredSize();
        } catch(Exception e) { return dim(333,333);}
    }
    /* <<< Paint <<< */
    /* ---------------------------------------- */
    /* >>> Tip >>> */
    @Override public String getToolTipText(java.awt.event.MouseEvent ev) {
        final StringBuffer sb=appendTooltips(this,ev,null);
        if (sb!=null) return sb.toString();
        return super.getToolTipText(ev);
    }

    @Override public Point getToolTipLocation(java.awt.event.MouseEvent event) {
        final Point p=(Point)gcp(KEY_TIP_LOCATION,this);
        if (p!=null) {
            final JViewport parent=parnt(this,JViewport.class);
            final Point vp=  parent!=null ? parent.getViewPosition() : null;
            return vp!=null ? new Point(vp.x+p.x, vp.y+p.y) : p;
        }
        return null;
    }
    /* <<< Tip <<< */
    /* ---------------------------------------- */
    /* >>> Scroll >>> */
     @Override public Dimension getPreferredScrollableViewportSize() { return getPreferredSize();}
     @Override public int getScrollableBlockIncrement(Rectangle visibleRect, int orientation, int direction) {
        return visibleRect==null ? 10 : orientation==SwingConstants.VERTICAL ? visibleRect.height-EX : visibleRect.width-EM;
    }
    @Override public boolean getScrollableTracksViewportHeight() { return gcp(KOPT_TRACKS_VIEWPORT_HEIGHT,this)!=null;}
    @Override public boolean getScrollableTracksViewportWidth() { return gcp(KOPT_TRACKS_VIEWPORT_WIDTH,this)!=null;}
    @Override public int getScrollableUnitIncrement(Rectangle visibleRect, int orientation, int direction) { return EX;}

    /* <<< Scroll <<< */
    /* ---------------------------------------- */
    /* >>> Event >>> */
    { this.enableEvents(ENABLE_EVT_MASK);}
    @Override public void processEvent(AWTEvent ev) {
        mayClosePopupMenu(ev);
        if (shouldProcessEvt(this,ev)) try {super.processEvent(ev);} catch(Throwable e){}
    }
    /* <<< Scroll <<< */

    public java.util.List getDndDateien() { return getDndFilesV(this);}
    @Override public void removeAll() {
        if (!isEDT()) {
            inEdtM("removeAll", this,NO_OBJECT);
        }
        else try {
                super.removeAll();
            } catch(Exception ex){ stckTrc(ex);}
    }
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>>  >>> */
    @Override public boolean isEnabled() {
        boolean enabled=super.isEnabled();
        Object o;
        if (null==gcp(UserProfile.KEY_IGNORE,this) && UserProfile.isHidden(this)) enabled=false;
        else if ( (o=gcp(KEY_ENABLED,this)) instanceof IsEnabled) enabled=((IsEnabled)o).isEnabled(this);
        return enabled;
    }

    @Override public void invalidate() {
        if (null==gcp(KOPT_DO_NOT_INVALIDATE,this)) {
            super.invalidate();
        }
    }

    // public void repaint() { super.repaint(); if (null!=gcp("JMOL",this)) stckTrc(); }

}

