package charite.christo;
import charite.christo.hotswap.ProxyClass;
import charite.christo.interfaces.*;
import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.net.URL;

import java.util.*;
import javax.swing.*;
import javax.swing.table.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import static java.awt.event.MouseEvent.*;

/**
   This list cell renderer is used for list components that contain java classes
   @author Christoph Gille
   BasicCheckBoxUI
*/
public class ChRenderer extends javax.swing.border.AbstractBorder
    implements ListCellRenderer,
    javax.swing.table.TableCellRenderer,
    javax.swing.tree.TreeCellRenderer,
    TableCellEditor,
    PaintHook, ChProcessEvent {
    {  assertInstAllowed(); }
    public final static int FG_SELECTED=0xFFffFF, BG_SELECTED=0xFF,
        LAST_PATH_COMPONENT_SLASH=1<<0,  LAST_PATH_COMPONENT_DOT=1<<1 ,CLASS_NAMES=1<<4;
    private final static Object KEY_HAS_CURSOR=new Object(),KEY_REJECTED=new Object(), KEY_COLOR_MARK=new Object();
    public final static String
        KEY_RENDERER_COMPONENT="CCR$$_3", KEY_TOGGLE_SELECTED="CCR$$_4",  KEY_NOT_EDITABLE_BG="CCR$$P",
        KEY_CB_SELECTED="CCR$$_6", KEY_EDITOR_COMPONENT="CCR$$_7",
        KEY_EDITED_ROW="CCR$$_10",
        KEY_EDITED_COL="CCR$$_11",
        KEY_KEEP_COLOR="CCR$$_12",
        KEY_TO_CLOSE="CCR$$CLOSE",
        CMD_FOND_NAME="FONT_NAME";
    /* ---------------------------------------- */
    /* >>> AWTEvent >>> */
    private final ChEventAdapter LI=new ChEventAdapter(this);
    public AWTEvent processEvent(JComponent c, AWTEvent ev) {
        final Object q=ev.getSource();
        final String cmd=actionCommand(ev);
        final int id=ev.getID();
        if (q==textField() && (cmd==ACTION_ENTER || cmd==ACTION_FOCUS_LOST)) {
            stopCellEditing();
        }
        if (q==CB_EDITOR) {
            final JTable jt=deref(ref_treeOrList, JTable.class);
            if (jt!=null) {
                jt.setValueAt(CB_EDITOR.isSelected() ? Boolean.TRUE : Boolean.FALSE, editedRow, editedCol);
            }
        }
        Object toBeClosed=gcp(KEY_TO_CLOSE,q);
        if (toBeClosed==CLOSE_PARENT_WINDOW) toBeClosed=parentWndw(q);
        if (toBeClosed!=null) {
            final boolean in=inSmallButClose(q, x(ev), y(ev));
            if (id==MOUSE_CLICKED && in)  dispos(DISPOSE_CLOSE_WINDOW_ONLY, toBeClosed);
        }

        if (id==MOUSE_MOVED) {
            final Component jc=(Component)q;
            final Graphics g=jc.getGraphics();
            /*
            g.setColor(Color.RED);
            g.drawRect(0,0,jc.getWidth()-1, jc.getHeight()-1);
            */

        }

        return ev;
    }
    final static boolean inSmallButClose(Object q, int x, int y) {
        final Object X=gcp(KEY_SMALL_X[SMALL_CLOSE],q);
        if (X==null) return false;
        final int xb0=atoi(X);
        final int xb=xb0<0? ((JComponent)q).getWidth()+xb0 : xb0;
        return y<=BUT_WIDTH && xb<=x && x<xb+BUT_WIDTH;
    }
    /* <<< AWTEvent <<< */
    /* ---------------------------------------- */
    /* >>> Instance and options >>> */
    private int options;
    private static ChRenderer inst;
    private static ChRenderer instance() {if (inst==null) inst=new ChRenderer(); return inst;}
    public ChRenderer options(long options) { this.options=(int)options; return this; }
    /* <<< Instance <<< */
    /* ---------------------------------------- */
    /* >>> JLabels, Buttons ...  >>> */
    private static Color coloredFieldColor=C(0x0000ff), colors[];
    private final AbstractButton CB_EDITOR=cbox(""); { LI.addTo("a", CB_EDITOR);}
    public ChLabel LABEL=new ChLabel(); { monospc(LABEL.bg(0xFFffFF)); addPaintHook(this,LABEL); }

    private static JComponent _togFilled, coloredField;
    private static FakedJComponent FAKED; { if (FAKED==null) FAKED=new FakedJComponent(); }
    private final static JCheckBoxMenuItem  CHECKBOX=new JCheckBoxMenuItem("");

    private ChTextField tf_;
    public final ChTextField textField(){
        if (tf_==null)  {
            tf_=new ChTextField().li(LI);
            tf_.tools().underlineRefs(UNDERLINE_REFS_NOT_CLICKABLE);
        }
        return tf_;
    }
    /* <<< JLabels, Buttons ...  <<< */
    /* ---------------------------------------- */
    /* >>> Rows and Cols >>> */
    private int editedRow=-1, editedCol=-1;
    public int editedRow() {return editedRow;}
    public int editedCol() {return editedCol;}
    boolean isSelected;
    public Object value;
    /* <<< Rows and Cols <<< */
    /* ---------------------------------------- */
    /* >>> CellEditor >>> */
    public boolean isCellEditable(EventObject anEvent){ return true;}
    public void removeCellEditorListener(javax.swing.event.CellEditorListener l){ vCellEditorListener.remove(weakRef(l));}
    public boolean shouldSelectCell(EventObject anEvent){return false;}
    public boolean stopCellEditing(){ stopOrCancelCellEditing(true); return true;}
    public void cancelCellEditing(){stopOrCancelCellEditing(false);}
    void stopOrCancelCellEditing( boolean isStopped){
        if (vCellEditorListener!=null) {
            for(int i=vCellEditorListener.size();--i>=0;) {
                final javax.swing.event.CellEditorListener lis=get(i,vCellEditorListener,javax.swing.event.CellEditorListener.class);
                if (lis==null)  continue;
                final javax.swing.event.ChangeEvent ev=new javax.swing.event.ChangeEvent(this);
                if (isStopped) lis.editingStopped(ev); else lis.editingCanceled(ev);
            }
        }
    }

    /* <<< CellEditor <<< */
    /* ---------------------------------------- */
    /* >>> Specific methods for JTree, JList ...  >>> */
    private Component component;
    Component getComponent() {
        if (component!=null) return component;
        final JComponent treeOrList=(JComponent)deref(ref_treeOrList);
        if (value instanceof JComponent) {
            JComponent c=(JComponent)value;
            return treeOrList instanceof JTree || c==FAKED ? c : FAKED.set(c);
        }
        final ChLabel LAB=gcp(KEY_JUST_WRITING_PNG,treeOrList)!=null ? new ChLabel() : LABEL;
        return LAB.t(value!=null ? value.toString() : "");
    }
    public Component getTreeCellRendererComponent(JTree t, Object valueOrRef,boolean selected, boolean expanded,boolean leaf, int row,boolean focus) {
        process(t, valueOrRef,row,0,selected,focus,false);
        return getComponent();
    }

    public Component getTableCellRendererComponent(JTable t,Object valueOrRef,boolean selected,boolean focus,int row,int col){
        process(t, valueOrRef,row,col,selected,focus,false);
        return getComponent();
    }

    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> Font >>> */

    private static Map<String,Object> mapFont=new HashMap();
    private static ChLabel _labFont;
    public Component getListCellRendererComponent(JList l,Object valueOrRef,int row,boolean selected, boolean focus) {
        if (gcp(KEY_ACTION_COMMAND,l)==CMD_FOND_NAME) {
            final ChLabel lab=_labFont==null ? _labFont=new ChLabel() : _labFont;
            lab.t("ABCDEFG abcdefg  "+valueOrRef).fg(selected ?  0xFFffFF : 0).bg(selected ?  0 : 0xFFffFF);
            final String fn=toStrg(valueOrRef);
            if (fn!=null) {
                Font f=getV(fn,mapFont,Font.class);
                if (f==null) mapFont.put(fn,newSoftRef(f=new Font(fn,Font.PLAIN,14)));
                lab.setFont(f);
            }
            return lab;
        }
        process(l, valueOrRef,row,0,selected,focus,false);
        return getComponent();
    }
    public Component getTableCellEditorComponent(JTable t,Object valueOrRef,boolean selected,int row,int col) {
        final Object value=deref(valueOrRef);
        if (value==blankLabel()) return null;
        editedRow=row;
        editedCol=col;
        final Object v_editor=gcp(KEY_EDITOR_COMPONENT,value);
        Component editor=(Component)(v_editor instanceof Component ? v_editor : value instanceof Component ? value : null);
        if (editor==null) {
            process(t, valueOrRef,row, col, selected,true,true);
            editor=getComponent();
        }
        pcp(KEY_EDITED_ROW,intObjct(row),editor);
        pcp(KEY_EDITED_COL,intObjct(col),editor);
        return editor;
    }
    private ArrayList vCellEditorListener;
    public void addCellEditorListener(javax.swing.event.CellEditorListener l){
        adUniq(weakRef(l), vCellEditorListener==null ? vCellEditorListener=new ArrayList() : vCellEditorListener);
    }
    public Object getCellEditorValue(){
        return editorComponent==textField() ? textField().getText() :
            editorComponent==CB_EDITOR ? (CB_EDITOR.isSelected()?Boolean.TRUE:Boolean.FALSE) : "";
    }
    /* <<< Specific methods for JTree, JList ... <<< */
    /* ---------------------------------------- */
    /* >>> Component >>> */
    private Component editorComponent;
    private transient Object ref_treeOrList;
    public void process(JComponent treeOrList, Object valueOrRef, int row, int column, boolean selected, boolean focus,boolean isEditing) {
        if (colors==null) colors=new Color[]{C(0xe0e0e0),C(0xb6b6b6),C(0xdeC8de),C(0xffFFff,200)};
        final ChLabel LAB=gcp(KEY_JUST_WRITING_PNG,treeOrList)!=null ? new ChLabel() : LABEL;

        pcp(KOPT_IS_IN_TABLE_HEADER, row<0 ? "" : null, LAB);
        if (treeOrList==null) { component=new JLabel("treeOrList==null"); return;}
        component=null;
        final ChTextField tf=textField();
        try {
            try {
                if (deref(ref_treeOrList)!=treeOrList) ref_treeOrList=weakRef(treeOrList);
                isSelected=selected;
                value = deref(valueOrRef);
                final boolean debug=value instanceof Object[] && get(0,value)=="sss";
                final ChRunnable chRun=value instanceof ChRunnable ? (ChRunnable)value : null;
                if (chRun!=null) {
                    Object o=chRun.run(MAY_PROVIDE_TREE_VALUE,null);
                    if (o!=null) value=o;
                }
                LAB.i((Icon)null).setText(null);
                if (value==null) { component=blankLabel(); return;}
                final Class cValue=value.getClass();
                LABEL.setHorizontalAlignment(cValue==Integer.class ? JLabel.RIGHT : JLabel.LEFT);
                final JComponent FILLED_AREA= _togFilled==null?_togFilled=new JToggleButton() : _togFilled;
                if (value==treeOrList) component=LAB.t("Root");
                if (value instanceof Color) {
                    component=FILLED_AREA;
                    FILLED_AREA.setBackground((Color)value);
                    FILLED_AREA.setBorder(null);
                    return;
                }
                if (value instanceof Object[]) {
                    final Object oo[]=(Object[]) value;
                    if (oo.length==2 && oo[0]==KEY_TOGGLE_SELECTED && oo[1] instanceof Color) {
                        component=FILLED_AREA;
                        FILLED_AREA.setBackground((Color)oo[1]);
                        FILLED_AREA.setBorder(selected ? BorderFactory.createLoweredBevelBorder() : BorderFactory.createRaisedBevelBorder());
                        return;
                    }
                }
                Color color=colr(value);
                this.rendererOption= value instanceof HasRendererOptions ? ((HasRendererOptions)value).getRendererOptions() : 0L;

                final boolean showClass=value instanceof Class ||
                    value instanceof ProxyClass ||
                    0!=(this.options&CLASS_NAMES)  && value instanceof CharSequence && strchr('.',value)>0;
                if (showClass) {
                    component=component4class(value,LAB);
                    color=value instanceof ProxyClass ? C(0xFFff00) : value instanceof Class && ((Class)value).isInterface() ? C(0x00FFFF) : null;
                    if (LAB.getIcon()==null) LAB.i(IC_BLANK);
                }
                final CharSequence titi_tip=TabItemTipIcon.tip(value), titi_itm;
                final ImageIcon titi_icn=TabItemTipIcon.imageIcon(value);
                if (showClass) titi_itm=null;
                else {
                    CharSequence rt=mapRendererText.get(value);
                    if (rt==null) rt=mapWeakRendererText.get(value);
                    try {
                    if (rt==null && value instanceof HasRendererText) rt=((HasRendererText)value).getRendererText( treeOrList instanceof JList ? HasRendererText.JLIST : 0);
                    } catch(Exception ex){ if (isMyComputer()) stckTrc(ex);}
                    if (rt==null) rt=TabItemTipIcon.item(value);
                    titi_itm=rt;
                }

                if (component==null && value instanceof String && 0!=(this.options&(LAST_PATH_COMPONENT_SLASH|LAST_PATH_COMPONENT_DOT))) {
                    final String s=0!=(options&LAST_PATH_COMPONENT_DOT) ? lastComponent(value,'.') : lastPathCompnt(value);
                    component=LAB.t(sze(s)>0?s:toStrg(value));
                }
                if (component==null && isAssignblFrm(HasRendererComponent.class,cValue)) component=((HasRendererComponent)value).getRendererComponent();
                if (component==null) component=gcp(KEY_RENDERER_COMPONENT,value, Component.class);
                if (component==null && value==KEY_CB_SELECTED) component=LAB.i(isSelected?IC_SHOW:IC_HIDE).bg(DEFAULT_BACKGROUND);
                if (component==null && value instanceof CharSequence) {
                    component= isEditing ? tf.t(toStrg(value)) : LAB.t((CharSequence)value);
                }
                if (component==null && value instanceof Boolean) {
                    final AbstractButton cb=isEditing ? CB_EDITOR :CHECKBOX;
                    cb.getModel().setSelected(Boolean.TRUE.equals(value));
                    component=cb;
                }
                if (component==null && value instanceof File) {
                    final File f=(File)value;
                    final long mode=ChJList.getOptions(treeOrList);
                    final String path= (mode&ChJTable.FILE_NAME)!=0 ? f.getName() : f.getAbsolutePath();
                    component=LAB.i("");
                    if (path.endsWith(TMP_DOWNLOAD_SFX)) {
                        final StringBuffer sb=strBuf(SB_TIP).append(path).append(' ');
                        LAB.t(formatSze(f,sb));
                    } else LAB.t(path);
                }
                if (component==null && value instanceof URL) {
                    final URL u=(URL)value;
                    final long mode=ChJList.getOptions(treeOrList);
                    component=LAB.t((mode&ChJTable.FILE_NAME)!=0 ? lastPathCompnt(u.getFile()) : toStrg(u));
                }
                if (component==null && value instanceof Color) {
                    coloredFieldColor=(Color)value;
                    if (coloredField==null) addPaintHook(instance(), coloredField=new ChPanel());
                    component=coloredField;
                }
                if (component==null && value instanceof Icon)  component=LAB.i((Icon)value).t("");
                if (component==null && HasName.class.isAssignableFrom(cValue)) component=LAB.t(((HasName)value).getName());
                if (component==null && cValue==Integer.class) component=LABEL.t(strBuf(SB_TIP).append(value).append(' '));
                if (component==null && value instanceof JComponent) component=(JComponent)value;
                if (component==null) component=LAB;
                final boolean keepColor=gcp(KEY_KEEP_COLOR,component)!=null;

                final Color fg= !isEnabled(value) ? colors[isSelected?2:1] :  C(isSelected ? FG_SELECTED : 0);
                if (component!=null && !keepColor) {
                    component.setBackground(C(isSelected ? BG_SELECTED : 0xFFffFF));
                    component.setForeground(fg);
                }
                if (component==LAB) {
                    LAB.cp(KEY_COLOR_MARK,color).setBorder(color==null?null: instance());
                    if (titi_icn!=null || titi_tip!=null || titi_itm!=null) {
                        if (titi_itm!=null) LAB.t(titi_itm);
                        if (titi_tip!=null) LAB.tt(titi_tip);
                        if (titi_icn!=null) LAB.i(titi_icn);
                    }
                    LAB.cp(KEY_COLOR, gcp(KEY_COLOR,value));
                }
            } catch(Throwable e) {stckTrc(e);}
        } finally {
            if (isEditing) editorComponent=component;
            pcp(KOPT_IS_SELECTED,isSelected?"":null,component);
            pcp(KEY_NOT_EDITABLE_BG, treeOrList instanceof JTable && isCellEditbl(row,column,(JTable)treeOrList) ? colors[0] : null, component);
        }
    }

    /* <<< Component <<< */
    /* ---------------------------------------- */
       /* >>> IsEnabled  >>> */
    private IsEnabled isEnabled;
    public ChRenderer setEnabled(IsEnabled ie) { isEnabled=ie; return this;}
    private boolean isEnabled(Object o) { return isEnabled!=null  ? isEnabled.isEnabled(o) : true;}
    /* <<< IsEnabled <<< */
    /* ---------------------------------------- */
    /* >>> Class >>> */
    private Component component4class(Object value, ChLabel LABEL) {
        if (value instanceof JLabel) return (JLabel)value;
        final String cn;
        if (value instanceof Class) cn=((Class)value).getName();
        else if (value instanceof String) cn=(String)value;
        else if (value instanceof ProxyClass) cn=toStrg(value); //{ final String cn0=((ProxyClass)value).getName(); cn=((ProxyClass)value) }
        else if (value!=null) cn=value.getClass().getName();
        else cn=null;
        if (cn==null) return LABEL.t("error");
        final String cnShort=cn.substring(cn.lastIndexOf('.')+1);
        this.rendererOption=isProxyClassUnavailable(value) ? HasRendererOptions.STRIKE_THROUGH : 0L;
        String cnShort2=delSfx("PROXY",cnShort);
        return LABEL.t(cnShort!=cnShort2 ? cnShort2+" *" : cnShort).i(TabItemTipIcon.icn(cn));
    }
    /* <<< Class <<< */
    /* ---------------------------------------- */
    /* >>> PaintHook >>> */
    private long rendererOption;
    public boolean paintHook(JComponent c,Graphics g, boolean after)  {
        if (after && c==coloredField) {
            g.setColor(coloredFieldColor);
            g.fillRect(0,0,99999,9999);
        }
        if (after && c==LABEL) {
            if (0!=(HasRendererOptions.STRIKE_THROUGH&rendererOption)) {
                g.setColor(C(0));
                final int y0=c.getHeight()/2, w=c.getWidth();
                randomStrikeThrough(STRIKE_THROUGH_THICK, hashCd(getTxt(c)), g, 0, w,  y0);
            }
        }
        return true;
    }
    private static Random random;
    private static Stroke strokeSU;
    public final static long STRIKE_THROUGH_V=1<<1, STRIKE_THROUGH_THICK=1<<2;
    public static void randomStrikeThrough(long opt, int randomSeed, Graphics g,  int xFrom, int xTo, int y0) {
        if (random==null) random=new Random();
        random.setSeed(randomSeed);
        final Graphics2D g2=(Graphics2D)g;
        final Stroke stroke0=g2.getStroke();
        if (0!=(STRIKE_THROUGH_THICK&opt)) g2.setStroke(strokeSU==null ? strokeSU=new BasicStroke(2.5f) : strokeSU);
        double dir=0, yLast=0, y=0;
        for(int x=xFrom;x<xTo;x++) {
            g.setColor(C(0));
            if (0!=(opt&STRIKE_THROUGH_V)) {
                g.drawLine( y0+(int)yLast,x, y0+(int)y, x+1);
            } else g.drawLine(x, y0+(int)yLast, x+1, y0+(int)y);
            dir+=random.nextFloat()-0.5-y/8-dir/8;
            y+=dir;
            yLast=y;
        }
        g2.setStroke(stroke0);

    }

    public static void paint(JComponent c,Graphics g) {
        if (c==null) return;
        if (gcp(KEY_HAS_CURSOR,c)!=null) {
            ChIcon.drawCursor(g,32,8,16,16,c);
        }
        if (gcp(KEY_REJECTED,c)!=null) {
            g.setColor(colors[3]);
            g.fillRect(0,0,9999,999);
        }
    }
    /* <<< PaintHook <<< */
    /* ---------------------------------------- */
    /* >>> Border >>> */
    @Override public void paintBorder(Component c, Graphics g, int x, int y, int width, int height) {
        Object o=gcp(KEY_COLOR_MARK,c);
        final Color
            col=colr(o),
            old=g.getColor();
        g.setColor(col);
        g.fillRect(0,height/2-4,4,8);
        g.setColor(old);
    }
    @Override public Insets getBorderInsets(Component c, Insets i) {
        i.left=4;  i.top =i.right=i.bottom=0;
        return i;
    }
    /* <<< Border <<< */
    /* ---------------------------------------- */
    /* >>> Small Button >>> */
    private final static Object KEY_SMALL_X[]={new Object(),new Object(),new Object()};
    public final static int BUT_WIDTH=EM, SMALL_CLOSE=1, SMALL_MAXIM=2;
    public static void drawSmallButtons(JComponent c, Graphics g0) {
        for(int type=KEY_SMALL_X.length; --type>=0;) {
            final boolean debug=c instanceof ChTextArea;
            final Object X=gcp(KEY_SMALL_X[type],c);
            if (X!=null) {
                int x=atoi(X);
                if (x==MIN_INT) return;
                if (x<0) x=c.getWidth()+x;
                final Graphics g=g0!=null ? g0 : c.getGraphics();
                if (g!=null) {
                    final int y=0;
                    g.setColor(C(0xFFffFF));
                    g.fillRect(x-2,y-2,BUT_WIDTH+4,BUT_WIDTH+4);
                    if (type==SMALL_CLOSE) {
                        g.setColor(C(0xff0000,99));
                        g.fill3DRect(x,y,BUT_WIDTH,BUT_WIDTH, true);
                        g.setColor(C(0x444444));
                        g.drawLine(x+1,y+1,x+BUT_WIDTH-1,y+BUT_WIDTH-1);
                        g.drawLine(x+BUT_WIDTH-1,y+1,x+1,y+BUT_WIDTH-1);
                    }
                    if (type==SMALL_MAXIM) {
                        g.setColor(C(0x8877ff));
                        g.fillRect(x,y,BUT_WIDTH-3,BUT_WIDTH-2);
                        g.setColor(C(0));
                        g.drawRect(x,y,BUT_WIDTH,BUT_WIDTH);
                    }
                }
            }
        }
    }
    public static boolean setSmallButtonXc(int x, Object o) {
        final Object toBeClosed=gcp(KEY_TO_CLOSE,o);
        if (toBeClosed!=null && o instanceof Component) instance().LI.addTo("m",o);
        return setSmallButtonX(SMALL_CLOSE,x,o);
    }
    public static boolean setSmallButtonX(int type, int x, Object o) {
        final Object key=KEY_SMALL_X[type],  old=gcp(key, o);
        final boolean same= x== (old==null?MIN_INT:atoi(old));
        if (!same) {
            pcp(key,  intObjct(x), o);
            if (type==SMALL_CLOSE && o instanceof AbstractButton) instance().LI.addTo("M",o);
        }
        return !same;
    }
    private final static Map<Object,String> mapRendererText=new IdentityHashMap();
    private final static Map<Object,String> mapWeakRendererText=new WeakHashMap();
    public static void setRendererText(Object o, String txt) { mapRendererText.put(o,txt);}
    public static void setWeakRendererText(Object o, String txt) { mapRendererText.put(o,txt);}

     static int hashC(Object o) {
        Object oHC=o;
        if (o instanceof UniqueList) {
            final String txt=((UniqueList)o).getText();
            if (txt!=null) oHC=txt;
        }
        return oHC==null ? 0 : oHC.hashCode();

    }

}
