package charite.christo;
import java.awt.*;
import javax.swing.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import static java.awt.event.MouseEvent.*;
public class ChScrollBar extends JScrollBar {
    public ChScrollBar(int v_or_h) {
        super(v_or_h);
        final DefaultBoundedRangeModel model=new DefaultBoundedRangeModel(0, 1, 0, 100) {
                @Override public int getValue() {
                    return (System.currentTimeMillis()-ChScrollBar.this.lockAtEnd)<5555 ? super.getMaximum() : super.getValue();
                }
            };
        setModel(model);
    }
    public @Override int getUnitIncrement() {
        final int ui=super.getUnitIncrement();
        final JScrollPane sp=deref(getParent(), JScrollPane.class);
        if (sp!=null) {
            final JViewport vp=sp==null?null:sp.getViewport();
            final Component view=vp==null?null: vp.getView();
            if (ChTextComponents.tools(view)!=null) return maxi(1, charH(view));
            final boolean isVert=sp.getVerticalScrollBar()==this;
            if (isVert && (view instanceof JList || view instanceof JTable)) {
                final int h=view.getHeight();
                final int n=view instanceof JTable ? ((JTable)view).getRowCount() : sze(view);
                return maxi(1, n==0 ? ICON_HEIGHT : h/n);
            }
            if (isVert && view instanceof JTable) {
                final int rh=((JTable)view).getRowHeight();
                return maxi(1,rh<1 ? ICON_HEIGHT : rh);
            }
        }
        return ui==1 ? EX : ui;
    }
    /* <<< Constructor <<< */
    /* ---------------------------------------- */
    /* >>> set selection >>> */
    private boolean _hasSelection;
    /** to be set in paint hook */
    public void setHasSelection(boolean b) {
        this._hasSelection=b;
    }
    private int[] selected;
    private int rowHeight;
    private Color colors[];
    public void setSelectedY(int[] ii, int rowHeight,Color cc[]) {
        this.selected=ii;
        this.colors=cc;
        this.rowHeight=rowHeight;
        repaint();
    }
    /* <<< set selection <<< */
    /* ---------------------------------------- */
    /* >>> paint >>> */

    @Override public void paintComponent(Graphics g) {

        final int modi=modifiers(getLastMouseEvt());
        /*
        if (0!=(modi&SHIFT_MASK)*(modi&ALT_MASK))  {
            super.paintComponent(g);
            final Rectangle t=getTrack(), b=getThumb();
            g.setColor(Color.RED);
            g.drawRect(t.x+1, t.y+1, t.width-2, t.height-2);
            g.setColor(Color.GREEN);
            g.drawRect(b.x+1, b.y+1, b.width-2, b.height/2);
            return;
        }
        */
        final int ii[]=this.selected;
        _hasSelection=sze(ii)>0;
        if (paintHooks(this, g, false)) {
            if (_hasSelection) {
                final Rectangle track=getTrack(), thumb=getThumb();
                g.setColor(C(0xFFffFF));
                g.fillRect(track.x,track.y,track.width,track.height);
                g.setColor(C(0));
                g.drawRect(thumb.x+1,thumb.y+1,thumb.width-2,  maxi(1,thumb.height-2));
            } else try { super.paintComponent(g); } catch(Exception e){}
            if (sze(ii)>0) {
                final Rectangle track=getTrack();
                final int max=getMaximum();
                final int w=track.width-5;
                Color cc[]=this.colors, c=C(ChRenderer.BG_SELECTED);
                if (max>0 && w>0 && track.height>0) {
                    for(int i=0; i<ii.length; i++) {
                        if (ii[i]>=0) {
                            if (cc!=null && i<cc.length) c=cc[i];
                            g.setColor(c!=null ? c : C(ChRenderer.BG_SELECTED));
                            g.fillRect(4,track.y + ii[i]*rowHeight * track.height/max, w,2);
                        }
                    }
                }
            }
        }
        paintHooks(this, g, true);
        if (System.currentTimeMillis()-lockAtEnd<5555) {
            g.setColor(C(0xFF));
            final Rectangle thumb=getThumb();
            g.drawRect(0,thumb.y,thumb.width-1, maxi(1,thumb.height-1));
        }
    }
    /* <<< paint <<< */
    /* ---------------------------------------- */
    /* >>> AWTEvent >>> */
    { this.enableEvents(ENABLE_EVT_MASK);}
    @Override public void processEvent(AWTEvent ev) {
        final int id=ev.getID(), modi=modifiers(ev);
        if (id==MOUSE_ENTERED && super.getUnitIncrement()!=getUnitIncrement()) setUnitIncrement(getUnitIncrement());
        if (id==MOUSE_DRAGGED || id==MOUSE_ENTERED || id==MOUSE_EXITED) lockAtEnd=0;
        if (shouldProcessEvt(this,ev)) {
            if (0==(modi&CTRL_MASK) || wheelRotation(ev)==0) super.processEvent(ev);
        }
    }

    /* <<< AWTEvent <<< */
    /* ---------------------------------------- */
    /* >>> Workaround for protected methods >>> */

    private boolean warningTrack;
    private final Rectangle rTrack=new Rectangle(), rThumb=new Rectangle();
    public Rectangle getTrack() {
        final Object ui=getUI();
        final String uic=ui.getClass().getName();
        if (uic.endsWith(" ChAquaScrollBarUI")) return ((ChAquaScrollBarUI )ui).getTrackBounds();
        if (uic.endsWith("ChMetalScrollBarUI")) return ((ChMetalScrollBarUI)ui).getTrackBounds();

        final int W=getWidth(), H=getHeight();
        final int incrGap=atoi(UIManager.get("ScrollBar.incrementButtonGap"));
        final int decrGap=atoi(UIManager.get("ScrollBar.decrementButtonGap"));

        //putln(" incrGap="+incrGap);
        final Component b1, b2;
        {
            Component c1=null,c2=null;
            for(Component c : getComponents()) {
                if (c instanceof AbstractButton) {
                    if (c1==null) c1=c;
                    else c2=c;
                }
            }
            if (c2==null) b1=b2=null;
            else if (c1.getY()<c2.getY() || c1.getX()<c2.getX()) { b1=c1; b2=c2; }
            else { b1=c2; b2=c1; }
        }
        final Rectangle r=rTrack;
        if (getOrientation()==JScrollBar.HORIZONTAL) {
            if (b2!=null) {
                r.x=b1.getX()+b1.getWidth()+incrGap;
                r.width=b2.getX()-decrGap-r.x;
            } else {
                r.x=EX;
                r.width=W-2*EX;
                if (!warningTrack) { warningTrack=true; putln(RED_WARNING+"ChScrollBar no buttons");}
            }
            r.height=H;
        } else {
            r.width=W;
            if (b2!=null) {
                r.y=b1.getY()+b1.getHeight()+incrGap;
                r.height=b2.getY()-decrGap-r.y;
            } else {
                r.y=EX;
                r.height=H-2*EX;
            }
        }
        return r;
    }
    public Rectangle getThumb() {
        final Object ui=getUI();
        final String uic=ui.getClass().getName();
        if (uic.endsWith( "ChAquaScrollBarUI")) return  ((ChAquaScrollBarUI)ui).getThumbBounds();
        if (uic.endsWith("ChMetalScrollBarUI")) return ((ChMetalScrollBarUI)ui).getThumbBounds();
        if (uic.endsWith("ChWindowsScrollBarUI")) return ((ChWindowsScrollBarUI)ui).getThumbBounds();

        final Rectangle track=getTrack(), r=rThumb;
        final int v=getValue(), m=getMaximum(), e=getVisibleAmount();
        //putln(" e="+e+" m="+m);
        if (getOrientation()==JScrollBar.HORIZONTAL) {
            r.x=track.x+track.width*v/m;
            r.width=track.width*e/m;
            r.height=track.height;
        } else {
            r.y=track.y+track.height*v/m;
            r.height=track.height*e/m;
            r.width=track.width;
        }
        return r;
    }

    /* <<< Workaround <<< */
    /* ---------------------------------------- */
    /* >>>  Lock End position >>> */
    private long lockAtEnd=0;
    public  static void setLock(boolean b, JScrollBar sb) {
        if (sb instanceof ChScrollBar) {
            ((ChScrollBar)sb).lockAtEnd=b ? System.currentTimeMillis() : 0;
        }
    }

}

/*
JComponent
 BasicScrollBarUI
 apple.laf.AquaScrollBarUI
 com.sun.java.swing.plaf.windows.WindowsScrollBarUI
 javax.swing.plaf.synth.SynthScrollBarUI
 javax.swing.plaf.metal.MetalScrollBarUI
*/