package charite.christo;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import javax.swing.JSlider;
import javax.swing.JLabel;
import java.awt.event.*;
import charite.christo.interfaces.*;
import java.awt.*;
import java.util.*;
/**
   convenient extension of JSlider
   @author Christoph Gille
*/
public final class ChSlider extends JSlider implements javax.swing.event.ChangeListener,MouseWheelListener, HasModiCount {
    private final String command;
    /* >>> Constructor  >>> */
    public ChSlider(String cmd,int mi,int ma,int ini ) {
        super(mi,ma,maxi(mi,ini));
        assertInstAllowed();
        command=cmd;
        addChangeListener(this);
        addMouseWheelListener(this);
    }
    public ChSlider tt(CharSequence tt) {
        setToolTipText(addHtmlTagsAsStrg(tt));
        return this;
    }
    /* <<< Constructor <<< */
    /* ---------------------------------------- */
    /* >>> Event  >>> */
    public void stateChanged(javax.swing.event.ChangeEvent ev) {
        if (clas!=null && id!=null) setPrpty(clas,id,ChSlider.this.getValue());
        handleActEvt(this,command,0);
        ChDelay.repaint(this,1111);
        modi++;
    }
    @Override public void processEvent(AWTEvent e) {
        try{ super.processEvent(e);} catch(Exception ex){}
    }
    public void mouseWheelMoved(MouseWheelEvent ev) {
        final int ma=getMaximum(),mi=getMinimum();
        int i=ev.getWheelRotation()*(ma-mi)/ (isCtrl(ev) ? 200:50)+getValue();
        if (i<mi)i=mi;
        if (i>ma)i=ma;
        setValue(i);
        modi++;
    }
    /* <<< Event <<< */
    /* ---------------------------------------- */
    /* >>> Value >>> */
    private int modi;
    public int getModificationCount() { return modi;}
    public JSlider cln() {
        return new JSlider(getModel());
    }
    /* <<< Value <<< */
    /* ---------------------------------------- */
    /* >>> Label >>> */
    private final String[] labels=new String[2];
    public ChSlider endLabels(String l0,String l1) {
        labels[0]=l0;
        labels[1]=l1;
        if (l0!=null || l1!=null) {
            Hashtable ht=new Hashtable();
            ht.put(intObjct(0),new JLabel(" "));
            setLabelTable(ht);
            try { setPaintLabels(true); } catch(Exception e){}
        }
        return this;
    }
    /* <<< Label <<< */
    /* ---------------------------------------- */
    /* >>> paint >>> */
    private boolean lastIsEnabled=true;
    public void paintComponent(Graphics g) {
        if (lastIsEnabled!=isEnabled()) { revalidate(); lastIsEnabled=isEnabled();}
        if (!isOpaque()) setBackground(C(0xFFffFF)); /* Nimbus bug */
        try { super.paintComponent(g);} catch(Throwable e){ stckTrc();}
        if (labels[0]!=null || labels[1]!=null) {
            final Font f=getFnt(11,false,0);
            g.setFont(f);
            final Rectangle cb=charBounds(f);
            final int y=getHeight()-cb.height+cb.y;
            final int w0=strgWidth(f,labels[0]);
            final int w1=strgWidth(f,labels[1]);
            if (w0+w1<getWidth()) {
                g.setColor(C(0));
                if (w0>0) g.drawString(labels[0],0,y);
                if (w1>0) g.drawString(labels[1],getWidth()-w1,y);
            }
        }
        ChButton.drawTopAndButtomText(this,g);
    }
    /* <<< paint <<< */
    /* ---------------------------------------- */
    /* >>> layout >>> */
    @Override public Dimension getPreferredSize() {
        Dimension d=getPrefSize(this);
        try {
            if (d==null) d=super.getPreferredSize();
        } catch(Exception e){ d=dim(32,32);}
        return d;
    }
    /* <<< layout <<< */
    /* ---------------------------------------- */
    /* >>>  >>> */
    private Class clas;
    private String id;
    public ChSlider save(Class clas,String id_str) {
        this.clas=clas;
        this.id="slider_"+id_str;
        setValue(getPrpty(clas,id,getValue()));
        return this;
    }

 }
