package charite.christo;
import charite.christo.interfaces.*;
import java.awt.*;
import java.io.File;
import java.util.*;
import javax.swing.*;
import javax.swing.text.JTextComponent;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**
   views html and plain text
   @author Christoph Gille
*/
public class ChTextViewer extends ChPanel implements Disposable, javax.swing.event.CaretListener, ChRunnable {

      final static Object KEY_TEXT_CSS_JS=new Object();
    private ImageIcon icon,infoIcon;
    public ChTextViewer infoIcon() {add(new JLabel(infoIcon=icon=iicon(IC_INFO)),BorderLayout.WEST); return this;}
    public final ChTextViewer i(ImageIcon ic) { TabItemTipIcon.set(null,null,null,ic,this);return this;}
    public void dispose() {
        final ChFrame f=getFrame();
        if (f!=null) f.dispose();
        else rmFromParent(this);
    }
    public ChTextViewer setCaretPosition(int p) {
        try{ _textPane.setCaretPosition(p);} catch(Exception e){}
        return this;
    }
    public void setCaretToLine(int line) {
        final ChTextComponents tools=ChTextComponents.tools(getTextComponent());
        if (tools!=null) {
            try{
                setCaretPosition(tools.byteArray().getLineEnds()[line]);
            }catch(Exception e){}
        }
    }
				private final boolean isJava,isHtml;
    private String text;

    public ChTextViewer(Object txt) { this(txt,ChFrame.AT_CLICK);}
    public ChTextViewer(Object txt, long options) {

        if (txt instanceof ByteArray) text=((ByteArray)txt).newString();
        else if (txt instanceof JTextComponent) _textPane=(JTextComponent)txt;
        else if (txt instanceof File)  { final String s=readStrg((File)txt); text=s!=null ? s :  " error: not found" ;}
        else text=toStrg(txt);

        final int i0=nxt(NO_SPC,text,0);
        if (i0>=0) {
            isHtml= chrAt(i0,text)=='<';
            isJava= equls("package",text,i0) || equls("import java",text,i0) || equls("import charite.",text,i0) || equls("import org.",text,i0);
        } else isHtml=isJava=false;
    }

    public ChTextViewer title(String s) {
        TabItemTipIcon.set(null,s,null,null,this);
        ChUtils.setTitl(s,getFrame());
        return this;
    }
    private JTextComponent _textPane;
    public JTextComponent getTextComponent() {
        if (this._textPane==null) {
            final JTextComponent tc=this._textPane= isHtml || isJava  ? new HyperTextPane() : new ChTextArea("");
            pcp(KEY_TITLE, (isHtml ? "Html" : isJava ? "Java" : null),tc);
            tc.setEditable(false);
            final String aClass=gcps(KEY_CLASS_NAME,this);
            pcp(KEY_CLASS_NAME,aClass,tc);
            setBG(0xFFffFF, tc);
            if (text!=null && !isHtml) ChTextComponents.tools(tc).setTextTS(text);
            if (isHtml||isJava) {
                tc.setOpaque(false);
                final HyperTextPane htp= (HyperTextPane)tc;
                final ChTextComponents tools=ChTextComponents.tools(tc);

                if (isHtml) {
                    final StringBuffer sbViewedText=new StringBuffer(999+sze(text)).append("<!DOCTYPE HTML><html><head>");
                    pcp(KEY_ORIGINAL_TEXT,text,tc);
                    final int posCss=sze(sbViewedText);
                    sbViewedText.append("<title>STRAP</title></head>\n<body bgcolor=\"#FFFFFF\">\n");
                    final int posJS=sze(sbViewedText);
                    sbViewedText.append(text).append("</body></html>");
                    String name=TabItemTipIcon.tab(this);
                    if (aClass!=null && name==null) name=aClass.substring(aClass.lastIndexOf('.')+1);
                    pcp("NAME",name,htp);
                    final String imported[]=HtmlDoc.getImportedPackages(sbViewedText,aClass);
                    HtmlDoc.process(sbViewedText,name, DOCTYPE_TUTORIAL,imported);
                    tools.setImportedPackages(imported);
                    try {
                        htp.setEditorKit(new HtmlDocEditorKit(imported));
                    } catch(Exception e){}
                    htp.setContentType("text/html");
                    HtmlDoc.addHyperlinkListener(htp);
                    htp.setEditable(false);
                    final String viewedText=sbViewedText.toString();
                    htp.setText(viewedText);
                    htmlTidy(viewedText);
                    pcp(KEY_TEXT_CSS_JS, new Object[]{viewedText,intObjct(posCss),intObjct(posJS)}, htp);
                    ((javax.swing.text.html.HTMLDocument)htp.getDocument()).getStyleSheet().addRule(HtmlDoc.getCssOrJS("css", DOCTYPE_TUTORIAL, false));

                }
                if (isJava) {
                    monospc(htp);
                    pcp(ChTextComponents.KEY_CLASS_AT_CURSOR,"",htp);
                    final javax.swing.text.StyledDocument doc=htp.getStyledDocument();
                    ChCodeViewer.highlightSyntax(tools.byteArray(),doc);
                    tools.underlineRefs(0);
                    htp.lineWrap(false).setEditable(false);
                }
                tools.underlineRefs(UNDERLINE_REFS);
            }
        }
        return this._textPane;
    }
    public ChTextViewer txt(Object text) {
        final JTextComponent tc=getTextComponent();
        tc.setText(toStrg(text));
        ChTextComponents.tools(tc).underlineRefs(0);return this;
    }

    private JComponent pButtons;
    private final JComponent pNorthEast=hB();
    public ChTextViewer addNorth(Component c) { pNorthEast.add(c,0);return this;}
    public final static String KEYBINDINGS="F1 Help   CTRL-key actions:   C Copy   V Paste   F Find   P Print  +/- Zoom   * Font quality   R shell script";
    public synchronized JComponent getPanel() {
        if (sp==null) {
            final ScrollLabel LAB_INFO=new ScrollLabel(KEYBINDINGS + (isHtml ? "" :"  L toggle-line-wrap"));
            setBG(0xFFffFF, LAB_INFO);
            final String aClass=gcps(KEY_CLASS_NAME,this);
            if (!isJava && hasSource(aClass)) pNorthEast.add(smallSourceBut(aClass));
            pButtons=newCNSEW(LAB_INFO,null,null,pNorthEast,null);
            final JTextComponent tc=getTextComponent();
            final ChTextComponents tools=ChTextComponents.tools(tc);
            this.sp=tools.scrollPane();
            //if (getFrame()==null) pNorthEast.add(new ChButton().actionClose(this));
            if (getFrame()==null) pNorthEast.add(new ChButton().actionClose(this,0L));
            disposeOnCtrlW(0L, tc,this);
            if (isHtml) sp.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
            cnsew(this,sp,pButtons, null,null,infoIcon);
            new CollapseComponent(pButtons,"S").child(pNorthEast).child(LAB_INFO);
            tc.addCaretListener(this);
            CollapseComponent.preventedBy(sp);
            tools.underlineRefs(0);
            ChDelay.afterMS(EDT,ChDelay.SCROLL_UP,sp,333,null);
        }
        return this;
    }
    private JScrollPane sp;
    public void caretUpdate(javax.swing.event.CaretEvent ev) {ChDelay.runAfterMS(EDT,this,"CURSOR",111);}
    public final Object run(String id, Object arg) {
        if (id=="CURSOR") {
            if (_textPane!=null) {
            if (lineNo==null) pButtons.add(lineNo=new ChTextField().cols(6,true,true).ro(),BorderLayout.WEST);
            if (lineNo.getHeight()<EX) pButtons.revalidate();
            final ChTextComponents tools=ChTextComponents.tools(this);
            lineNo.t(String.valueOf(tools.byteArray().idxToRow(_textPane.getCaretPosition())));
            }
        }
        return null;
    }
    private ChTextField lineNo;
    private Object refFrame;
    public ChFrame getFrame() { return deref(refFrame,ChFrame.class);}
    public ChTextViewer shw(long options) {
        ChFrame f=getFrame();
        if (f==null || f.isDisposed()) {
            if (icon==null) icon=iicon(IC_STRAP);
            refFrame=weakRef(f=new ChFrame(TabItemTipIcon.item(this)).ad(getPanel()).relativeSize(.7,.7).i(icon));
        }
        f.shw(AsciiView.FRAME_OPTS|options);
        ChTextComponents.reduceHeight(f,getTextComponent());
        final Object db=gcp(ACTION_DATABASE_CLICKED,this);
        if (db!=null) pcp(ACTION_DATABASE_CLICKED,db,getTextComponent());
        return this;
    }
 }
