package charite.christo;
import java.awt.*;
import java.awt.image.RGBImageFilter;
/**
   Contains color filters
   @author Christoph Gille
*/
public final class ColorFilter extends RGBImageFilter {
    public ColorFilter(int blue,int green,int red) {this.blue=blue;this.green=green;this.red=red;}
    public ColorFilter(Color c) {blue=c.getBlue();green=c.getGreen();red=c.getRed();}
    private final int blue,green,red;
    @Override public int filterRGB(int x, int y, int rgb) {
        int
            b=(rgb>>0) & 255,
            g=(rgb>>8) & 255,
            r=(rgb>>16) & 255,
            a=(rgb>>24) &255;
        x=(r+g+b)/3;
        b=(x*blue)>>8;
        g=(x*green)>>8;
        r=(x*red)>>8;
        return b + (g<<8) +(r<<16) +(a<<24);
    }
}
