package charite.christo;
import charite.christo.interfaces.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**HELP

With this dialog obtainable from the "plugin"-menu shell programs
can be run on files or character sequences.

The program can be chosen from the choice menu or can be typed.

If the command line contains a dollar followed by an asterisk, it is replaced by the
command arguments. Otherwise the arguments are placed behind the
expression.

<br><br><b>New shell process:</b>

Complex command lines involving pipes, redirection, variable assignments or loops need to be interpreted by a shell.

This is achieved by starting the command with "SH"  (or "CYGWINSH" on Windows PCs).

<br><br><b>White space:</b>

White space within arguments must be written as <b>"%20"</b>.

<br><br><b>More Details:</b>
For details of the running process hold the CTRL key while pressing the button <i>LABEL:ChButton#BUTTON_GO</i> or watch the stdout.

   @author Christoph Gille
*/
public class DialogExecuteOnFile extends JPanel implements ActionListener {
    private String argv[];
    private ChTextField tf;
    private ChCombo combo;
    private Object[] radioTf;
    private final Customize customize;
    public DialogExecuteOnFile(Customize c) { this.customize=c;  }
    private ChFrame frame;

    public void show(String[] ff) {
        this.argv=ff;
        for(int i=ff.length; --i>=0;) ff[i]=rplcToStrg(" ","%20",ff[i]);
        if (frame==null) {
            this.combo=customize.newComboBox();
            this.radioTf=radioGrp(new String[]{"",""},0,this);
            this.tf=new ChTextField().saveInFile(getClass()+"tf");
            this.tf.setEnabled(false);
            pcp(KEY_IF_EMPTY,"enter command line",this.tf);
            if (""==tf.toString()) tf.t("SH echo $* > /tmp/t;xterm -e less /tmp/t");
            final JComponent
                pViewFile=this,
                panCombo=hB(radioTf[0],"#",combo," ",customize.newButton().options(ChButton.NO_FILL|ChButton.NO_BORDER|ChButton.ICON_SIZE)),
                pMain=vB(
                         hB(pnl("<h2>Shell command</h2>"),"#",panHS(this)),

                            hBL(new ChButton("A").t("See argument list").li(this)),
                            pViewFile,
                            " ",
                            newCNSEW(pnl(new ChButton("C").t("\u2193").li(this).tt("Copy the selected string into the text-field")),panCombo,hB(radioTf[1],"#",tf),null,null),
                            pnl(new ChButton("GO").t(ChButton.GO).li(this))
                            );
            frame=new ChFrame("execute").ad(pMain);
        }
        frame.shw(ChFrame.PACK|ChFrame.AT_CLICK);
    }

    public void actionPerformed(ActionEvent ev) {
        final Object q=ev.getSource();
        final String cmd=ev.getActionCommand();
        if (cmd=="A") new ChTextViewer(joinLines(argv)+"\n").title("argument list").shw(ChFrame.SIZE_REGARD_RESOLUTION|ChFrame.AT_CLICK);
        if (cmd=="C") tf.t(combo.toString());
        if (cmd=="GO") {
            final String command= (radioGrpIdx(radioTf)==0 ? combo : tf).toString();
            final String args=joinAsStrg(argv," ");
            final StringBuffer sb=new StringBuffer(99).append(command);
            if (command.indexOf("$*")>=0) rplcSb(0L,"$*",args,sb);
            else sb.append(" ").append(args);
            ChExec ex=new ChExec(ChExec.STDOUT_IN_TEXT_BOX|ChExec.LOG).setCommandLine(sb);
            if (isCtrl(ev)) ex.log(customize);

            new Thread(ex,"DialogExecuteOnFile").start();
        }
        final int iRadio=radioGrpIdx(q);
        if (iRadio>=0) {
            combo.setEnabled(iRadio==0);
            tf.setEnabled(iRadio!=0);
        }
    }
}
