package charite.christo;
import static charite.christo.ChUtils.*;
import javax.swing.*;
import java.awt.*;
import java.util.*;
/**
   Used by CellRenderers. This JComponent draws inside another JCcomponent.
   @author Christoph Gille
*/
public class FakedJComponent extends JPanel  {
    private Object component;
    public FakedJComponent set(JComponent c) { component=c; noInsets(this); return this;  }
    private JComponent get() {
        return (JComponent) deref(component);
    }
    @Override public Dimension getPreferredSize() {
        final JComponent c=get();
        return c!=null ? c.getSize() : dim(32,32);
    }
    @Override public void paintComponent(Graphics g) {
        final JComponent c=get();
        if (c==null) {
            g.setColor(Color.RED);
            g.drawString("FakedJComponent no component to fake",10,10);
            putln("FakedJComponent no component to fake");
        } else {
            SwingUtilities.paintComponent(g,c,getParent(),0,0,getWidth(),getHeight());
        }
    }
}
