package charite.christo;
import java.util.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
public class HelpCommands {
    public final static int DEFINITION=0, EXAMPLE=1, HINT=2, ALL=255;
    private ByteArray ba;
    private final String resource;
    private HelpCommands(String resource) {
        this.resource=resource;
    }
    private Map<String, String> maps[];
    public Map[] getMaps() {
        if (maps==null) {
            maps=new HashMap[4];
            ba=readBytes(rscAsStream(0L,"",resource));
            if (ba==null) ba=new ByteArray(0);

            final byte T[]=ba.getBytes();
            final int[] ends=ba.getLineEnds();
            String command=null;
            for(int iL=0; iL<ends.length; iL++) {
                final int b=iL==0 ? 0 : ends[iL-1]+1;
                final int e=prev(NO_SPC,T,ends[iL]-1,b-1)+1;
                if (e-b<3) continue;
                if (T[b]!=' ') {
                    command=ba.newString(b,nxtE(SPC,T,b,e));
                }
                if (command!=null) {
                    int start=0, type=0;
                    if (T[b]==' ') {
                        start=2;
                        type= T[b+1]=='E' ? EXAMPLE : T[b+1]=='H' ? HINT : 0;
                    }
                    if (maps[type]==null) maps[type]=new HashMap();
                    String prev=maps[type].get(command);
                    final String line=ba.newString(b+start, e);
                    final String value=prev!=null ? prev+"\n"+line : line;
                    maps[type].put(command, value);
                    maps[type].put(command+" ", value);
                }
            }
        }
        return maps;
    }
    final StringBuffer sb=new StringBuffer();
    public String get(int type, String c) {
        final Map<String,String> maps[]=getMaps();
        if (type==ALL) {
            sb.setLength(0);
            for(int i=0; i<maps.length; i++) {
                final String v=maps[i]==null?null:maps[i].get(c);
                if (v==null) continue;
                sb.append(i==EXAMPLE ? "Example: " : i==HINT ? "Hint: " : "").append(v).append('\n');
            }
            return sb.toString();
        }
        else return maps[type].get(c);
    }

    private static Map<String,HelpCommands> map;
    public static HelpCommands getInstance(String resource) {
        if (map==null) map=new HashMap();
        HelpCommands h=map.get(resource);
        if (h==null) map.put(resource,h=new HelpCommands(resource));
        return h;
    }

    // java charite.christo/HelpCommands
    public static void main(String argv[]) throws Exception {
        HelpCommands h=getInstance(_CCS.replace('.','/')+"/scriptHelp.rsc");
        putln(h.get(ALL,"cursor"));
        putln("\n");
        putln(h.get(ALL,"cursor"));

    }

}

