package charite.christo;
import charite.christo.interfaces.*;
import java.io.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
public class Hex2bin {
    private Hex2bin(){}
    /*
    public static void test() {
        putln(FROM_HEX_LO['F']);
        putln( hex2bin(bin2hex("hal\nlo~".getBytes())));
        byte hh[]={0,1,2,3,4,5, -1,-2,-4,1,2,3};
        File f=ChUtils.file("t");
        ChUtils.wrte(f,hh);
        //  hh=ChUtils.readBytes(f);
        for(byte h:hh) { out.print(h);out.print(" ");}
    }
    */
    public static void main(String args[]){
        //test();
        for(String a:args) main(a);
    }
    public static void main(String args){
        byte bb[]=ByteArray.trimSize(ChUtils.readAndDecompress(args,(ByteArray)null));
        if (!args.endsWith(".hex")) { putln("File name "+args+" does not end with .hex"); return;}
        if (bb==null) { putln("could not read ");putln(args); return;}
        final File f=ChUtils.file(ChUtils.delSfx(".hex",args));
        putln("read file "+args+" "+bb.length+" bytes");
        final byte hh[]=hex2bin(bb);
        putln("read file "+args+" "+hh.length+" bytes");
        ChUtils.wrte(f,hex2bin(bb),0,MAX_INT);
    }
    private final static byte[] HEX="0123456789ABCDEF".getBytes();
    private static int[] FROM_HEX_LO=new int[256],FROM_HEX_HI=new int[256];
    static {
        for(int i=HEX.length;--i>=0;) {
            FROM_HEX_HI[HEX[i]]=i*16;
            FROM_HEX_LO[HEX[i]]=i;
        }
    }

  public static byte[] hex2bin(byte hh[]) { return hex2bin(hh, 0, MAX_INT); }
    public static byte[] hex2bin(byte hh[], int from, int to) {
        final int t=mini(to, sze(hh));
        if (from>=t) return NO_BYTE;
        byte bb[]=new byte[(t-from)/2];
        for(int i=0,i2=from; i<bb.length; i++,i2+=2) {
            bb[i]=(byte)(FROM_HEX_HI[hh[i2]]+FROM_HEX_LO[hh[i2+1]]);
        }
        return bb;
    }
    public static byte[] bin2hex(byte[] bb) { return bin2hex(bb,0,MAX_INT);}
    public static byte[] bin2hex(byte[] bb,int from,int to) {
        if (bb==null) return null;
        to=mini(to,bb.length);
        int n=to-from;
        byte hh[]=new byte[2*n];
        for(int i=from,i2=0;i<to;i++) {
            int b=bb[i]; if (b<0) b+=256;
            hh[i2++]=HEX[b>>4];
            hh[i2++]=HEX[b&0xf];
        }
        return hh;
    }
}
