package charite.christo;
import charite.christo.interfaces.*;
import javax.swing.*;
import java.util.*;
import java.io.File;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
public class HtmlDoc implements javax.swing.event.HyperlinkListener, java.awt.event.ActionListener {
    public final static Object KEY_DO_NOT_CLONE=new Object();
    private final static Object KEY_ORIGINAL_SIZE=new Object();
    private final static String
        sDOCTYPE_HTML="<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\" \"http://www.w3.org/TR/html4/strict.dtd\">\n",
        STRING="STRING:",HOME_PAGE="HOME_PAGE:",STRING_ARRAY="STRING_ARRAY:",TEXT_LINES="TEXT_LINES:",
        DIALOG="DIALOG:",ITEM="ITEM:", CLASS_REF="CLASS_REF:",
        INCLUDE_DOC="INCLUDE_DOC:", INCLUDE_DOC1="INCLUDE_DOC1:",
        INCLUDE_DOC2="INCLUDE_DOC2:",INCLUDE_DOC3="INCLUDE_DOC3:",INCLUDE_FILE="INCLUDE_FILE:",
        REGISTER_JAVADOC="REGISTER_JAVADOC:",JAVADOC="JAVADOC:",
        SEE_DIALOG="SEE_DIALOG:",JAVASOURCE="JAVASOURCE:",ABOUT="ABOUT:",SEE_CLASS="SEE_CLASS:",
        CONTROL="CONTROL:",CUSTOMIZE="CUSTOMIZE:",
        COMBO="COMBO:",TREENODE="TREENODE:",JCOMPONENT="JCOMPONENT:",CB="CB:",
        BUTTON="BUTTON:",LABEL="LABEL:", TEXTFIELD="TEXTFIELD:",ICON="ICON:", IMAGE="IMAGE:", CLASSICON_CLASSNAME="CLASSICON_CLASSNAME:";
      final static String
        PACKAGE="PACKAGE:",
        TAGS_FOR_EDITOR_KIT[]={TREENODE,JCOMPONENT,CLASSICON_CLASSNAME,CB,BUTTON,CONTROL,CUSTOMIZE,COMBO,LABEL,TEXTFIELD, PACKAGE,ICON, IMAGE};
    public final static String
    ID_LAST_COMPONENT="ID_LAST_COMPONENT",
        ID_BUTTON_FOR_CLASS="ID_BUTTON_FOR_CLASS",
        ACTION_VIEW_SOURCE="http://VIEW_SOURCE",
        ACTION_OPEN_DIALOG="http://OPEN_DIALOG",
        SPECIAL_HTML_TAG[]={PACKAGE,STRING_ARRAY,TEXT_LINES,STRING,HOME_PAGE,CLASSICON_CLASSNAME,REGISTER_JAVADOC,ABOUT,DIALOG,ITEM,CLASS_REF, TREENODE,
                            JCOMPONENT,INCLUDE_DOC,INCLUDE_FILE,CUSTOMIZE,
                            INCLUDE_DOC1,INCLUDE_DOC2,INCLUDE_DOC3,SEE_CLASS,SEE_DIALOG,JAVASOURCE,JAVADOC,BUTTON,COMBO,LABEL,TEXTFIELD, ICON, IMAGE,
                            CB,TREENODE,TREENODE};
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> JComponent >>> */
    static boolean jComponent(String id,HtmlDocElement f) {
        if (f==null || idxOf(id,TAGS_FOR_EDITOR_KIT)<0) return false;
        final Object fValue=f.getValue();
        final java.lang.reflect.Member member=f.getMember();
        final JComponent fValueJC=fValue instanceof JComponent ? (JComponent)fValue : null;
        final CharSequence fValueCS=fValue instanceof CharSequence ? (CharSequence)fValue : null;
        final String fieldOrMethod=f.getFieldOrMethod();
        final boolean noField=sze(fieldOrMethod)==0;
        final Class clazz=f.getClazz();
        final Object likelyParameter=
            noField &&clazz!=null ?clazz :
            fValue!=null ? fValue :
            !noField ? fieldOrMethod : null;
        final String fPara=f.getParameter();
        JComponent jComponent=null;
        boolean isError=false;
        if (id==CONTROL) {
            final ChButton b=ChButton.actionSharedCtrl(clazz);
            jComponent=b;
            b.setBorderPainted(true);
            b.setContentAreaFilled(true);
        } else if (id==CUSTOMIZE) {
            Customize cust=
                fValue instanceof Integer ? Customize.customize(atoi(fValue)) :
                fValue instanceof Customize ? (Customize)fValue :
                Customize.customize(idxOf(toStrgIntrn(fPara), getFinalStaticInts(Customize.class,Customize.MAX_VARIABLE)));
            if (cust==null) cust=Customize.mapInstances.get(fPara);
            if (cust!=null) jComponent=cust.newButton().i(null).t("Customize");
            else {
                final ChButton b=ChButton.actionCustomize(clazz);
                if (b!=null) {
                    jComponent=b;
                    b.setBorderPainted(true);
                    b.setContentAreaFilled(true);
                }
            }
        } else if (id==COMBO) {
            if (fValue instanceof Object[]) jComponent=new ChCombo(ChJTable.CLASS_RENDERER, fValue);
            else if (likelyParameter!=null) {
                jComponent=new ChCombo(ChJTable.CLASS_RENDERER, new Object[]{likelyParameter,likelyParameter+"    "});
            } else isError=true;
        } else if (id==CLASSICON_CLASSNAME) {
            if (clazz!=null) jComponent=new ChLabel(delSfx("PROXY",shrtClasNam(clazz))).i(TabItemTipIcon.icn(clazz));
            else isError=true;
        } else if (id==BUTTON) {
            if (fValue instanceof ChButton) jComponent=((ChButton)fValue).cln();
            else if (fValue instanceof AbstractButton) jComponent=new ChLabel().like((AbstractButton)fValue);
            else if (fValue instanceof String) jComponent=new ChLabel(toStrgIntrn(fValue));
            else if (fValue==null && clazz!=null) {
                if (buttonForClass==null) jComponent=new JButton(shrtClasNam(clazz)+" Error: not specified HtmlDoc.setButtonForClass(...)");
                else {
                    final Object oo[]={clazz};
                    buttonForClass.run(ID_BUTTON_FOR_CLASS,oo);
                    jComponent=(JComponent)oo[0];
                }
            }
            else if (fValue instanceof Customize) jComponent=((Customize)fValue).newButton();
            else if (fValue!=null ) jComponent=new ChLabel(toStrg(fValue));
            else isError=true;
        } else if (id==CB) {
            if (fValue instanceof ChButton) jComponent= ((ChButton)fValue).cb();
            else {
                final StringBuffer sb=fValue instanceof AbstractButton ?
                    removeHtmlHeadBody(((AbstractButton)fValue).getText()) :
                    new StringBuffer(99).append(likelyParameter);
                if (sb!=null) {
                    for(String s:SOME_HTML_TAGS) rplcSb(0L,s,"",sb);
                    for(String s:SOME_CLOSING_HTML_TAGS) rplcSb(0L,s,"",sb);
                    if (sze(sb)>45) sb.delete(45,sze(sb)).append("...");
                    jComponent=new ChLabel(sb.insert(0,"[X] "));
                } else if (member==null) isError=true;
            }
        } else if (id==ICON || id==IMAGE) {
            String icon=null;
            if (fPara.startsWith("IC_")) try { icon=(String)ChConstants.class.getField(fPara).get(null);  } catch(Exception e){ }
            if (icon==null) icon=toStrg(fValue);
            final Icon ic= icon!=null ? iicon(icon) : null;
            if (ic!=null) pcp(KEY_ORIGINAL_SIZE, id==IMAGE ? "":null, jComponent=new JLabel(ic));
            else if (member==null) isError=true;
        } else if (id==PACKAGE) {
            //jComponent=pnl(dim(0,0),WHITE);
            //pcp(KEY_PREF_SIZE,dim(0,0),jComponent);
        } else if (id==LABEL || id==TREENODE || id==TEXTFIELD) {
            if (fValue instanceof Icon) jComponent=new JLabel((Icon)fValue);
            else {
                String s= getTxt(fValueJC);
                if (s==null) s= toStrg(fValue);
                if (fValue instanceof JToggleButton || fValue instanceof ChButton && ((ChButton)fValue).isToggle() || fValue instanceof JCheckBoxMenuItem) s="[X] "+s;
                jComponent= new ChLabel().like(fValueJC).t(s).i("");
                if (id==TEXTFIELD) setBG(0xFFffFF, monospc(jComponent));
            }
        } else if (id==JCOMPONENT) {
            if (fValueJC!=null) {
                jComponent=fValueJC;
                if (gcp(KEY_DO_NOT_CLONE,jComponent)==null) {
                    final Object clone=invokeMthd("cln" ,jComponent);
                    if (clone instanceof JComponent) jComponent=(JComponent)clone;
                }
                pcp(KEY_ORIGINAL_SIZE,"",jComponent);
            } else if (member==null) isError=true;
        }
        if (jComponent instanceof ChButton) pcp(UserProfile.KEY_IGNORE,"",jComponent);
        if (!f.isActive()) {
            if (id==JCOMPONENT && jComponent!=null) {}
            else if (jComponent instanceof AbstractButton) jComponent=new ChLabel().like(jComponent);
            rmAllListnrs(true, jComponent);
        }
        if (jComponent!=null) {
            noInsets(jComponent);
            if (jComponent instanceof JLabel) jComponent.setBorder(BorderFactory.createEtchedBorder());
            if (createComponentHook!=null) createComponentHook.run(ID_LAST_COMPONENT,jComponent);
        }
        f.setJComponent(jComponent);
        if (isError && member==null) {
            putln(RED_ERROR+"HtmlDoc: ",f+"\n"+ANSI_GREEN+" member="+ANSI_RESET+member);
            assertTrue(false);
        }
        return jComponent!=null;
    }
    private static HtmlDocElement[] specialExpressions(String id,StringBuffer text,String[] myPackages,String documentId) {
        final List v=new ArrayList();
        final String key="<i>"+id;
        int pos=-1;
        while( (pos=text.indexOf(key,pos+1))>0) {
            if(pos<0) break;
            final int to=text.indexOf("</i>",pos);
            v.add( new HtmlDocElement( id, text.substring(pos+sze(key),to), new Range(pos,to+4), myPackages, documentId) );
        }
        return toArry(v, HtmlDocElement.class);
    }
    /* <<< JComponent <<< */
    /* ---------------------------------------- */
    /* >>> Settings >>> */
    private static ChRunnable createComponentHook,buttonForClass;
    public static void setCreateComponentHook(ChRunnable r) {createComponentHook=r;}
    public static void setButtonForClass(ChRunnable b4c) {buttonForClass=b4c;}
    /* <<< Settings <<< */
    /* ---------------------------------------- */
    /* >>> Log >>> */
    private static ChTextArea log_;
    public static ChTextArea log(Object... oo) {  return (log_==null ?  log_=new ChTextArea("") : log_).appnd(oo); }
    /* <<< Log <<< */
    /* ---------------------------------------- */
    /* >>> Reflection >>> */
    static String[] getImportedPackages(final CharSequence txt, Object clazz) {
        List<String> v=null;
        for (int i=-1;  (i=strstr(STRSTR_AFTER,"<i>"+PACKAGE,txt,i,MAX_INT))>=0;) {
            final int iClose=strstr("</i>",txt, i, MAX_INT);
            if (iClose<0) { assertTrue(false); continue; }
            adUniq(txt.subSequence(i,iClose).toString(), (v==null ? v=new ArrayList() : v));
        }
        final String sClass=clazz instanceof String ? (String)clazz : clazz instanceof Class ? clazzName(clazz) : null;
        final int dot=sClass!=null ? sClass.lastIndexOf('.') : -1;
        if (dot>0)  (v==null ? v=new ArrayList() : v).add(sClass.substring(0,dot+1));

        return strgArry(v);
    }
    private static StringBuffer relatedDialogsAndClasses(Class[] cc,char docType,boolean alsoDialogs) {
        final StringBuffer SB=new StringBuffer(999);
        if (cc.length==0) return SB;
        SB.append("\n<hr><h3>Related ").append(alsoDialogs ? "Dialogs" :"Classes").append("</h3> <ul>\n");
        for(Class c : cc) {
            final String cn=c.getName();
            SB.append("<li>\n <b>").append(shrtClasNam(c)).append("</b>: ");
            if (docType==DOCTYPE_TUTORIAL) {
                if (alsoDialogs) SB.append("  <a href=\"").append(HtmlDoc.ACTION_OPEN_DIALOG).append(cn).append("\">open dialog </a> &nbsp; \n");
                if (hasHelp(c)) SB.append("  <a href=\"").append(cn).append("\">docu</a>\n");
            } else {
                final CharSequence javadoc=ChJavadoc.javadocUrl(c);
                if (javadoc!=null) SB.append("<a href=\"").append((Object)javadoc).append("\">javadoc </a> -  \n");
            }
            final String item=TabItemTipIcon.item(c);
            if (item!=null) SB.append("<br>").append(item);
            SB.append("</li>\n");
        }
        return SB.append("</ul>\n");
    }
    /* <<< Reflection <<< */
    /* ---------------------------------------- */
    /* >>> Menu >>> */
    private static void  menuPath(String[][] ppp,String del,StringBuffer sb) {
        int i=0;
        if (ppp==null) return;
        boolean nothingYet=true;
        for(String pp[]:ppp){
            if (pp==null) break;
            if (i++>0) sb.append(del);
            int j=0;
            for(String p:pp) {
                if (sze(p)>0) {
                    if (nothingYet) { sb.append('['); nothingYet=false;}
                    if (j++>0) sb.append("<font color=\"#ff0000\">  /  </font>");
                    sb.append("<font color=\"#0000FF\">\n").append(p).append("\n</font>");
                }
            }
        }
        if (!nothingYet) sb.append(']');
    }
    static StringBuffer insertHeadline(String className,char level,StringBuffer sb,char docType) {
        if (sb==null || className==null) return null;
        final String headLine=delSfx("...",TabItemTipIcon.item(className));
        if (headLine==null) { sb.insert(0,"<div></div>");return sb;} /* Now it starts With an html tag */
        final StringBuffer SB=new StringBuffer("<a name=\""+delToLastChar(className,'.')+"\"></a><a name=\""+className+"\"></a>\n<h"+level+" class=\"withCounter\" >"+headLine+"</h"+level+">\n\n");
        final String menuPath[]=getMenuPaths(TabItemTipIcon.item(className),null);
        if (menuPath.length>0) join(menuPath,"&gt;",SB.append('[')).append("] ");
        final String hl=SB.toString();
        if (sb.indexOf(hl)<0) sb.insert(maxi(strstr(STRSTR_IC,"<body>",sb),0) ,hl);
        return sb;
    }
    /* <<< Menu <<< */
    /* ---------------------------------------- */
    /* >>> Image >>> */
    private static boolean renewAllImages=true;
    private static String mayBeImageTag(HtmlDocElement sf) {
        if (sf.getJComponent()==null) return null;
        final String
            cssStyle=sf.getStyle()!=null ? " style=\""+sf.getStyle()+"\" " : gcp(KEY_ORIGINAL_SIZE,sf.getJComponent())!=null ? "  style=\"vertical-align: bottom;\" " : " class=\"smallImage\"",
            alt=sf.getParameter()!=null ? sf.getParameter().replace('"',' ') : null,
            img="<img "+cssStyle+"  alt=\""+alt+"\"  src=\""+sf.urlImageFile()+"\">";
        final File imageFile=sf.imageFile();
        if (imageFile!=null && (sze(imageFile)==0  || renewAllImages && (System.currentTimeMillis()-imageFile.lastModified())>1000*60)) {
            final JComponent jc=sf.getJComponent();
            if (jc!=null && imageFile!=null) writePng(jc,imageFile);
        }
        return img;
    }

    /* <<< Image <<< */
    /* ---------------------------------------- */
    /* >>> Html >>> */
    private final static String CSS[]=new String['T'+2];
    public static String getCssOrJS(String css_or_js,  char docType, boolean addTags) {
        final boolean isCss=css_or_js=="css", isJs=css_or_js=="js";
        assert isCss || isJs;
        final int idx=docType+ ( isCss  ? 0:1);
        if (CSS[idx]==null) {
            final ByteArray ba=readBytes(ChUtils.class.getResourceAsStream("strap."+css_or_js));
            if (ba!=null) {
                if (isCss && docType==DOCTYPE_TUTORIAL) ba.setEnd(strstr(STRSTR_E,"@media",ba));
                if (isJs) {
                    final ByteArray sb=new ByteArray(3333).append("\n function replaceCrossRefs(s) {\n");
                    final String[] ss[]=Hyperrefs.getDatabases(Hyperrefs.WEB_LINK|Hyperrefs.PLAIN_TEXT), kk=ss[0], uu=ss[1];
                    for(int i=0; i<kk.length; i++) {
                        if (kk[i]!=null && uu[i].indexOf('*')<0) sb.append("s=s.replace('").append(kk[i]).append("','").append(uu[i]).append("');\n");
                    }
                    sb.append("return s;\n }");
                    final File f=file("~/java/web/replaceCrossRefs.js");
                    if (isMyComputer() && Insecure.canModify(f)) wrte(f,sb);
                    ba.append(sb);
                }
                if (addTags) {
                    ba.replace(0,0, isCss ? "<style type=\"text/css\">\n" : "\n<script language=\"JavaScript\" type=\"text/javascript\">\n");
                    ba.append(isCss ?  "\n</style>\n" : "\n</script>\n<span id=\"toolTipLayer\"></span>\n");
                }
                CSS[idx]=ba.newString();
            } else { CSS[idx]=""; assertTrue(false); }
        }
        return CSS[idx];
    }
    /* <<< Html <<< */
    /* ---------------------------------------- */
    /* >>> StringBuffer >>> */
    static void process(StringBuffer sb,String documentId,char docType, String[] packages) {
        recursiveInclude(sb,documentId,docType,packages);
        stringTags(sb,documentId, docType, packages);
        if (docType==DOCTYPE_TUTORIAL) rplcSb(0L,"<CAPTION>","<CAPTION><BR>",sb);
    }
    private static void stringTags(final StringBuffer sb,String documentId,char docType, String packages[]) {
        final StringBuffer SB=new StringBuffer(999);
        final List<Class> vSeeClass=new ArrayList(), vSeeDialog=new ArrayList();
        for(String id: SPECIAL_HTML_TAG) {
            HtmlDocElement vSpEl[]=specialExpressions(id,sb,packages,documentId);
            boolean isError=false;
            for(int iSpEl=sze(vSpEl);--iSpEl>=0;) {
                final HtmlDocElement f=vSpEl[iSpEl];
                boolean ok=false;
                SB.setLength(0);
                final Class clazz=f.getClazz();
                final String parameter=f.getParameter();
                final String fieldOrMethod=f.getFieldOrMethod();
                final boolean noField=sze(fieldOrMethod)==0;
                if (id==STRING) {
                    final Object v=f.getValue();
                    SB.append(docType==DOCTYPE_HTML && v instanceof File ? filepathUnixStyle((File)v) : v);
                } else if (id==SEE_CLASS) {
                    if (clazz!=null) {  ok=true;  adUniq(clazz,vSeeClass);  } else isError=true;
                } else if (id==SEE_DIALOG) {
                    if (clazz!=null) {
                        ok=true;
                        adUniq(clazz,vSeeDialog);
                    } else isError=true;
                } else if (id==INCLUDE_DOC || id==INCLUDE_DOC1|| id==INCLUDE_DOC2|| id==INCLUDE_DOC3 || id==PACKAGE) {
                    ok=true;
                } else if (id==JAVADOC) {
                    if (clazz!=null) {
                        final java.lang.reflect.Member member=ChJavadoc.findMember(clazz,fieldOrMethod, packages, (Object[])null);
                        final Object url=member!=null ? ChJavadoc.javadocUrl(member) : ChJavadoc.javadocUrl(clazz);
                        SB.append("<a href=\""+ url+"\">"+ parameter+"</a>\n");
                    } else isError=true;
                } else if (id==HOME_PAGE && clazz!=null) {
                    SB.append(TabItemTipIcon.homePage(clazz));
                } else if (id==JAVASOURCE) {
                    if (clazz!=null) SB.append("\n<pre>\n"+ChCodeViewer.highlightSyntax(getJavaSource(clazz.getName()),NO_STRING)+"\n</pre>\n");
                    else SB.append("\n<pre>"+ChCodeViewer.highlightSyntax(new ByteArray(" "+parameter+" "),packages)+"</pre>\n");
                }
                else if (id==ABOUT) {
                    SB.append("<b>About this document:</b> This text was processed with the tool ");
                    ChJavadoc.javadocLink(HtmlDoc.class.getName(),SB);
                    SB.append('\n');
                } else if (id==REGISTER_JAVADOC) {
                    ok=true;
                    final String[] ss=splitTokns(0L, parameter);
                    if (sze(ss)==2) {
                        if (url(ss[1])!=null) ChJavadoc.addJavadocUrl(ss[0],ss[1]);
                        else { log(RED_ERROR,parameter,ANSI_BLUE+" invalid url ",ss[1],"\n\n"+ANSI_RESET); isError=true;}
                    } else {
                        log(RED_ERROR+ANSI_BLUE,f,"\n syntax: <i>"+ANSI_RESET+REGISTER_JAVADOC+"java.lang. http://java.sun.com/j2se/1.5.0/docs/api/</i>\n\n"+ANSI_RESET);
                        isError=true;
                    }
                } else if (id==ITEM || id==DIALOG || id==CLASS_REF) {
                    final String item=noField && clazz!=null ? TabItemTipIcon.item(clazz) : null;
                    String txt= id==CLASS_REF ? " <b>*</b> " : 	item!=null ? item : null;
                    if (txt==null && id==ITEM) {
                        final Object v=f.getValue();
                        txt=v instanceof CharSequence ? v.toString() : getTxt(v);
                    }
                    if (txt!=null) {
                        if (clazz!=null) {
                            final String cn=clazz.getName();
                            final CharSequence ref=docType==DOCTYPE_JAVADOC ? ChJavadoc.javadocUrl(clazz) : getHlp(clazz)!=null ? cn+".html" : null;
                            if (ref!=null) SB.append("<a href=\""+ref+"\"><b><I>"+txt+"</I></b></a>");
                        } else isError=true; //SB.append("<i>LABEL:"+parameter+"</i>");
                        if (id==ITEM) {
                            final String ss[]=getMenuPaths(txt,null);
                            if (ss!=null && ss.length>0) {
                                join(ss,"&gt;",SB.append('[')).append("] ");
                            }
                        }
                    }
                } else if (id==STRING_ARRAY) {
                    if (f.getValue()!=null) {
                        int count=0;
                        for(Object o : oo(f.getValue())) {
                            if (count++>0) SB.append(',');
                            SB.append(o);
                        }
                    }
                } else if (id==TEXT_LINES) {
                    final Object
                        v=f.getValue(),
                        oo[]=v instanceof Object[] ? (Object[])v : v instanceof List ? ((List)v).toArray() : null;
                    if (oo!=null) join(oo,"\n",SB); else SB.append(v);
                } else if (id==INCLUDE_FILE) {
                    final String ss[]=readLines(parameter);
                    if (ss!=null) for(String s:ss) SB.append(s);
                } else if (docType!=DOCTYPE_TUTORIAL) {
                    if (jComponent(id,f)) {
                        final String img=mayBeImageTag(f);
                        if (img!=null) SB.append(img);
                        else log(ANSI_RED+"\nNo png for  "+ANSI_BLUE,documentId," ",id,ANSI_RESET,f,"\n\n");
                    }
                }
                if (sze(SB)>0 || ok) {
                    final Range range=f.getRange();
                    final String toBeREplaced=sb.substring(range.getFrom(),range.getTo());
                    if (chrAt(0,toBeREplaced)!='<' || !toBeREplaced.endsWith(">")) log(RED_ERROR+": not ending with > Or not  starting with  < ",toBeREplaced,"\n"+ANSI_RESET);
                     sb.replace(range.getFrom(),range.getTo(),SB.toString());
                } else if (idxOf(id,TAGS_FOR_EDITOR_KIT)<0 && id!=PACKAGE) {
                    log("\n"+RED_ERROR+" Nothing todo for "+ANSI_BLUE,"docid=",documentId,ANSI_RESET+"  id=",id,"\n",f,"\n\n");
                }
                if (isError) {
                    putln(RED_ERROR+"HtmlDoc: ",f);
                    assertTrue(false);
                }
            }
        }
        if (docType==DOCTYPE_TUTORIAL) {
            final StringBuffer related=relatedDialogsAndClasses( toArry(vSeeClass,Class.class),docType,false)
                .append(relatedDialogsAndClasses(toArry(vSeeDialog,Class.class),docType,true));
            int idxBody=sb.indexOf("<!-- ======== NESTED CLASS SUMMARY");
            if (idxBody<0) idxBody=sb.indexOf("</body>");
            if (idxBody<0) idxBody=sb.indexOf("</BODY>");
            if (idxBody<0) sb.append(related); else sb.insert(idxBody,(Object)related);
        }
    }
    private static void recursiveInclude(final StringBuffer sb,final String documentId,final char docType, String[] packages) {
        for(String id: SPECIAL_HTML_TAG) {
            final HtmlDocElement[] vSpEl=specialExpressions(id,sb,packages,documentId);
            for(int iSpEl=sze(vSpEl);--iSpEl>=0;) {
                final HtmlDocElement f=vSpEl[iSpEl];
                boolean ok=false;
                final Class clazz=f.getClazz();
                if (id==INCLUDE_DOC || id==INCLUDE_DOC1|| id==INCLUDE_DOC2|| id==INCLUDE_DOC3) {
                    if (clazz!=null) {
                        final StringBuffer include=toStringBuffer(getHlp(clazz));
                        if (include!=null) {
                            final char level=id==INCLUDE_DOC1 ? '1' : id==INCLUDE_DOC2 ? '2' : id==INCLUDE_DOC3 ? '3' : 0;
                            if (level!=0) insertHeadline(clazz.getName(),level,include,docType);
                            final String title=clazz==HtmlDocElement.class ? "Manual" : shrtClasNam(clazz);
                            recursiveInclude(include, title, docType,packages);
                            if (docType==DOCTYPE_HTML) {
                                final StringBuffer single=new StringBuffer(sze(include)+999).append(include);
                                insertIntoHtmlHeader("\n<title>"+title+"</title>\n",single);
                            }
                            sb.replace(f.getRange().getFrom(),f.getRange().getTo(),include.toString());
                        }
                    }
                }
            }
        }
    }

    public static StringBuffer rplcWIKI(StringBuffer sb) {
        for(int i=sb.length(); --i>=0; ) {
            final char c0=sb.charAt(i);
            if (c0=='W' || c0=='P' || c0=='h' || c0=='f' || c0=='<' ) {
                final char c1=chrAt(i-1,sb);
                if (c1!='"' && c1!='\'' && !is(LETTR_DIGT_US,sb,i-1)) {
                    if (equls("WIKI:",sb,i)) {
                        int end=nxtE(NO_LETTR_DIGT_US,sb,i+5,i+20);
                        if (chrAt(end,sb)=='(') end=sb.indexOf(")",end)+1;
                        assert end>0;
                        if (end>0) {
                            final String term=sb.substring(i+5,end);
                            sb.replace(i,end,"<script>WIKI('"+term+"')</script>");
                        }
                    } else if (equls("PUBMED:",sb,i)) {
                        final int end=nxt(NO_DIGT,sb,i+7,i+20);
                        if (end>i+7) {
                            final String term=sb.substring(i+7,end);
                            sb.replace(i,end,"<script>pubmed('"+term+"')</script>"+term);
                        }
                    } else if (looks(LIKE_EXTURL,sb,i)) {
                        if (c1!='"' &&  !is(LETTR_DIGT_US,c1)) {
                            int end=nxt(SPC_CLOSE,sb,i+5,i+100);
                            if (end>0) {
                                if (sb.charAt(end-1)=='.') end--;
                                final String url=sb.substring(i,end);
                                sb.replace(i,end,"<a href=\"javascript:shw('"+url+"');\">"+url+"</a>");
                            }
                        }
                    }
                    if (equls("<i>"+PACKAGE,sb,i)) {
                        final int end=sb.indexOf("</i>",i);
                        if (end>0) sb.delete(i, end+4); else assertTrue(false);
                    }
                }
            }
        }
        return sb;
    }
    /* <<< StringBuffer <<< */
    /* ---------------------------------------- */
    /* >>> Dimension >>> */
    public static java.awt.Dimension getPrefSize(JComponent c) {
        if (c==null) return dim(0,0);
        java.awt.Dimension d=deref(gcpa(KEY_PREF_SIZE,c), java.awt.Dimension.class);
        if (d==null)  d=c.getPreferredSize();
        if (gcp(KEY_ORIGINAL_SIZE,c)!=null) return d;
        if (c instanceof AbstractButton || c instanceof JLabel) {
            final String txt=getTxt(c);
            final Icon ic=getIcn(c);
            if  ( (txt==null || txt.indexOf("<br>")<0)  && gcpa(TOP_TEXT,c)==null) {
                  d=dim(d.width, (ic==null || ic==iicon(IC_BLANK))  ? 16 : ic.getIconHeight());
            }
        }
        if (c instanceof JComboBox) d=dim(d.width,20);
        return d;
    }
    /* <<< Dimension <<< */
    /* ---------------------------------------- */
    /* >>> Event >>> */
    private HtmlDoc(){}
    private static HtmlDoc instance;
    public static HtmlDoc instance() { return instance==null ?  instance=new HtmlDoc() : instance;}
    private static Class clickedClass;
    public static Class getClickedClass() { return clickedClass;}
    public static void addHyperlinkListener(JEditorPane tc) {tc.addHyperlinkListener(instance()); }
    public void hyperlinkUpdate(javax.swing.event.HyperlinkEvent ev) {
        if (ev.getEventType()==javax.swing.event.HyperlinkEvent.EventType.ACTIVATED) {
            final String sUrl=ev.getDescription();
            if (sUrl==null) return;
            for(String actio :new String[]{"#",ACTION_VIEW_SOURCE,ACTION_OPEN_DIALOG}) {
                if (!sUrl.startsWith(actio)) continue;
                final String sClass=sUrl.substring(actio.length()).trim();
                if (actio==ACTION_VIEW_SOURCE) {
                    showJavaSource(sClass,STRAP_PACKAGES);
                    return;
                }
                if (actio==ACTION_OPEN_DIALOG) {
                    clickedClass=name2class(sClass);
                    handleActEvt(this, ACTION_OPEN_DIALOG, 0);
                    //handleEvt(HtmlDoc.class,new java.awt.event.ActionEvent(this, java.awt.event.ActionEvent.ACTION_PERFORMED, ACTION_OPEN_DIALOG, 0));
                    return;
                }
            }
             final String className=delSfx(".html",delPfx(ChConstants.URL_STRAP_DOC,sUrl));
             final Class c=findClas(className,STRAP_PACKAGES);
             if (c!=null) showHelp(c);
             else visitURL(ev.getURL(),0);
        }
    }
    public void actionPerformed(java.awt.event.ActionEvent ev) {
        final String cmd=ev.getActionCommand();
        handleActEvt(this,  cmd,  modifiers(ev));
    }
    /* <<< Event <<< */
    /* ---------------------------------------- */
    /* >>> main >>> */
    // java charite.christo.HtmlDoc -log charite.christo.strap.Texshade
    public static void main(String... argv) {
        boolean exit=true;
        if (sze(TabItemTipIcon.MAP)==0) {
          TabItemTipIcon.add(readLines(rscAsStream(0L,_CC,"tabItemTipIcon1.rsc")));
          TabItemTipIcon.add(readLines(rscAsStream(0L,_CC,"tabItemTipIcon2.rsc")));
        }
        boolean view=false;
        for(String arg: argv) {
            arg=arg.intern();
            if (""==arg) continue;
            if ("-v"==arg) { exit=false; view=true; }
            else if ("-log"==arg) log().showInFrame("HtmlDoc",ChFrame.ALWAYS_ON_TOP);
            else if (arg=="-h" || arg=="-help" || arg=="--help") { showHelp(HtmlDoc.class); return; }
            else if ("-noExit"==arg) exit=false;
            else if (chrAt(0,arg)=='-') { putln("Error in HtmlDoc: unrecognized option: ",arg); continue;}
        }
        if (isMyComputer()) renewAllImages=false;
        if (argv.length==0) showHelp(HtmlDoc.class);
        for(String arg: argv) {
            if (arg!=null && chrAt(0,arg)!='-') {
                if (view && name2class(arg)!=null) showHelp(arg);
                else main1(arg);
            }
        }
        if (exit) {
            putln("HtmlDoc.exit");
            System.exit(0);
        }
    }
    static File main1(String arg) {
        if (arg==null || arg.indexOf('$')>0) return null;
        if (arg.endsWith(".class")) arg=delSfx(".class",delPfx("./",arg)).replace('/','.');
        final File fArg=file(arg);
        final Class c=name2class(arg);
        StringBuffer txt=null;
        File fOut=null;
        if (sze(fArg)>0) {
            if (arg.endsWith(".html") || arg.endsWith(".HTML") || arg.endsWith(".htm")) {
                join(readLines(fArg),"\n",txt=new StringBuffer(sze(fArg)*5/4));
                final String fn=fArg.getName();
                process(txt,withoutDotSuffix(fn),DOCTYPE_HTML, getImportedPackages(txt,(Class)null));
                fOut=file(dirDocumentation()+"/"+fn);
            }
        } else if (c!=null) {
            txt=toStringBuffer(getHlp(c));
            if (txt==null) error("HtmlDoc: no help for "+c);
            else {
                insertHeadline(c.getName(),'2', txt,DOCTYPE_HTML);

                process(txt,shrtClasNam(c),DOCTYPE_HTML,getImportedPackages(txt,c));
                fOut=file(dirDocumentation(),c.getName()+".html");
            }
        }
        if (fOut!=null && txt!=null) {
            rplcWIKI(txt);
            final boolean hasTags=txt.indexOf("<html>")>=0 && txt.indexOf("</html>")>=0;
            if (!hasTags) {
                txt.insert(0,"<!DOCTYPE HTML>\n<!-- saved from url=(0023)http://3d-alignment.eu/ -->\n<html><head>\n"+
                           HtmlDoc.getCssOrJS("css",DOCTYPE_HTML,true)+"<title>"+delSfx(".html",fOut.getName())+"</title></head>\n<body>\n"+HtmlDoc.getCssOrJS("js",DOCTYPE_TUTORIAL,true));
                txt.append("</body></html>");
            }
            putln("HtmlDoc: Written: "+fOut+" "+sze(txt)+" bytes");
            mkParentDrs(fOut);
            wrte(fOut,txt);
        }
        writePng(null,null);
        return fOut;
    }
}
