package charite.christo;
import static charite.christo.ChUtils.*;
import charite.christo.interfaces.*;
import java.util.*;
import java.awt.Component;
import java.awt.Dimension;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.text.html.*;
import javax.swing.text.ViewFactory;
import javax.swing.text.Element;
import javax.swing.text.View;
import static charite.christo.ChConstants.*;
/**HELP

      <div id="Dokument" >
      <div class="NOPRINT" >
      Preparing document for printing:
      <form action="">
      <input type="button" onClick="showHideFigures();" value="Hide figures" >
      <input type="button" onClick="showHideFigures(true);" value="Show figures" >
      </form> When printing, backgrounds are automatically turned to white.<br>
      </div>
      <i>PACKAGE:charite.christo.strap.</i>
        <i>PACKAGE:charite.christo.protein.</i>

        <i>INCLUDE_DOC2:StrapAlign</i>
        <i>INCLUDE_DOC2:DialogProjectFiles</i>
        <hr><hr>

        <i>INCLUDE_DOC2:StrapTree</i>
        <a name="MENU"></a><i>INCLUDE_FILE:~/@/doc/JMenuBar.html</i>
        <a name="MENU"></a><i>INCLUDE_FILE:~/@/doc/JPopupMenu.html</i>
        <i>INCLUDE_DOC2:UserProfile</i>
        <hr><hr>

        <i>INCLUDE_DOC2:StrapView</i>
        <i>INCLUDE_DOC2:StrapKeyStroke</i>
        <i>INCLUDE_DOC2:Gaps2Columns</i>

        <hr><hr>

        <i>INCLUDE_DOC2:MainDialogProjectFiles</i>
        <a name="DRAG"></a><h2>Drag-and-drop</h2><i>INCLUDE_DOC2:ChTransferable</i>
        <i>INCLUDE_DOC2:DialogGenbank</i>
        <hr><hr>

        <i>INCLUDE_DOC3:Protein3d</i>
        <i>INCLUDE_DOC3:Pymol</i>
        <hr><hr>

        <i>INCLUDE_DOC2:ResidueSelection</i>
        <i>INCLUDE_DOC2:ResidueAnnotation</i>
        <i>INCLUDE_DOC2:ResidueAnnotationView</i>
        <hr><hr>

        <i>INCLUDE_DOC2:DialogExportProteins</i>
        <i>INCLUDE_DOC2:Texshade</i>
        <i>INCLUDE_DOC2:DialogPublishAlignment</i>
        <hr><hr>

        <i>INCLUDE_DOC2:Strap</i>
        <i>INCLUDE_DOC2:ChStdout</i>
        <i>INCLUDE_DOC2:Microsoft</i>
        <h2 class="withCounter" >Macintosh</h2>

        The computer mouse of classical Macs had only one mouse button which is ergonomically better.
        The right mouse button can be simulated in STRAP by holding  ALT and CTRL while clicking.

        <br>Classical software installation of additional
        Bioinformatics tools requires WIKI:Compilers for C++ and
        Fortran. The compilers are unfortunately not present and must
        be installed from the DVD.

      </div>
						<div id="Navigation"  style="font-size: small;">

        <div class="menu_headings">Introduction</div>
        <a 	href="#StrapAlign">Features</a><br>
        <a 	href="#DialogProjectFiles">Projects</a><br>

        <div class="menu_headings">User interface</div>
        <a 	href="#StrapTree">Context menus</a><br>
        <a 	href="#MENU">Menu items</a><br>
        <a 	href="#UserProfile">User profile</a><br>

        <div class="menu_headings">Alignment Panel</div>
        <a 	href="#StrapView">Alignment Panel</a><br>
        <a 	href="#StrapKeyStroke">Key bindings</a><br>
        <a 	href="#Gaps2Columns">Gaps</a><br>

        <div class="menu_headings">Import</div>
        <a 	href="#MainDialogProjectFiles">Reading files</a><br>
        <a 	href="#DRAG">Drag'n Drop</a><br>
        <a 	href="#DialogGenbank">Nucleotide files</a><br>

        <div class="menu_headings">Export</div>
        <a 	href="#DialogExportProteins">Export proteins</a><br>
        <a 	href="http://www.bioinformatics.org/strap/exampleOutput.html">Example alignment</a><br>
        <a 	href="#Texshade">PDF</a><br>

        <div class="menu_headings">3D-Visualization</div>
        <a 	href="#Protein3d">Backbone</a><br>
        <a 	href="#Pymol">Pymol</a><br>

        <div class="menu_headings">Residue Selections</div>
        <a 	href="#ResidueSelection">Residue selections</a><br>
        <a 	href="#ResidueAnnotation">Residue annotations</a><br>

        <div class="menu_headings">Running Strap</div>
								<a 	href="#Strap">Command line parameters</a><br>
								<a 	href="#Microsoft">Operation systems</a><br>

        <br>
						</div>

@author Christoph Gille

*/
public class HtmlDocEditorKit extends HTMLEditorKit implements ViewFactory {
    private final String[] vPackages;
    public HtmlDocEditorKit(String[] vPackages) {
        this.vPackages=vPackages;
    }
    private ViewFactory origViewFactory;
    public View create(Element elem) {
        if (elem.isLeaf()) {
            try {
                final int start=elem.getStartOffset(),end=elem.getEndOffset();
                final String txt=elem.getDocument().getText(start,end-start).trim();
                for(String id:HtmlDoc.TAGS_FOR_EDITOR_KIT) {
                    if (txt.startsWith(id)) {
                        final String text=txt.substring(id.length());
                        final HtmlDocElement el=new HtmlDocElement(id,text,new Range(start,end),vPackages,"unknown");
                        HtmlDoc.jComponent(id,el);
                        final JComponent jComponent=el.getJComponent();
                        if (jComponent==null) return origViewFactory.create(elem);
                        final View view=new MyComponentView(elem,jComponent);
                        addRef(KEY_CLONES, weakRef(view), jComponent);
                        return view;
                    }
                }
            } catch(Exception e){}
        }
        return origViewFactory.create(elem);
    }
    private static class MyComponentView extends ObjectView {
        private final Object component;
        private Dimension d;
        @Override public float getPreferredSpan(int axis) { return d==null ? 32 : axis==X_AXIS ? d.width:d.height;}
        @Override public float getAlignment(int axis) {
            return axis==X_AXIS ? 0f: .8f;
        }
        @Override public float getMaximumSpan(int axis) { return getPreferredSpan(axis);}
        public MyComponentView(Element el,Object component) {
            super(el);
            this.component=component;
        }
        @Override protected Component createComponent() {
            JComponent c=null;
            if (component instanceof JComponent) c=(JComponent)component;
            else c=new JLabel(component!=null ? component.toString() : "null");
            this.d=HtmlDoc.getPrefSize(c);
            //putln(clazz(c)+"  "+(c==ChUtils.buttn(TOG_WHITE_BG)));
            return c;
        }
    }
    @Override public ViewFactory getViewFactory() {
        if (origViewFactory==null) origViewFactory=super.getViewFactory();
        return this;
    }
}
