package charite.christo;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import javax.swing.JComponent;
import java.io.File;
import java.lang.reflect.Member;
import static charite.christo.HtmlDoc.log;
/**
   For the generation of the documentation of STRAP
   @author Christoph Gille
*/
public class HtmlDocElement implements charite.christo.interfaces.HasRendererComponent {
    private final String vPackages[], id, documentId, parameter, className, fieldOrMethod;
    private final boolean isActive;
    private final Range range;
    private JComponent jComponent;
    private final Class clazz;
    private File imageFile;
    private String urlImageFile, style;
    private Object _value;
    private static ChLabel _label;
    public JComponent getRendererComponent() {
        if (jComponent!=null) return jComponent;
        return (_label==null ? _label=new ChLabel() : _label).t(parameter);
    }
    @Override public String toString() {
        return "HtmlDocElement: id="+id+
            "\n    fieldOrMethod="+fieldOrMethod+
            "\n par="+getParameter()+
            "\n class="+getClazz()+
            "\n value="+_value+
            "\n vPackages="+joinAsStrg( vPackages,",");}
    public String getFieldOrMethod() { return fieldOrMethod;}
    public String getParameter() { return parameter;}
    public void setJComponent(JComponent c) { jComponent=c;}
    public String urlImageFile() {
        imageFile();
        return urlImageFile;
    }

    public File imageFile() {
        if (imageFile==null) {
            final String
                REGEX="[^A-Za-z0-9_+.-]",
                name=
                clazz!=null ? (clazz.getName().replace('.','-')+("+"+fieldOrMethod)).replaceAll(REGEX,"_")+".png" :
                ((getValue()!=null ? getValue() : getParameter())+".png").replaceAll(REGEX,"_");
            imageFile=new File(dirDocumentation(),name!=null ? name : toStrg(getValue()));
            urlImageFile=documentId==ChTextComponents.DOCID_TMP ? toStrg(url(imageFile)) : name;
        }
        return imageFile;
    }
    public Range getRange() { return range;}
    public Class getClazz() { return clazz;}
    public JComponent getJComponent() { return jComponent;}
    public boolean isActive() { return isActive;}
    public String id() { return id;}
    public String getDocumentID() { return documentId;}
    public String getStyle() {return style;}

    public HtmlDocElement(String id,String param,Range r,String[] packages,String docId) {
        final String para=delSfx("!",param);
        this.isActive=param!=para;
        this.documentId=docId;
        this.id=id;
        this.range=r;
        this.vPackages=packages;
        this.parameter=para;
        final int len=sze(para);
        final boolean isConstructor=para.startsWith("new ");
        if (chrAt(0, para)=='"' && chrAt(len-1,para)=='"') {
            _value=rplcToStrg("&LT;","<",rplcToStrg("&GT;",">",para.substring(1,len-1)));
            this.className=this.fieldOrMethod=null;
            this.clazz=null;
            return;
        }
        final int iSharp=para.indexOf('#');
        {
            String cn=iSharp>=0 ? para.substring(0,iSharp) : isConstructor ? para.substring(para.lastIndexOf(' ')+1,para.indexOf('(')) : para;
            this.clazz=findClas(cn,packages);
            this.className=  this.clazz!=null ? cn: null;
        }
        if (iSharp>=0) {
            final int iColon=para.indexOf(':',iSharp);
            this.fieldOrMethod=iColon<0 ? para.substring(iSharp+1) : para.substring(iSharp+1,iColon);
            if (iColon>0) style=para.substring(iColon+1);
        } else if (isConstructor) {
            this.fieldOrMethod=para;
        } else this.fieldOrMethod=null;
    }
    private Member member;
    public final Member getMember() { return member;}
    public final Object getValue() {
        if (_value==null) {
            _value=ERROR_OBJECT;
            final String sMember=this.fieldOrMethod;
            if (sze(sMember)>0) {
                Member mem=null;
                //final Class cl=sze(className)>0 ? this.clazz=findClas(className,vPackages) : null;
                final Class cl=this.clazz;
                if (cl!=null) {
                    final Object[] returnValue={null};
                    this.member=mem=ChJavadoc.findMember(cl, sMember, vPackages, returnValue);
                    _value=returnValue[0];

                }
                if (_value==null) log(documentId,RED_ERROR+" HtmlDocElement:"+ANSI_RESET," id=",id, " class=",cl,cl==null?className:null," sMember=",sMember," mem!=null: ",mem!=null?"t":"f","\n");
            }
        }
        return _value!=ERROR_OBJECT?_value:null;
    }

}

