package charite.christo;
import java.util.Map;
import java.util.HashMap;
import java.io.InputStream;
import static charite.christo.ChUtils.*;

public class HtmlUtil {
    private HtmlUtil(){}
    /* frequenently changing tags first */
    public final static int  S=1<<1, A=1<<2, U=1<<3,  B=1<<4, I=1<<5, F=1<<6;
    private final static String TAG[]={"error","S","A","U","B","I","FONT"};
    private final static int TAGS=7, FG=TAGS+1, BG=TAGS+2;
    public static int[] createBuffer() { int buf[]=new int[BG+1]; buf[BG]=0xFFffFF; return buf;}

    public static void setStyles(int fontStyle, int foregnd, int backgnd, int[] current,  String url, String attribute, StringBuffer sb) {
        final int fg=foregnd&0xFFffFF, bg=backgnd&0xFFffFF;
        final boolean colorChanged=((fg^current[FG]) | (bg^current[BG]))!=0;
        final int style= fontStyle | (fg!=0 || bg!=0xFFffFF ? F:0);
        int countOpen=idxOf(0,current,0,TAGS);
        closeTags:
        for(int i=0;i<countOpen; i++) {
            final long bit=1<<current[i]+32;
            if ( (style&bit)==0 || bit==F && colorChanged) {
                for(int j=countOpen;--j>=i;) {
                    sb.append("</").append(TAG[current[j]]).append('>');
                    current[j]=0;
                    if (bit==F)  { current[FG]=0; current[BG]=0xFFffFF; }
                }
                countOpen=i;
                break closeTags;
            }
        }
        for(int i=TAGS+1; --i>0;) {
            final long bit=1<<i+32;
            if ( (style&bit)!=0 && idxOf(i,current,0,countOpen)<0) {
                sb.append('<').append(TAG[i]);
                if (bit==A && url!=null && url!="") sb.append(" href=\"").append(url).append('\"');
                if (attribute!=null) sb.append(attribute);
                if (bit==F) {
                  if (fg!=0) {sb.append(" color=\"#"); toHex(fg,6,sb).append('\"');}
                  if (bg!=0xFFffFF) {sb.append(" style=\"background-color: #"); toHex(bg,6,sb).append(";\"");}
                    current[FG]=fg;
                    current[BG]=bg;
                }
                sb.append('>');
                current[countOpen++]=i;
            }
        }
    }

    public static StringBuffer attributeTooltip(String tooltip, int colorRGB, StringBuffer sb) {
        sb.append(" onmouseover=\"tt('").append(tooltip).append("','#");
        return toHex(colorRGB,6, sb).append("' )\"  onmouseout=\"tt()\"");
    }

//     private static int brighter(int rgb, float f) {
//         float r=((rgb>>>16)&255)*f, g=((rgb>>>8)&255)*f, b=((rgb)&255)*f;
//         return  (((int)r)<<16) | (((int)g)<<8) | (((int)b));
//     }

//     public static int notTooBright(int rgb) {
//         int r=((rgb>>>16)&255), g=((rgb>>>8)&255), b=((rgb)&255);
//         if (r+g+b<350) return rgb;
//         final int sum=r+g+b;
//         final float f= (sum-333) *(.6f-1) /(255*3-333)+1;
//         //putln(f);
//         return  (((int)(r*f))<<16) | (((int)(g*f))<<8) | (((int)(b*f)));
//     }
    public static int rgb(java.awt.Color c) { return c!=null ? c.getRGB() : 0xFFffFF;}

    public static long hexToInt(Object text, int pos) {
        final byte txt[];
        final CharSequence seq;
        final int l;
        if (text instanceof byte[]) { txt=(byte[])text; l=txt.length;  seq=null;}
        else if (text instanceof CharSequence) { seq=(CharSequence)text; l=seq.length(); txt=null;}
        else {
            seq=toStrg(text);
            if (seq==null) return -1;
            l=seq.length();
            txt=null;
        }
        if (pos+6>l) return -1;
        if (seq!=null && seq.charAt(pos)=='#') pos++;
        if (pos<0  || pos+6>l) return -1;
        if (pos+6<l) {
            final int c=txt!=null ? txt[pos+6] : seq.charAt(pos+6);
            if ('0'<=c && c<='9' || 'A'<=c && c<='F' || 'a'<=c && c<='f')  return -1;
        }
        long col=0;
        for(int i=6; --i>=0;) {
            final long
                c=txt!=null ? txt[i+pos] : seq.charAt(i+pos),
                d=
                '0'<=c && c<='9' ? c-'0':
                'a'<=c && c<='f' ? 10-'a'+c :
                'A'<=c && c<='F' ? 10-'A'+c :
                -1;
            if (d==-1) return -1;
            col|= (d<< ((5-i)*4));
        }
        return col;
    }

    private static Map<String,Customize> mapCustomize;
    public static Customize customize(char type) {
        final String name="alignBrowser";
        if (mapCustomize==null) mapCustomize=new HashMap();
        Customize c=mapCustomize.get(name);
        if (c==null) {
            final String s="charite/christo/"+name+".css";
            InputStream is=CLASSLOADER.getResourceAsStream(s);
            final ByteArray ba=readBytes(is, null);
            final byte bb[]=ba.getBytes();
            for(int i=ba.getEnd(); --i>=0;) if (bb[i]=='\t') bb[i]=' ';
            c=new Customize(name,splitLnes(SPLIT_ALLOW_EMPTY_TOKENS,ba),
                            "Modify the text to get the optimal layout for the browser / Textprocessor.",
                            Customize.TEXT_LINES);
            mapCustomize.put(name,c);
        }
        return c;
    }

    public static void appendRsc(String fileName, StringBuffer sb) {
        join(readLines(ChUtils.class.getResourceAsStream(fileName)),"\n",sb);

    }

    public static void blankImage(int w, int h, StringBuffer sb) {
        sb.append("<img width=\"").append(w).append("\" height=\"").append(h).append("\" src=\""+ChConstants.URL_STRAP+"blank.png\" />");
    }
}

