package charite.christo;
import static charite.christo.ChUtils.*;

import java.awt.AWTEvent;
import java.awt.Graphics;
import javax.swing.*;
import java.awt.event.MouseEvent;
import static java.awt.event.MouseEvent.*;
import static charite.christo.ChConstants.*;
/**HELP
<h3>Text-Pane short-cuts</h3>

The multi-line text-pane is derived from the standard Java text-pane
and provides additional functionality.

<b>Shortcuts with the CTRL key:</b>

The control key is locateted at the left on the keyboard is labeled
"Control", "Ctrl" or "Strg", IKIde:Steuerung_(Taste).

The text-pane receives the key-strokes only if it has the input focus. Click to set focus.

<ul>
<li>X  Cut Text and copy</li>
<li>C  Copy text.</li>
<li>V  Paste text.</li>
<li>F  Find text pattern. Visit  http://www.bioinformatics.org/straputils/ for a complete description of search and highlighting options.</li>
<li>L  Toggle line numbers. Or toggle truncate/fold lines</li>
<li>+  Enlarge font.</li>
<li>-  Smaller font.</li>
<li>*  Toggle text quality (see WIKI:Antialiasing ).</li>
<li>T  Toggle frame is always floating on top. Indicated in frame title.</li>
<li>P  If it is a HTML document a printable html document will be opened in the Web-Browser.</li>
<li>ESC   Disable links until the mouse exits and re-enters.</li>
</ul>
Function keys:
<ul>
<li>F1  Help</li>
<li>F6  Settings: Specify Web-Browser, File-Browser and Standard URLs</li>
<li>F7  Spell check</li>
<li>F10 Toggle WIKI:Line_wrap</li>
</ul>

For editable text fields  the following features may or may not be active:
<ul>

<li>ALT-slash or ctrl-ENTER and sometimes also Tab  &nbsp;
WIKI:Word_completion.
File path completion  if the word at the cursor looks like a  file path.
Also Environment variables are completed.</li>

<li>Ctrl-Z WIKI:Undo </li>
<li>Ctrl-Y WIKI:Redo </li>
</ul>

<h3>Hyperlinks</h3>

In most text views
URLs like http://www.google.de or database references like
PUBMED:12166070 or PUBMED{fructose glucose}  or EC classes like "1.2.2.1" can be clicked to open the
selected item in the browser or document viewer.

To specify another Web-browser hold the CTRL-key while clicking.

The list of database links can be customized: <i>CUSTOMIZE:Customize#webLinks!</i>,
<i>CUSTOMIZE:Customize#databases!</i>, <i>CUSTOMIZE:Customize#proteinDatabases!</i>.

<h3>Context Menus</h3>

The context menu is opened by right-clicking a word.
Pubmed links like PMID2840859 have a specific context menu.

<i>INCLUDE_DOC:ChCodeViewer</i>

   @author Christoph Gille
*/
public class HyperTextPane extends JTextPane {
  /*
    @Override protected void finalize() throws Throwable {
        logFinalize(ANSI_BLACK+ANSI_FG_WHITE+"HyperTextPane ","");
        super.finalize();
    }
  */

    @Override public String getToolTipText(MouseEvent ev){  return tools().getToolTipText(ev); }
    public HyperTextPane(CharSequence s) { this(); t(s); }
    public HyperTextPane() {
        rtt(this);
        setFont(getFnt(14,true,0));
        setOpaque(true);
    }
    public HyperTextPane t(CharSequence s){
        //pcp(KEY_NOT_DISPATCHING_EV,"",this);
        setText(toStrg(s));
        tools().underlineRefs(0);
        return this;
    }

    public void paintComponent(Graphics g){
        if (!isOpaque()) setOpaque(true);
        if (tools().paintHook(this,g,false))
            try {super.paintComponent(g);} catch(Throwable e){}

        tools().paintHook(this,g,true);
    }

    { this.enableEvents(MOUSE_EVENT_MASK|KEY_EVENT_MASK|MOUSE_WHEEL_EVENT_MASK );}
    @Override public void processEvent(AWTEvent ev) {
        final AWTEvent newEv=tools().processEvent(this,ev);
        if (newEv!=null) super.processEvent(newEv);
    }
    /* --- LineWrap --- */
    private boolean isLineWrap=true;
    public HyperTextPane setLineWrap(boolean b) { isLineWrap=b;return this;}
    public void toggleLineWrap() { isLineWrap=!isLineWrap; ChDelay.revalidate(this,0,(long[])null);}
    public HyperTextPane lineWrap(boolean yesNo) { isLineWrap=yesNo;return this;}
    @Override public boolean getScrollableTracksViewportWidth() { return isLineWrap;}

    private ChTextComponents chTextComponents_;
    public final ChTextComponents tools() {
        if (chTextComponents_==null) chTextComponents_=new ChTextComponents(this);
        return chTextComponents_;
    }
    public int getFixedRowHeight() { return -1;}

    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>>  Get rid of Background. setOpaque not working >>> */
  /*
    @Override public void updateUI() { try { setUI(this.ui=new ChTaUI()); } catch(Exception e){}  }
    private ChTaUI ui;
    private ChTaUI ui() {     if (this.ui==null) updateUI(); return this.ui;   }

    private static class ChTaUI extends javax.swing.plaf.basic.BasicTextPaneUI {
        @Override protected void paintBackground(Graphics g) {}
    }
  */
  public java.util.List getDndDateien() { return getDndFilesV(this); }
}

