package charite.christo;
import java.io.File;
import java.io.IOException;
/**
   All Insecure operations such as file modification or running native
   code are chaneled through this class.
   This class contains all security checks.
   @author Christoph Gille
*/

public class Insecure {
    private final static boolean ALL_ALLOWED=true;
    public final static boolean
        CLASSLOADING_ALLOWED=ALL_ALLOWED,
        EXEC_ALLOWED=ALL_ALLOWED,
       	ARBITRARY_WORKING_DIRECTORY_ALLOWED=ALL_ALLOWED,
        UNCONTROLLED_FILE_MODIFICATION_ALLOWED=ALL_ALLOWED;
    public final static String
        TEXMF_DOT_CONF="/usr/share/texmf/web2c/texmf.cnf",
        DIR_DesktopUtils="/strap_utils",
        DIR_STRAP_ALIGN="StrapAlign",
        DIR_METANNOGEN="/metannogen",
        STRAP_DISCLAIMER_TXT="strapDisclaimer.txt";
    /* --------------------------------------- */
    /* >>> Is file modification allowed ? >>> */
    private final static String
        ERROR="\u001B[45mError\u001B[0m in charite.christo.Insecure.java: ",
        ALLOWED_SUBSTRING[]={
        TEXMF_DOT_CONF,     TEXMF_DOT_CONF.replace('/','\\'),
        DIR_DesktopUtils, DIR_DesktopUtils.replace('/','\\'),
        DIR_STRAP_ALIGN,   DIR_STRAP_ALIGN.replace('/','\\'),
        DIR_METANNOGEN,     DIR_METANNOGEN.replace('/','\\'),
        STRAP_DISCLAIMER_TXT,
        "\\cygwin\\ftp%3a%2f%2f",
        "\\cygwin\\http%3a%2f%2f",
        "\\cygwin\\etc\\",
        "StrapAlign.ini",
        "/christo/java/"
    };
    private static String getPath(File f) {
        try {
            return f==null ? null : f.getCanonicalPath();
        } catch(IOException iox) { }
        return f.getAbsolutePath();
    }

    private static boolean canModifyThrowEx(File f) {
        final boolean canModify=canModify(f);
        if (!canModify) {
            final String path=getPath(f),txt=
                "\nInsecure.canModify(File) return false for getPath=\""+path+
                "\"\n this.file=\""+f+
                "\"\nWorking dir="+allowedPath+
                "\nIf you think that throwing this exception is not justified, then contact the program author.";
            System.out.println(ERROR+txt);
            if (VIOLATIONS.get(path)==null) {
                final String stckTrc=stackTrceAsStrg(new IllegalAccessException(txt));
                VIOLATIONS.put(path,stckTrc.intern());
                System.out.println(stckTrc);
            }
        }
        return canModify;
    }
    public static boolean canModify(File f) {
        if (f==null) return false;
        if (UNCONTROLLED_FILE_MODIFICATION_ALLOWED && !securityEnabled) return true;
        final String path=getPath(f);
        final String ap=Insecure.allowedPath;
        if (ARBITRARY_WORKING_DIRECTORY_ALLOWED && ap!=null && path.startsWith(ap)) {
            final int L=ap.length();
            if (path.length()==L) return true;
            final char slash=path.charAt(L);
            if (slash=='\\' || slash=='/') return true;
        }
        if (path.endsWith(".jnlp") && path.indexOf("strap")>=0) return true;
        for(String s : ALLOWED_SUBSTRING) if (path.indexOf(s)>=0) return true;
        /* Modification not allowed if beyond this point */

        return false;
    }
    private static String allowedPath;
    public static void securitySetAllowedPath(File dir) {
        if (ARBITRARY_WORKING_DIRECTORY_ALLOWED) {
            if (dir==null || (dir.exists() && !dir.isDirectory())) {
                System.out.println("dir="+dir);
                assert false;
            }
            final String ap=getPath(dir);
            final int L=ap.length();
            boolean hasLetterOrDigit=false;
            for(int i=0; i<L; i++) {
                final char c=ap.charAt(i);
                if ('a'<=c && c<='z' || 'A'<=c && c<='Z' || '0'<=c && c<='9') hasLetterOrDigit=true;
            }
            if (!hasLetterOrDigit) {
                System.out.println("Error in securitySetAllowedPath "+dir+" has no letter or digit");
                return;
            }
            final char cLast=ap.charAt(L-1);
            Insecure.allowedPath= cLast=='/'||cLast=='\\' ? ap.substring(0,L-1) : ap;
        }
    }
    private static boolean securityEnabled;
    public static void setFileModificationControl(boolean b) {securityEnabled=b;}
    /* <<< Is file modification allowed ? <<< */
    /* ---------------------------------------- */
    /* >>> Report Violations >>> */
    public final static java.util.HashMap<String,String> VIOLATIONS=new java.util.HashMap();
    public static String stackTrceAsStrg(Throwable t) {
        java.io.ByteArrayOutputStream os=new  java.io.ByteArrayOutputStream();
        if (t==null) t=new Throwable();
        t.printStackTrace(new java.io.PrintStream(os));
        return os.toString();
    }
    public static void tellNoPermission(char what, String pfx) {
        //ChUtils.stckTrc();
        final String
            w=what=='X'?"Execution of native code " : "",
            msg=
            " is disabled in STRAPlite.<br>\n"+
            "You can Launch_STRAP* with  full functionality by pressing the Web-start button on the STRAP-home-page:<br>"+
            ChConstants.URL_STRAP+"<br><br>\n\n"+
            "You can exchange proteins between two STRAP views with the mouse using Drag-and-Drop.<br>"+
            "Watch Movie "+ChConstants.MOVIE_Drag_to_another_STRAP+" <br>";
        ChUtils.error( pfx+w+msg);
    }
    /* >>> Report Violations >>> */
    /* ---------------------------------------- */
    /* >>> Native binaries  >>> */
    public static Process runtimeExec(String arg[], String[] env, File dir) throws IOException{
        return EXEC_ALLOWED ?  Runtime.getRuntime().exec(arg, env,dir) : null;
    }
    /* <<< Native binaries <<< */
    /* ---------------------------------------- */
    /* >>> File modification >>> */
    public static boolean renameToIgnoreSecurity(File fSrc, File fDest) {
        return fSrc!=null && fDest!=null && fSrc.renameTo(fDest);
    }
    static boolean renameFile(File src, File dest) {
        return canModifyThrowEx(src) && canModifyThrowEx(dest) ? src.renameTo(dest): false;
    }
    static boolean delFile(File f) {
        return canModifyThrowEx(f) ? f.delete() : false;
    }
    static java.io.OutputStream fileOutputStream(File f, boolean append) throws IOException {
        if (f==null) return null;
        if (canModifyThrowEx(f)) return new java.io.FileOutputStream(f,append);
        else {
            System.out.println(ERROR+"new FileOutputStream failed for "+f);
            throw new IOException("Insecure.java: "+f);
        }
    }
    static java.io.Writer fileWriter(File f) throws IOException {
        if (f==null) return null;
        if (canModifyThrowEx(f)) return new java.io.FileWriter(f);
        else {
            System.out.println(ERROR+"new FileWriter failed for "+f);
            throw new IOException("Insecure.java: "+f);
        }
    }
    static java.io.RandomAccessFile randomAccessFile(File f, String mode) throws IOException {
        if (canModifyThrowEx(f)) return new java.io.RandomAccessFile(f, mode);
        else {
            System.out.println(ERROR+"new FileWriter failed for "+f);
            throw new IOException("Insecure.java: "+f);
        }
    }
    /* <<< File modification <<< */
    /* ---------------------------------------- */
    /* >>> Directory >>> */
    static boolean makeDirectories(File f, boolean printErr) {
        if (f==null || f.isDirectory()) return false;
        if (canModifyThrowEx(f)) f.mkdirs();
        else {
            if (printErr){
                System.out.println(ERROR+"new FileWriter failed for "+f);
            }
        }
        return f.isDirectory();
    }
    /* <<< Directory <<< */
    /* ---------------------------------------- */
    /* >>> Reflection >>> */

    public static Class findClassByName(final String cn, File[] classpath) {
        if (cn==null) return null;
        if (CLASSLOADING_ALLOWED) {
          final ChClassLoader1 cl=ChClassLoader1.getInstance(false, classpath, (File)null);
            try{
                if (cl!=null) return cl.loadClass(cn);
            } catch(Throwable ex){}
        }
        try {
            //System.out.println("findClassByName Class.forName "+cn);
            return Class.forName(cn);
        } catch(Throwable ex) {
            ChUtils.stckTrc(ex);
            tellNoPermission(' ', "Insecure.java: Class.forName("+cn+") failed<br><br>Maybe that the requested operation ");
        }
        return null;
    }

}