package charite.christo;
import javax.swing.*;
import java.awt.*;
import java.util.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
public class LAFChooser extends ChPanel implements java.awt.event.ActionListener {
    public static boolean METAL=false;
    public final static String IF_NOT_ALREADY="LC$$INA";
    private final ChJList jList=new ChJList(null,ChJTable.ICON_ROW_HEIGHT).li(this);
    public LAFChooser() {
        setListData();
        final Object
            pS=vBhB(" ","#JS","#JS"),
            pE=pnl(new Dimension(2*ICON_HEIGHT,EX*8), Customize.newButton(Customize.laf).t(null).options(ChButton.ICON_SIZE));

        cnsew(this, jList,null,pS, pE,null);
        addActLi(this,Customize.customize(Customize.laf));
        addActLi(this,UserProfile.class);

    }

    public void actionPerformed(java.awt.event.ActionEvent ev) {
        final Object q=ev.getSource();
        if (q instanceof Customize && jList!=null) setListData();
        if (q==jList) {
            Object v=jList.getSelectedValue();
            if (v!=null) {
                final String s=v.toString();
                for(String laf : getCustomSettings(Customize.laf)) {
                    if (laf.endsWith(s) || laf.endsWith(s+"LookAndFeel")) {
                        setLAF(laf, true);
                        break;
                    }
                }
                jList.clearSelection();
            }
        }
        if (q==UserProfile.class)  SwingUtilities.updateComponentTreeUI(this);
    }
    private void setListData() {
        final String ss[]=getCustomSettings(Customize.laf) , ll[]=new String[ss.length];
        for(int i=ss.length; --i>=0;) {
            ll[i]=delSfx("LookAndFeel",ss[i].substring(ss[i].lastIndexOf('.')+1));
        }
        jList.setListData(ll);
    }
    /* <<< Instance <<< */
    /* ---------------------------------------- */
    /* >>> static utils >>> */
    public static Object getLaf(){ return isGraphicsAvailable() ? UIManager.getLookAndFeel() : null; }
    public static boolean isSystemLAF() {
        return eqNz(clazzName(getLaf()), UIManager.getSystemLookAndFeelClassName());
    }
    public static boolean isCrossPlatform() {
        return eqNz(clazzName(getLaf()), UIManager.getCrossPlatformLookAndFeelClassName());
    }
    public static void setDefaultBG(Component c) {
        if (c!=null) {
            final Color bg=UIManager.getDefaults().getColor("Button.background");
            if (bg!=null) c.setBackground(bg);
        }
    }

    /*
      public static Thread thread_setLAF(Object s, boolean updateTree) {
      return threadM("setLAF",LAFChooser.class,new Object[]{s==null ? getLaf() : s, boolObjct(updateTree)});
      }
    */
    private static LookAndFeel _current;
    public static boolean setLAF(Object classOrClassName, boolean updateTree) {
        if (!isGraphicsAvailable()) return false;
        Object s=classOrClassName;
        if (s==IF_NOT_ALREADY) {
            if (_initalized) return false;
            else s=METAL ? "M" : "S";
        }
        try {
            if (s==null) s=_current;
            if ("G".equals(s)) s="com.sun.java.swing.plaf.gtk.GTKLookAndFeel";
            if ("m".equals(s)) s="com.sun.java.swing.plaf.motif.MotifLookAndFeel";
            if ("N".equals(s)) s="com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel";
            if ("M".equals(s)) s=UIManager.getCrossPlatformLookAndFeelClassName();

            if (s=="S") {
                final String pref=
                    isSystProprty(IS_LINUX)   ? "com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel" :
                    isSystProprty(IS_WINDOWS) ? "com.sun.java.swing.plaf.windows.WindowsLookAndFeel" :
                    null;
                if (pref!=null) {
                    final Class c=name2class(pref);
                    if (c!=null) s=c.newInstance();
                }
                if (s=="S") s=UIManager.getSystemLookAndFeelClassName();
            }
            final Class cl=name2class(deref(s,String.class));
            _current=(LookAndFeel) (s instanceof LookAndFeel ? s : cl!=null ? cl.newInstance() : null);
            if (_current!=null) UIManager.setLookAndFeel(_current);
            if (updateTree) SwingUtilities.updateComponentTreeUI(ChFrame.getMainFrame());
        } catch(Throwable e){
            putln(RED_CAUGHT_IN+" setLAF");
            stckTrc(e);
            return false;
        }
        putln("LAFChooser.setLAF now: ",getLaf());
        init();
        return true;
    }

    private static boolean restoreLaf;
    static void mayRestoreLaf() {
        if (restoreLaf) {
            restoreLaf=false;
            setLAF(null,false);
            putln(ANSI_GREEN+"restoreLaf");
        }

    }
    private static void propCh() {
        if (UIManager.getLookAndFeel()!=_current && _current!=null) {
            putln(RED_WARNING+"LookAndFeel changed outside STRAP. Revert ");
            restoreLaf=true;
        }
    }

    private static boolean _initalized;
    private static void init() {
        if (_initalized) return;
        _initalized=true;
        UIManager.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
                public void propertyChange(java.beans.PropertyChangeEvent evt) { propCh();}
            });

        if (!isSystProprty(IS_MAC)) UIManager.put("Button.margin", new Insets(0, 2, 0, 2) );
        UIManager.put("ScrollBar.allowsAbsolutePositioning",Boolean.TRUE); /* See BasicScrollBarUI */
        if (UIManager.get("ScrollBar.width")==null) UIManager.put("ScrollBar.width",new Integer(17));
        Object sbui=null;
        try {
            final String s=
                isMacintosh() ?"ChAquaScrollBarUI" :
                isWindows() ? "ChWindowsScrollBarUI" :
                isCrossPlatform() ? "ChMetalScrollBarUI" :
                null;
            sbui= s==null ? null : name2class(_CC+s).newInstance();
        } catch(Throwable ex){stckTrc(ex);}

        if (sbui!=null) putln(ANSI_GREEN+sbui+ANSI_RESET);
        try {
            UIManager.put("StrapScrollBar", name2class(_CC+"ChMetalScrollBarUI").getName());
        } catch(Throwable ex) {}

        if (sbui!=null) {
            UIManager.put("ScrollBarUI",sbui.getClass().getName());
        }
        UIManager.put("TextAreaUI",javax.swing.plaf.basic.BasicTextAreaUI.class.getName()); /* Sonst immer opaque */
        UIManager.put("TextFieldUI",javax.swing.plaf.basic.BasicTextFieldUI.class.getName()); /* Sonst immer opaque */
        UIManager.put("TextPaneUI",javax.swing.plaf.basic.BasicTextPaneUI.class.getName()); /* Sonst immer opaque */
        UIManager.put("TextField.border", BorderFactory.createEtchedBorder());
    }

    /* <<< static Utils <<< */
    /* ---------------------------------------- */
    /* >>> Testing UI  >>> */
    public static void showUiDefaults() {
        final UIDefaults defaults = UIManager.getDefaults();
        final ArrayList set=new ArrayList(999);
        for(Map.Entry e : entryArry(defaults)){
            final Object v=e.getValue();
            if (v!=null) set.add(e.getKey()+"    "+v+"   "+clazzName(v));
        }
        final Object ss[]=set.toArray();
        Arrays.sort(ss);
        new ChTextArea(joinAsStrg(ss,"\n\n")).showInFrame("UIManager.getDefaults()",0L);
    }
    /* http://nadeausoftware.com/node/87 */
    /* http://filibeto.org/unix/macos/lib/dev/documentation/Java/Conceptual/Java14Development/Java14Development.pdf */
    /* http://www.java2s.com/Tutorial/Java/0120__Development/SystemsetPropertyapplelafuseScreenMenuBartrue.htm */

    public static boolean isUseScreenMenuBar() {
        return !METAL && isSystProprty(IS_MAC) && "true".equals(System.getProperty("apple.laf.useScreenMenuBar"));
    }
    public static void testAquaButtonType() {
        final String[] data={ "default", "toolbar", "icon", "text" };
        final JComponent pnl=vB();
        for(String d : data) {
            ChButton bb[]={new ChButton("Button"),new ChButton("B")};
            for(ChButton b :bb) b.putClientProperty("ChButton.buttonType",d);
            pnl.add(pnl(d," ",bb[0],bb[1]));
        }
        new ChFrame("Buttons").ad(pnl).shw(0L);
    }
    public static void testSounds() {
        final String ss[]={"FrameClose","FrameMaximize","FrameMinimize","FrameRestoreDown","FrameRestoreUp","MenuItemCommand","OptionPaneError","OptionPaneInformation","OptionPaneQuestion","OptionPaneWarning","PopupMenuPopup"};
        for(String s : ss) {
            final java.net.URL u=UIManager.class.getResource("plaf/metal/sounds/"+s+".wav");
            if (u!=null) { java.applet.Applet.newAudioClip(u).play(); sleep(500); } else assertTrue(false);
        }
    }
  /*
    public static void testSB() {
        final StringBuffer ba=new StringBuffer();
        for(int i=0;i<1000;i++) ba.append("i="+i+"\n");
        for(int i=0;i<1000;i++) ba.append('x');
        final JScrollPane sp=new JScrollPane(new ChTextArea(ba));
        new ChFrame("XXXMAC").ad(sp).shw(0L);
        final JScrollBar sb=sp.getVerticalScrollBar();
        final Component cc[]=sb.getComponents();
        putln("\ncc=",cc,"\n");
        for(Component c : cc) {
            putln(clazzName(c)+" "+c.getBounds()+" "+(c instanceof AbstractButton));
        }
        putln(" getMinimumSize="+sb.getMinimumSize());
    }
  */
}

