package charite.christo;
import static charite.christo.ChUtils.*;
import java.io.File;
public class NativeTools extends AbstractExecutable {
    {
        final boolean isW=isSystProprty(IS_WINDOWS), isM=isSystProprty(IS_MAC);
        final String n="nativeTools_"+(isW ? "windows2" : isM ? "mac" : "unix2");
        setName(n);
        setSourceInstallationScript(isW || isM ? null :  "C_COMPILER -lm -lX11 -o "+n+".exe "+n+".c");
        if (isSystProprty(IS_LINUX386) || isW) setBinaryPackageURLs("charite/christo/files/bin/"+n+".zip");
        setSourcePackageURLs("charite/christo/files/src/"+n+".zip");
    }
    private static int countTriedInstallation;

    public static void setWindowState(char m, int x, int y, String ...title) {
        new NativeTools().sws(m,x,y,title);
    }

    private static boolean alreadyInstalled;
    @Override public void installPackage() {
        if (!alreadyInstalled)  super.installPackage();
        alreadyInstalled=true;
    }
    private void sws(char m, int x, int y, String ...title) {
        if (!isSystProprty(IS_MAC)) {
            final File bin=fileExecutable();
            if (bin.length()==0 && countTriedInstallation++<3) installPackage();
            if (bin.length()==0) return;
            ChExec ex=new ChExec(ChExec.IGNORE_ERROR|ChExec.EXEC_WITHOUT_ASKING).setCommandLineV(bin,String.valueOf(m),String.valueOf(x),String.valueOf(y), title);
            new Thread(ex).start();
        }
    }
}
/*
  xorg-x11-libx11-devel (Suse)
  libx11-dev (Debian)
*/
