package charite.christo;
import charite.christo.interfaces.*;
import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import static java.awt.event.MouseEvent.*;
public class OverlayScrollPane extends JPanel implements PaintHook, ChProcessEvent {
    private final static Object KEY=new Object();
    private final JComponent box=vB();
    private final ChEventAdapter LI=new ChEventAdapter(this);
    private final JComponent component;
    private final Object refSp;
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> Constructor >>> */
    public static OverlayScrollPane getSP(JComponent c) {return gcp(KEY,c,OverlayScrollPane.class);}
    public OverlayScrollPane(JComponent c) {
        final JScrollPane sp=scrllpn(0L,component=c);
        this.refSp=weakRef(sp);
        setLayout(
                  new OverlayLayout(this) {
                      @Override public void layoutContainer(Container target) {try {super.layoutContainer(target);} catch(Throwable ex){ stckTrc(ex);}}
                  }
                  );
        add(box);
        add(sp);
        addPaintHook(this,c);
        addPaintHook(this,box);
        pcp(KEY,weakRef(this),c);
        //sb('V').setUnitIncrement(16);
        //sb('H').setUnitIncrement(16);
        LI.addTo("m",sb('V'));
        LI.addTo("m",sb('H'));
        LI.addTo("m",c);
    }
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> PaintHook >>> */
    private int lastPos;
    public boolean paintHook(JComponent c, Graphics g, boolean after) {
        if (c==this && component!=null && !component.isEnabled()) {
            if (after) g.clearRect(0,0,Short.MAX_VALUE,Short.MAX_VALUE);
            box.setBounds(0,0,0,0);
            return false;
        }
        if (c==box && !after) {
            setBounds();
        }
        if (c==component && after && !sb('V').getValueIsAdjusting()) {
            final int scrollPos=sb('V').getValue()+sb('H').getValue();
            if (lastPos!=scrollPos) {
                lastPos=scrollPos;
                box.repaint();
            }
        }
        return true;
    }
    /* <<< PaintHook <<< */
    /* ---------------------------------------- */
    /* >>> Button  >>> */
    public OverlayScrollPane addButton(JComponent but) {
        if (but==null) return this;
        if (jPopup!=null) {
            jPopup.add(but);
        } else {
          if (box.getComponentCount()==0) {
                box.setBorder(new javax.swing.border.MatteBorder(EX,0,0,0, Color.WHITE));
            }
            but.setAlignmentX(1f);
            box.add(but);
            box.setOpaque(false);
            pcp(KEY_NO_PAINT_IF_ADJUSTING, sb('V'),but);
        }
        return this;
    }
    public OverlayScrollPane addStringMatchButton(String toolTip, long options, String fileName) {
        ChButton b=new DialogStringMatch(options,component, fileName).button(null);
        if (toolTip!=null) b.tt(toolTip);
        return addButton(b);
    }
    public final static int EXPAND_NODES=1, COLLAPSE_NODES=2, REDRAW=3, UPDATE_TREE=4, UPDATEUI=5;
    public OverlayScrollPane addButton(int id) {
        String t=null,tt=null,cmd=null;
        if (id==REDRAW) {
            cmd="UI";
            t="Redraw";
            tt="Calls updateUI()<br>shift: calls doLayout()<brctrl calls revalidate()";
        }
        if (id==UPDATE_TREE) {
            cmd="UT";
            t="Update tree";
        }
        if (id==UPDATEUI) {
            cmd="UI";
            t="Call updateUI";
        }
        if (id==EXPAND_NODES) {
            cmd="EXP";
            t="Expand";
            tt="show subnodes of tree-nodes that are not leafs";
        }
        if (id==EXPAND_NODES) {
            cmd="COLL";
            t="Collapse";
            tt="Collapse tree nodes";
        }
        return addButton(new ChButton(cmd).t(t).tt(tt).li(LI));
    }
    public OverlayScrollPane addButtonSort(int type) {
        String t=
            type==COMPARE_SIZE ? "Sort by size" :
            type==COMPARE_ID ? "Sort by id" :
            type==COMPARE_NAME ? "Sort by name" :
            type==COMPARE_WHEN_MODIFIED ? "Sort by modification  time" :
            type==COMPARE_WHEN_CREATED ? "Sort by creation time" :
            type==COMPARE_ALPHABET ? "Sort alphabetically" :
            type==COMPARE_ALPHABET_IC ? "Sort alphabetically case insensitive"  :
            type==COMPARE_REVERT ? "Revert order"  :
            "Sort";
        return addButton(new ChButton("SORT").t(t).li(LI).cp("SORT",intObjct(type)));
    }
    private JPopupMenu jPopup;
    public JPopupMenu createPopupMenu() {
        if (this.jPopup==null) {
          this.jPopup=jPopupMenu(0L,"Scrollpane", (Object[])box.getComponents());
            box.removeAll();
            box.add(ChButton.actionViewMessage("Tools\u25bc",jPopup));
        }
        return jPopup;

    }
    /* <<< Button  <<< */
    /* ---------------------------------------- */
    /* >>> Layout  >>> */
    private void setBounds() {
        final JScrollBar vsp=sb('V'),hsp=sb('H');
        int w=getWidth(), h=getHeight();
        if (hsp!=null && hsp.isVisible()) h-=hsp.getHeight();
        if (vsp!=null && vsp.isVisible()) w-=vsp.getWidth();
        final Dimension d=box.getPreferredSize();
        box.setBounds(-EM+w-d.width-4 ,h-d.height-4,d.width,d.height);
    }

    @Override public final Dimension getPreferredSize() {
        Dimension d=getPrefSize(this);
        if (d!=null) return d;
        d=component.getPreferredSize();
        return d==null ? dim(4*EM,4*EX) : dim(d.width,d.height+ICON_HEIGHT);
    }

    private JScrollBar sb(char VH) {
        final JScrollPane sp=deref(refSp,JScrollPane.class);
        return sp==null ? null : VH=='H' ? sp.getHorizontalScrollBar() : sp.getVerticalScrollBar();
    }
    /* <<< Layout <<< */
    /* ---------------------------------------- */
    /* >>> AWTEvent >>> */
    public AWTEvent processEvent(JComponent evtComp, AWTEvent ev) {
        final String cmd=actionCommand(ev);
        final JScrollPane sp=deref(refSp,JScrollPane.class);
        final int id=ev.getID();
        final Object q=ev.getSource();
        if (sp==null) return null;
        if (cmd!=null) {
            if (cmd=="SORT") {
                if (component instanceof ChJTree) ((ChJTree)component).sort(atoi(gcp("SORT",q)));

            }
            if (cmd=="UI") {
                final JComponent c=(JComponent)sp.getViewport().getView();
                if (isCtrl(ev))  c.revalidate();
                else if (isShift(ev)) c.doLayout();
                else ChDelay.updateUI(c,333,(long[])null);
                if (c instanceof JTree) ((JTree)c).setRowHeight(32);
            }
            if (cmd=="UT" || cmd=="UI") {
                final ChJTree t=deref(component,ChJTree.class);
                if (t!=null) {
                    if (cmd=="UT") t.updateKeepStateLater(0L, 99);
                    else t.updateUI();
                }
            }
            if ((cmd!="COLL" && cmd!="EXP") || !(component instanceof JTree)) return null;
            final JTree jTree=(JTree)component;
            final javax.swing.tree.TreePath pp[]=jTree.getSelectionPaths();
            if (pp!=null) {
                for( javax.swing.tree.TreePath p:pp) {
                    if (cmd=="COLL" && !jTree.isCollapsed(p)) jTree.collapsePath(p);
                    if (cmd=="EXP" && !jTree.isExpanded(p)) jTree.expandPath(p);
                }
            } else {
                for(int i=jTree.getRowCount(); --i>0; )
                    if (cmd=="EXP") jTree.expandRow(i);
                    else jTree.collapseRow(i);
            }

        }
        if (id==MOUSE_RELEASED && q instanceof JScrollBar) {
            ChDelay.repaint(component,222);
            ChDelay.repaint(box,333);
        }
        if (id==MOUSE_ENTERED || id==MOUSE_EXITED) box.repaint();
        return ev;
    }

}
