package charite.christo;
import javax.jnlp.*;
import charite.christo.interfaces.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import java.io.*;
import java.net.*;
/*
See http://java.sun.com/developer/onlineTraining/Programming/BasicJava2/socket.html
 */
public class Sil implements  ChRunnable {
    public final static String ACTION="SilNewAct";
    private final ChRunnable run;
    private Object sisl;
    private ServerSocket server;
    private boolean success;
    private final int port;
    private static int portLastWarning;
    public Sil(ChRunnable r, int port) {
      //putln(ANSI_GREEN+"new Sil "+port+ANSI_RESET);
        this.run=r;
        this.port=port;
        if (r!=null) {
            if (port!=0) {
                try{
                    server=new ServerSocket(port);
                    ChDelay.newThread(this,"waitForSocket",null).start();
                    this.success=true;
                } catch (IOException ex) {
                    if (portLastWarning!=port) putln("Warning: Could not listen on port "+port+" ",ex);
                    portLastWarning=port;
                }
            } else {
              if (!isSystProprty(IS_OPENJDK)) try {
                    this.sisl=new SingleInstanceListener() {public void newActivation(String[] params) {
                        ChDelay.invokeAndWait(Sil.this.run, ACTION, params);
                    }};
                    //putln("sisl=",sisl);
                    run("WS","");
                    this.success=true;
              } catch (Throwable e) {
                  //putln("caught in Sil ",e);
}
            }
        }
    }
    public boolean isSuccess() { return this.success;}

    public static void toSocketAndWaitForAnswerThenDie(int port, String argv[]) {
        try {
            final Socket socket=new Socket("localhost",  port);
            putln("Sil Going to write to socket ",socket);
            final OutputStream sos=socket.getOutputStream();
            for(String a : argv) {
                sos.write(a.replace('\t',' ').replace('\n',' ').getBytes());
                sos.write((byte)'\t');
            }
            sos.write((byte)'\n');
            //  sos.flush();
            ChDelay.newThread(new Sil(null,0),"DIE",new Object[]{socket,"DIE"+port}).start();
            sleep(2222);
        } catch(Exception ex) { putln("toSocketAndWaitForAnswerThenDie: "+port+" ",ex); }
    }

    public Object run(String id,Object arg) {
        final Object[] argv=arg instanceof Object[] ? (Object[])arg :null;
        if (id=="DIE") {
            final Socket socket=(Socket)argv[0];
            final Object dieFor=argv[1];
            try {
                final String line=readLne(socket.getInputStream());
                if (line!=null && line.equals(dieFor)) {
                  putln("Sil going to die ",line);
                  System.exit(0);
                }
            } catch(IOException iox) {}

        }

        if (id=="waitForSocket") {
            while(true) {
                try{
                    final Socket client=server.accept();
                    //putln(" client=",client);
                    ChDelay.newThread(this, "readLines",client).start();
                } catch (IOException ex) { putln("Caught in Sil: ",ex); }
            }
        }
        if (id=="readLines") {
            final Socket client=(Socket)arg;
            InputStream in=null;
            OutputStream os=null;
            try{
                in=client.getInputStream();
                os=client.getOutputStream();
            } catch (IOException ex) {putln("Caught in Sil: ", ex);  }

            while(true){
                try {
                    final String line=readLne(in);
                    if (line==null) break;
                    putln("Sil "+ANSI_GREEN, line, ANSI_RESET);
                    final String GET="GET /?";
                    final boolean startsGET=line.startsWith(GET);
                    final String send=startsGET ? line.substring(GET.length()).replaceAll("HTTP/[0-9].*","") : line;
                    if (run.run(ACTION, send)!=null) {
                        os.write(("DIE"+this.port+"\n").getBytes());
                        //os.flush();
                    }
                } catch (IOException ex) { putln("Caught in Sil: ",ex); break; }
            }
        }
        if (id=="WS") {
            try{
                Object s=ServiceManager.lookup("javax.jnlp.SingleInstanceService");
                if (s!=null) {
                    ((SingleInstanceService)s).removeSingleInstanceListener((SingleInstanceListener)sisl);
                    if (arg!=null) {
                        ((SingleInstanceService)s).addSingleInstanceListener((SingleInstanceListener)sisl);
                        addShutdownHook1(ChDelay.newThread(this,"WS",null));
                    }
                }
            } catch(Throwable e){}
        }
        return null;
    }
}