package charite.christo;
import charite.christo.interfaces.*;
import java.util.*;

import javax.swing.*;
import static charite.christo.ChConstants.*;
import static charite.christo.ChUtils.*;

/**
   @author Christoph Gille
*/
public class Strings2Tree implements ChRunnable {
    public final static int SKIP_LINES_WITH_HASH=1<<0, LEAFS_CONTAIN_ENTIRE_PATH=1<<2;

    private final Object list;

    private final long options;
    private final String sDelim;
    public Strings2Tree(long options, Object v, char delim) {
        this.list=v;
        this.options=options;

        sDelim=delim=='\\' ? "\\\\" : delim=='.' ? "\\." : String.valueOf(delim);
    }

    private int modi, nLines;
    public UniqueList getTree() {
        final Object list=this.list;
        int mc=modiCount(list), L=sze(list);
        if (this.root==null || this.modi!=mc || this.nLines!=L) {
            this.modi=mc;
            this.nLines=L;
            //putln(ANSI_YELLOW+"Strings2Tree getTree update"+ANSI_RESET+list);
            if (root==null) root=new UniqueList(Object.class).t("Root");
            vAllNodes.clear();
            for(int iLine=0; iLine<L; iLine++) {
                final String line=toStrgTrim(get(iLine,this.list));
                if (sze(line)==0 || 0!=(options&SKIP_LINES_WITH_HASH) && chrAt(0,line)=='#') continue;
                final String fields[]=split(line);
                final String leaf=0!=(options&LEAFS_CONTAIN_ENTIRE_PATH)?line:fields[fields.length-1];
                vAllNodes.add(leaf);
                insert(fields).add(leaf);
            }
            //putln("Strings2Tree root="+root);
            removeUnusedNodes(root);
        }
        return root;
    }

    private final static Map<String,String[]> mapSplit=new HashMap();
    private String[] split(String s) {
        String ss[]=mapSplit.get(s);
        if (ss==null) {
            mapSplit.put(s,ss=s.split(sDelim));
        }
        return ss;
    }

    private UniqueList<Object> root;
    private final Collection vAllNodes=new HashSet();
    private UniqueList insert(String[] fields) {
        UniqueList<Object> v=root;
        for(int i=0;i<fields.length-1; i++) {
            final Map<String,UniqueList> m=map(v);
            final String f=fields[i];
            UniqueList<Object> child=m.get(f);
            if (child==null) {
                m.put(f, child=new UniqueList(Object.class).t(f));
                v.add(child);
            }
            adUniq(child,vAllNodes);
            v=child;
        }
        return v;
    }

    private void removeUnusedNodes(UniqueList v) {
        for(Object o : v.asArray()) {
            final UniqueList v2=o instanceof UniqueList ? (UniqueList)o : null;
            if (v2!=null) removeUnusedNodes( v2);
            if (!vAllNodes.contains(o)) {
                putln(ANSI_RED+"remove "+ANSI_RESET+o);
                v.remove(o);
                if (v2!=null) map(v).remove(v2.getText());
            }

        }
    }

    private final static Object KEY=new Object();
    private final static Map<String,UniqueList> map(UniqueList v) {
        Map m=gcp(KEY,v,Map.class);
        if (m==null) pcp(KEY, m=new HashMap(), v);
        return m;

    }

    public Object run(String id, Object arg) {
        final Object argv[]=arg instanceof Object[] ? (Object[])arg : null;
        if (id==PROVIDE_JTREE_CHILDS) return getTree();
        return null;
    }

// java charite.christo.Strings2Tree
    /*
    public static void main(String argv[]) throws Exception {
        final List vLines=new UniqueList(String.class);
        for(String s : new String[]{
                "Frucht\\Apfel\\Kerne",
                "Frucht\\Apfel\\Stiel",
                "Gemuese\\Gurke\\Gruen",
                "Gemuese\\Gurke\\Gelb",
                "Haus\\Fenster"
            }) vLines.add(s);

        final Strings2Tree s2m=new Strings2Tree(SKIP_LINES_WITH_HASH,vLines,'\\');

        final List v0=s2m.getTree();
        UniqueList row1=get(1,v0,UniqueList.class);
        final ChTreeModel tm=new ChTreeModel(0L,v0);
        final JTree jt=new ChJTree(ChJTable.DEFAULT_RENDERER,tm);

        jt.setRootVisible(false);
        jt.setShowsRootHandles(true);
        new ChFrame("").ad(jt).shw(0);

    }
    */
}