package charite.christo;
import charite.christo.hotswap.ProxyClass;
import java.awt.*;
import javax.swing.Icon;
import javax.swing.ImageIcon;

import java.util.Map;

import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**
Obtains  texts for tabs of JTabbedPane, menu item texts, tool=tips and tabs.
   @author Christoph Gille
*/
public class TabItemTipIcon {
    private static  TabItemTipIcon inst;
      public static TabItemTipIcon shared(CharSequence tab,CharSequence item, CharSequence tip,Icon icon) {
        if (inst==null) inst=new TabItemTipIcon();
        inst.tab=toStrg(tab);
        inst.item=toStrg(item);
        inst.tip=toStrg(tip);
        inst.icon=icon;
        return inst;
    }

    private TabItemTipIcon() {}
    public TabItemTipIcon(CharSequence tab,CharSequence item, CharSequence tip,Icon icon) {
        this.tab=toStrg(tab);
        this.item=toStrg(item);
        this.tip=toStrg(tip);
        this.icon=icon;
    }

    private String tip,item,tab,homePage, sIcon,userProfile;
    private Icon icon;

    private Icon icn() {
        if (icon==null && sIcon!=null) {
            icon=iicon(sIcon);
            if (icon==null) icon=iicon(IC_ERROR_ICON);
        }
        return icon!=iicon(IC_ERROR_ICON) ? icon : null;
    }

    private static String sKey(Object o) {
        if (o==null) return null;
        if (o instanceof String) return (String)o;
        if (o instanceof CharSequence) return o.toString();
        Class c=o instanceof Class ? (Class)o : o instanceof ProxyClass ? ((ProxyClass)o).getClassInstance() : null;
        return c!=null ? c.getName() : null;

    }
    public static Object set(String tab,CharSequence item,CharSequence tip,Object icon,  Object o) {
        if (o==null) return null;
        final String  s=  sKey(o);
        TabItemTipIcon titi=s!=null ? MAP.get(s) : WEAK_MAP.get(o);

        if (titi==null) {
            titi=new TabItemTipIcon();
            if (s!=null) MAP.put(s,titi);
            else if (o!=null) WEAK_MAP.put(o,titi);
        }
        if (tab!=null) titi.tab=tab;
        if (item!=null) titi.item=item.toString();
        if (icon instanceof String) titi.sIcon=(String) icon;
        else if (icon instanceof Icon) titi.icon=(Icon)icon;
        if (tip!=null) titi.tip=tip.toString();
        return o;
    }

      final static Map<String,TabItemTipIcon> MAP=new java.util.HashMap();
    private final static Map<Object,TabItemTipIcon> WEAK_MAP=new java.util.WeakHashMap();

    private static TabItemTipIcon lastTiti;
    private static Object lastO;
    public static TabItemTipIcon get(Object o) {
        if (o==null) return null;
        if(o==lastO) return lastTiti;
        if (isInstncOf(Interface.class,o)) {
            return ((Interface)o).getTabItemTipIcon(null);
        }
        final String  s=sKey(o);
        TabItemTipIcon titi= s!=null ? MAP.get(s) : WEAK_MAP.get(o);
        if (titi==null) titi=MAP.get(clazzName(o));
        if (titi!=null) {
            lastTiti=titi;
            lastO=o;
        }
        return titi;
    }
    public static String tab(Object o) {
        final TabItemTipIcon mc=o!=null ? get(o) : null;
        return (mc!=null) ? mc.tab : null;
    }
    public static String item(Object o) {
        TabItemTipIcon mc=o!=null ? get(o) : null;
        return  mc!=null ? mc.item : null;
    }
    public static String tip(Object o) {
        TabItemTipIcon mc=o!=null ? get(o) : null;
        return mc!=null ? mc.tip : null;
    }

    public static String tip(Object o, AWTEvent ev) {
        if (o instanceof Interface) {
            TabItemTipIcon t=((Interface)o).getTabItemTipIcon(ev);
            if (t!=null) return t.tip;
        }
        return tip(o);
    }

    public static ImageIcon imageIcon(Object o) { Icon i=icn(o); return i instanceof ImageIcon ? (ImageIcon)i : null;}

    public static Object iconOrStrg(Object o) {
        final TabItemTipIcon mc=get(o);
        return mc==null ? null : mc.icon!=null?mc.icon : mc.sIcon;
    }

    public static Icon icn(Object o) {
        if (o==null) return null;
        final TabItemTipIcon mc=get(o);
        Icon icon= mc!=null? mc.icn(): null;
        if (icon==null) {
            final String cn=clazzName(o);
            if (sze(cn)>0) {
                if (cn.charAt(0)=='j' && cn.startsWith("java.")||cn.startsWith("javax.")) return null;
               icon=iicon(cn.replace('.','/'));
            }
            set(null,null,null,icon!=null ? icon:iicon(IC_ERROR_ICON),cn);
        }
        return icon;
    }
    public static String userProfile(Object o) {
        final TabItemTipIcon mc=o!=null ? get(o) : null;
        return  mc==null ? null : mc.userProfile;
    }

    public static String homePage(Object o) {
        TabItemTipIcon mc=o!=null ? get(o) : null;
        if (mc==null) return null;
        if ("SRC".equals(mc.homePage)) {
            Object inst=HotswapUtil.instance(o);
            if (inst==null) inst=o;
            try {
                //               mc.homePage=withoutLastComponent( ((AbstractExecutable)inst).getSourcePackageURLs()[0][0],'/');
            } catch(Exception e) {}
        }
        return  mc.homePage;
    }

    public static void add(String text[]) {for(String t:text) add(t);}
    private static void add(String line) {
        try {
            if (line==null) return;
            int l=sze(line),l1=l+1, i1=l,i2=l,i3=l,i4=l,i5=l,i6=l,i7=l;
            if (l==0) return;
            final char c0=line.charAt(0);
            if (c0==' '|| c0=='\t'|| c0=='#') return;
            if ((i1=line.indexOf(';')+1)>0)
                if ((i2=line.indexOf(';',i1)+1)>0)
                    if ((i3=line.indexOf(';',i2)+1)>0)
                        if ((i4=line.indexOf(';',i3)+1)>0)
                            if ((i5=line.indexOf(';',i4)+1)>0)
                                if ((i6=line.indexOf(';',i5)+1)>0)
                                    if ((i7=line.indexOf(';',i6)+1)>0);
                                    else i7=l+1;
                                else i6=l+1;
                            else i5=l1;
                        else i4=l1;
                    else i3=l1;
                else i2=l1;
            else i1=l1;
            final String className=
                line.startsWith("CCSE.") ? _CCSE+line.substring(5,i1-1) :
                line.startsWith("CCSI.") ? _CCS+"interfaces."+line.substring(5,i1-1) :
                line.startsWith("CCS.") ? _CCS+line.substring(4,i1-1) :
                line.startsWith("CCP.") ? _CCP+line.substring(4,i1-1) :
                line.startsWith("CCI.") ? _CC+"interfaces."+line.substring(4,i1-1) :
                line.startsWith("CC.") ? _CC+line.substring(3,i1-1) :
                line.substring(0,i1-1);

            final TabItemTipIcon mc= new TabItemTipIcon();
            if (i1<i2) mc.tab =line.substring(i1,i2-1);
            if (i2<i3) mc.item=line.substring(i2,i3-1);
            if (i3<i4) mc.tip =line.substring(i3,i4-1);
            if (i4<l) mc.sIcon=line.substring(i4,i5-1).intern();
            if (i5<l) mc.homePage=line.substring(i5,i6-1);
            if (i7<l) mc.userProfile=line.substring(i7);
            MAP.put(className,mc);
        } catch(Exception e) { putln("TabItemTipIcon: caught ",e);}
    }
    public interface Interface {
        TabItemTipIcon getTabItemTipIcon(AWTEvent ev);
    }
}
