package charite.christo;
import static charite.christo.ChUtils.*;
import charite.christo.interfaces.ChRunnable;
import java.net.URL;
import java.util.*;
import java.io.*;
import javax.swing.JComponent;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**HELP

<br><br><b>Internet and Web-proxy</b><br>
<br>
In some institutions all Internet connections are going through a Web proxy (see WIKI:Proxy_server).

If the proxy is not set correctly, STRAP is unable to download files from the Web.

The proxy cannot be set in the running application.

The way how the proxy is set depends on whether the application is
started via WIKI:Webstart (See WIKI:JNLP) or started directly.

<h3>Webstart</h3>

In Windows or Linux there is a program called Java control panel  which allows to set the proxy (Button "Network settings"):
<i>STRING:charite.christo.ChUtils#fileJcontrol()</i> located in
<i>STRING:ChUtils#dirJavaws()</i>.

Under Macintosh, however, the system wide proxy setting is also used in Java.

<h3>Direct start without Webstart</h3>

The proxy is specified with command line arguments. Example:
<pre class="terminal">
java -Dhttp.proxyHost=realproxy.charite.de -Dhttp.proxyPort=888   ...
</pre>

If there are addresses that should bypass the proxy use vertical bar separated list of hosts as in the following example:
<pre class="terminal">
 ....  -Dhttp.nonProxyHosts="localhost|host.mydomain.com" ...
</pre>

<h3>Testing the Proxy settings</h3>

Use the item <i>BUTTON:charite.christo.ChUtils#buttn(NEW_BUT_TEST_PROXY)!</i>
In the menu "Preferences" is.

Further reading http://java.sun.com/javase/6/docs/technotes/guides/net/proxies.html

   @author Christoph Gille

*/

public class Web implements ChRunnable {
    private Web(){}
    private static Web inst;
    private static Web instance() {if (inst==null) inst=new Web(); return inst;}
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> getServerResponse >>> */
    public static ByteArray getServerResponse(long options, String url,Object variables[][]) {
        InputStream is=getServerResponseAsStream(options, url,variables);
        ByteArray ba=readBytes(is);
        closeStrm(is);
        return ba;
    }
    public static InputStream getServerResponseAsStream(long options, String url,Object data[][]) {
        final ByteArray httpData=new ByteArray(99999), baTmp=new ByteArray(999);
        int i=0;
        for(Object dd[]:data) {
            if (dd==null||dd.length<2  || dd[1]==null) continue;
            if (i++>0) httpData.append('&');
            baTmp.setEnd(0).append(dd[1]);
            httpData.append(dd[0]).append('=').urlEncode(baTmp.getBytes(),0,baTmp.getEnd());
        }
        return getServerResponseAsStream(options, url,httpData);
    }

    public static boolean uploadPermission(long frameOpts, ByteArray httpData, String url) {
        if (httpData==null) return false;
        if (strstr(DO_NOT_ASK, url)>0  || !isGraphicsAvailable()) return true;
        final ChButton tog=buttn(TOG_NASK_BEFORE_UPLOADING_DATA);
        if (tog.s()) return true;
        final JComponent
            tp=new AsciiView(new ByteArray(0).foldText(httpData.getBytes(),0,httpData.getEnd(),  90)),
            msg=newCNSEW(scrllpn(0L, tp, dim(EM*80,EX*10)), hB("Going to transmit above data to ",url), tog.cb(), null,null);
        return ChMsg.yesNo(tog, ChFrame.PACK|frameOpts, msg);
    }
    public static InputStream getServerResponseAsStream(long options, String url,ByteArray httpData) {
        OutputStream os=null;
        InputStream is=null;
        java.net.URLConnection uc=null;
        try {
            if (!uploadPermission(ChFrame.CENTER, httpData,url)) return null;
            final URL u=url(delSfx("&"+DO_NOT_ASK, url));
            if (u!=null) {
                uc=u.openConnection();
                uc.setDoOutput(true);
                uc.setDoInput(true);
                uc.setUseCaches(false);
                os=new BufferedOutputStream(uc.getOutputStream());
                wrte(os,httpData);
                os.flush();
                is=uc.getInputStream();
                return is;
            } else assertTrue(false);
        } catch(IOException e) { closeStrm(is); putln(RED_CAUGHT_IN,"getServerResponseAsStream",e); }
        finally{ closeStrm(os); }
        return null;
    }
    /* <<< getServerResponse <<< */
    // nc -l -p 1234

    public final static Map<String,String> MAP_VIA_PORT_MSG=new HashMap();
    public static Thread thread_sendDataToPort(int port, CharSequence data, String wordUnderMouse) {
        return threadM("sendDataToPort", Web.class, new Object[]{intObjct(port),data,wordUnderMouse});
    }

    public static boolean sendDataToPort(int port, CharSequence data, String wordUnderMouse) {
        if (sze(wordUnderMouse)>0) {
            for(Map.Entry<String,String> e : entryArry(MAP_VIA_PORT_MSG)) {
              final String k=e.getKey(), v=e.getValue();
              if (sze(k)*sze(v)>0&& equls(k,wordUnderMouse)) {
                  new ChTextViewer(addHtmlTagsAsStrg(v)).shw(ChFrame.AT_CLICK);
                  MAP_VIA_PORT_MSG.remove(k);
              }
            }
        }
        OutputStream os=null;
        try {
            final java.net.Socket s=new java.net.Socket("localhost", port);
            os=s.getOutputStream();
            wrte(os,toByteArray(data));
            return true;
        } catch(IOException iox){ stckTrc(iox); }
        finally{ closeStrm(os); }
        return false;
    }
    /* ---------------------------------------- */
    /* >>> to URL >>> */
    public static URL[] urls(Object urlBase, String files) {
        final String tokens[]=splitTokns(0L, files);
        if (tokens==null) return null;
        assert files.indexOf('|')<0;
        final ArrayList<URL> v=new ArrayList();
        for(String jar : tokens) {
            adUniq(url(looks(LIKE_EXTURL,jar) || urlBase==null ? jar : delSfx("/",urlBase.toString())+"/"+delPfx("/",jar)),v);
        }
        return toArry(v,URL.class);
    }
    /* <<< to URL <<< */
    /* ---------------------------------------- */
    /* >>> Process HTML Page >>> */
    public static void insertBaseTag(URL url, File fDest, ByteArray html) {
        if (html==null) return;
        byte[] T=html.getBytes();
        final String  sUrl=url.toString();
        final int
            B=html.getBegin(),
            E=html.getEnd(),
            slash=-1,//sUrl.lastIndexOf('/');
            eHead=strstr(STRSTR_IC,"</head",T,B, E);
        {
        final String insert= (eHead<0?"<head>\n":"") + "<base href=\""+ (slash>9 ? sUrl.substring(0,slash) : sUrl)+"\"  /> \n"+(eHead<0?"</head>\n":"");
        if (eHead>0 &&  strstr(STRSTR_IC,"<base",T, B, eHead)>0) return;
        final int i= eHead>0?eHead: strstr(STRSTR_IC,"<body",T, B, E);
        if (i>0) { html.replace(i,i,insert.getBytes()); T=html.getBytes(); }
        }
        final byte[] fDestBB=toByts(toStrg(url(fDest)));
        if (fDest!=null) {
            String base0=null;
            for(int i=html.getEnd(); --i>=0; ) {
                if ((T[i]|32)=='h' && ( equls(STRSTR_IC,"href=\"#",T,i) || equls("href=\'#",T,i))) {
                    html.replace(i+6,i+6,fDestBB);
                    T=html.getBytes();
                }
            }
        }
    }
    /* <<< Process HTML Page <<< */
    /* ---------------------------------------- */
    /* >>> Thread  >>> */
    public Object run(String id, Object arg) {
        final Object[] argv=arg instanceof Object[] ? (Object[])arg:null;
        if (id=="TEST_URL") {
            final String url=(String)argv[0];
            final AsciiView v=(AsciiView)argv[1];
            final ByteArray ba=readBytes(inStreamT(20,url,STREAM_UNZIP));
            v.setText(ba!=null ? ba : new ByteArray("Unable to connect to "+url));
            v.revalidate();
        }

        if (id=="CK_NEW_VERS") {
            final File f=thisJarFile();
            final ByteArray ba=new ByteArray(99).append(URL_STRAP)
                .append("checkUpdates.php?j=").append(appName()+"_"+delPfx(".jar",getNam(f)))
                .append("&c=").urlEncode(dateOfCompilation())
                .append("&s=").urlEncode(readStrg(file(dirTmp()+"/last_"+appName()+".txt")));
            try {
                final ByteArray info=readBytes(url(ba).openStream());
                if (0<=strstr(STRSTR_IC, "new version", info)) ChMsg.msgDialog(0L, info.newString());
            } catch(Throwable ex) {}
        }

        return null;
    }
    public static void checkForNewVersion(String title) {
        if (!isMyComputer()) ChDelay.newThread(instance(), "CK_NEW_VERS", new Object[]{title}).start();
    }
    /* <<< Thread  <<< */
    /* ---------------------------------------- */
    /* >>> Proxy >>> */
    static void testConnectionForURL(String url) {
        if (url(url)!=null) {
            final AsciiView v=new AsciiView("Connecting to "+url+" ...\n\n");
            v.showInFrame("Test connection "+url);
            ChDelay.newThread(instance(), "TEST_URL",new Object[]{url,v}).start();
        }
    }
    public static Thread thread_startJnlp(URL url, ChTextReplacement rplc) {
        final Object[] para={url,rplc};
        return threadM("startJnlp", Web.class,para);
    }
    /* <<< Proxy <<< */
    /* ---------------------------------------- */
    /* >>> Jnlp >>> */
    public static void startJnlp(URL url, ChTextReplacement rplc) throws IOException {
        if (url==null) return;
        final ByteArray ba=readBytes(url.openStream());
        if (ba!=null) {
            ba.replace(rplc);
            final File f=createTempFile("jnlp");
            wrte(f,ba);
            visitURL(f,0);
        }
    }

}
