package charite.christo.blast;
import charite.christo.*;
import static charite.christo.ChConstants.*;
import static charite.christo.ChUtils.*;
public class BlastAlignment {
    private byte[] matchSeq,querySeq,matchUngapped;
    private int
    queryStart, queryEnd, matchStart,matchEnd, matchHashcode,
      identity, positives, score, number,
        querySeqFrom, querySeqTo, matchSeqFrom, matchSeqTo;
    private double expect,bits;
    private BlastHit blastHit;
    public void setMatchSeq(byte[] s,int from,int to) {this.matchSeq=s; matchSeqFrom=from; matchSeqTo=mini(s.length,to); }
    public void setQuerySeq(byte[] s,int from,int to) {this.querySeq=s; querySeqFrom=from; querySeqTo=mini(s.length,to); }
    public void setQueryStartEnd(int s,int e) {queryStart=s;queryEnd=e;}
    public void setMatchStartEnd(int s,int e) {matchStart=s; matchEnd=e;}
    public void setIdentity(int i) {identity=i;}
    public void setPositives(int i) {positives=i;}
    public void setScore(int i) {score=i;}
    public void setNumber(int i) {number=i;}
    public void setExpect(double d) {expect=d;}
    public void setBits(double d) {bits=d;}

    public byte[] getMatchSeq() {
        final int f=matchSeqFrom, t=matchSeqTo;
        if (this.matchSeq!=null && (f>0 || t!=matchSeq.length)) {
            final byte bb[]=new byte[t-f];
            System.arraycopy(this.matchSeq,f,bb,0, t-f);
            this.matchSeqFrom=0;
            this.matchSeqTo=bb.length;
            this.matchSeq=bb;
        }
        return this.matchSeq;
    }

    public int getMatchSeqHashCode() {
        if (matchHashcode==0) matchHashcode=hashCd(getMatchSeq(),0,MAX_INT,true);
        return matchHashcode;
    }

    public byte[] getQuerySeq() {
        final int f=querySeqFrom, t=querySeqTo;
        if (this.querySeq!=null && (f!=0 || t!=querySeq.length) ) {
            final byte bb[]=new byte[t-f];
            System.arraycopy(this.querySeq,f,bb,0, t-f);
            this.querySeqFrom=0;
            this.querySeqTo=bb.length;
            this.querySeq=bb;
        }
        return this.querySeq;
    }

    public byte[] getMatchUngapped() {
        if (matchUngapped==null) matchUngapped=onlyLetters(getMatchSeq());
        return matchUngapped;
    }
    public int getQueryStart() { return queryStart;}
    public int getQueryEnd() { return queryEnd;}
    public int getMatchStart() { return matchStart;}
    public int getMatchEnd() { return matchEnd;}
    public int getIdentity() { return identity;}
    public int getPositives() { return positives;}
    public int getScore() { return score;}
    public int getNumber() { return number;}
    public double getExpect() { return expect;}
    public double getBits() { return bits;}
    public String getDatabase(){ return blastHit.getDatabase();}
    public String getID(){ return blastHit.getID();}
    public BlastHit getBlastHit() { assertNotNull(blastHit); return blastHit;}
    public void setBlastHit(BlastHit b) { blastHit=b;}
    private boolean isNovel;
    public void setIsNew(boolean b){isNovel=b;}
    final int descrFromTo[]={0,0};
    public final void toText(ByteArray sb,int outputWidth) {
        final BlastHit bh=getBlastHit();
        final String db=bh.getDatabase(), id=bh.getID();
        sb.append("> ").append(db);
        if (db!=null && db.startsWith("EM")) {
            sb.append("EMCDS".equals(db) ? " EMBLCDS" : " EMBL");
        }
        final byte descr[]=bh.getDescription(descrFromTo);
        sb.append(':').append(id).append(' ',2)
            .append(descr, descrFromTo[0], descrFromTo[1])
            .append( isNovel ? " (NEW)" : "")
            .append("\n\n Score = ").append(getScore()).append(" (").appendFloat(getBits(), 6)
            .append("), Expect = ").appendFloat(getExpect(),6)
            .append("\nIdentities = ").append(getIdentity()).append('/').append(matchSeqTo-matchSeqFrom)
            .append(", Positives = ").append(getPositives()).append('/').append(matchSeqTo-matchSeqFrom)
            .append('\n',2);

        final byte[] query=this.querySeq, mSeq=this.matchSeq;
        final int len=maxi(matchSeqTo-matchSeqFrom, querySeqTo-querySeqFrom, matchSeqTo-matchSeqFrom);
        for(int col=0, posQuery=getQueryStart(), posMatch=getMatchStart(); col<len; col+=outputWidth) {
            final int colE=mini(col+outputWidth,len);
            sb.append('Q').append(posQuery+1,8).append(' ')
                .append(query,col+querySeqFrom,colE+querySeqFrom).append(' ').append(posQuery+=countLetters(query,col+querySeqFrom,colE+querySeqFrom)).append('\n')
                .append(' ',10);
            midline(query,col+querySeqFrom,colE+querySeqFrom,mSeq,col+matchSeqFrom,colE+matchSeqFrom,sb);
            sb.append("\nH").append(posMatch+1,8).append(' ')
                .append(mSeq,col+matchSeqFrom,colE+matchSeqFrom).append(' ').append(posMatch+=countLetters(mSeq,col+matchSeqFrom,colE+matchSeqFrom))
                .append('\n',2);
        }

    }

    public static void midline(byte[] q,int qFrom, int qTo, byte[] m, int mFrom, int mTo, ByteArray sb) {
        final byte[][] M=charite.christo.protein.Blosum.BLASTMIDLINE;
        for(int iQ=qFrom, iM=mFrom; iQ<qTo && iM<mTo; iQ++,iM++) {
            sb.append( (char) M[q[iQ]&127][m[iM]&127]);
        }
    }
    public final static BlastAlignment[] NONE={};
}
