package charite.christo.protein;
import charite.christo.*;
import charite.christo.interfaces.*;
import java.util.Map;

import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;

/**
   @author Christoph Gille
*/
public abstract class AbstractProteinViewerProxy extends AbstractProxy implements ProteinViewer, ChRunnable {

    public ProteinViewer pv(){
        ProteinViewer v=(ProteinViewer)proxyObject();
        return v;
    }
    //    {  if (ChUtils.isMyComputer())  ChFrame.frame("ChClassLoader1", ChClassLoader1.log(),0).shw(0);    }
    public Protein getProtein() { ProteinViewer pv=pv(); return pv!=null ? pv.getProtein() : null;}
    public boolean setProtein(long options, Protein p, ProteinViewer inSameView) {
        try {
            final ProteinViewer pv=pv();
            this.toString=p+"@"+ChUtils.shrtClasNam(this);
            return pv!=null && p!=null && pv.setProtein(options, p,inSameView);
        } catch(Throwable ex) {ChUtils.stckTrc(ex); return false;}
    }

    public void handleEvent(StrapEvent ev) {
        final ProteinViewer pv=pv();
        if (pv instanceof StrapListener) ((StrapListener)pv).handleEvent(ev);
    }
    public void setProperty(String id, Object value) {
        ProteinViewer pv=pv(); if (pv!=null) pv.setProperty(id, value);
    }
    public Object getProperty(String id) { ProteinViewer pv=pv(); return pv!=null ? pv.getProperty(id) : null;}
    public Object run(String id, Object arg) {
        if (id==ChRunnable.COLUMN_TITLE) return Protein3dUtils.titleFor3dViewers(Protein3dUtils.getProteinsInView(this));
        final ProteinViewer pv=pv();
        return pv instanceof ChRunnable ? ((ChRunnable)pv).run(id,arg) : null;
    }
    @Override public void dispose() {
        super.dispose();
        new StrapEvent(this, StrapEvent.PROTEIN_VIEWER_CLOSED).run();
    }
    public ProteinViewer[] getViewersSharingView() {
        final ProteinViewer pv=pv();
        final ProteinViewer vvPo[]=pv!=null ? pv.getViewersSharingView() : null;
        if (vvPo==null) return ProteinViewer.NONE;
        final ProteinViewer vv[]=new ProteinViewer[vvPo.length];
        for(int i=vv.length; --i>=0;) {
            vv[i]=getProxy(vvPo[i],ProteinViewer.class);
        }
        return vv;
    }
    private String toString;
    @Override public String toString() { return toString!=null ? toString : super.toString();}

    {
        ProteinUtils.initCustomizableSettings(this);
    }

    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> static utility >>> */

}
