package charite.christo.protein;
import charite.christo.*;
/**
   Counting identical residues in two aligned sequences.
   see http://wikiomics.org/wiki/Percentage_identity
   @author Christoph Gille
*/
public class CrudeSequenceSimilarity {
    private CrudeSequenceSimilarity(){}
    public static Ratio getIdentity(byte seq1[],byte seq2[],int from,int to) {
        return getIdentity(null,seq1,seq2,from,to);
    }

    public static Ratio getIdentity(Ratio result,byte seq1[],byte seq2[],int from,int to) {
        if (seq1==null || seq2==null) return null;
        final int l=ChUtils.mini(seq1.length,seq2.length,to);
        int ident=0,count=0;
        for(int i=from;i<l;i++) {
            int b1=seq1[i]|32,b2=seq2[i]|32;
            if ('a'<=b1  && b1<='z' &&'a'<=b2  && b2<='z') {
                count++;
                if (b1==b2) ident++;
            }
        }
        if (result==null) result=new Ratio(1,1);
        result.setNumerator(ident);
        result.setDenominator(count);
        return result;
    }
}
