package charite.christo.protein;
import static charite.christo.ChUtils.*;
import charite.christo.*;

/**HELP
.sbd Files created with SeqBuilder
   @author Christoph Gille
*/
public class SBD_Parser implements ProteinParser {
    public boolean parse(Protein p, long options, ByteArray ba) {
        final byte[] T=ba.getBytes();
        final int E=ba.getEnd();
        final int B=ba.getBegin();
        final int i=E-B<100 ? -1 : strstr(STRSTR_AFTER, "Created by SeqBuilder version ",T,B,mini(E,B+80));
        if (i<0) return false;
        final int seqStart=nxt(LETTR, T,i,E);
        if (seqStart<0) return false;
        final int seqEnd=nxtE(NO_LETTR,T,seqStart,E);
        //putln("seq="+ba.newString(seqStart,seqEnd)+"<<<");
        p.setResidueType(substrgB(T, seqStart ,seqEnd));

        return true;
    }
}
