package charite.christo.protein;

import static charite.christo.ChUtils.*;
public class Selection3D implements Comparable {
    public final static Selection3D[] NONE={};
    private long options;
    private int first, last;
    private char insertion, chain;
    private String atoms[], name, nativeAtoms;
    public Selection3D(Selection3D s) {
        this(s.options,s.first, s.last, s.insertion, s.chain, s.atoms);
        nativeAtoms=s.nativeAtoms;
        name=s.name;
    }

    public Selection3D(long options,int first, int last, char insertion, char chain, String atoms[]) {
      this.options=options;

      this.first=name==null?first:-1;
      this.last=name==null?last:-1;
      this.insertion=name==null?insertion:0;
      this.chain=name==null?chain:0;
      this.atoms=atoms;
  }

    public Selection3D(long options, String name, char chain, String atoms[]) {
        this.options=options;
        this.name=name;
        this.chain=name==null?chain:0;
        this.atoms=atoms;
    }

    public long getOptions() { return options;}

    public int getFirst() {return first;}
    public int getLast() {return last;}

    public char getInsertion() { return insertion;}
    public char getChain() { return chain;}

    public String[] getAtoms() { return atoms;}
    public String getResidueName() { return name; }
    public String getNativeAtoms() { return nativeAtoms; }

    public Selection3D newInstanceChangeAtoms(String[] atoms) {
        final Selection3D n=new Selection3D(this);
        n.atoms=atoms;
        return n;
    }
    public Selection3D newInstanceNativeAtoms(String atoms) {
        final Selection3D n=new Selection3D(this);
        n.nativeAtoms=atoms;
        return n;
    }

    public int compareTo(Object o) {
        final Selection3D s=(Selection3D)o;
        final String nThis=getResidueName(), n=s.getResidueName();
        if (nThis!=null && n!=null) return n.compareTo(nThis);
        else if (nThis!=null) return 1;
        else if (n!=null) return -1;
        final long iThis=(  chain<<63L) | (  first<<32L) | (  last<<1L) |   insertion;
        final long i=    (s.chain<<63L) | (s.first<<32L) | (s.last<<1L) | s.insertion;
        return iThis==i ? 0 : iThis<i?-1 : 1;
    }
}