package charite.christo.protein;
import static charite.christo.ChConstants.*;
import static charite.christo.ChUtils.*;
public class SelectionVariables {

    private static String[]  _names[];
    public static String[] names(int n) {
        if (_names==null) {

            final String[]
                fl=splitTokns(0L, "AAA aaa Aaa Aaa INDEX NUMBER A "),
                vv=splitTokns(0L,"$CHAIN $SELECTION_NAME $TEX_RESIDUES $TEX_PROTEIN"),
            aa=new String[fl.length*2];
            for(int i=0; i<fl.length; i++) {
                aa[2*i  ]="$FIRST_"+fl[i];
                aa[2*i+1]= "$LAST_"+fl[i];
            }
            _names=new String[][]{joinArrays(aa, vv, String.class), aa};
        }
        return _names[n];
    }
    public static CharSequence replace(CharSequence s0, Object o0) {
      if (strchr('$',s0)<0) return s0;
      if (s0==null) return null;
        ResidueSelection a=deref(o0,ResidueSelection.class);
        Protein p=deref(o0,Protein.class);
        Object oo[]=deref(o0, Object[].class);
        for(int i=sze(oo); --i>=0; ) {
            if (a==null) a=deref(oo[i],ResidueSelection.class);
            if (p==null) p=deref(oo[i],Protein.class);
        }
        if (p==null && a!=null) p=a.getProtein();
        CharSequence s= replaceBB(s0, a==null?null:a.getSelectedAminoacids(), a==null?0:a.getSelectedAminoacidsOffset(), getNam(a), p, null);
        final java.awt.Color color=colr(a);
        if (color!=null) { /* Pymol */
            final int iDef=strstr(STRSTR_w, Pymol.DEFINE_THIS_COLOR,s);
            final int iCol=strstr(STRSTR_w, Pymol.PYMOL_COLOR_NAME,s);
            if (iDef>=0 || iCol>=0) {
                final int rgb=color.getRGB();
                String hex=toHex(rgb,6,new StringBuffer(7).append('c')).toString();
                if (iDef>=0 ) {
                    s=rplcCS(STRSTR_w, Pymol.DEFINE_THIS_COLOR, "set_color "+hex+" , [ "+  ( (rgb>>16)&255)/256f+","+(((rgb>>8)&255)/256f)+","+((rgb&255)/256f)+" ] ", s);
                }
                if (iCol>=0) s=rplcCS(STRSTR_w, Pymol.PYMOL_COLOR_NAME, hex, s);
            }
        }
        return s;
    }

    public static CharSequence replaceBB(CharSequence s0,  boolean bb[], int offset, String name, Protein p, Protein allPP[]) {
        if (strchr('$',s0)<0) return s0;
        CharSequence s=rplcCS(STRSTR_w,"$SELECTION_NAME",name,s0);
        if (strstr("$FIRST_",s)>=0 || strstr("$LAST_",s)>=0) {
            for(String n : names(1)) {
                if (strstr(n,s)<0) continue;
                final int L=sze(n);
                final char c1=chrAt(L-1, n), cz=chrAt(L-1, n), cy=chrAt(L-2, n), cx=chrAt(L-3, n);
                final int idx=offset+ c1=='F' ? firstTrue(bb) : lastTrue(bb);
                String rplc=null;
                if (p==null || idx<0) rplc="?";
                else if ( (cx|32)=='a' && (cy|32)=='a' && (cz|32)=='a') {
                    final int a=p.getResidueName32(idx);
                    final byte[] aaa={
                        (byte)((a    )&0xff|(cx&32)),
                        (byte)((a>>8 )&0xff|(cy&32)),
                        (byte)((a>>16)&0xff|(cz&32))
                    };
                    rplc=toStrg(aaa);
                }
                else if (cy=='E'&&cz=='X') rplc=toStrg(idx+1);
                else if (cy=='_'&&cz=='A') rplc=toStrg((char) p.getResidueType(idx));
                else if (cy=='E'&&cz=='R') rplc= idx<0||p==null?"-1":toStrg(p.getResidueIndexForExport(idx));
                if (rplc!=null) s=rplcCS(STRSTR_w, n, rplc, s);
            }
        }
        String n;
        if (strstr(n="$CHAIN",s)>=0)            s=rplcCS(STRSTR_w,n,toStrg(p==null ? '?' : (char) p.getResidueChain(firstTrue(bb)+offset)),s);
        if (strstr(n="$TEXSHADE_RESIDUES",s)>=0)s=rplcCS(STRSTR_w,n,texshadeRange(bb,offset,p),s);
        if (strstr(n="$PROTEIN_NO",s)>=0) {
          //final ProteinAlignment a=p==null?null:p.getAlignment();
            s=rplcCS(STRSTR_w, n, p==null||allPP==null ? "1" : toStrg(idxOf(p,allPP)+1),s);
        }
        return s;
    }

    public static String texshadeRange(boolean bb[], int offset, Protein p) {
        final StringBuffer sb=new StringBuffer(40);
        for(int i=0;i<bb.length;i++) {
            if (bb[i]) {
                if (sze(sb)>0) sb.append(',');
                sb.append(p==null ? i+offset+1 : p.getResidueIndexForExport(i+offset)).append("..");
                while (i<bb.length && bb[i]) i++;
                sb.append(p==null ? --i+offset : p.getResidueIndexForExport(--i+offset));
            }
        }
        return toStrg(sb);
    }

}