package charite.christo.protein;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import charite.christo.interfaces.*;
import charite.christo.*;

/**
   @author Christoph Gille
*/
public interface SimilarPdbFinder {
    Result[] NOT_FOUND={};
    Result[] getSimilarStructures();
    Class CLASSES[]={};

    void setProtein(Protein p);
    public static class Result implements HasRendererComponent{
        public Object protein;
        public SimilarPdbFinder simPdbFinder;
        public String id;
        public int fromTo[], ident[];
        public Result(Protein p, SimilarPdbFinder simPdbFinder, String pdbID, int fromTo[], int[] ident) {
            protein=weakRef(p);
            this.simPdbFinder=simPdbFinder;
            id=pdbID;
            this.fromTo=fromTo;
            this.ident=ident;

        }
        //public int[] getFromTo() {return fromTo;}
        //public int[] getIdent() { return ident;}
        public Protein getProtein() { return deref(protein,Protein.class);}
        public String getPdbID() { return id;}
        private javax.swing.JComponent rComp;
        public javax.swing.JComponent getRendererComponent() {
            if (rComp==null) {
                final Protein p=getProtein();
                final int n=p==null?0:p.countResidues();
                final ChLabel labRange=new ChLabel();
                if (n>0) {
                    labRange.setDrawFromTo(fromTo[0]*100/n, fromTo[1]*100/n);
                }
                //final String tip="range="+from+"-"+to+"   #aminos="+n;
                final ByteArray sScore=new ByteArray(33).append(" ident=").append(ident[0]).append('/').append(ident[1]).append(' ');
                rComp=newCNSEW(labRange,dim(99,ICON_HEIGHT),null,monospc(sScore), monospc(" "+delPfx("PDB:",getPdbID())+" "));
            }
            return rComp;
        }
    }

}

/*
support@ebi.ac.uk
   This sounds very similar to the pseudo-HSP mechanism used in FASTA 36. Which
   should be available as part of our SSS services
   (http://www.ebi.ac.uk/Tools/sss/) in the near future.


http://webclu.bio.wzw.tum.de/portal/web/simap/

*/