package charite.christo.strap;
import charite.christo.strap.interfaces.*;
import charite.christo.*;
import charite.christo.protein.*;
import charite.christo.interfaces.*;
import java.awt.*;
import static charite.christo.ChUtils.*;
public abstract class AbstractAlignerProxy extends AbstractProxy {
    /* ---------------------------------------- */
    /* >>> SequenceAligner >>> */
    private long options;
    public void setOptions(long flags) {
        this.options=flags;
        if (po!=null) {
            SequenceAligner sa=psa(); if (sa!=null) sa.setOptions(flags);
            Superimpose3D su=su();    if (su!=null) su.setOptions(flags);
        }
    }
    public long getOptions() { SequenceAligner psa=psa(); return psa!=null ? psa.getOptions() : this.options;  }

    private Object po;
    private final Object po() {
        if (this.po==null) {
            po=proxyObject();
            if (options!=0) {
                if (po instanceof SequenceAligner) ((SequenceAligner)po).setOptions(options);
                if (po instanceof Superimpose3D) ((Superimpose3D)po).setOptions(options);
            }
        }
        return po;
    }

    private final SequenceAligner psa() { return deref(po(), SequenceAligner.class); }
    private Superimpose3D su() {return deref(po(), Superimpose3D.class); }

    public void setSequences(byte[]... ss){
        final SequenceAligner psa=psa();
        if (psa!=null) psa.setSequences(ss);
    }

    public byte[][] getAlignedSequences(){ SequenceAligner psa=psa(); return psa!=null ? psa.getAlignedSequences() : null;}
    public byte[][] getSequences() { SequenceAligner psa=psa(); return psa!=null ? psa.getSequences() : null;  }

    /* <<< SequenceAligner <<< */
    /* ---------------------------------------- */
    /* >>> Superimpose3D >>> */

    public void setMobileProtein(Protein p) {
        Superimpose3D su=su();
        if (su!=null) su.setMobileProtein(p); }
    public void setReferenceProtein(Protein p) {
        Superimpose3D su=su();
        if (su!=null) su.setReferenceProtein(p);}
    public Protein getReferenceProtein() {
        Superimpose3D su=su();
        return su!=null ? su.getReferenceProtein() : null;
    }
    public Protein getMobileProtein() {
        Superimpose3D su=su();
        return su!=null ?  su.getMobileProtein() : null;
    }
    public void compute() {
        final Object o=proxyObject();
        if (o instanceof Superimpose3D) {
            ((Superimpose3D)o).compute();
        } else if (o instanceof SequenceAligner) ((SequenceAligner)o).compute();
    }
    public final void setProteins(StrapProtein... pp) { setMobileProtein(pp[0]); setReferenceProtein(pp[1]); }
    public Superimpose3D.Result getResult() { Superimpose3D su=su(); return su!=null ? su.getResult() : null;}

}
