package charite.christo.strap;
import charite.christo.*;
import charite.christo.strap.interfaces.*;
import charite.christo.interfaces.*;
import charite.christo.protein.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**
   @author Christoph Gille
*/
public abstract class AbstractSuperpositionDebug {

    public static void checkCache_ClassSectionKey(Class c, String section, String key, byte[] ss[]) {
        if (sze(ss)!=2) return;
        //CacheResult.saveAndClear();
        boolean error=false;
        final ByteArray output=CacheResult.getValue(c, section, key, (ByteArray)null);
        if (output==null) { error=true; putln(ANSI_MAGENTA+"AbstractSuperpositionDebug output is null"); }
        else {
            final Superimpose3D.Result result=AbstractSuperposition.parse(ss.length, output, null, Superimpose3D.PARSE_ALIGNMENT);
            errorInPairalignment(result,ss, "checkResultClassSectionKey");
        }
        if (error) {
            putln(ANSI_YELLOW+"checkResultClassSectionKey ",section, "  ",key);
            putln(ss[0],"\n",ss[1],"\n"+ANSI_RESET);
        }
    }

    static boolean errorInPairalignment(Superimpose3D.Result r, Protein pp[], String msg) {
        if (sze(pp)!=2 || r==null)return false;
        final byte[] s0=pp[0].getResidueTypeExactLength(), s1=pp[1].getResidueTypeExactLength();
        if ( errorInPairalignment(r, Protein.getResidueType(pp),msg)) {
            putln("Proteins=",pp);
            return true;
        }
        return false;
    }
    static boolean errorInPairalignment(Superimpose3D.Result r, byte[] ss[], String msg) {
        if (sze(ss)!=2 || r==null)return false;
        final byte[][] ali=r.getGappedSequences();
        boolean error=false;
        if (sze(ali)<2) error=true;
        else {
            final byte[] a0=onlyLetters(ali[0]),a1=onlyLetters(ali[1]);

            if (strstr(STRSTR_IC,a0,ss[0])<0 || strstr(STRSTR_IC,a1,ss[1])<0) {
                putln(RED_ERROR+" AbstractSuperpositionDebug   "+msg);
                putln(" errorInResult s0=",ss[0],"\n\n AbstractSuperposition s1=",ss[1],"\n");
                putln(r.toText(null,0L));
                error=true;
            }

        }
        return error;
    }
}