package charite.christo.strap;
import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.protein.*;
import java.awt.*;
import javax.swing.*;
import static java.awt.event.MouseEvent.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
public final class DialogAlignResult extends ChPanel implements Runnable, Disposable, PaintHook, ChProcessEvent {
    public final static String BUT_LAB_Apply="Approve alignment";
    final static long USE_THREADS=1<<1;
    private final ChEventAdapter LI=new ChEventAdapter(this);
    private final DrawGappedSequence dgs=new DrawGappedSequence();
    private final JComponent
        togSort=toggl("Apply order of aligned proteins").li(LI),
        butApply=new ChButton(BUT_LAB_Apply).li(LI),
        butUndo=new ChButton("Undo",ChButton.DISABLED|ChButton.HIDE_IF_DISABLED).t("Undo").li(LI),
        rowHeader=pnl(C(DEFAULT_BACKGROUND), KOPT_TRACKS_VIEWPORT_WIDTH),
        panAlignment=pnl(C(DEFAULT_BACKGROUND));
    private final Thread thread=new Thread(this);
    private final SequenceAligner aligner;
    private final ChTableLayout tLayout;
    private static SequenceAligner lastRunningAligner;
    private Protein proteins[];
    private int iiSorting[];
    private final JComponent butDetails;
    private byte[][] aligned;
    private float rh_adjust;
    /* ---------------------------------------- */
    /* >>> Constructor >>> */
    DialogAlignResult(SequenceAligner aligner,Protein pp[], long options) {
        this.aligner=aligner;
        this.proteins=pp;
        LI.addTo("mw",panAlignment);
        LI.addTo("w",rowHeader);
        scrollByWheel(panAlignment);
        butDetails=ChButton.actionCtrl(aligner);
        final JScrollPane scrollPane=scrllpn(0L,panAlignment);
        panAlignment.setPreferredSize(dim(EM*100,EX*100));
        tLayout=new ChTableLayout(ChJTable.NO_REORDER);
        final JScrollPane spHeader=scrllpn(0L,rowHeader);
        tLayout.addColumn(spHeader);
        tLayout.addColumn(scrollPane);
        scrollPane.setVerticalScrollBar(spHeader.getVerticalScrollBar());
        thread.setPriority(Thread.MIN_PRIORITY);
        if ( (options&USE_THREADS)!=0) thread.start(); else thread.run();
        final JComponent
          pButtons=pnl(butApply, butUndo, " ", isAssignblFrm(SequenceAlignerSorting.class,aligner) ? ((ChButton)togSort).cb() : null, butDetails);
        // bClose=javaVsn()<16 ? new ChButton().actionClose(this, DISPOSE_RM_CHILDS) : null;
        cnsew(this, tLayout,null,pButtons,null,null);
        tLayout.setColWidth(true,0, 10*EM);

        setDragScrolls(scrollPane.getViewport(),scrollPane);
        setDragScrolls(panAlignment,scrollPane);
        for(JComponent c:new JComponent[]{tLayout,panAlignment,scrollPane}) disposeOnCtrlW(0L, c,this);
        setPrefSize();
        addActLi(LI,aligner);
        addPaintHook(this,rowHeader);
        addPaintHook(this,panAlignment);

    }
    /* <<< Constructor <<< */
    /* ---------------------------------------- */
    /* >>> PaintHook >>> */
    private final static int lineSkip=5;
    private final static Point origin=new Point();
    private int localAliStartsAt[],  maxCol;
    private short frequenciesOfAA[][];
    public boolean paintHook(JComponent toBePainted,Graphics g, boolean after) {
        final Protein[] pp=this.proteins;
        if (pp==null) return true;
        final int W=toBePainted.getWidth(), H=toBePainted.getHeight();
        final boolean isSorting=isSelctd(togSort) && sze(iiSorting)>=pp.length;
        final Font font=font();
        g.setFont(font);
        final Rectangle cb=charBounds(font), clip=g.getClipBounds();
        final int lineH=cb.height+lineSkip;
        if (!after) return true;
        if (toBePainted==rowHeader || toBePainted==panAlignment) {
            g.setColor(C(0));
            final int y=pp.length*lineH;
            fillBigRect(g, 0,0,W, y);
            g.setColor(C(DEFAULT_BACKGROUND));
            if (H>y) fillBigRect(g, 0,y,W, H-y);
        }

        if (toBePainted==rowHeader && after) {
            for(int i=0;i<pp.length;i++) {
                final int y=lineH*i;
                if (clip!=null && (clip.y>y+lineH | clip.y+clip.height<y)) continue;
                final int idx=mini(pp.length-1,maxi(0,isSorting ?  iiSorting[i] :i));
                final Protein p=pp[idx];
                if (p==null) continue;
                final Image im=p.getIconImage();
                final int imW0=im==null?0: im.getWidth(toBePainted),
                    imH=im==null?0:im.getHeight(toBePainted),
                    imW=imW0*imH==0?0:imW0*cb.height/imH,
                    labelW=imW+strgWidth(font,p.getName()),
                    x=(int) ((W-labelW)*rh_adjust);
                if (im!=null) g.drawImage(im,x,y,imW,cb.height,toBePainted);
                g.setColor(C(0xffFFff));
                g.drawString(p.getName(),x+imW,y+cb.y);
            }
        }
        if (toBePainted==panAlignment) {
            if (!isReady) paintProgress(g);
            else {
                final byte[] aligned[]=this.aligned;
                final int alignedL=sze(aligned);
                if (alignedL!=pp.length)  { g.drawString("error   ",0,cb.y);return true;}
                if (frequenciesOfAA==null) {
                    frequenciesOfAA=new short[maxCol]['z'-'a'+1];
                    for(byte[] s : aligned) {
                        for(int iCol=mini(frequenciesOfAA.length, sze(s)); --iCol>=0;) {
                            final int c=(s[iCol]|32)-'a';
                            if (0<=c && c<='z'-'a')
                                frequenciesOfAA[iCol][c]++;
                        }
                    }
                }
                final boolean isShadeSecStru=StrapAlign.isShadingSecStru();
                final int[] startsAt=this.localAliStartsAt;
                final Color shadingColors[]=StrapAlign.getShadingColors();
                for(int i=0;i<pp.length;i++) {
                    final int iP=isSorting && iiSorting!=null && iiSorting.length>=pp.length ?  iiSorting[i] : i;
                    final Protein p=pp[iP];
                    final int y=lineH*i;
                    final byte[] s=(aligned!=null && alignedL>iP && aligned[iP]!=null) ? aligned[iP] : "error".getBytes();
                    origin.x=0;
                    origin.y=y;
                    dgs.setConservation(frequenciesOfAA,StrapView.sliderSimilarity().getValue()*pp.length/100);
                    final int firstAmino=startsAt!=null ? startsAt[i] : 0;
                    final long options=isShadeSecStru && firstAmino>=0 ? DrawGappedSequence.SHADE_SEC_STRU : 0L;
                    dgs.draw(panAlignment,g,origin, maxi(0,firstAmino) ,s,0,MAX_INT,(StrapProtein)p,shadingColors, options);
                    dgs.setConservation(null,0);
                }
                final int y=pp.length*lineH+cb.y;
                g.setColor(C(0));
                g.drawString("Info: This is the alignment result preview",0,y);
                g.drawString("You need to press the button \""+BUT_LAB_Apply.replaceAll("<[^>]*>","")+"\"" ,0,y+lineH);
            }
        }
        return true;
    }
    /* <<< Paint  <<< */
    /* ---------------------------------------- */
    /* >>> PreferredSize >>> */
    public Thread thread_setPrefSize() { return threadM("setPrefSize",this,new Object[0]);}

    private int fontSize=12, lastFontSiz;
    private Font font;

    private Font font() {
        if (font==null || lastFontSiz!=fontSize) {
            font=getFnt(lastFontSiz=fontSize, true, Font.PLAIN);
        }
        return font;
    }

    public void setPrefSize() {
        final Protein[] pp=this.proteins;
        final Font font=font();
        final Rectangle cb=charBounds(font);
        final int N=sze(pp), h=(cb.height+lineSkip)*(2+N);
        final byte ali[][]=this.aligned;
        final HasScore hs=deref(aligner,HasScore.class);

        tLayout.setTitle(0, ali!=null && hs!=null ? "Score="+hs.getScore() : "Protein names");
        final Object clazz=aligner instanceof MultiFromPairAligner ? ((MultiFromPairAligner)aligner).getClasses()[0]:aligner;
        tLayout.setTitle(1,"preview of "+delSfx("PROXY",shrtClasNam(clazz)));
        setEnabld(ali!=null, new Object[]{togSort,butApply});
        if (ali!=null) {
            for(byte[] s : ali) if (maxCol<sze(s)) maxCol=s.length;
            final int startsAt[]=new int[N];
            for(int i=mini(sze(aligned), N); --i>=0;) {
                startsAt[i]=idxOfLetters(aligned[i], pp[i].getResidueTypeExactLength(),0,pp[i].countResidues());
            }
            this.localAliStartsAt=startsAt;
        } else maxCol=80;
        panAlignment.setPreferredSize(dim( (1+maxCol)*cb.width , h));
        tLayout.setPreferredSize(dim(EM,h+EX));

        int w=0;
        for(int i=0; i<N;i++) w=maxi(w, cb.height*2+strgWidth(font,pp[i].getName()));
        rowHeader.setPreferredSize(dim(w,h));
        panAlignment.revalidate();
        rowHeader.revalidate();
    }
    /* <<< PreferredSize <<< */
    /* ---------------------------------------- */
    /* >>> Disposable >>> */
    public void dispose() { // war InvokeAndWait warum ?
        try { thread.stop();}catch(Exception e){}
        dispos(0L,aligner);
        dispos(0L,lastRunningAligner);
        rmAllChilds(this);
        rmFromParent(this);
        proteins=null;
    }
    /* <<< Disposable <<< */
    /* ---------------------------------------- */
    /* >>> Threading >>> */
    private boolean isReady;
    public void run() {
        (lastRunningAligner=aligner).compute();

        //if (this.butDetails!=null) butDetails.revalidate();
        final SequenceAlignerSorting sorting=deref(aligner,SequenceAlignerSorting.class);
        if (sorting!=null) this.iiSorting=sorting.getIndicesOfSequences();
        this.isReady=true;
        this.aligned=ChAlignUtils.trimAlignment(2,aligner.getAlignedSequences());
        inEDT(thread_setPrefSize());
    }

    private String progress;
    private void paintProgress(Graphics gr) {
        final String progr=this.progress;
        if (progr==null) return;
            try {
                final Graphics g=gr!=null ? gr : panAlignment.getGraphics();
                g.setColor(C(0));
                fillBigRect(g,0,0,EM*100,2*EX);
                g.setColor(C(0x00FF00));
                g.drawString(progr,10,EX);
            } catch(Exception ex){}

    }
    /* <<< Threading  <<< */
    /* ---------------------------------------- */
    /* >>> AWTEvent >>> */

    private static boolean msgShownPreview;
    public AWTEvent processEvent(JComponent component, AWTEvent ev) {
        final int id=ev.getID();
        final int scaleUpDown=scaleUpDown(ev);
        final Object q=ev.getSource();
        final String cmd=actionCommand(ev);
        final StrapAlign align=StrapAlign.getInstance();
        final int wheel=wheelRotation(ev);
        if (scaleUpDown!=0) {

            if ((fontSize+=(scaleUpDown>0?1:-1))<4) fontSize=4;
            setPrefSize();
            repaint();
        }
        if (wheel!=0 && !isCtrl(ev) && q==rowHeader) {
            final float f=rh_adjust+wheel*.1f;
            this.rh_adjust=f<0?0:f>1?1:f;
            rowHeader.repaint();
        }
        if (id==MOUSE_CLICKED && q==panAlignment && !msgShownPreview) {
            msgShownPreview=true;
            error(
                  "This alignment preview is not editable.<br>"+
                  "You can only edit the working alignment in the alignment panel below.<br>"+
                  "If you do not see this panel you may need to drag the divider bar up.<br><br>"+
                  "By pressing the button <I>"+BUT_LAB_Apply+"</I><br>"+
                  "The alignment from the preview is infered to  the working  alignment panel."
                  );
        }
        if (cmd!=null && cmd.startsWith(KEY_PROGRESS)) {
                this.progress=delPfx(KEY_PROGRESS,cmd);
                paintProgress(null);
        }
        if (q==togSort) repaint();
        if (q==butApply || q==butUndo) {
            final StrapProtein pp[]=StrapUtils.spp(this.proteins);
            if (pp!=null) {
                final StrapView panel=align.getAlignmentPanelWithFocus();
                final StrapProtein ppVis[]=panel!=null ? panel.getProteins() : null;
                for(StrapProtein p : ppVis!=null ? ppVis : pp) {
                    final int gg[]=gcp(butApply, p, int[].class);
                    if (q==butApply && gg==null) pcp(butApply, p.getResidueGap().clone(),p);
                    if (q==butUndo  && gg!=null) p.setResidueGap(gg.clone());
                }
                if (q==butApply) {
                    final byte[] aligned[]=this.aligned;
                    if (panel==null || sze(aligned)<pp.length || pp.length<2) return null;

                    int midColumn=0;
                    final int lastIdx[]=new int[pp.length];
                    for(int r=pp.length; --r>=0;) {
                        final int col=idxOfLetters(aligned[r],pp[r].getGappedSequenceExactLength());
                        final int nL=countLetters(aligned[r]);
                        lastIdx[r]=pp[r].column2nextIndex(col)+nL;
                        midColumn+=col+nL/2;
                    }
                    midColumn/=pp.length;

                    final AcceptAlignment2 accept=new AcceptAlignment2(pp,aligned);
                    final int[] inserts=accept.getCountInserts();
                    putln("getCountInserts ", inserts);
                    putln("getLastChangedA ", lastIdx);
                    putln("midColumn "+midColumn);

                    final int MAX_SQUEEZE=5;
                    boolean canCompensate=true;
                    for(int r=pp.length; --r>=0;) {

                        final int a0=lastIdx[r]+1, nR=pp[r].countResidues();
                        if (a0+MAX_SQUEEZE>=nR) continue;
                        int bias=inserts[r];
                        for(int a=a0; bias>0 && a<nR && a<a0+MAX_SQUEEZE; a++)  bias-=pp[r].getResidueGap(a);
                        if (bias>0) { canCompensate=false; break; }
                    }
                    final int addToBias= canCompensate ? 0 : -maxi(inserts);
                    putln(ANSI_GREEN+"canCompensate="+canCompensate+"addToBias="+addToBias+ANSI_RESET);
                    for(int r=pp.length; --r>=0;) {
                        final int a0=lastIdx[r]+1, nR=pp[r].countResidues();
                        int bias=inserts[r]+addToBias;
                        for(int a=a0; bias!=0 && a<nR; a++) {
                            bias+=pp[r].addResidueGap(a,-bias);
                            putln(pp[r]+" addResidueGap "+a+" "+ (-bias));
                        }
                    }

                    if (addToBias!=0 && ppVis!=null) {
                        for(StrapProtein p : ppVis) {
                            if (cntains(p,pp)) continue;
                            putln("addToBias "+addToBias+"  "+p+"  column2nextIndex "+p.column2nextIndex(midColumn));
                            p.addResidueGap(p.column2nextIndex(midColumn), -addToBias);
                        }

                    }
                    new StrapEvent(this,StrapEvent.ALIGNMENT_CHANGED).run();

                    if (isSelctd(togSort) && sze(iiSorting)==pp.length) {
                        for(int i=iiSorting.length; --i>=0;) ((StrapProtein)pp[i]).setPreferedOrder(iiSorting[i]);
                        align.inferOrderOfProteins(pp,StrapAlign.SORT_PREFORDER);
                    }
                    for(Protein p:pp) pcp("ALIGNED_BY_METHOD",aligner.getClass(),p);
                }

                setEnabld(q==butApply, butUndo);

                StrapAlign.dispatchLater(StrapEvent.ALIGNMENT_CHANGED,1);
            }
        }
        return ev;
    }
}
