package charite.christo.strap;
import static charite.christo.ChUtils.*;
import charite.christo.*;
import charite.christo.protein.*;
import javax.swing.JComponent;
import javax.swing.JTextField;
/**HELP
Residue annotations of one protein can be
copied to the equivalent positions in another.
<br>
<i>SEE_CLASS:ResidueAnnotation</i>
@author Christoph Gille
*/
public class DialogCopyAnnotations extends AbstractDialogJPanel implements java.awt.event.ActionListener {
    private final ProteinCombo comboProt=new ProteinCombo(align,0);
    private final JTextField tfGroup=new ChTextField("copied from protein <br>PROTEIN");
    public void actionPerformed(java.awt.event.ActionEvent ev) {
        StrapAlign.errorMsg("");
        final String cmd=ev.getActionCommand();
        if (cmd=="GO") {
            final StringBuffer sbError=new StringBuffer();
            ResSelUtils.copyResidueSelections(align.SELECTED_OBJECTS.residueSelections('A'),new StrapProtein[]{comboProt.getProtein()},toStrg(tfGroup), sbError, ResSelUtils.COPY_ADD_TO_PROTEIN|ResSelUtils.COPY_REPORT);
            if (sze(sbError)>0) error(sbError);

            StrapAlign.dispatchLater(StrapEvent.RESIDUE_SELECTION_CHANGED,111);
        }
    }
    public DialogCopyAnnotations() {
        JComponent b=vBhB(
                          pTop(),
                          "<b>Annotations to be copied:</b> "+
                          "Select the residue annotations that should be copied by<br>"+
                          "Ctrl left-Click or opening a box with the mosud selects annotations in the align panel.<br>",
                          hBL("The selecte residue annotations will have ","WIKI:marching_ants"),
                          " ",
                          hBL("Target protein",comboProt),
                          " ",
                          hBL("Name of group for generated annotations: ", tfGroup),
                          "<sup>(\"PROTEIN\" will be replaced by the source protein)</sup>",
                          " ",
                          hBL("#",new ChButton("GO").li(this).t(ChButton.GO))
                          );
        add(b);
    }
}
