package charite.christo.strap;
import charite.christo.interfaces.*;
import charite.christo.*;
import java.awt.*;
import java.awt.event.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**HELP

For manipulating several proteins
simultaneously, more than one protein may be stacked in one single
line by pressing either button:
<ul>
<li> <i>JCOMPONENT:DialogManyInOneRow#getButton("A")!</i> or<br> </li>
<li> <i>JCOMPONENT:DialogManyInOneRow#getButton("X")!</i> </li>
</ul>

Only one representative is shown and the others are hidden.

<br><br>

<b>Simultaneous manipulation of many sequences:</b>

When gaps are inserted or deleted or when proteins are aligned automatically, this will be applied to all
proteins that are stacked on the alignment row.

<br><br>

<b>Separatating the stacked proteins:</b>
Select the and subsequently press one of the two buttons.

 @author Christoph Gille
*/
public class DialogManyInOneRow  implements ActionListener {
    private static DialogManyInOneRow li;
    public static ChButton getButton(String id) {
        final boolean cAlpha="A".equals(id);
        if (li==null) li=new DialogManyInOneRow();
        final String T="Stack selected proteins";
        return new ChButton(cAlpha?"A":"X").t(cAlpha?T+". Take one with 3D-coordinates as representative.":T).li(li);
    }

    public void actionPerformed(ActionEvent ev) {
        StrapAlign.errorMsg("");
        putln(ev);
        final StrapAlign align=StrapAlign.getInstance();
        final boolean takeOneWithCalpha= ev.getActionCommand()=="A";
        final StrapView ap=align.getAlignmentPanelWithFocus();
        final StrapProtein pp[]=align.getSelectedProteins();

        StrapProtein pVisible=null;
        if (ChMsg.noProteinsSelected(pp)) return;
        if (!takeOneWithCalpha) pVisible=pp[0];
        else {
            for(StrapProtein p: pp) if (p.hasCalpha()) pVisible=p;
            if (pVisible==null) {
                StrapAlign.errorMsg("No protein with C-alpha coordinate among the selected proteins");
                return;
            }
        }
        putln("pVisible="+pVisible);
        if (pVisible!=null && ap!=null) ap.oneLineManyProteins(pVisible,pp);
        align.getTree().clearSelection();
    }
}
