package charite.christo.strap;
import charite.christo.interfaces.*;
import charite.christo.*;
import charite.christo.protein.*;
import charite.christo.strap.interfaces.*;
import java.awt.*;
import java.awt.event.*;

import java.util.*;
import javax.swing.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**HELP

   This dialog is used to draw phylogenetic dendrograms of aligned
   protein sequences.

   @author Christoph Gille
*/
public class DialogPhylogeneticTree extends AbstractDialogJPanel implements ChRunnable,ActionListener {
    private final ChCombo comboClass=StrapAlign.classChoice(PhylogeneticTree.class);


    public void actionPerformed(ActionEvent ev) {
        final String cmd=ev.getActionCommand();
        if ( cmd=="GO"){
            setNextProcessHasLogPanel(isCtrl(ev));
            final StrapProtein pp[]=StrapView.getProteinsInRectangleForAlignment(3);
            if (pp.length<3) StrapAlign.errorMsg("For phylogenetic trees at least 3 proteins are required");
            else {
                StrapAlign.errorMsg("");
                final Rectangle r=StrapView.getRectangle(null);
                final byte[][] gapped=StrapAlign.getGappedSequences(pp, r!=null?r.x:0, r!=null?r.x+r.width:MAX_INT,'-');
                final String[] names=new String[pp.length];
                final ImageIcon[] icons=new ImageIcon[pp.length];
                for(int i=pp.length; --i>=0;) {
                    names[i]=pp[i].getName();
                    icons[i]=pp[i].getIcon();
                }
                ChDelay.newThread(this,"GO",new Object[]{gapped, names, icons}).start();
            }
        }
    }
    public DialogPhylogeneticTree() {
        JComponent
            pWest=vBhB(
             " ",
             "The proteins must be correctly aligned.",
             "Select some aligned proteins or select a rectangular alignment region with the mouse.",
             " ",
             comboClass.panel(),
             StrapView.newLabelRectRegion(),
             pnl(new ChButton("GO").t(ChButton.GO).li(this))
             );
        add(pWest);
    }
    public Object run(String id, Object arg) {
        final Object[] argv=(Object[])arg;
        final byte[][] gapped=(byte[][])argv[0];
        final String[] names=(String[])argv[1];
        final ImageIcon[] icons=(ImageIcon[])argv[2];

        final PhylogeneticTree phy= HotswapUtil.instance(comboClass,PhylogeneticTree.class,true);
        if (phy==null) StrapAlign.errorMsg("Unable to instantiate "+comboClass);
        else {
        phy.setNamesIconsAndGappedSequences(names,icons,gapped);
        phy.drawTree();
        }
        return null;
    }
}
/*
  http://mesquiteproject.org/mesquite/mesquite.html
*/
