package charite.christo.strap;
import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.protein.ResidueSelection;
import java.awt.*;

import javax.swing.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**HELP

Residues selections are computed by a method chosen by the user.
The selected residues will be shown in the alignment pane,  the
horizontal scroll-bar and all 3d-backbones.

   @author Christoph Gille
*/
public class DialogSelectionOfResiduesMain extends AbstractDialogJTabbedPane implements java.awt.event.ActionListener {
    private final ChCombo comboClass;
    public void actionPerformed(java.awt.event.ActionEvent ev) {
        final String cmd=ev.getActionCommand();
        if (cmd=="GO") {
            final ResidueSelection c=comboClass.instanceOfSelectedClass(ResidueSelection.class);
            if (c!=null) adTabTITI(new DialogSelectionOfResidues(c,comboClass.getSelectedItem()), c.getClass(), this);
        }
    }
    public DialogSelectionOfResiduesMain() {
        comboClass=StrapAlign.classChoice(ResidueSelection.class);

        final JComponent
            pCenter=vBpnl(KOPT_TRACKS_VIEWPORT_WIDTH,
             StrapAlign.headLine(this),
             comboClass.panel(),
             new ChButton("GO").li(this).t(ChButton.GO)
             );
        adMainTab(scrllpn(0L,pCenter), this, null);
        pcp(KEY_CHOICE_CLASS,comboClass,this);
    }
}
