package charite.christo.strap;
import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.protein.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
class DialogSuperimpose3DResult extends JPanel implements Disposable,StrapListener,Runnable,ActionListener,PaintHook  {
    /* pR upon pM */
    private String msg=" still calculating ...";
    private final Superimpose3D superimpose3d;
    private final ChTextArea taResult=new ChTextArea(msg);
    private final Protein proteins[]={null,null};
    private final JComponent pSouth, butDetails;
    private final DialogSuperimpose3D dialog;
    private final Protein3d p3D;
    private Matrix3D transformation;
    private final ChButton
        butApply=new ChButton(DialogSuperimpose3D.BUT_LAB_Apply,ChButton.DISABLED).li(this).tt("<ul><li>Accept the transformation as shown in the preview.</li><li>CTRL: accept all</li>"),
        butUndo=new ChButton("Undo",ChButton.DISABLED).li(this),
        butDist=new ChButton("Distance in alignment...").li(this);
    DialogSuperimpose3DResult(Superimpose3D s3d, DialogSuperimpose3D dialog) {
        this.superimpose3d=s3d;
        this.dialog=dialog;
        StrapAlign.getInstance().addListener(this);
        for(int i=2; --i>=0;) {
            Protein p= i==0 ? s3d.getReferenceProtein() : s3d.getMobileProtein();
            Protein p0=gcp(KEY_CLONED_FROM,p,Protein.class);
            this.proteins[i]= p0!=null ? p0 : p;
        }
        p3D=StrapAlign.newBackbone3D_View(proteins, V3dUtils.OPEN_NOT_ADD_PANEL);
        addPaintHook(this,p3D);
        pSouth=hB(smallHelpBut(new Object[]{s3d,DialogSuperimpose3D.class}),"#",
                  butApply," ",butUndo,"#","More info ",toggl().actionCollapse(false,taResult)," ",butDist,
                  butDetails=ChButton.actionCtrl(s3d));
        cnsew(this,p3D,taResult,pSouth,null,null);
    }

    public Superimpose3D.Result getResult() {
        final Superimpose3D s3d=this.superimpose3d;
        return s3d==null?null:s3d.getResult();
    }
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> Disposable >>> */
    public void dispose() {
        StrapAlign.getInstance().removeListener(this);
        StrapAlign.dispatchLater(StrapEvent.RESIDUE_SELECTION_CHANGED,111);
        dialog.remove(this);
        try { ((Disposable)superimpose3d).dispose();}catch(Throwable e){}
    }
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>>  AWTEvent >>> */
    public void handleEvent(StrapEvent ev) {
        final int t=ev.getType();
        if (p3D!=null) {
            if (t==StrapEvent.RESIDUE_SELECTION_CHANGED || t==StrapEvent.RESIDUE_SELECTION_CHANGED_COLOR) p3D.repaint();
            if (t==StrapEvent.PROTEIN_VIEWER_CLOSED && ev.getSource()==p3D) {
                dispose();
                StrapAlign.addDialog(DialogSuperimpose3D.class,false);
            }
        }
    }
    public void actionPerformed(ActionEvent ev) {
        final Protein pp[]=this.proteins;
        final Object q=ev.getSource();
        if (q==butApply || q==butUndo) {
            if (q==butApply) {
                if (isCtrl(ev) && ChMsg.yesNo("Really accept results in all result tabs?")) {
                    for(int i=dialog.getTabCount();--i>=1;)
                        try {
                            ((DialogSuperimpose3DResult)dialog.getComponentAt(i)).apply();
                        } catch(Exception e) {}
                }
                apply();
            }
            if (q==butUndo) {
                pp[1].setRotationAndTranslation(gcp(butApply, pp[1],Matrix3D.class));
                new StrapEvent(dialog,StrapEvent.PROTEIN_3D_MOVED).setParameter(pp[1]).run();
            }
            setEnabld(q==butApply, butUndo);
            StrapAlign.drawMessage("@1 3D Coordinates of "+ANSI_GREEN+pp[1]+(q==butApply?" changed ":" reset ")+" coordinates");
        }
        if (q==butDist && pp[1]!=null) {
            if (ChMsg.yesNo(
                            "<b>3D-distance of C-alpha atoms in the alignment: </b><br><br>"+
                            "All residues within a certain range around the cursor position are highlighted.<br><br>"+
                            "This is applicable when the homologous proteins are superimposed<br>"+
                            "by pressing the button \""+DialogSuperimpose3D.BUT_LAB_Apply+"\".<br>With the ctrl-key pressed, all previews are accepted with one singel click.<br>")) {
                if (pp[1].getRotationAndTranslation()!=null
                    || ChMsg.yesNo("You have not yet approved the superposition shown in the preview by<br>"+
                                   "pressing \""+DialogSuperimpose3D.BUT_LAB_Apply+"\".<br><br>Proceed anyway?")) {
                    StrapAlign.addDialogSetClass(CLASS_DialogSelectionOfResiduesMain, Distance3DToCursor.class);
                }
            }
        }
    }
    private void apply(){
        final Protein pp[]=this.proteins;
        if (gcp(butApply,pp[1])==null) {
            final Matrix3D m3d=pp[1].getRotationAndTranslation();
            if (m3d!=null) pcp(butApply, new Matrix3D(m3d),pp[1]);
        }
        Matrix3D m=new Matrix3D().mult(transformation);
        final Protein pR=this.superimpose3d.getReferenceProtein();
        if (pR==null) stckTrc();
        else m.mult(pR.getRotationAndTranslation());
        pp[1].setRotationAndTranslation(m);
        new StrapEvent(dialog,StrapEvent.PROTEIN_3D_MOVED).setParameter(pp[1]).run();
    }
    /* <<< AWTEvent <<< */
    /* ---------------------------------------- */
    /* >>> Graphics >>> */
    public boolean paintHook(JComponent c, Graphics g, boolean after) {
        if (after && gcp("COMPUTING",this)!=null) {
            g.setColor(Color.PINK);
            g.setFont(getFnt(ICON_HEIGHT,true,Font.BOLD));
            g.drawString(msg,ICON_HEIGHT,3*ICON_HEIGHT);
        }
        return true;
    }
    /* <<< Graphics <<< */
    /* ---------------------------------------- */
    /* >>> Computation  >>> */
    private boolean superimpose() {
        if (p3D!=null) p3D.eachProteinInDifferentColor(false,false);
        superimpose3d.compute();
        if (this.butDetails!=null) butDetails.revalidate();
        final Superimpose3D.Result result=superimpose3d.getResult();
        if (result!=null) {
            this.transformation=result.getMatrix();
            result.getScore();
        }
        return result!=null;
    }

    /* <<< Computation <<< */
    /* ---------------------------------------- */
    /* >>> Thread  >>> */
    public void run(){
        final Protein pp[]=this.proteins;
        try {
            final Superimpose3D s3d=this.superimpose3d;
            pcp("COMPUTING","",this);
            if (!superimpose()) {
                msg="calculation terminated with an error! ";
                taResult.t(msg); return;
            }
            final Superimpose3D.Result result=s3d.getResult();
            final ByteArray sb=new ByteArray(999).append("Superimposed ").append(pp[1]).append(" upon ").append(pp[0]);
            sb.append("\nMethod: ").append(shrtClasNam(s3d)).append('\n');
            for(int i=0;i<2; i++) {
                final int n= gcp(KEY_CLONED_FROM, proteins[i])==null ? 0 : countTrue(proteins[i].getResidueSubsetB());
                if (n>0) sb.append(pp[i]).append(": ").append(n).append(" c-Alpha-Atoms selected for superposition\n");
            }
            if (result!=null) result.toText(sb.append('\n'), Superimpose3D.PRINT_HUMAN_READABLE);
            taResult.t(sb);
            setEnabld(true, butApply);
            final Protein3d.PView p3DM= p3D.getView(pp[1]);
            if (p3D!=null) {
                p3DM.transformPreview(transformation);
                ChDelay.repaint(p3D,333);
            }
        }
        finally{
            pcp("COMPUTING",null,this);
            if (pSouth!=null) pSouth.revalidate();
            if (p3D!=null) p3D.repaint();
        }
    }
}
