package charite.christo.strap;
import charite.christo.*;
import charite.christo.protein.*;
import java.util.*;
import javax.swing.JPopupMenu;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**
   @author Christoph Gille
*/
public class HeteroPopup implements java.awt.event.ActionListener, charite.christo.interfaces.IsEnabled  {
    public final static String TITLE=" Nucleotide and Hetero 3D-Structure";
    private HeteroCompound[] hh;
    private final ContextObjects objects;
    private JPopupMenu popup;
    private final javax.swing.JLabel LAB_TITLE=new javax.swing.JLabel();
    public HeteroPopup(ContextObjects o) { this.objects=o;}
    public boolean isEnabled(Object buttton) {
        final HeteroCompound hh[]=this.hh;
        final String cmd=gcps(KEY_ACTION_COMMAND,buttton);
        boolean enabled=false;
        for(int iH=sze(hh); --iH>=0;) {
            final HeteroCompound h=hh[iH];
            if (h!=null) {
                if (cmd=="L") enabled=true;
                if (cmd=="RM" && h.getBelongsToProtein()!=null) enabled=true;
                if ((cmd=="K" || cmd=="PDB") && h.getFile()!=null) enabled=true;
            }
        }
        return enabled;
    }

    private ChButton b(String s) {
        ChButton b=new ChButton(s).li(HeteroPopup.this).cp(KEY_ENABLED,this);
        rtt(b);
        return b;
    }
    // ----------------------------------------
    public JPopupMenu menu() {
        this.hh=objects.heteroCompounds();
        LAB_TITLE.setText("Menu For "+hh.length+TITLE+(hh.length==1 ? "" : "s"));
        if (popup==null) {
            final String tt1="Only if the compound is coded in a file of its own, instead of being defined in one file together with the peptide chain.";
            Object oo[]={
                newCNSEW(pnl(LAB_TITLE),null,null, pnl(b("L").t(ProteinPopup.ACTION_showInList)),smallHelpBut(HeteroCompound.class)),
                b("PDB").i(IC_PDB).t("View 3D-structure file").tt(tt1),
                b("RM").i(IC_CLOSE).t("Remove from protein[s]"),
                "-",
                b("K").i(IC_KILL).t("Move file to ./trash").tt(tt1),
            };
            popup=jPopupMenu(0L, "Context-menu for "+TITLE, oo);
        }
        return popup;
    }
    private static int countJList;
    public void actionPerformed(java.awt.event.ActionEvent ev) {
        final String cmd=ev.getActionCommand();
        final HeteroCompound[] hh=this.hh;
        if (sze(hh)==0) return;
        final StrapProtein[] ppSel=StrapAlign.getInstance().getSelectedProteins(), pp=StrapAlign.getInstance().getProteins();
        if (cmd=="RM" && sze(ppSel)==0 && !ChMsg.yesNo("Remove from proteins:<br>No proteins selected. Remove the "+hh.length+TITLE+" from any protein")) return;
        for(HeteroCompound h :hh) {
            if (cmd=="PDB") {
                for(java.io.File f : h.getDndFiles()) {
                    if (sze(f)>0) new AsciiView(f).showInFrame(filepathUnixStyle(f),ChFrame.STAGGER);
                }
            }
            if (cmd=="L") {
                StrapAlign.showInJList(0L, null, hh,TITLE,null).showInFrame(ChFrame.AT_CLICK|ChFrame.SIZE_REGARD_RESOLUTION,TITLE+"  "+ ++countJList);
            }
            if (cmd=="RM" || cmd=="K") {
                int count=0;
                for(StrapProtein p:sze(ppSel)>0?ppSel:pp) {
                    if (cntains(h,p.getDnaAndRnaAndHeteros())) {
                        p.removeHeteroCompound(h);
                        count++;
                    }
                }
                if (count>0)  StrapAlign.dispatchLater(StrapEvent.HETERO_OR_NUCLEOTIDE_STRUCTURE_ADDED_OR_REMOVED, 33);
            }
            if (cmd=="K") {
                final java.io.File f=h.getFile();
                if (f!=null) renamFile(h.getFile(), "./trash/"+f.getName());
            }
        }
        this.hh=null;
    }

}
