package charite.christo.strap;
import charite.christo.*;
import charite.christo.blast.*;
import charite.christo.interfaces.*;

import charite.christo.protein.Blosum;
import charite.christo.strap.interfaces.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.util.List;
import javax.swing.*;
import static charite.christo.ChConstants.*;
import static charite.christo.ChUtils.*;
/**
   @author Christoph Gille
*/
public class IntermediateSeqPair extends JPanel implements Disposable,Runnable,HasControlPanel,
                                                           ActionListener, javax.swing.table.TableModel, MouseWheelListener, PaintHook ,PreferredSize{
    private final static Point ORIGIN=new Point();
    private StrapProtein[] protein;
    private int fontSize=14;
    private Font font=getFnt(14,true,0);
    private Container controlPanel;
    private final DrawGappedSequence dgs=new DrawGappedSequence();
    final UniqueList<BlastHitIntersection> vAllAlignments=new UniqueList(BlastHitIntersection.class);

    private final DialogDotPlot plot;
    private final ByteArray LOG=new ByteArray(0);
    private final ChJTable jTable;
    private final BlastResult blastResult[];
    private final ChTextField tfExp,tfNum,labNum=new ChTextField().cols(8,true,true).ro();
    private final JScrollBar vSB;
    private final UniqueList<HitView> vHitView=new UniqueList(HitView.class);
    final UniqueList<HitView> vHitViewShown=new UniqueList(HitView.class);
    private final JScrollPane scrollPane;
    private int[][] allBlosums_;

    private final ChTextField tfGapOpen=new ChTextField("8").cols(4,true,true), tfGapExt=new ChTextField("2").cols(4,true,true);
    private int gapOpen=8, gapExt=2;

    /* --- TableModel --- */
    public String getColumnName(int c) {return   "";}
    public boolean isCellEditable(int row,int column) {return true;}
    public void setValueAt(Object o,int row,int col) {}
    public Class getColumnClass(int c) { return Object.class;}
    public int getColumnCount() {return 1;}
    public int getRowCount() { final List v=this.vHitViewShown; return v!=null ? v.size() : 0;}
    public Object getValueAt(int row,int col) { final List v=this.vHitViewShown; return v!=null ? v.get(row): null; }
    public void addTableModelListener(javax.swing.event.TableModelListener l){}
    public void removeTableModelListener(javax.swing.event.TableModelListener l){}
    /* --- end TableModel --- */
    public IntermediateSeqPair( StrapProtein p0,StrapProtein p1,BlastResult res0, BlastResult res1) {
        final ChJTable t=this.jTable=new ChJTable(this,ChJTable.DEFAULT_RENDERER);
        t.addMouseWheelListener(this);
        final JScrollPane sp=this.scrollPane=scrllpn(0L,t);
        noInsets(sp);
        plot=new DialogDotPlot("fn2I",p0,p1);
        this.blastResult=new BlastResult[]{ res0,res1};
        this.protein=new StrapProtein[]{p0,p1};
        this.tfExp=new ChTextField("1").cols(9,true,true).li(this);
        this.tfNum=new ChTextField(IntermediateSeq.tfNumAlignments.getText()).cols(4,true,true).li(this);

        final JComponent
            pNorth=newCNSEW(pnl(new ProteinLabel(0L,p0),new ProteinLabel(0L,p1),ChButton.actionPrint(this)),null,null,
                                   new ChButton().actionClose(this, DISPOSE_RM_CHILDS),
                            ChButton.actionCtrl(this).magnifyUnderMouse(IC_CONTROLPANEL)),
            pSouth=vB(
                      pnl(
                          new ChButton("LOG").t("Log").li(this),
                          "  e-value<",this.tfExp," show",this.tfNum,this.labNum
                          )
                      );
        for(int i=0;i<2;i++) {
            final JComponent pnl=new ChPanel();
            addPaintHook(this,pnl);
            pnl.setPreferredSize(dim(9999,EX));
            pcp("ID", i==0 ? "ALL0":"ALL1",pnl);
            pSouth.add(pnl);
        }
        t.setRowSelectionAllowed(false);
        t.setColumnSelectionAllowed(false);
        this.vSB=sp.getVerticalScrollBar();
        this.vSB.setUnitIncrement(3*EX);
        final int h=StrapAlign.getDialogPanel().getHeight()/2;
        plot.setPreferredSize(dim(100,h));
        plot.setMinimumSize(dim(0,0));
        final JSplitPane pSplit=new JSplitPane(JSplitPane.VERTICAL_SPLIT,plot,sp);
        pSplit.setOneTouchExpandable(true);
        cnsew(this, pSplit,pNorth,pSouth,null,null);
        run();
        {
            String name=this.protein[0]+"-"+this.protein[1];
            pcp(KEY_IMAGE_FILE_NAME,"intermedSequence-dotplot-"+name,plot);
            pcp(KEY_IMAGE_FILE_NAME,"intermedSequence-"+name,this.jTable);
            pcp(KEY_PRINTABLE_COMPONENTS,new Object[]{plot,jTable},this);
        }
    }

    public void actionPerformed(ActionEvent ev) {
        final Object q=ev.getSource();
        final String cmd=ev.getActionCommand();
        final boolean isSelected=isSelctd(q);
        ByteArray showLog=null;
        if ((q==this.tfNum || q==this.tfExp) && (cmd==ACTION_ENTER || cmd==ACTION_FOCUS_LOST)) {
            this.run(); SwingUtilities.updateComponentTreeUI(this);
        }
        if (cmd=="LOG") showLog=LOG;
        final HitView v=(HitView)gcp(HitView.class,q);
        if (v!=null) {
            if (cmd=="CB") {
                v.SELECTED[0]=isSelected;
                allBlosums(true);
                final int fromIdx,toIndex;
                final HitView vv[]=vHitViewShown.asArray();
                if (isShift(ev)) {
                    fromIdx=0;
                    toIndex=vv.length;
                    for(HitView hv:vv) hv.cb.setSelected(hv.SELECTED[0]=isSelected);
                } else {
                    int i=0;
                    while(i<vv.length && vv[i]!=v) i++;
                    fromIdx=toIndex=i;
                }
                final ListSelectionModel lsm=this.jTable.getSelectionModel();
                if (isSelected) lsm.addSelectionInterval(fromIdx, toIndex);
                else lsm.removeIndexInterval(fromIdx, toIndex);
                IntermediateSeqPair.this.repaint();
                toDotplot();
            }
            if (cmd=="L") showLog=new ByteArray(v.logMsg);
            if (cmd=="V") {
                final ByteArray sb=new ByteArray(999);
                int i=0;
                for(StrapProtein p: this.protein) {
                    sb.append(p.getName()).append("\nscore=").append(v.scores[i]).append(" X-score=").append(v.score).append("\n\n");
                    v.intersection.getAlignment(i).toText(sb,120);
                    i++;
                }
                final AsciiView ta=new AsciiView(sb);
                ta.tools().underlineRefs(0);
                pcp(ACTION_DATABASE_CLICKED,"Load",ta);
                ta.showInFrame("blast result");
            }
        }
        if (showLog!=null) new AsciiView(showLog).showInFrame("Log");
    }
    private static void removeIfMatchedSequenceToShort(List<BlastAlignment>v) {
        for(int i=v.size(); --i>=0;) {
            final BlastAlignment a=v.get(i);
            if (a.getMatchSeq().length<20)
                v.remove(a);
        }
    }
    private static void removeIfMatchedSequencesAreIdentical(UniqueList<BlastAlignment>v) {
        final int size=v.size();
        putln("removeIfMatchedSequencesAreIdentical ["+size+"]: ");
        for(int i=size; --i>=0;) {
            final BlastAlignment a0=v.get(i);
            final int a0Hash=a0.getMatchSeqHashCode();
            boolean del=false;
            for(BlastAlignment a1:v.asArray())
                if (a0!=a1 && a0Hash==a1.getMatchSeqHashCode() && compareAlphabetically(a0.getMatchSeq(), a1.getMatchSeq(),true )==0) {
                    del=true;
                    break;
                }
            if (del) v.remove(a0);
        }
        StrapAlign.progressBar(0);
    }
    private void listIntersections() {
        vAllAlignments.clear();
        final UniqueList<BlastAlignment> vBlastAli0=new UniqueList(BlastAlignment.class),  vBlastAli1=new UniqueList(BlastAlignment.class);
        for(BlastHit h0:this.blastResult[0].getHits()) adAll(h0.getAlignments(),vBlastAli0);
        for(BlastHit h1:this.blastResult[1].getHits()) adAll(h1.getAlignments(),vBlastAli1);
        removeIfMatchedSequenceToShort(vBlastAli0);
        removeIfMatchedSequenceToShort(vBlastAli1);
        removeIfMatchedSequencesAreIdentical(vBlastAli0);
        removeIfMatchedSequencesAreIdentical(vBlastAli1);
        final int size=vBlastAli0.size();
        puts("BlastHitIntersection.intersect["+size+"]: ");
        int count=0;
        for(BlastAlignment a0:vBlastAli0.asArray()) {
            if (size>0 && count%10==0) StrapAlign.progressBar(count++*100/size);
            for(BlastAlignment a1:vBlastAli1.asArray()) {
                BlastHitIntersection a=BlastHitIntersection.intersect(a0,a1);
                if (a!=null) vAllAlignments.add(a);
            }
        }
        LOG.append(" The proteins have ").append(vAllAlignments.size()).append(" BLAST hits in common\n\n");
        if (vAllAlignments.size()>333) {
            final int[]  hist=BlastHitIntersection.expectValueHistogramm(vAllAlignments.asArray());
            LOG.append("\nE-value histogram\n");
            for(int h:hist) LOG.append(h).append(' ');
            float eValueCutoff=BlastHitIntersection.expectValueCutoff(hist,333);
            LOG.append("\nI want to have less than #333 and take an E-value cutoff of ").append(eValueCutoff).append('\n');
            for(int i=vAllAlignments.size(); --i>=0;) {
                BlastHitIntersection sect=vAllAlignments.get(i);
                if (sect.getExpect()>eValueCutoff) vAllAlignments.remove(sect);
            }
            LOG.append("The number vAllAlignments.size() is now ").append(vAllAlignments.size()).append('\n');
        }
    }
    public void run() {
        if (vAllAlignments.size()==0) listIntersections();
        final List<BlastHitIntersection> vAlignments=new UniqueList(BlastHitIntersection.class);
        vAlignments.addAll(vAllAlignments);
        gapOpen=atoi(tfGapOpen);
        gapExt=atoi(tfGapExt);
        final float expVal=(float)atof(this.tfExp,0);
        if (!Float.isNaN(expVal)) {
            final int size=vAlignments.size();
            for(int i=size;--i>=0;) {
                puts("+");
                final BlastHitIntersection sect=vAlignments.get(i);
                if (sect.getExpect()>expVal) vAlignments.remove(sect);
            }
            LOG.append(" apply text field e-value "+expVal+" vAlignments.size()="+size+" ==> "+vAlignments.size()+"\n\n");
        }
        final HitView[] aHitView=new HitView[vAlignments.size()];
        final int size=vAlignments.size();
        puts(" Creating HitView ["+size+"]: ");
        for(int i=vAlignments.size();--i>=0;) {
            if (size!=0 && i%30==0) StrapAlign.progressBar((size-i-1)*100/size);
            aHitView[i]=newHitView(vAlignments.get(i));
        }
        puts(" done"); StrapAlign.progressBar(0);

        sortArry(aHitView);
        this.vHitView.clear();
        adAll(aHitView, this.vHitView);
        JComponent firstComponent=null;
        final int countDisplayedHits=mini(this.vHitView.size(),atoi(this.tfNum));
        this.labNum.setText("of "+vAlignments.size());
        this.vHitViewShown.clear();
        for(int i=0;i<countDisplayedHits;i++) {
            final HitView view=this.vHitView.get(i);
            initView(view);
            if (firstComponent==null) firstComponent=view;
            this.vHitViewShown.add(view);
        }
        if (firstComponent!=null) {
            firstComponent. scrollRectToVisible(new Rectangle(0,0,1,1));
            setFont(this.fontSize,false);
        }
        //        this.vSB.setValue(1);
    }
    public void dispose() {
        UIupdateList.remove(this);
        rmAllChilds(this);
        vAllAlignments.clear();
        this.vHitView.clear();
    }
    private int[][] allBlosums(boolean always) {
        int all[][]=this.allBlosums_;
        if (all==null) this.allBlosums_=new int[][]{new int[protein[0].countResidues()],new int[protein[1].countResidues()]};
        if (always||all==null) {
            all=this.allBlosums_;
            final byte[][] BLOS=Blosum.BLOSUM62;
            for(int iP=0;iP<2;iP++) {
                final int[] blos=all[iP];
                Arrays.fill(blos,0);
                for(HitView v: this.vHitViewShown.asArray()) {
                    if (!v.SELECTED[0])  continue;
                    final byte q[]=v.gapped[iP];
                    final byte m[]=v.match;
                    for(int col=0, iAa=0; col<q.length && col<m.length; col++) {
                        final int c=q[col]|32;
                        if ('a'<=c && c<='z') {
                            final int b=BLOS[c&127][m[col]&127];
                            if (b>Byte.MIN_VALUE) blos[iAa]+=b;
                            iAa++;
                        }
                    }
                }
                for(int i=blos.length; --i>=0;)
                    if (blos[i]<Blosum.BLOSUM62_MIN) blos[i]=Blosum.BLOSUM62_MIN;
                    else if (blos[i]>Blosum.BLOSUM62_MAX) blos[i]=Blosum.BLOSUM62_MAX;

            }
        }
        return all;
    }

    public boolean paintHook(JComponent component,Graphics g, boolean after) {
        if (!after) return true;
        else {
            final boolean isWhiteBG=isWhiteBG();
            final Color fg=C(isWhiteBG ? 0:0xFFffFF);
            final Color bg=C(isWhiteBG ? 0xFFffFF:0);
            g.setColor(bg);
            final Font fnt=IntermediateSeqPair.this.font;
            final Rectangle cb=charBounds(fnt), clip=g.getClipBounds();
            final int w=component.getWidth();
            final int h=component.getHeight(), h2=h/2;
            final Object ID=gcp("ID",component);
            final int all01= ID=="ALL0" ? 0 : ID=="ALL1" ? 1 : -1;
            final int charH=cb.height, charW=cb.width;
            if (all01>=0) {
                final int blosums[]=allBlosums(false)[all01], n=blosums.length, rgb[]=sharedRGB(n);
                Arrays.fill(rgb,0,n,0);
                for(int i=n;--i>=0;) {
                    final int bl0=blosums[i];
                    if (bl0<0) continue;
                    final int bl=((bl0<<8)/Blosum.BLOSUM62_MAX)&255;
                    final int white=bl>>>1;
                    rgb[i]= all01==0 ? (white<<16) +  (bl<<8) + white :  (bl<<16) +  (white<<8)  + white;
                    if (isWhiteBG) rgb[i]=~rgb[i];
                }
                final java.awt.image.BufferedImage image=sharedImage('H',n);
                image.setRGB(0,0,n,1, rgb,0,n);
                g.drawImage(image,0,1,w,h,   0,0,n,1,this);
            }
            final HitView v=(HitView)gcp(HitView.class,component);
            if (v!=null) {
                if (ID=="CENTER") {
                    initView(v);
                    final byte[]  q0=v.gapped[0], q1=v.gapped[1], m=v.match;
                    g.setColor(bg); g.fillRect(0,0,w,h);
                    setFont(fnt);
                    g.setFont(fnt);
                    final int mode=StrapAlign.isShadingSecStru() ? dgs.SHADE_SEC_STRU : 0;
                    final Color[] shadingColors=StrapAlign.getShadingColors();
                    ORIGIN.x=0;
                    ORIGIN.y=-charH/2;
                    final int fromCol=clip!=null ? maxi(0,clip.x/charW-1) : 0;
                    final int toCol=clip!=null ? (clip.x+clip.width)/charW+1 : 0;
                    g.setColor(fg);dgs.drawBlastMidline(q0,q1,fromCol,toCol, null, g,0,ORIGIN.y-1);
                    ORIGIN.y+=charH;
                    dgs.draw(this,g,ORIGIN, 0,q0, fromCol, toCol, null, shadingColors,mode);
                    ORIGIN.y+=charH;
                    g.setColor(fg);dgs.drawBlastMidline(q0,m,0,MAX_INT, null, g,0,ORIGIN.y);
                    ORIGIN.y+=charH;
                    dgs.draw(this,g,ORIGIN, 0, m, fromCol, toCol, null, shadingColors,mode);
                    ORIGIN.y+=charH;
                    g.setColor(fg);dgs.drawBlastMidline(m,q1,0,MAX_INT, null, g,0,ORIGIN.y);
                    ORIGIN.y+=charH;
                    dgs.draw(this,g,ORIGIN, 0, q1, fromCol, toCol, null, shadingColors,mode);
                    ORIGIN.y+=charH;
                    g.setColor(fg);dgs.drawBlastMidline(q1,q0,0,MAX_INT, null, g,0,ORIGIN.y+1);
                    return true;
                }
                final int oneOrTwo=ID=="SP0"?0 : ID=="SP1" ? 1 : -1;
                if (oneOrTwo>=0) {
                    final ChScrollBar sb=(ChScrollBar) component;
                    final Rectangle track=sb.getTrack();
                    final int dx1=track.x;
                    final int dx2=track.x+track.width;
                    g.setColor(bg);
                    g.fillRect(0,h2, 1,1);
                    g.fillRect(0,0,dx1,h);
                    g.fillRect(dx1,0,w,h);
                    final byte[] seq=v.gapped[oneOrTwo], match=v.match;
                    final int nRes=v.countLetters[oneOrTwo];
                    final int[] rgb=sharedRGB(nRes);
                    final byte[][]M=Blosum.BLOSUM62;
                    final java.awt.image.BufferedImage image=sharedImage('H',nRes);
                    final int allBl_[][]=allBlosums(false);
                    final int[]allBl=allBl_[oneOrTwo];
                    final int colF=sb.getValue()/charW;
                    final int colT=(sb.getValue()+sb.getVisibleAmount())/charW;
                    int iaF=0, iaT=0;
                    for(int isDiff=0; isDiff<2; isDiff++) {
                        Arrays.fill(rgb,0,nRes,0);
                        for(int col=0, iAa=0; iAa<nRes && col<seq.length; col++) {
                            final int c=seq[col]|32;
                            if ('a'<=c && c<='z') {
                                final int bl0=col<match.length ? M[c&127][match[col]&127] : -1;
                                final int bl1=isDiff>0 ? bl0-allBl[iAa]:bl0;
                                if (bl0>=0 && bl1>0) {
                                    final int bl= (bl1 * 256 / Blosum.BLOSUM62_MAX)&255;
                                    final int white=bl/2;
                                    rgb[iAa]=  (oneOrTwo==0 ? (white<<16)|(bl<<8) : (bl<<16)|(white<<8) )  + white;
                                    if (isWhiteBG) rgb[iAa]=~rgb[iAa];
                                }
                                if (iaF==0 && col>colF) iaF=iAa;
                                iAa++;
                                if (col<=colT) iaT=iAa;
                            }
                        }
                        image.setRGB(0,0,nRes,1, rgb,0,nRes);
                        final int dy1=isDiff>0 ? h2+1: 1;
                        final int dy2=isDiff>0 ? h: h2;
                        g.drawImage(image,  dx1,dy1, dx2,dy2,    0,0,nRes,1, this);
                    }
                    if (nRes!=0) {
                        final int span=w-2*dx1;
                        final int x0=iaF*span/nRes;
                        final int x1=iaT*span/nRes;
                        g.setColor(C(0x8080ff,0x60));
                        g.fillRect(x0+dx1,0, x1-x0,h);
                        if (colF!=atoi(gcp("LV",sb))) { pcp("LF",intObjct(colF),sb); ChDelay.repaint(sb,333); }
                    }

                }
            }
        }
        return true;
    }
    public Container getControlPanel() {
        if (this.controlPanel==null) this.controlPanel=pnl(" gapOpen=",tfGapOpen," gapExt=",tfGapExt);
        return this.controlPanel;
    }

    private void setFont(int dFont,boolean isRelative) {
        this.fontSize=maxi(4,((isRelative ? this.fontSize : 0)+dFont));
        this.font=getFnt(this.fontSize,true,0);
        if (this.vHitViewShown.size()>0) {
            this.jTable.setRowHeight(prefHeight(this.vHitViewShown.get(0))+ChJTable.COLUMN_EXTRA_WIDTH);
            this.jTable.revalidate();
        }
    }

    public void mouseWheelMoved(MouseWheelEvent mev) {
        final int i=mev.getWheelRotation();
        if (isCtrl(mev)) setFont(i,true);
        else if (!isShift((mev))) this.vSB.setValue(this.vSB.getValue()+i*EX);
    }

    public Dimension getPreferredSize(JComponent component) {
        final Object ID=gcp("ID",component);
        final HitView v=(HitView)gcp(HitView.class,component);
        if (ID=="CENTER" && v!=null) {
            initView(v);
            final Rectangle cb=charBounds(IntermediateSeqPair.this.font);
            final int w=cb.width*(maxi(v.gapped[0].length, v.gapped[1].length)+1);
            return dim(w+3*cb.width, cb.height*6);
        }
        return dim(0,0);
    }

    public void initView(HitView v) {
        if (v.cb!=null) return;
        final Object refHitView=weakRef(v);
        v.setLayout(new BoxLayout(v,BoxLayout.Y_AXIS));
        final JComponent  panAlignment=pnl();
        setPrefSize(this,panAlignment);
        addPaintHook(this,panAlignment);
        monospc(panAlignment);
        final BlastHitIntersection intersect=v.intersection;
        final String db=intersect.getAlignment(0).getDatabase();
        v.id=db+":"+intersect.getAlignment(0).getID();
        final ChButton tog=toggl("CB").t(null).tt("With SHIFT key: select all").li(this).s(v.SELECTED[0]);
        pcp(HitView.class,refHitView,tog);
        v.cb=tog.cb();
        final ChTextField tf=new ChTextField(v.id+"  score "+(int)v.blosumScore+" "+toStrg(intersect.getAlignment(0).getBlastHit().getDescription()));
        try { ((JTextField)tf).setCaretPosition(0); } catch(Exception e){}
        final JScrollPane sp=scrllpn(0L,panAlignment);
        sp.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        sp.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
        tf.setPreferredSize(dim(999999,EX+4));
        pcp(ACTION_DATABASE_CLICKED,"Load",tf);
        tf.tools().underlineRefs(0);
        ChButton butLog=new ChButton("L").t("Log").li(this).cp(HitView.class,refHitView);
        ChButton butView=new ChButton("V").t("view").li(this).cp(HitView.class,refHitView);
        v.add(hB(v.cb,new JScrollPane(tf,JScrollPane.VERTICAL_SCROLLBAR_NEVER,JScrollPane.HORIZONTAL_SCROLLBAR_NEVER),butLog,butView));
        for(int j=0; j<2; j++) {
            final ChScrollBar sb=new ChScrollBar(JScrollBar.HORIZONTAL);
            addPaintHook(this,sb);
            sb.setUnitIncrement(2*EM);
            if (j==0) sp.setHorizontalScrollBar(sb);
            v.add(sb);
            if (j==0) {
                v.add(sp);
                setDragScrolls(panAlignment,sp);
                setDragScrolls(panAlignment,this.scrollPane);
            } else sb.setModel(sp.getHorizontalScrollBar().getModel());
            generateMiddleForLeftButton(sb);
            pcp(HitView.class,refHitView,sb);
            pcp("ID",j==0?"SP0":"SP1",sb);
        }

        pcp("ID","CENTER",panAlignment);
        pcp(HitView.class,refHitView,panAlignment);
        pcp(ChRenderer.KEY_RENDERER_COMPONENT,refHitView,v);

    }

    private HitView newHitView(BlastHitIntersection a) {
        final HitView v=new HitView();
        v.intersection=a;
        v.SELECTED=a.SELECTED;
        byte[] q0=null,q1=null, m0=null, m1=null;
        final ByteArray log=new ByteArray(999);

        for(int i=0;i<2;i++) {
            final byte[] querySeq=this.protein[i].getResidueType();
            final byte[] matchSeq=a.getSeq('M',i);
            final int nSpc=a.getQueryStart(i);
            final byte[] spc_matchSeq=new byte[nSpc+matchSeq.length];
            Arrays.fill(spc_matchSeq,0,nSpc,(byte)32);
            System.arraycopy(matchSeq,0,spc_matchSeq,nSpc,matchSeq.length);
            final byte[] q=concat(querySeq,0,a.getQueryStart(i),   a.getSeq('Q',i),0,MAX_INT,   querySeq, a.getQueryEnd(i), MAX_INT,null);
            v.countLetters[i]=countLetters(q,0,MAX_INT);

            if (i==0) { q0=q; m0=spc_matchSeq;} else { q1=q; m1=spc_matchSeq; }
            if (log!=null) {
                log.append("i=").append(i).append('\n').append(q).append('\n').append(spc_matchSeq).append("\n\n")
                    .append("getSeq(M,0)=").append(a.getSeq('M',0)).append('\n')
                    .append("getSeq(M,1)=").append(a.getSeq('M',1)).append("\n\n");
            }
            v.scores[i]=a.getAlignment(i).getScore();
        }
        final byte[][] l3=BlastHitIntersection.mergeAlignments(q0,q0.length, m0,m0.length, q1,q1.length, m1,m1.length);
        v.match=l3[1];
        v.gapped=new byte[][]{l3[0],l3[2]};
        v.score=v.scores[0]*v.scores[1];
        {
            final byte[] m=l3[1];
            int im=0;
            while(im<m.length && m[im]==' ') im++;
            v.blosumScore=Blosum.blosumScore(gapOpen,gapExt,m, l3[0], l3[2], im, m.length)/(float)(m.length-im);
        }
        v.logMsg=ByteArray.trimSize(log);
        return v;
    }

    //card4_human q7rtr2_human

    private static class HitView extends ChPanel implements Comparable {
        final int[] countLetters={0,0};
        final float scores[]=new float[2];
        String id;
        byte[] logMsg, gapped[], match;
        float blosumScore=Float.NaN,score;
        BlastHitIntersection intersection;
        boolean SELECTED[]={false};
        AbstractButton cb;
        public int compareTo(Object o) {  return o instanceof HitView  && ((HitView)o).blosumScore > blosumScore ? 1 : -1;}
    }

    private void toDotplot() {
        if (plot==null) return;
        final int[][] vDots=new int[protein[1].countResidues()][];
        for(HitView v : this.vHitView.asArray())  {
            if (!v.SELECTED[0]) continue;
            BlastHitIntersection is=v.intersection;
            //            addPoints(byte[] tX,byte[] tY, int startX,   int startY, boolean revX, boolean revY,   int endX, int endY, int fromX, int fromY,double score, int[][] vHits, StrapProtein px, StrapProtein py) {
            plot.addPoints(is.getSeq('Q',0), is.getSeq('Q',1), 0,0,  false,false, MAX_INT, MAX_INT, is.getQueryStart(0),is.getQueryStart(1),   v.blosumScore, vDots);
        }
        plot.setBl2seq(vDots,null);
        plot.repaint();
    }
        //        plot.removeTopPanel();
}
