package charite.christo.strap;
import charite.christo.*;
import java.io.File;
import java.net.URL;
import java.util.*;
import java.util.zip.ZipFile;
import static charite.christo.ChUtils.*;
/**
   @author Christoph Gille
*/
public class StrapPlugin implements charite.christo.interfaces.HasRendererText {
    private final ZipFile zipFile;
    private final String clazzName, menu;
    private final URL downloads[];
    private final ByteArray help;
    private Class clazz;
    public StrapPlugin(String clazzName, String menu, ZipFile zipFile) {
        this.clazzName=clazzName;
        this.zipFile=zipFile;
        this.menu=menu!=null?menu:"";
        String lines[]=readLines(ChZip.inputStream("download.txt", zipFile));
        List v=null;
        for (int i=sze(lines); --i>=0;) {
            for(String s : splitTokns(0L, lines[i])) {
                adUniq(url(withoutLastComponent(s,'#')),v==null?v=new ArrayList():v );
            }
        }
        this.downloads=toArry(v, URL.class);
        this.help=readBytes(ChZip.inputStream(clazzName.replace('.','/')+"Help.html", zipFile));
    }
    public String getMenu() { return this.menu;}
    public final Class getClazz(boolean compute) {
        if (clazz==null && compute) {
            List vU=new ArrayList(), vF=new ArrayList();
            for(URL u : this.downloads) {
                final String s=delSfx(".pack.gz",toStrg(u));
                if (s.endsWith(".jar")) {
                    if (vU==null) { vU=new ArrayList(); vF=new ArrayList();}
                    vU.add(u);
                    vF.add(jarFile(u));
                }
            }
            //putln(" vF="+vF+"   "+vU);
            InteractiveDownload.downloadFiles(toArry(vU,URL.class), toArry(vF,File.class) );
            vF.add(file(this.zipFile.getName()));
            clazz=Insecure.findClassByName(this.clazzName, toArry(vF,File.class) );
        }
        return clazz;
    }
    public String toString() {
        return "StrapPlugin@"+clazzName+",["+joinAsStrg(downloads,"|")+"],"+menu;
    }
    public CharSequence getRendererText(int options) { return this.clazzName;}
    public ByteArray getDocumentation() { return help; }
    public String getClassName() { return clazzName;}
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> static utils >>> */
    public static File jarFile(Object url) {
        return file(dirPlugins()+"/"+rplcNoFilenameChars(toStrgTrim(url)));
    }

    private static int getPlugins_mc;
    private static StrapPlugin[] _getPlugins;
    public static StrapPlugin[] getPlugins() {
        final ChZip chZip=ChZip.getInstance(dirPlugins());
        chZip.jarFiles();
        final int mc=ChZip.getInstance(dirPlugins()).jarFiles_modificationCount();
        if (_getPlugins==null || getPlugins_mc!=mc) {
            getPlugins_mc=mc;
            for(String dd : chZip.joinFiles("delete.txt", (Map)null)) {
                for(String d: splitTokns(0L, dd)) delFile(file(dirPlugins()+"/"+dd));
            }
            List v=new ArrayList();
            final Map<String,java.util.zip.ZipFile> map=new HashMap();
            for(String line : chZip.joinFiles("classes.txt", map)) {
                final String tt[]=splitTokns(0L, line);
                if (tt.length==0) continue;
                v.add(new StrapPlugin(tt[0], get(1,tt, String.class), map.get(line)));
            }
            _getPlugins=toArry(v,StrapPlugin.class);
        }
        return _getPlugins;
    }
}
