package charite.christo.strap;
import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.strap.interfaces.*;
import javax.swing.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**HELP
<h2>What is LaTeX - mini tutorial</h2>
WIKI:LaTeX is a widely applied  scientific type setting program.
It takes a text-file as input and creates a PDF-document (or PS).
The text-file contains LaTeX-commands which are preceded by a backslash.
When a '%' sign is in the text all characters right from this sign are ignored.
Thus comments are preceded by a  "%".
For convenience STRAP prepares  some deactivated lines which  can be activated by removing the "%".
<br>
<br>
The following shows how "hellow world" is created with LaTeX:
<ul>
  <li>First step: Type the following into a  text file
    named test.tex and save it as plain text: (!text-file not word-file)
<pre class="data"> \documentclass[pdftex,a4paper]{letter}
 \begin{document}
 hello world
 \end{document}</pre>
</li>
  <li>Second step:  Open your terminal shell. Run the following command
<pre class="terminal">
pdflatex test
</pre>
  When everything goes right, a file test.pdf is generated.
      </li>
  <li>final step: view test.pdf with ACROBAT</li>
</ul>
*/
public class TexshadeGraph extends Box implements java.awt.event.ActionListener,IsEnabled {
    private final Object instanceVoR[]={null};
    private final String where;
    private final ProteinCombo comboProtein;
    private final ChCombo comboClass, comboColor;
    private final ChButton toggle, butProteins;
    private final ChTextField tfMin, tfMax;
    private final Class interf;
    private ProteinList jlProteins;
    public final Object[] needsReval;
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> Constructor >>> */
   TexshadeGraph(String where,Class interf) {
       super(BoxLayout.Y_AXIS);
        this.where=where;
        this.interf=interf;
        final String save=Texshade.SAVE+where+" ";
        final boolean isBottom="bottom"==where && interf!=ValueOfResidue.class;
        final String ttMiMa="By giving a max and min value you can scale  the plot<br>Keep field blank to take entire range of values";
        tfMin=new ChTextField("auto").tt(ttMiMa).saveInFile(save+"tfMin");
        tfMax=new ChTextField("auto").tt(ttMiMa).saveInFile(save+"tfMax");
        comboColor=new ChCombo("ColdHot","BlueRed","GreenRed", "Blue","Red","Green","Brown","Black","Yellow","Orange","Pink").save(TexshadeGraph.class,"solor_"+where);
        toggle=toggl().s(isBottom).save(TexshadeGraph.class,"enabled_"+where);
        comboClass=StrapAlign.classChoice(interf).li(this).classRenderer(interf).save(TexshadeGraph.class,"class_"+where);
        if (interf==ValueOfResidue.class) {
            comboProtein=new ProteinCombo(StrapAlign.getInstance(),0);
            pcp(KEY_ENABLED, this, comboProtein.li(this));
            butProteins=null;
        } else {
            butProteins=new ChButton("Choose other proteins").li(this);
            comboProtein=null;
        }
        final JComponent
            bCtrlS=ChButton.actionSharedCtrl(instanceVoR),
            bCtrl=ChButton.actionCtrl(instanceVoR),
            pan1=pnl(comboColor," min=",tfMin," max=",tfMax),
            pan2=hBL(comboProtein,butProteins,comboClass, bCtrlS, bCtrl,panHS(comboClass));

        add(hBL(toggle,"Location: ",where, pan1));
        add(pan2);
        toggle.actionCollapse(false,new Object[]{pan1,pan2});
        replaceInstance();
        replaceProteins();
        needsReval=new Object[]{bCtrl, bCtrlS};
    }
    /* <<< Constructor <<< */
    /* ---------------------------------------- */
    /* >>> Replace >>> */
    private void replaceInstance() {
        dispos(0L, instanceVoR[0]);
        instanceVoR[0]=HotswapUtil.instance(comboClass,  interf, true);
        replaceProteins();
        //putln("replaceInstance");
    }
    private void replaceProteins() {
        final ValueOfResidue vor=deref(instanceVoR[0], ValueOfResidue.class);
        final ValueOfAlignPosition vap=deref(instanceVoR[0], ValueOfAlignPosition.class);
        if (vor!=null) vor.setProtein(comboProtein.getProtein());
        if (vap!=null && jlProteins!=null) vap.setProteins(jlProteins.getSelectedProteins());
    }
   public final boolean isEnabled(Object p) {
       final Object o=instanceVoR[0];
       return p==null ? false : o instanceof IsEnabled ? ((IsEnabled)o).isEnabled(o) : true;
    }
    StringBuffer makeTex(StringBuffer sb, final int colFrom, final int colTo) {
        final String errorPrefix="% TexshadeGraph "+where+" "+shrtClasNam(interf);
        final StrapProtein pp[]=Texshade.proteins();
        if (!isSelctd(toggle) || !comboClass.isEnabled()) return sb;
        if (pp==null) return sb.append(errorPrefix).append(" pp=null\n");
        final String color=toStrg(comboColor);
        final String barOrColor=nxt(UPPR, color, 1,MAX_INT)>0 ? "color":"bar";
        double min=atof(tfMin,0), max=atof(tfMax,0);
        final ValueOfResidue vor=interf==ValueOfResidue.class ? deref(instanceVoR[0], ValueOfResidue.class) : null;
        final ValueOfAlignPosition vap=interf==ValueOfAlignPosition.class ? deref(instanceVoR[0], ValueOfAlignPosition.class) : null;
        final double[] values;
        int valuesFrom=0, valuesTo=0;
        String sRange=null,protNum=null;
        boolean[] takeValue=null;
        if (vor!=null) {
            final StrapProtein pVoR=comboProtein.getProtein();
            if ( pVoR==null) return sb.append(errorPrefix+" p=null\n");
            vor.setProtein(pVoR);
            valuesFrom=pVoR.column2nextIndex(colFrom);
            valuesTo=pVoR.column2thisOrPreviousIndex(colTo);
            values=vor.getValues();
            sRange=(valuesFrom+1)+".."+(valuesTo+1);
            protNum=String.valueOf(idxOf(pVoR,pp)+1);
        } else if (vap!=null) {
            final StrapProtein[] ppVoAP=jlProteins!=null ? jlProteins.getSelectedProteins(): Texshade.proteins();
            if (sze(ppVoAP)==0) return sb.append(errorPrefix+" ppVoAP=null\n");
            else {
                final byte gappedSeq[][]=new byte[ppVoAP.length][];
                for(int iP=ppVoAP.length; --iP>=0;) gappedSeq[iP]=ppVoAP[iP].getGappedSequences();
                vap.setProteins(ppVoAP);
                values=vap.getValues();
                if (values!=null) {
                    valuesFrom=0;
                    valuesTo=values.length;
                    takeValue=new boolean[valuesTo+1];
                    int count=0;
                    for(int iC=colFrom; iC<=colTo && iC<values.length; iC++) {
                        boolean isGap=true;
                        for(int iP=ppVoAP.length; --iP>=0;) {
                            final byte c=gappedSeq[iP].length>iC ? gappedSeq[iP][iC] : 0;
                            if ('a'<=c && c<='z' || 'A'<=c && c<='Z') {
                                isGap=false;
                                break;
                            }
                        }
                        if (!isGap) { count++; takeValue[iC]=true;}
                    }
                    sRange="1.."+count;
                    protNum="consensus";
                }
            }
        } else return sb.append(errorPrefix+"Could not initialize "+comboClass+"\n");
        if (values==null) return sb.append(errorPrefix+" noValues \n");
        final StringBuffer sbData=new StringBuffer(999);
        boolean minAuto=Double.isNaN(min), maxAuto=Double.isNaN(max);
        if (minAuto) min=Double.MAX_VALUE;
        if (maxAuto) max=Double.MIN_VALUE;
        for(boolean write:new boolean[]{false,true}) {
            for(int i=valuesFrom; i<=valuesTo && i<values.length; i++) {
                if (takeValue!=null && (takeValue.length<=i || !takeValue[i])) continue;
                if (write) {
                    final double v=(1000*(values[i]-min)/(max-min));
                    if (Double.isNaN(v)) sbData.append("NaN\n");
                    else sbData.append((int)v).append("\n");
                } else {
                    if (minAuto && min>values[i]) min=values[i];
                    if (maxAuto && max<values[i]) max=values[i];
                }
            }
            if (min==max || Double.isNaN(min) || Double.isNaN(min)) return sb.append(errorPrefix+" min="+min+" max="+max+"\n");
        }
        final String fileName=shrtClasNam(interf)+"_"+where+".dat";
        wrte(file(Texshade.DIR+fileName),sbData);
       return sb.append("\\feature{"+where+"}{"+protNum+"}{"+sRange+"}{"+barOrColor+"[0,1000]:"+fileName+"["+color+"]}{}\n");
    }
    /* <<< make Tex <<< */
    /* ---------------------------------------- */
    /* >>> ActionListener  >>> */
    public void actionPerformed(java.awt.event.ActionEvent ev) {
        final Object q=ev.getSource();
        if (q==comboProtein || q==jlProteins) replaceProteins();
        if (q==comboClass) replaceInstance();
        if (q==butProteins) {
            if (jlProteins==null) (jlProteins=new ProteinList(StrapAlign.getInstance(),0)).li(this);
            jlProteins.showInFrame(ChFrame.AT_CLICK, "Proteins");
        }

        revalidateC(needsReval);
    }
}
