package charite.christo.strap.extensions;
import charite.christo.*;
import charite.christo.interfaces.*;
import static charite.christo.ChUtils.*;

public abstract class AbstractSubcellularLocation implements PredictSubcellularLocation {
    private byte sequence[];
    private Prediction[] prediction;
    public void setResidueType(byte[] aa) { sequence=aa;}
    public byte[] getResidueType() { return sequence;}

    public Prediction[] getCompartments() {
        if (prediction==null) {
            String cacheKey=null, cacheSection=null;
            ByteArray data=null;
            if (CacheResult.isEnabled()) {
                final StringBuffer sb=new StringBuffer(333);
                join(getPrgParas().asStringArray(HasPrgParas.EQUALS_SIGN), "_", sb);
                cacheKey=sb.append(sequence).toString();
                sb.setLength(0);
                cacheSection=CacheResult.sectionForSequence(sequence,sb).toString();
                data=CacheResult.getValue(getClass(), cacheSection, cacheKey, (ByteArray) null);
            }
            if (data==null) {
                data=computeOutput();
                if (data!=null && cacheKey!=null) CacheResult.putValue(getClass(),cacheSection,cacheKey,data, false);
            }
            if (data!=null) {
                this.prediction=Prediction.text2prediction(data.getBytes(),0,data.getEnd());
            } else this.prediction=ERROR;
        }
        return prediction;
    }
    public abstract ByteArray computeOutput();
    public void setOrganism(int organism){}

    /* ---------------------------------------- */
    /* >>> Command line options >>> */
    private final PrgParas prgPara=new PrgParas();
    public final PrgParas getPrgParas() { return prgPara;}
    /* <<<  Command line options <<< */
    /* ---------------------------------------- */

}

/*

http://202.120.37.186/bioinf/hum-add/Hum-mPLoc-upload.asp

*/
