package charite.christo.strap.extensions;
import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.strap.*;
import charite.christo.strap.interfaces.*;
import charite.christo.protein.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**HELP
This demo shows how own objects can be attached, retrieved and removed
from proteins.  <br> This will become important to you when you
develop STRAP extensions that require a storage place for information.
<i>SEE_CLASS:StrapProtein</i>
*/
public class DemoAssociateObjectsToProteins extends JPanel implements ActionListener,StrapExtension,Disposable ,HasRendererText {
    public void run() {
        DemoAssociateObjectsToProteins.this.add(getPanel());
        StrapAlign.addDialog(DemoAssociateObjectsToProteins.this);
    }
    {
        final String tip="Demo associating user objects";
        TabItemTipIcon.set(null,null,tip,IC_SUPERIMPOSE,DemoAssociateObjectsToProteins.class);
    }
    public CharSequence getRendererText(int options) { return "this is returned by labelText()";}
    // ----------------------------------------
    private JComponent p;
    private JComponent getPanel() {
        if (p==null) {
            p=Box.createVerticalBox();
            p.add(hB("This demo shows how to add and remove user objects",new ChButton().actionClose(this)));
            p.add(pCombo=new ProteinCombo(align,0));
            p.add(hB(butAdd,butCount,butRemove));
        }
        return p;
    }
    // ----------------------------------------
    public final void handleEvent(StrapEvent ev) {
        if (align==null) {
            align=(StrapAlign)ev.getProteinAlignment();
            align.removeListener(this);
        }
    }
    // ----------------------------------------
    private UniqueList<Object> vObjects;
    private StrapAlign align;
    private ProteinCombo pCombo;
    private final ChButton
        butAdd=new ChButton("add one object").li(this),
        butRemove=new ChButton("remove  object").li(this),
        butCount=new ChButton("count objects").li(this);
    public void actionPerformed(ActionEvent ev) {
        final Object q=ev.getSource();
        final StrapProtein p=pCombo.getProtein();
        if (p==null) return;
        if (q==butAdd){
            if (p!=null) {
                if (vObjects==null) {
                    vObjects=new UniqueList(Object.class).t("Demo Objects");
                    p.putClientProperty(DemoAssociateObjectsToProteins.class,vObjects);
                }
                vObjects.add(new MyObject());
            }
        }
        if (q==butRemove){
            if (p!=null && vObjects!=null) vObjects.clear();
        }
        if (q==butCount){
            ChMsg.msgDialog(0L, "I counted "+(vObjects==null ? 0 : vObjects.size()) +" Objects in "+p);
        }
        //new StrapEvent(this,StrapEvent.CLIENT_OBJECTS_OF_PROTEINS_CHANGED).run();
    }
    private static class MyObject  {
        String date;
        public MyObject() { date=new java.text.SimpleDateFormat("yyyy MM:dd:hh mm").format(new Date()); }
        @Override public String toString() { return date;}
    }
    public void dispose() {align.removeListener(this); }
}
