package charite.christo.strap.extensions;
import charite.christo.interfaces.*;
import charite.christo.*;
import charite.christo.protein.*;
import static charite.christo.ChUtils.*;
/**HELP
   Mafft  <i>HOME_PAGE:MultipleAlignerMafft</i>  is an  alignment program published in PUBMED:15661851
*/
public class MultipleAlignerMafft extends charite.christo.strap.AbstractSuperposition implements HasPrgParas, SequenceAlignerSorting  {
    public MultipleAlignerMafft() {
        getPrgParas().defineGUI(null, FURTHER_PARAMETERS);
    }
    @Override public Superimpose3D.Result computeResult(byte[][] seqs, Protein[] proteinsNotNeeded) {
        final String
          //            n="mafft-6.717-without-extensions",
            n="mafft-6.846-without-extensions",
            instScript=
            "cd "+n+"/core\n"+
            "make;\n"+
            "cp ../scripts/mafft ../../"+n+".exe\n",
            srcUrls[]={"http://mafft.cbrc.jp/alignment/software/mafft-6.846-without-extensions-src.tgz"}; /* WATCH_URL */

            final AbstractExecutable e=new AbstractExecutable(n);
            setExecutable(e, srcUrls, instScript, (String[])null);
            if (!Insecure.EXEC_ALLOWED) return null;
            final java.io.File dirTmp=dirTemp();

            e.exec()
                .setCommandLineV("sh",e.fileExecutable(),getPrgParas().asStringArray(EQUALS_SIGN),mfaInFile(seqs) )
                .dir(dirTmp).setOptions(ChExec.STDOUT | ChExec.STDERR | ChExec.LOG | ChExec.CYGWIN_DLL)
                .addToEnvironement("MAFFT_BINARIES="+file(e.dirBinaries()+"/"+n+"/core"))
                .run();

            return parse(seqs.length, e.exec().getStdoutAsByteArray(), null, Superimpose3D.PARSE_SCORE|Superimpose3D.PARSE_MSA_START_S);
    }

}
