package charite.christo.strap.extensions;
import static charite.christo.ChUtils.*;
import charite.christo.protein.*;
import charite.christo.*;
import charite.christo.strap.*;
import charite.christo.interfaces.*;
import java.io.File;
/**HELP
Home: <i>HOME_PAGE:MultipleAlignerProbcons2</i>
<br>
Author: Mahathi Mahabhashyam
<br>
Publication: PUBMED:15687296
*/
// probcons  -v --consistency 2  --iterative-refinement 1000     input_file
public final class MultipleAlignerProbcons2 extends AbstractSuperposition implements HasPrgParas, SequenceAlignerSorting {
    private final static String PARAMERS[][]={
        {"-c","Use 0<=REPS<=5 (default: 2)<br>passes of consistency transformation:"},
        {"-ir","Use 0<=REPS<=1000 (default: 100)<br>passes of iterative refinement.:"}
    };

    public MultipleAlignerProbcons2() {
        getPrgParas().defineGUI(PARAMERS, FURTHER_PARAMETERS);
    }

    @Override public Superimpose3D.Result computeResult(byte[][] seqs, Protein[] proteinsNotNeeded) {
        final String n="probcons-1_12",
            srcUrls[]={"http://probcons.stanford.edu/probcons_v1_12.tar.gz"}, /* WATCH_URL */
            instScript=
                "cd probcons;\n"+
                "make;\n"+
                "cp probcons ../"+n+".exe";
            final AbstractExecutable e=new AbstractExecutable(n);
            for(int i=3; --i>=0;) {
                final String s=i==0?"ProjectPairwise":i==1?"CompareToRef": "Main";
                e.replaceInSourceFile(AbstractExecutable.REPLACEME_INLCUDE_STRING, file(e.dirBinaries()+"/probcons/"+s+".cc"));
            }
            setExecutable(e, srcUrls, instScript, (String[])null);
        if (!Insecure.EXEC_ALLOWED) return null;
        final File mfaInfile=mfaInFile(seqs);

            e.exec()
                .setCommandLineV(e.fileExecutable(), getPrgParas().asStringArray(EQUALS_SIGN) , mfaInfile)
                .dir(dirTemp())
                .setOptions(ChExec.STDOUT | ChExec.STDERR | ChExec.LOG | ChExec.CYGWIN_DLL)
                .run();
            return parse(seqs.length, e.exec().getStdoutAsByteArray(), null, Superimpose3D.PARSE_SCORE|Superimpose3D.PARSE_MSA_START_S);
    }
}
