package charite.christo.strap.extensions;
import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.protein.*;
import charite.christo.strap.*;
import charite.christo.strap.interfaces.*;
import java.io.File;

import java.util.*;
import static charite.christo.ChUtils.*;
/**HELP

<br>Home page:  <i>HOME_PAGE:MultipleAlignerT_Coffee</i>

<br>Publication: PUBMED:10964570

<br>Author: Cedric Notredame
<br>

*/
public final class MultipleAlignerT_Coffee extends AbstractSuperposition implements HasPrgParas, /*SequenceAlignerTakesProfile,*/ SequenceAlignerSorting, HasScore, NeedsProteins {
   private final static String PARAMERS[][]={
            {"-gapopen"," D [0] "},
            {"-gapext"," D [0] "},
            {"-fgapopen"," D [0] "},
            {"-fgapext"," D [0] "}
        };

    public MultipleAlignerT_Coffee() {
        getPrgParas().defineGUI(PARAMERS, FURTHER_PARAMETERS);

    }
    @Override public Superimpose3D.Result computeResult(byte[][] seq, Protein[] proteins) {
        final String
            n="t_coffee8.97",
            instScript=
            "mkdir ~/.t_coffee ~/.t_coffee/cache ~/.t_coffee/methods ~/.t_coffee/mcoffee  ~/.t_coffee/tmp \n"+
            "cd T-COFFEE_distribution_*/t_coffee_source/ \n"+
            "C_COMPILER  -lm  *.c -o ../../"+n+".exe\n",
            srcUrls="http://www.tcoffee.org/Packages/Stable/Latest/T-COFFEE_distribution_Version_8.97_101117.tar.gz"; /*WATCH_URL */
        final AbstractExecutable e=new AbstractExecutable(n);
        setExecutable(e, new String[]{srcUrls}, instScript, (String[])null);
        if (!Insecure.EXEC_ALLOWED) return null;

        final File dirTmp=dirTemp();

         if (isWindows()) {
            File f=file(dirTmp,"os"); if (!f.exists()) wrte(f,"");
         }
         //final byte ss[][]=sequencesWithoutFixed!=null ? sequencesWithoutFixed : getSequences();

         final ByteArray baTemplate=new ByteArray(99);
         if ((OPTION_USE_SECONDARY_STRUCTURE&getOptions())!=0 && proteins!=null) { /* Prepare secondary structure */
             for(int iP=proteins.length; --iP>=0;) {
                 final byte ss[]=proteins[iP].getResidueSecStrType();
                 final int nR=proteins[iP].countResidues();
                 if (ss!=null) {
                     ByteArray ba=new ByteArray(nR+10).append(">s").append(iP).append('\n');
                     for(int i=0;i<nR && i<ss.length; i++) {
                         final char c=(char)(ss[i]&~32);
                         ba.append(c=='H' || c=='E' ? c : 'C');
                     }
                     ba.append('\n');
                     wrte(file(dirTmp+"/s"+iP+".ssp"),ba);
                     baTemplate.append(">s").append(iP).append(" _E_ s").append(iP).append(".ssp\n");
                 }
             }

         }
         File fTemplate=null;
         if (sze(baTemplate)>0) wrte(fTemplate=file(dirTmp+"/template_file"),baTemplate);
         if (isWindows()) e.exec().addToEnvironement("HOME="+dirSettings());
         e.exec().setCommandLineV(
                                  e.fileExecutable(),  mfaInFile(seq), mayAddProfile(), fTemplate!=null ? new Object[] {"-template_file" , "template_file",  "-method_evaluate_mode", "ssp", "-method", "lalign_id_pair", "slow_pair"} : null,
                                //  fileExecutable()/*, mayAddFixed()*/, mfaInfile().getName(), mayAddProfile(),
                                "-outfile=output.msf",  getPrgParas().asStringArray(EQUALS_SIGN),
                                "-email=no@mail", "-proxy=noProxy"
                                )
             .dir(dirTmp).setOptions(ChExec.STDOUT | ChExec.STDERR | ChExec.CYGWIN_DLL).run();
         final ByteArray ba=readBytes(file(dirTmp,"output.msf"));
         return parse(seq.length, ba,null, Superimpose3D.PARSE_SCORE|Superimpose3D.PARSE_MSA_START_S);

    }
    //~/testTC $ t_coffee  Aa1b1hs_3d.clusta Ra1b1hs_3d.clustalW  sequencesWithout.fasta   -outfile=out
    private String mayAddFixed() {
        if (fixed==null) return null;
        final StringBuffer sb=new StringBuffer("CLUSTAL\n\n");
        ChAlignUtils.toGappedMSF(fixed,"s",sequencesWithoutFixed.length,false, sb);
        wrte(file(getNativeExec().dirTemp(),"fixed.clustalW"),sb);
        return "Afixed.clustalW";
    }
    /* --- Keep these aligned --- */
    private byte[][] fixed,sequencesWithoutFixed;
    public void setSequencesWithoutFixed(byte ss[][]) {sequencesWithoutFixed=ss;  }
    private Object mayAddProfile() {
        final byte[] profiles[][]=getProfiles();
        if (profiles==null) return null;
        StringBuffer sb=null;
        for(int iProfile=profiles.length; --iProfile>=0;) {

            final String fn="profile"+iProfile+".mfa";
            wrte(file(getNativeExec().dirTemp(),fn),ChAlignUtils.toGappedMSF(profiles[iProfile],"p",0,true, (StringBuffer)null));
            if (sb==null) sb=new StringBuffer().append("-profile="); else sb.append(',');
            sb.append(fn);
        }
        return sb;
    }
}
