package charite.christo.strap.extensions;
import charite.christo.*;
import charite.christo.interfaces.*;
import static charite.christo.ChUtils.*;
/**HELP

   http://www.genome.jp/SIT/plocdir/
   <b>Publication</b> PMID:12967962 <br>
   <b>Author:</b> Keun-Joon Park and  Minoru  Kanehisa (2003) <br>

*/
public class SubcellularLocationPLOC extends AbstractSubcellularLocation implements HasPrgParas {
    private final static String[][] PARAMERS={{"kingdom","{animal,plant,yeast}"}};
    public SubcellularLocationPLOC() {
        getPrgParas().defineGUI(PARAMERS, FURTHER_PARAMETERS);  // ======
    }

    @Override public ByteArray computeOutput() {
       java.util.Map m=getPrgParas().getMapVariables();
       return Web.getServerResponse(0L, "http://www.genome.jp//sit-bin/plocdir/ploc.cgi",new Object[][]{
                {"kingdom", m==null ? "animal" : m.get("kingdom")},
                {"seq",getResidueType()},
            });
    }
}
