package charite.christo.strap.extensions;
import charite.christo.*;
import charite.christo.protein.*;
import charite.christo.interfaces.*;

import javax.swing.*;
import java.util.*;
import static charite.christo.ChUtils.*;

/**HELP
   Server site:   <i>HOME_PAGE:TransmembraneHelix_DAS</i>
   <br>
   Author: Miklos Cserzo
   @author Christoph Gille
*/
public class TransmembraneHelix_DAS extends AbstractPredictionFromAminoacidSequence implements TransmembraneHelix_Predictor,HasControlPanel,HasSharedControlPanel {
    private java.awt.Container staticControlPanel;
    private static JComboBox comboLibSize=new JComboBox(new String[]{"08","16","24","32"}),comboEval=new JComboBox(new String[]{"-t","-u"});
    public java.awt.Container getSharedControlPanel() {
        if (staticControlPanel==null) {
            staticControlPanel=vB(
                                  pnl("Evaluation: [u]nconditional, [t]rusted:",comboEval),
                                  pnl("TM-library size:",comboLibSize)
                                  );
        }
        return staticControlPanel;
    }
    /* --- Computation --- */
    @Override public char[] compute(String sequ) {
        if (sequ==null) return null;
        final int n=sequ.length();
        final char pred[]=new char[n];
        final ByteArray fromServer=getResultText(sequ,"http://mendel.imp.ac.at/sat/DAS//cgi-bin/das.cgi",new Object[][]{
            {"LEN","-s"},
            {"CON",comboEval.getSelectedItem()},
            {"LIB",comboLibSize.getSelectedItem()},
            {"SEQ",sequ},
            {"submit","submit"}
            },false);
        if (fromServer==null) return null;
        //int idx=-1;
        for(String line:splitLnes(0L,fromServer)){
            if (chrAt(0,line)=='@') {
                final StringTokenizer st=new StringTokenizer(line);
                int nT=st.countTokens();
                while(nT>0 && !st.nextToken().equals("core:")) nT--;
                if (nT<3) continue;
                final int from=atoi(st.nextToken())-1;
                st.nextToken();
                final int to=atoi(st.nextToken())-1;
                if (from>0 && to<=n)
                    for(int i=from-1; i<to && i<pred.length;i++)
                        pred[i]='H';
            }
        }
        return pred;
    }
}
