package charite.christo.strap.extensions;
import charite.christo.*;
import charite.christo.protein.*;
import charite.christo.interfaces.*;
import java.awt.*;
import javax.swing.*;
import java.util.*;
import static charite.christo.ChUtils.*;
/**HELP
   Web site:   <i>HOME_PAGE:TransmembraneHelix_HMMTOP</i>
   <br>
   Publication: PUBMED:11590105
   <br>
   Authors:  G.E. Tusnady
   <br>
   @author Christoph Gille
*/
public class TransmembraneHelix_HMMTOP extends AbstractPredictionFromAminoacidSequence implements TransmembraneHelix_Predictor,Disposable,HasControlPanel {
    @Override public char[] compute(String sequ) {
        if (sequ==null) return null;
        final ByteArray serverResult=getResultText(sequ,"http://www.enzim.hu/hmmtop/server/hmmtop.cgi",new Object[][]{
            {"if",sequ},
            {"submit","submit"}
            },false);
        if (serverResult==null) return null;
        char preds[][]={new char[sequ.length()]};
        parse(splitLnes(0L,serverResult),preds);
        return preds[0];
    }
    private void parse(String[] sResult,char[][] pred) {
        if (sResult==null) return;
        final int nP=pred.length;
        int iP=0;
        StringBuffer sb[]=new StringBuffer[nP];
        for(String l:sResult){
            if (l.startsWith("Protein: s")) iP=atoi(l,10);
            if (l.startsWith("     pred ")) {
                if (sb[iP]==null) sb[iP]=new StringBuffer();
                sb[iP].append(l.substring(9));
            }
        }
        for(int i=0;i<nP; i++) {
            final StringBuffer b=sb[i];
            if (b==null) continue;
            final int l=b.length();
            int iA=0;
            final char cc[]=pred[i];
            boolean isOuwards=false;
            for(int j=0;j<l && iA<cc.length;j++) {
                final int c=b.charAt(j)|32;
                if ('a'<=c&&c<='z') {
                    if (c=='o') isOuwards=false;
                    if (c=='i') isOuwards=true;
                    if (c=='h') cc[iA]= isOuwards ? 'H' : 'h';
                    iA++;
                }
            }
        }
    }
}
