package charite.christo.strap.extensions;
import charite.christo.*;
import charite.christo.interfaces.*;
import java.awt.*;
import javax.swing.*;
import java.util.*;
import static charite.christo.ChUtils.*;
/**HELP
   Home page: <i>HOME_PAGE:TransmembraneHelix_PRED_TMR</i>
   <br>
   <b>Author:</b> Claude Pasquier <br>
   @author Christoph Gille
*/
public class TransmembraneHelix_PRED_TMR extends AbstractPredictionFromAminoacidSequence implements TransmembraneHelix_Predictor,HasControlPanel,HasSharedControlPanel,NeedsInternet {

    private final static JComboBox comboServer=new JComboBox(new String[]{"http://o2.biol.uoa.gr/cgi-bin/PRED-TMR/PRED-TMR","http://o2.biol.uoa.gr/cgi-bin/PRED-TMR2/PRED-TMR"});
    /* --- Control panels --- */
    private static Container staticControlPanel;
    public Container getSharedControlPanel() {
        if (staticControlPanel==null){
            staticControlPanel=vBhB("Server 1 or 2 ?",comboServer);
        }
        return staticControlPanel;
    }
    /* --- Computation --- */
    @Override public char[] compute(String sequ) {
        if (sequ==null) return null;
        final int n=sequ.length();
        final char result[]=new char[n];
        final String server=comboServer.getSelectedItem().toString();
        final ByteArray data=getResultText(sequ,server,new Object[][]{
            {"seq_data",sequ},
            {"show_obsTM",""},
            },false);
        if (data==null) return null;
        boolean started=false;
        for(String d:splitLnes(0L,data)) {
            String line=rplcToStrg("<B>","",d);
            line=rplcToStrg("</B>","",line);
            if (line.startsWith("#TM")) {started=true;continue;}
            if (!started) continue;
            final StringTokenizer st=new StringTokenizer(line);
            if (st.countTokens()<3) continue;
            st.nextToken();
            final int from=atoi(st.nextToken());
            final int to=atoi(st.nextToken());
            if (0<from && to<=n)
                for(int i=from-1; i<to; i++)
                    result[i]='H';
        }
        return result;
    }

}
