package charite.christo.strap.extensions;
import charite.christo.*;
import charite.christo.interfaces.*;
import java.awt.*;
import javax.swing.*;
import java.util.*;
import static charite.christo.ChUtils.*;
/**HELP
Web site: <i>HOME_PAGE:TransmembraneHelix_THUMBUP</i>,
<br>Maintainer:  Hongyi Zhou. Author  Hongyi Zhou and Yaoqi Zhou
<br>Publication: PUBMED:12824500
@author Christoph Gille
*/
public class TransmembraneHelix_THUMBUP extends AbstractPredictionFromAminoacidSequence implements TransmembraneHelix_Predictor,HasControlPanel,NeedsInternet {
    /* --- Computation --- */
    @Override public char[] compute(String sequ) {
        if (sequ==null) return null;
        final int n=sequ.length();
        final char result[]=new char[n];
        final ByteArray fromServer=getResultText(sequ,"http://sparks.informatics.iupui.edu/cgi-bin/caltmtop.cgi",new Object[][]{{"SEQ",sequ}},false);
        if (fromServer==null) return null;
        for(String s: splitLnes(0L,fromServer)) {
            if (s.startsWith(" Helix ")) {
                final StringTokenizer st=new StringTokenizer(s);
                if (st.countTokens()<5) continue;
                st.nextToken(); st.nextToken(); st.nextToken();
                final int from=atoi(st.nextToken());
                final int to=atoi(st.nextToken());
                if (0<from && to<=n)
                    for(int i=from-1; i<to; i++)
                        result[i]='H';
            }
        }
        return result;
    }
}

//"http://www.smbs.buffalo.edu/phys_bio/cgi-bin/caltmtop.cgi"
