import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.protein.*;
import java.awt.*;
import java.io.*;
import javax.swing.*;
import java.util.*;

public class ProteinViewerExample implements ProteinViewer, HasControlPanel, HasSharedControlPanel  {
   // ----------------------------------------
    private Protein  protein;
    @Override public Protein getProtein() {return protein;}
    @Override public boolean setProtein(long options, Protein p, ProteinViewer inSameView, Runnable runAfterInstallation) {
        System.out.println(getClass().getName()+" setProtein("+p+")");
        protein=p;
        return true;
    }
    // ----------------------------------------
    @Override public void setSelectedResidues(long options, boolean[] bb, Object atomType, String selection_id) {
        final StringBuffer sb=new StringBuffer(99);
        sb.append(getClass().getName()).append(" setSelectedResidues(");
        for(boolean b:bb) sb.append(b?'X':'.');
        sb.append(',').append(selection_id).append(')');
        System.out.println(sb);
    }
    // ----------------------------------------
    @Override public Container getSharedControlPanel() {
        return new JLabel("Here you can add GUI-controls for all instances");
    }
    @Override public Container getControlPanel() {
        return new JLabel("Here you can add GUI-controls for the particular instance");
    }
     // -----------------------------+-----------
    @Override public void interpret(long options, String s) {
        System.out.println(getClass().getName()+" interpret("+options+","+s+")");
    }
    // ----------------------------------------
    @Override public void dispose() {
        System.out.println(getClass().getName()+" dispose");
        new StrapEvent(this,StrapEvent.PROTEIN_VIEWER_CLOSED).run();
    }
    // ----------------------------------------
    @Override public Object getProperty(Object key) {
        return null;
    }

    private final Map shared_hashMap=new HashMap();
    @Override public Map getSharedHashMap() { return shared_hashMap;}
    @Override public ProteinViewer[] getViewersSharingView() { return null; }

}

