import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.strap.*;
import charite.christo.strap.interfaces.*;
import charite.christo.protein.*;
import java.io.*;
import java.awt.*;
import javax.swing.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;

/**
			implementation of the superposition algorithm using CE
			http://cl.sdsc.edu/
*/
public class Superimpose3DExample implements Superimpose3D , HasControlPanel,HasSharedControlPanel {
    public long getOptions() { return 0L; }
    public void setOptions(long options) { }

    private Protein proteinM,proteinR;
    //private double translation[]=new double[]{0,0,0},rotation[][]=new double[][]{{1,0,0},{0,1,0},{0,0,1}};
    public void setMobileProtein(Protein p){proteinM=p;}
    public void setReferenceProtein(Protein p){proteinR=p;};
    public Protein getMobileProtein(){return proteinM;}
    public Protein getReferenceProtein(){return proteinR;}

    //public double[][]  getRotation(){return rotation;}
    //public double[] getTranslation(){return translation;}
    private Result result;
    public Superimpose3D.Result getResult(){ return result;}

    private String stdout;
    public void compute(){
        {
            /* --- mobile protein --- */
            ProteinWriter1 pw=new ProteinWriter1();
            ByteArray sb=new ByteArray(0);
            pw.setChainForAllResidues('A');
            pw.toText(proteinM, (Matrix3D[])null, ProteinWriter.PDB,  sb);
            wrte(file(dirTmp()+"/"+proteinM+".cAlpha.pdb"),sb);
        }
        {/* --- reference protein --- */
            ProteinWriter1 pw=new ProteinWriter1();
            ByteArray sb=new ByteArray(0);
            pw.setChainForAllResidues('B');
            pw.toText(proteinR, (Matrix3D[])null, ProteinWriter.PDB,  sb);
            wrte(file(dirTmp()+"/"+proteinR+".cAlpha.pdb"),sb);
        }

								/* --- Add computation by external process and analyze result --- */
								stdout=
												"please enter a transformation\n"+
												"     X2 = ( 0.018530)*X1 + (-0.955898)*Y1 + ( 0.293113)*Z1 + (  176.273087) \n"+
												"     Y2 = (-0.038094)*X1 + ( 0.292275)*Y1 + ( 0.955575)*Z1 + (  -37.874550) \n"+
												"     Z2 = (-0.999102)*X1 + (-0.028872)*Y1 + (-0.030998)*Z1 + (   59.276119) \n";

								final JTextArea ta=new JTextArea(stdout);
								monospc(ta);
								ChMsg.msgDialog(0L, new Object[]{ta});

								stdout=ta.getText();
								final int iX2=stdout.indexOf("X2");
								if (iX2<0) { 	error("Error: unable to parse"); return;}
								final byte data[]=stdout.substring(iX2).getBytes();
								final int parOpen[]=new int[12];
								for(int i=0,count=0; i<data.length;i++) {
												if (data[i]=='(') parOpen[count++]=i+1;
								}
                                final Matrix3D m3d=new Matrix3D();
								m3d.setTranslation(new double[]{ d(data,parOpen[3]),d(data,parOpen[7]),d(data,parOpen[11])});
								m3d.setRotation(new double[][] {
												{ d(data,parOpen[0]),d(data,parOpen[1]),d(data,parOpen[2])},
												{ d(data,parOpen[4]),d(data,parOpen[5]),d(data,parOpen[6])},
												{ d(data,parOpen[8]),d(data,parOpen[9]),d(data,parOpen[10])},
								});
								result=new Result();
                                result.setMatrix(m3d);

				}
				private double d(byte txt[],int from) {
								int to=from;while (txt[to]!=')') to++;
								return Double.parseDouble(new String(txt,from,to-from));
				}

				public String toString() { return " toString method of example Superimpose3D";}
    public Container getControlPanel() {	return null;	}
    public Container getSharedControlPanel() {	return null;	}

}
