import charite.christo.strap.interfaces.*;
import charite.christo.strap.*;
import charite.christo.*;
import charite.christo.protein.*;
/**
			This example returns the similarity of each residue in the protein to Histidin
			according to the Blosum matrix.
*/
public class ValueOfResidueExample implements ValueOfResidue {
				private StrapProtein protein;
    public StrapProtein getProtein(){return protein;}
    public boolean  setProtein(Protein p){ protein=(StrapProtein)p; return true;}
				private final byte[][]  blosum62=Blosum.BLOSUM62;
				/* The  blosum62 table works with upper and lower case letters
							E.g.blosum62['K']['l'] is identical to blosum62['K']['L'] or blosum62['k']['L']
							and returns the blosum62 value for Lys and Leu.
				*/
    public double[] getValues(){
								byte residues[]=protein.getResidueType();
								int n=residues.length;
								double values[]=new double[n];/* ineficient due to array object creation with each call ! */
								for(int i=0;i<n;i++) {
												byte res=residues[i];
												if (res<0) continue; // just for safety. should not happen.
												values[i]=blosum62['H'][res];
								}
        modiCount++;
								return values;
				}
    private int modiCount;
    public int getModificationCount() {
        return modiCount;
    }
    public String toString() { return " toString method of example ValueOfResidue";}
}
