package charite.christo.strap.interfaces;
import charite.christo.strap.*;
import charite.christo.protein.*;
/**
   Returns values for pairs of   proteins.
   It should notify changes by creating an event of type
   <i>JAVADOC:StrapEvent#PROTEIN_PROTEIN_DISTANCE_CHANGED</i>
   and dispatching it with  <i>JAVADOC:StrapEvent#run()</i>.
*/
public abstract interface ProteinProteinValue extends ValueOfProtein, charite.christo.interfaces.HasModiCount  {
    void setOtherProtein(StrapProtein p);
    StrapProtein getOtherProtein();
/**
       please store and reuse values if appropriate
       return NaN when not calculated yet
*/
    double  getValue();
    /** the values may depend on the range of alignment positions */
    void setColumnRange(int from,int to);
    //    StrapListener getStrapListener();
/**
       When it is time consuming then do the calculation in the compute method.
       Non time intensive calculations can be performed in getValue();
*/
    void compute();

}
