package charite.christo.strap.interfaces;
import charite.christo.strap.*;
/**
   Plugins that return a numeric value for each position (column) in the alignment or null.
   These are plotted in the alignment pane.
   It should notify changes by  dispatching events of type 
   <i>JAVADOC:StrapEvent#VALUE_OF_ALIGN_POSITION_CHANGED</i>
   and dispatching it with  <i>JAVADOC:StrapEvent#run()</i>.
*/
public interface ValueOfAlignPosition extends charite.christo.interfaces.HasModiCount{
    void setProteins(StrapProtein... proteins);
    StrapProtein[] getProteins();
    double[] getValues();
    /**
       Increment value when new values are computed.
    */


}
