package charite.christo.strap.science;
import charite.christo.*;
import java.util.*;

/*Bortz Seite 415 */
public class SpearmansRangCorrelation {
    private SpearmansRangCorrelation(){}
    public static double calcRoh(double xx[],double yy[]) {
        final int n=xx.length;
        final boolean isNaN[]=new boolean[n];
        for(int i=ChUtils.mini(n,yy.length); --i>=0;)
            isNaN[i] = Double.isNaN(xx[i]) || Double.isNaN(yy[i]);

        final int rxx[]=getRangs(xx,isNaN),ryy[]=getRangs(yy,isNaN);
        long d2=0;
        for(int i=0;i<rxx.length;i++) {
            int x=rxx[i],y=ryy[i];
            int d=x-y;
            d2+=d*d;
        }

       double sigma=1.0-6.0*d2/n/(n*n-1);
       return sigma;
    }
    private static int[] getRangs(double dd[],boolean isNaN[]){
        int n=dd.length,countTrue=ChUtils.countTrue(isNaN), rr[]=new int[n-countTrue];
        double sorted[]=new double[n-countTrue];
        int count=0;
        for(int i=0;i<dd.length && i< isNaN.length;i++)
            if (!isNaN[i]) sorted[count++]=dd[i];
        Arrays.sort(sorted);
        for(int i=0,j=0;i<n;i++) {
            if (!isNaN[i])
                rr[j++]=idxOf(dd[i],sorted);
        }
        return rr;
    }
    private static int idxOf(double o,double oo[]) {
        for(int  i=0;i<oo.length;i++)
            if (o==(oo[i])) return i;
        return -1;
    }
    //java charite.christo.strap.science.SpearmansRangCorrelation
    /*
    public static void main(String argv[]) {
        double ff1[]=new double[]{207.0f, 221.0f, 256.0f, 262.0f, 273.0f, 289.0f, 291.0f, 292.3f, 304.0f, 327.5f, 372.0f, 397.0f, 460.0f, 632.0f};
        double ff2[]=new double[]{ 16.6f,  18.0f,  15.9f,  20.7f,  19.3f,  19.8f,  11.7f,  21.9f,  23.0f,  13.6f,  19.6f,  22.9f,  19.4f,  28.4f};
        double ff3[]=new double[ff2.length];
        for(int i=0;i<ff2.length;i++) ff3[i]=-ff2[i];
        double sigma=calcRoh(ff1,ff3);
        int rags[]=getRangs(ff2,null);
        for(int i=0;i<ff2.length;i++) {
            out.println(ff2[i]+"\t"+rags[i]);
        }
    }
    */
}
